/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern0 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern0 (x1, 
E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern0 (x1, 
E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern0 (x1, 
E_DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern4 (x1, 
E_HFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern25 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern25 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern25 (x1, 
E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern25 (x1, 
E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern25 (x1, 
E_DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern27 (x1, 
E_HFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_register_operand (operands[0], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x2;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!nvptx_register_operand (operands[0], E_BImode)
          || !nvptx_float_comparison_operator (operands[1], E_BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[2], E_SFmode)
              || !nvptx_nonmemory_operand (operands[3], E_SFmode))
            return -1;
          return 138; /* *cmpsf */

        case E_DFmode:
          if (!nvptx_register_operand (operands[2], E_DFmode)
              || !nvptx_nonmemory_operand (operands[3], E_DFmode))
            return -1;
          return 139; /* *cmpdf */

        case E_HFmode:
          if (!nvptx_register_operand (operands[2], E_HFmode)
              || !nvptx_nonmemory_operand (operands[3], E_HFmode)
              || !
#line 905 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 140; /* *cmphf */

        default:
          return -1;
        }

    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || !nvptx_float_comparison_operator (operands[1], E_SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[2], E_SFmode)
              || !nvptx_nonmemory_operand (operands[3], E_SFmode))
            return -1;
          return 191; /* setcc_floatsf */

        case E_DFmode:
          if (!nvptx_register_operand (operands[2], E_DFmode)
              || !nvptx_nonmemory_operand (operands[3], E_DFmode))
            return -1;
          return 192; /* setcc_floatdf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_12 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!nvptx_register_operand (operands[0], E_BImode)
          || !nvptx_float_comparison_operator (operands[1], E_BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[2], E_SFmode)
              || !nvptx_nonmemory_operand (operands[3], E_SFmode))
            return -1;
          return 561; /* *p *cmpsf */

        case E_DFmode:
          if (!nvptx_register_operand (operands[2], E_DFmode)
              || !nvptx_nonmemory_operand (operands[3], E_DFmode))
            return -1;
          return 562; /* *p *cmpdf */

        case E_HFmode:
          if (!nvptx_register_operand (operands[2], E_HFmode)
              || !nvptx_nonmemory_operand (operands[3], E_HFmode)
              || !
#line 905 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 563; /* *p *cmphf */

        default:
          return -1;
        }

    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || !nvptx_float_comparison_operator (operands[1], E_SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[2], E_SFmode)
              || !nvptx_nonmemory_operand (operands[3], E_SFmode))
            return -1;
          return 610; /* *p setcc_floatsf */

        case E_DFmode:
          if (!nvptx_register_operand (operands[2], E_DFmode)
              || !nvptx_nonmemory_operand (operands[3], E_DFmode))
            return -1;
          return 611; /* *p setcc_floatdf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_19 (x1, insn, pnum_clobbers);

    case PARALLEL:
      if (XVECLEN (x1, 0) >= 1
          && call_operation (x1, E_VOIDmode))
        {
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || XINT (x4, 1) != 17
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 17
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XVECEXP (x6, 0, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x9 = XVECEXP (x4, 0, 0);
          operands[2] = x9;
          x10 = XEXP (x3, 0);
          operands[1] = x10;
          if (!nvptx_register_operand (operands[1], E_SImode))
            return -1;
          x11 = XVECEXP (x6, 0, 0);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[2], E_DImode))
                return -1;
              return 315; /* unpackdisi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[2], E_DFmode))
                return -1;
              return 316; /* unpackdfsi2 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          switch (XVECLEN (x4, 0))
            {
            case 4:
              x6 = XEXP (x3, 1);
              if (GET_CODE (x6) != UNSPEC_VOLATILE
                  || XVECLEN (x6, 0) != 1)
                return -1;
              x11 = XVECEXP (x6, 0, 0);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x8 = XEXP (x2, 0);
              operands[0] = x8;
              x9 = XVECEXP (x4, 0, 0);
              operands[1] = x9;
              x5 = XVECEXP (x4, 0, 1);
              operands[2] = x5;
              x12 = XVECEXP (x4, 0, 2);
              operands[3] = x12;
              x13 = XVECEXP (x4, 0, 3);
              operands[4] = x13;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x3, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (XINT (x4, 1))
                {
                case 2:
                  switch (pattern69 (x1, 
2))
                    {
                    case 0:
                      return 319; /* atomic_compare_and_swapsi_1_local */

                    case 1:
                      return 320; /* atomic_compare_and_swapdi_1_local */

                    default:
                      return -1;
                    }

                case 1:
                  switch (pattern69 (x1, 
1))
                    {
                    case 0:
                      return 321; /* atomic_compare_and_swapsi_1 */

                    case 1:
                      return 322; /* atomic_compare_and_swapdi_1 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2:
              x5 = XVECEXP (x4, 0, 1);
              operands[3] = x5;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              switch (XINT (x4, 1))
                {
                case 3:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  x9 = XVECEXP (x4, 0, 0);
                  operands[1] = x9;
                  x6 = XEXP (x3, 1);
                  operands[2] = x6;
                  x10 = XEXP (x3, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern59 (x4, 
E_SImode) != 0)
                        return -1;
                      return 323; /* atomic_exchangesi */

                    case E_DImode:
                      if (pattern59 (x4, 
E_DImode) != 0)
                        return -1;
                      return 324; /* atomic_exchangedi */

                    default:
                      return -1;
                    }

                case 0:
                  x8 = XEXP (x2, 0);
                  operands[1] = x8;
                  x10 = XEXP (x3, 0);
                  operands[0] = x10;
                  x6 = XEXP (x3, 1);
                  if (!rtx_equal_p (x6, operands[1]))
                    return -1;
                  x9 = XVECEXP (x4, 0, 0);
                  switch (GET_CODE (x9))
                    {
                    case PLUS:
                      x14 = XEXP (x9, 1);
                      operands[2] = x14;
                      x15 = XEXP (x9, 0);
                      if (!rtx_equal_p (x15, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SImode:
                          if (pattern55 (x4, 
E_SImode) != 0)
                            return -1;
                          return 329; /* atomic_fetch_addsi */

                        case E_DImode:
                          if (pattern55 (x4, 
E_DImode) != 0)
                            return -1;
                          return 330; /* atomic_fetch_adddi */

                        case E_SFmode:
                          if (pattern55 (x4, 
E_SFmode) != 0)
                            return -1;
                          return 331; /* atomic_fetch_addsf */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern56 (x4))
                        {
                        case 0:
                          return 332; /* atomic_fetch_andsi */

                        case 1:
                          if (!
#line 2328 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 335; /* atomic_fetch_anddi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern56 (x4))
                        {
                        case 0:
                          return 333; /* atomic_fetch_orsi */

                        case 1:
                          if (!
#line 2328 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 336; /* atomic_fetch_ordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern56 (x4))
                        {
                        case 0:
                          return 334; /* atomic_fetch_xorsi */

                        case 1:
                          if (!
#line 2328 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 337; /* atomic_fetch_xordi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      switch (XWINT (x1, 0))
        {
        case 0L:
          return 286; /* nop */

        case 1L:
          return 287; /* exit */

        case 2L:
          return 288; /* fake_nop */

        default:
          return -1;
        }

    case RETURN:
      return 289; /* return */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 13)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || !(
#line 1724 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
            return -1;
          return 292; /* set_softstack_si */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || !(
#line 1724 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
            return -1;
          return 293; /* set_softstack_di */

        default:
          return -1;
        }

    case TRAP_IF:
      x16 = XEXP (x1, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x17 = XEXP (x1, 0);
      switch (GET_CODE (x17))
        {
        case CONST_INT:
          if (XWINT (x17, 0) != 1L)
            return -1;
          return 298; /* trap */

        case NE:
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XEXP (x17, 0);
          operands[0] = x19;
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          return 299; /* trap_if_true */

        case EQ:
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XEXP (x17, 0);
          operands[0] = x19;
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          return 300; /* trap_if_false */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 15:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 303; /* nvptx_fork */

            case 16:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 304; /* nvptx_forked */

            case 17:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 305; /* nvptx_joining */

            case 18:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 306; /* nvptx_join */

            case 21:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!nvptx_register_operand (operands[0], E_SImode)
                      || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                    return -1;
                  return 312; /* omp_simt_exit_si */

                case E_DImode:
                  if (!nvptx_register_operand (operands[0], E_DImode)
                      || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                    return -1;
                  return 313; /* omp_simt_exit_di */

                default:
                  return -1;
                }

            case 9:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2385 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_6_0))
                return -1;
              return 339; /* nvptx_warpsync */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 343; /* nvptx_uniform_warp_check */

            case 19:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 347; /* nvptx_nounroll */

            default:
              return -1;
            }

        case 2:
          if (XINT (x1, 1) != 8)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!nvptx_nonmemory_operand (operands[0], E_SImode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 338; /* nvptx_barsync */

        default:
          return -1;
        }

    case COND_EXEC:
      x17 = XEXP (x1, 0);
      if (!predicate_operator (x17, E_VOIDmode))
        return -1;
      x19 = XEXP (x17, 0);
      if (!nvptx_register_operand (x19, E_BImode))
        return -1;
      x18 = XEXP (x17, 1);
      if (!const0_operand (x18, E_BImode))
        return -1;
      x16 = XEXP (x1, 1);
      switch (GET_CODE (x16))
        {
        case SET:
          return recog_18 (x1, insn, pnum_clobbers);

        case PARALLEL:
          if (XVECLEN (x16, 0) >= 1
              && call_operation (x16, E_VOIDmode))
            {
              res = recog_17 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (x16, 0) != 2)
            return -1;
          x20 = XVECEXP (x16, 0, 0);
          if (GET_CODE (x20) != SET)
            return -1;
          x21 = XVECEXP (x16, 0, 1);
          if (GET_CODE (x21) != SET)
            return -1;
          x22 = XEXP (x20, 1);
          switch (GET_CODE (x22))
            {
            case UNSPEC:
              if (XVECLEN (x22, 0) != 2
                  || XINT (x22, 1) != 17
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XVECEXP (x22, 0, 1);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x24 = XEXP (x21, 1);
              if (GET_CODE (x24) != UNSPEC
                  || XVECLEN (x24, 0) != 2
                  || XINT (x24, 1) != 17
                  || GET_MODE (x24) != E_SImode)
                return -1;
              x25 = XVECEXP (x24, 0, 1);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              operands[3] = x17;
              operands[4] = x19;
              operands[5] = x18;
              x26 = XEXP (x20, 0);
              operands[0] = x26;
              if (!nvptx_register_operand (operands[0], E_SImode))
                return -1;
              x27 = XVECEXP (x22, 0, 0);
              operands[2] = x27;
              x28 = XEXP (x21, 0);
              operands[1] = x28;
              if (!nvptx_register_operand (operands[1], E_SImode))
                return -1;
              x29 = XVECEXP (x24, 0, 0);
              if (!rtx_equal_p (x29, operands[2]))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_DImode:
                  if (!nvptx_register_operand (operands[2], E_DImode))
                    return -1;
                  return 725; /* *p unpackdisi2 */

                case E_DFmode:
                  if (!nvptx_register_operand (operands[2], E_DFmode))
                    return -1;
                  return 726; /* *p unpackdfsi2 */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              switch (XVECLEN (x22, 0))
                {
                case 4:
                  if (XINT (x22, 1) != 1)
                    return -1;
                  x24 = XEXP (x21, 1);
                  if (GET_CODE (x24) != UNSPEC_VOLATILE
                      || XVECLEN (x24, 0) != 1
                      || XINT (x24, 1) != 1)
                    return -1;
                  x29 = XVECEXP (x24, 0, 0);
                  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  operands[5] = x17;
                  operands[6] = x19;
                  operands[7] = x18;
                  x26 = XEXP (x20, 0);
                  operands[0] = x26;
                  x27 = XVECEXP (x22, 0, 0);
                  operands[1] = x27;
                  x23 = XVECEXP (x22, 0, 1);
                  operands[2] = x23;
                  x30 = XVECEXP (x22, 0, 2);
                  operands[3] = x30;
                  x31 = XVECEXP (x22, 0, 3);
                  operands[4] = x31;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x28 = XEXP (x21, 0);
                  if (!rtx_equal_p (x28, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern73 (x16, 
E_SImode) != 0)
                        return -1;
                      return 729; /* *p atomic_compare_and_swapsi_1 */

                    case E_DImode:
                      if (pattern73 (x16, 
E_DImode) != 0)
                        return -1;
                      return 730; /* *p atomic_compare_and_swapdi_1 */

                    default:
                      return -1;
                    }

                case 2:
                  operands[4] = x17;
                  operands[5] = x19;
                  operands[6] = x18;
                  x23 = XVECEXP (x22, 0, 1);
                  operands[3] = x23;
                  if (!const_int_operand (operands[3], E_SImode))
                    return -1;
                  switch (XINT (x22, 1))
                    {
                    case 3:
                      x26 = XEXP (x20, 0);
                      operands[0] = x26;
                      x27 = XVECEXP (x22, 0, 0);
                      operands[1] = x27;
                      x24 = XEXP (x21, 1);
                      operands[2] = x24;
                      x28 = XEXP (x21, 0);
                      if (!rtx_equal_p (x28, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern72 (x22, 
E_SImode) != 0)
                            return -1;
                          return 731; /* *p atomic_exchangesi */

                        case E_DImode:
                          if (pattern72 (x22, 
E_DImode) != 0)
                            return -1;
                          return 732; /* *p atomic_exchangedi */

                        default:
                          return -1;
                        }

                    case 0:
                      x26 = XEXP (x20, 0);
                      operands[1] = x26;
                      x28 = XEXP (x21, 0);
                      operands[0] = x28;
                      x24 = XEXP (x21, 1);
                      if (!rtx_equal_p (x24, operands[1]))
                        return -1;
                      x27 = XVECEXP (x22, 0, 0);
                      switch (GET_CODE (x27))
                        {
                        case PLUS:
                          x32 = XEXP (x27, 1);
                          operands[2] = x32;
                          x33 = XEXP (x27, 0);
                          if (!rtx_equal_p (x33, operands[1]))
                            return -1;
                          switch (GET_MODE (operands[1]))
                            {
                            case E_SImode:
                              if (pattern70 (x22, 
E_SImode) != 0)
                                return -1;
                              return 737; /* *p atomic_fetch_addsi */

                            case E_DImode:
                              if (pattern70 (x22, 
E_DImode) != 0)
                                return -1;
                              return 738; /* *p atomic_fetch_adddi */

                            case E_SFmode:
                              if (pattern70 (x22, 
E_SFmode) != 0)
                                return -1;
                              return 739; /* *p atomic_fetch_addsf */

                            default:
                              return -1;
                            }

                        case AND:
                          switch (pattern71 (x22))
                            {
                            case 0:
                              return 740; /* *p atomic_fetch_andsi */

                            case 1:
                              if (!
#line 2328 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 743; /* *p atomic_fetch_anddi */

                            default:
                              return -1;
                            }

                        case IOR:
                          switch (pattern71 (x22))
                            {
                            case 0:
                              return 741; /* *p atomic_fetch_orsi */

                            case 1:
                              if (!
#line 2328 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 744; /* *p atomic_fetch_ordi */

                            default:
                              return -1;
                            }

                        case XOR:
                          switch (pattern71 (x22))
                            {
                            case 0:
                              return 742; /* *p atomic_fetch_xorsi */

                            case 1:
                              if (!
#line 2328 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 745; /* *p atomic_fetch_xordi */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          operands[0] = x17;
          operands[1] = x19;
          operands[2] = x18;
          switch (XWINT (x16, 0))
            {
            case 0L:
              return 705; /* *p nop */

            case 1L:
              return 706; /* *p exit */

            case 2L:
              return 707; /* *p fake_nop */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 13)
            return -1;
          operands[1] = x17;
          operands[2] = x19;
          operands[3] = x18;
          x20 = XVECEXP (x16, 0, 0);
          operands[0] = x20;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || !(
#line 1724 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
                return -1;
              return 708; /* *p set_softstack_si */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || !(
#line 1724 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
                return -1;
              return 709; /* *p set_softstack_di */

            default:
              return -1;
            }

        case TRAP_IF:
          x34 = XEXP (x16, 0);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x35 = XEXP (x16, 1);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[0] = x17;
          operands[1] = x19;
          operands[2] = x18;
          return 714; /* *p trap */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x16, 0) != 1)
            return -1;
          switch (XINT (x16, 1))
            {
            case 21:
              operands[1] = x17;
              operands[2] = x19;
              operands[3] = x18;
              x20 = XVECEXP (x16, 0, 0);
              operands[0] = x20;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!nvptx_register_operand (operands[0], E_SImode)
                      || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                    return -1;
                  return 722; /* *p omp_simt_exit_si */

                case E_DImode:
                  if (!nvptx_register_operand (operands[0], E_DImode)
                      || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                    return -1;
                  return 723; /* *p omp_simt_exit_di */

                default:
                  return -1;
                }

            case 9:
              x20 = XVECEXP (x16, 0, 0);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              operands[0] = x17;
              operands[1] = x19;
              operands[2] = x18;
              if (!
#line 2385 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_6_0))
                return -1;
              return 746; /* *p nvptx_warpsync */

            case 10:
              x20 = XVECEXP (x16, 0, 0);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              operands[0] = x17;
              operands[1] = x19;
              operands[2] = x18;
              return 747; /* *p nvptx_uniform_warp_check */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
