/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern1 (x1, 
E_SImode) != 0)
        return -1;
      return 0;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern8 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern1 (x1, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern8 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V4SImode:
      if (pattern1 (x1, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern8 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern1 (x1, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V8DImode:
      if (pattern8 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 7;

    case E_V16SImode:
      if (pattern1 (x1, 
E_V16SImode) != 0)
        return -1;
      return 8;

    case E_V16DImode:
      if (pattern8 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
        return -1;
      return 9;

    case E_V32SImode:
      if (pattern1 (x1, 
E_V32SImode) != 0)
        return -1;
      return 10;

    case E_V32DImode:
      if (pattern8 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
        return -1;
      return 11;

    case E_V64SImode:
      if (pattern1 (x1, 
E_V64SImode) != 0)
        return -1;
      return 12;

    case E_V64DImode:
      if (pattern8 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!gcn_alu_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!gcn_alu_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    case E_V64DFmode:
      if (!gcn_alu_operand (operands[1], E_V64DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32DImode)
      || GET_MODE (x1) != E_V32DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!gcn_alu_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gcn_valu_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_valu_src0_operand (operands[1], i1)
      || !gcn_valu_src1com_operand (operands[2], i1)
      || !gcn_register_ds_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    case E_V2HFmode:
      if (!gcn_alu_operand (operands[1], E_V2HFmode))
        return -1;
      return 2;

    case E_V2SFmode:
      if (!gcn_alu_operand (operands[1], E_V2SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!gcn_alu_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    case E_V16HFmode:
      if (!gcn_alu_operand (operands[1], E_V16HFmode))
        return -1;
      return 2;

    case E_V16SFmode:
      if (!gcn_alu_operand (operands[1], E_V16SFmode))
        return -1;
      return 3;

    case E_V16DFmode:
      if (!gcn_alu_operand (operands[1], E_V16DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!gcn_alu_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!gcn_alu_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!gcn_alu_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern67 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  if (!gcn_exec_reg_operand (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern40 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern40 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern40 (x1, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern40 (x1, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern40 (x1, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern40 (x1, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x1) != E_HFmode
          || !gcn_alu_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !gcn_alu_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !gcn_alu_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 6;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 13;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 14;

    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 15;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 16;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 17;

    case E_V2DImode:
      if (!gcn_alu_operand (operands[1], E_V2DImode))
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern100 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern103 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gcn_ds_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_ds_memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gcn_valu_dst_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!gcn_alu_operand (operands[2], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!scratch_operand (operands[3], E_BImode))
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x7;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 106
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x3, 1);
          operands[3] = x10;
          x11 = XEXP (x3, 2);
          operands[4] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              return pattern131 (x3, 
E_V2DImode, 
E_V2SImode); /* [-1, 0] */

            case E_V4DImode:
              if (pattern131 (x3, 
E_V4DImode, 
E_V4SImode) != 0)
                return -1;
              return 1;

            case E_V8DImode:
              if (pattern131 (x3, 
E_V8DImode, 
E_V8SImode) != 0)
                return -1;
              return 2;

            case E_V16DImode:
              if (pattern131 (x3, 
E_V16DImode, 
E_V16SImode) != 0)
                return -1;
              return 3;

            case E_V32DImode:
              if (pattern131 (x3, 
E_V32DImode, 
E_V32SImode) != 0)
                return -1;
              return 4;

            case E_V64DImode:
              if (pattern131 (x3, 
E_V64DImode, 
E_V64SImode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x12 = XEXP (x8, 1);
          if (GET_CODE (x12) != AND
              || GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != LTU
              || GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != ZERO_EXTEND)
            return -1;
          x16 = XEXP (x14, 1);
          if (GET_CODE (x16) != VEC_DUPLICATE)
            return -1;
          x17 = XEXP (x7, 0);
          operands[2] = x17;
          if (!gcn_alu_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[4] = x10;
          x11 = XEXP (x3, 2);
          operands[5] = x11;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!register_operand (operands[3], E_DImode))
            return -1;
          x18 = XEXP (x15, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          x19 = XEXP (x16, 0);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x20 = XEXP (x13, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x12, 1);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern132 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
                return -1;
              return 6;

            case E_V4DImode:
              if (pattern132 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
                return -1;
              return 7;

            case E_V8DImode:
              if (pattern132 (x1, 
E_V8DImode, 
E_V8SImode) != 0)
                return -1;
              return 8;

            case E_V16DImode:
              if (pattern132 (x1, 
E_V16DImode, 
E_V16SImode) != 0)
                return -1;
              return 9;

            case E_V32DImode:
              if (pattern132 (x1, 
E_V32DImode, 
E_V32SImode) != 0)
                return -1;
              return 10;

            case E_V64DImode:
              if (pattern132 (x1, 
E_V64DImode, 
E_V64SImode) != 0)
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x12 = XEXP (x8, 1);
      if (GET_CODE (x12) != AND
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != LTU
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != ZERO_EXTEND)
        return -1;
      x18 = XEXP (x15, 0);
      if (GET_CODE (x18) != VEC_DUPLICATE)
        return -1;
      x22 = XEXP (x6, 0);
      operands[1] = x22;
      if (!gcn_alu_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x10 = XEXP (x3, 1);
      operands[4] = x10;
      x11 = XEXP (x3, 2);
      operands[5] = x11;
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x23 = XEXP (x18, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x16 = XEXP (x14, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x20 = XEXP (x13, 1);
      if (!rtx_equal_p (x20, operands[1]))
        return -1;
      x21 = XEXP (x12, 1);
      if (!rtx_equal_p (x21, operands[5]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern133 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 12;

        case E_V4DImode:
          if (pattern133 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 13;

        case E_V8DImode:
          if (pattern133 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
            return -1;
          return 14;

        case E_V16DImode:
          if (pattern133 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
            return -1;
          return 15;

        case E_V32DImode:
          if (pattern133 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
            return -1;
          return 16;

        case E_V64DImode:
          if (pattern133 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern222 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  return pattern222 (x2, 
E_V16DImode, 
E_V16SImode); /* [-1, 0] */
}

int
pattern236 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2
      || !gcn_register_or_unspec_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[5] = x4;
  x5 = XEXP (x3, 2);
  operands[6] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  x14 = XEXP (x13, 2);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  x15 = XEXP (x12, 1);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x11, 1);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  x17 = XEXP (x10, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  x18 = XEXP (x9, 1);
  x19 = XEXP (x18, 0);
  x20 = XEXP (x19, 0);
  x21 = XEXP (x20, 2);
  if (!rtx_equal_p (x21, operands[3]))
    return -1;
  x22 = XEXP (x19, 1);
  if (!rtx_equal_p (x22, operands[1]))
    return -1;
  x23 = XEXP (x18, 1);
  if (!rtx_equal_p (x23, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern244 (x1, 
E_V2SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern244 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern244 (x1, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16SImode:
      if (pattern244 (x1, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V32SImode:
      if (pattern244 (x1, 
E_V32SImode) != 0)
        return -1;
      return 4;

    case E_V64SImode:
      if (pattern244 (x1, 
E_V64SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern88 (x2))
    {
    case 0:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8926; /* *xor_dpp_shr_v2qi */

    case 1:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8934; /* *xor_dpp_shr_v2hi */

    case 2:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8942; /* *xor_dpp_shr_v2si */

    case 3:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8950; /* *xor_dpp_shr_v2hf */

    case 4:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8958; /* *xor_dpp_shr_v2sf */

    case 5:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8966; /* *xor_dpp_shr_v4qi */

    case 6:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8974; /* *xor_dpp_shr_v4hi */

    case 7:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8982; /* *xor_dpp_shr_v4si */

    case 8:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8990; /* *xor_dpp_shr_v4hf */

    case 9:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8998; /* *xor_dpp_shr_v4sf */

    case 10:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9006; /* *xor_dpp_shr_v8qi */

    case 11:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9014; /* *xor_dpp_shr_v8hi */

    case 12:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9022; /* *xor_dpp_shr_v8si */

    case 13:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9030; /* *xor_dpp_shr_v8hf */

    case 14:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9038; /* *xor_dpp_shr_v8sf */

    case 15:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9046; /* *xor_dpp_shr_v16qi */

    case 16:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9054; /* *xor_dpp_shr_v16hi */

    case 17:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9062; /* *xor_dpp_shr_v16si */

    case 18:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9070; /* *xor_dpp_shr_v16hf */

    case 19:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9078; /* *xor_dpp_shr_v16sf */

    case 20:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9086; /* *xor_dpp_shr_v32qi */

    case 21:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9094; /* *xor_dpp_shr_v32hi */

    case 22:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9102; /* *xor_dpp_shr_v32si */

    case 23:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9110; /* *xor_dpp_shr_v32hf */

    case 24:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9118; /* *xor_dpp_shr_v32sf */

    case 25:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9126; /* *xor_dpp_shr_v64qi */

    case 26:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9134; /* *xor_dpp_shr_v64hi */

    case 27:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9142; /* *xor_dpp_shr_v64si */

    case 28:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9150; /* *xor_dpp_shr_v64hf */

    case 29:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9158; /* *xor_dpp_shr_v64sf */

    case 30:
      return 9162; /* *xor_dpp_shr_v2di */

    case 31:
      return 9166; /* *xor_dpp_shr_v4di */

    case 32:
      return 9170; /* *xor_dpp_shr_v8di */

    case 33:
      return 9174; /* *xor_dpp_shr_v16di */

    case 34:
      return 9178; /* *xor_dpp_shr_v32di */

    case 35:
      return 9182; /* *xor_dpp_shr_v64di */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  switch (XINT (x2, 1))
    {
    case 2:
      return recog_9 (x1, insn, pnum_clobbers);

    case 40:
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern136 (x2, 
E_V2HFmode) != 0)
            return -1;
          return 3081; /* div_fixupv2hf */

        case E_V2SFmode:
          if (pattern136 (x2, 
E_V2SFmode) != 0)
            return -1;
          return 3083; /* div_fixupv2sf */

        case E_V2DFmode:
          if (pattern136 (x2, 
E_V2DFmode) != 0)
            return -1;
          return 3085; /* div_fixupv2df */

        case E_V4HFmode:
          if (pattern136 (x2, 
E_V4HFmode) != 0)
            return -1;
          return 3087; /* div_fixupv4hf */

        case E_V4SFmode:
          if (pattern136 (x2, 
E_V4SFmode) != 0)
            return -1;
          return 3089; /* div_fixupv4sf */

        case E_V4DFmode:
          if (pattern136 (x2, 
E_V4DFmode) != 0)
            return -1;
          return 3091; /* div_fixupv4df */

        case E_V8HFmode:
          if (pattern136 (x2, 
E_V8HFmode) != 0)
            return -1;
          return 3093; /* div_fixupv8hf */

        case E_V8SFmode:
          if (pattern136 (x2, 
E_V8SFmode) != 0)
            return -1;
          return 3095; /* div_fixupv8sf */

        case E_V8DFmode:
          if (pattern136 (x2, 
E_V8DFmode) != 0)
            return -1;
          return 3097; /* div_fixupv8df */

        case E_V16HFmode:
          if (pattern136 (x2, 
E_V16HFmode) != 0)
            return -1;
          return 3099; /* div_fixupv16hf */

        case E_V16SFmode:
          if (pattern136 (x2, 
E_V16SFmode) != 0)
            return -1;
          return 3101; /* div_fixupv16sf */

        case E_V16DFmode:
          if (pattern136 (x2, 
E_V16DFmode) != 0)
            return -1;
          return 3103; /* div_fixupv16df */

        case E_V32HFmode:
          if (pattern136 (x2, 
E_V32HFmode) != 0)
            return -1;
          return 3105; /* div_fixupv32hf */

        case E_V32SFmode:
          if (pattern136 (x2, 
E_V32SFmode) != 0)
            return -1;
          return 3107; /* div_fixupv32sf */

        case E_V32DFmode:
          if (pattern136 (x2, 
E_V32DFmode) != 0)
            return -1;
          return 3109; /* div_fixupv32df */

        case E_V64HFmode:
          if (pattern136 (x2, 
E_V64HFmode) != 0)
            return -1;
          return 3111; /* div_fixupv64hf */

        case E_V64SFmode:
          if (pattern136 (x2, 
E_V64SFmode) != 0)
            return -1;
          return 3113; /* div_fixupv64sf */

        case E_V64DFmode:
          if (pattern136 (x2, 
E_V64DFmode) != 0)
            return -1;
          return 3115; /* div_fixupv64df */

        default:
          return -1;
        }

    case 5:
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8919; /* *smin_dpp_shr_v2qi */

        case 1:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8927; /* *smin_dpp_shr_v2hi */

        case 2:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8935; /* *smin_dpp_shr_v2si */

        case 3:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8943; /* *smin_dpp_shr_v2hf */

        case 4:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8951; /* *smin_dpp_shr_v2sf */

        case 5:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8959; /* *smin_dpp_shr_v4qi */

        case 6:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8967; /* *smin_dpp_shr_v4hi */

        case 7:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8975; /* *smin_dpp_shr_v4si */

        case 8:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8983; /* *smin_dpp_shr_v4hf */

        case 9:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8991; /* *smin_dpp_shr_v4sf */

        case 10:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8999; /* *smin_dpp_shr_v8qi */

        case 11:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9007; /* *smin_dpp_shr_v8hi */

        case 12:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9015; /* *smin_dpp_shr_v8si */

        case 13:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9023; /* *smin_dpp_shr_v8hf */

        case 14:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9031; /* *smin_dpp_shr_v8sf */

        case 15:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9039; /* *smin_dpp_shr_v16qi */

        case 16:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9047; /* *smin_dpp_shr_v16hi */

        case 17:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9055; /* *smin_dpp_shr_v16si */

        case 18:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9063; /* *smin_dpp_shr_v16hf */

        case 19:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9071; /* *smin_dpp_shr_v16sf */

        case 20:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9079; /* *smin_dpp_shr_v32qi */

        case 21:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9087; /* *smin_dpp_shr_v32hi */

        case 22:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9095; /* *smin_dpp_shr_v32si */

        case 23:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9103; /* *smin_dpp_shr_v32hf */

        case 24:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9111; /* *smin_dpp_shr_v32sf */

        case 25:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9119; /* *smin_dpp_shr_v64qi */

        case 26:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9127; /* *smin_dpp_shr_v64hi */

        case 27:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9135; /* *smin_dpp_shr_v64si */

        case 28:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9143; /* *smin_dpp_shr_v64hf */

        case 29:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9151; /* *smin_dpp_shr_v64sf */

        default:
          return -1;
        }

    case 6:
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8920; /* *smax_dpp_shr_v2qi */

        case 1:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8928; /* *smax_dpp_shr_v2hi */

        case 2:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8936; /* *smax_dpp_shr_v2si */

        case 3:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8944; /* *smax_dpp_shr_v2hf */

        case 4:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8952; /* *smax_dpp_shr_v2sf */

        case 5:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8960; /* *smax_dpp_shr_v4qi */

        case 6:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8968; /* *smax_dpp_shr_v4hi */

        case 7:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8976; /* *smax_dpp_shr_v4si */

        case 8:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8984; /* *smax_dpp_shr_v4hf */

        case 9:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8992; /* *smax_dpp_shr_v4sf */

        case 10:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9000; /* *smax_dpp_shr_v8qi */

        case 11:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9008; /* *smax_dpp_shr_v8hi */

        case 12:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9016; /* *smax_dpp_shr_v8si */

        case 13:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9024; /* *smax_dpp_shr_v8hf */

        case 14:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9032; /* *smax_dpp_shr_v8sf */

        case 15:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9040; /* *smax_dpp_shr_v16qi */

        case 16:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9048; /* *smax_dpp_shr_v16hi */

        case 17:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9056; /* *smax_dpp_shr_v16si */

        case 18:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9064; /* *smax_dpp_shr_v16hf */

        case 19:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9072; /* *smax_dpp_shr_v16sf */

        case 20:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9080; /* *smax_dpp_shr_v32qi */

        case 21:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9088; /* *smax_dpp_shr_v32hi */

        case 22:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9096; /* *smax_dpp_shr_v32si */

        case 23:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9104; /* *smax_dpp_shr_v32hf */

        case 24:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9112; /* *smax_dpp_shr_v32sf */

        case 25:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9120; /* *smax_dpp_shr_v64qi */

        case 26:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9128; /* *smax_dpp_shr_v64hi */

        case 27:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9136; /* *smax_dpp_shr_v64si */

        case 28:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9144; /* *smax_dpp_shr_v64hf */

        case 29:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9152; /* *smax_dpp_shr_v64sf */

        default:
          return -1;
        }

    case 7:
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8921; /* *umin_dpp_shr_v2qi */

        case 1:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8929; /* *umin_dpp_shr_v2hi */

        case 2:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8937; /* *umin_dpp_shr_v2si */

        case 3:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8945; /* *umin_dpp_shr_v2hf */

        case 4:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8953; /* *umin_dpp_shr_v2sf */

        case 5:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8961; /* *umin_dpp_shr_v4qi */

        case 6:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8969; /* *umin_dpp_shr_v4hi */

        case 7:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8977; /* *umin_dpp_shr_v4si */

        case 8:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8985; /* *umin_dpp_shr_v4hf */

        case 9:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8993; /* *umin_dpp_shr_v4sf */

        case 10:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9001; /* *umin_dpp_shr_v8qi */

        case 11:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9009; /* *umin_dpp_shr_v8hi */

        case 12:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9017; /* *umin_dpp_shr_v8si */

        case 13:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9025; /* *umin_dpp_shr_v8hf */

        case 14:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9033; /* *umin_dpp_shr_v8sf */

        case 15:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9041; /* *umin_dpp_shr_v16qi */

        case 16:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9049; /* *umin_dpp_shr_v16hi */

        case 17:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9057; /* *umin_dpp_shr_v16si */

        case 18:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9065; /* *umin_dpp_shr_v16hf */

        case 19:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9073; /* *umin_dpp_shr_v16sf */

        case 20:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9081; /* *umin_dpp_shr_v32qi */

        case 21:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9089; /* *umin_dpp_shr_v32hi */

        case 22:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9097; /* *umin_dpp_shr_v32si */

        case 23:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9105; /* *umin_dpp_shr_v32hf */

        case 24:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9113; /* *umin_dpp_shr_v32sf */

        case 25:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9121; /* *umin_dpp_shr_v64qi */

        case 26:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9129; /* *umin_dpp_shr_v64hi */

        case 27:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9137; /* *umin_dpp_shr_v64si */

        case 28:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9145; /* *umin_dpp_shr_v64hf */

        case 29:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9153; /* *umin_dpp_shr_v64sf */

        default:
          return -1;
        }

    case 8:
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8922; /* *umax_dpp_shr_v2qi */

        case 1:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8930; /* *umax_dpp_shr_v2hi */

        case 2:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8938; /* *umax_dpp_shr_v2si */

        case 3:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8946; /* *umax_dpp_shr_v2hf */

        case 4:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8954; /* *umax_dpp_shr_v2sf */

        case 5:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8962; /* *umax_dpp_shr_v4qi */

        case 6:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8970; /* *umax_dpp_shr_v4hi */

        case 7:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8978; /* *umax_dpp_shr_v4si */

        case 8:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8986; /* *umax_dpp_shr_v4hf */

        case 9:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8994; /* *umax_dpp_shr_v4sf */

        case 10:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9002; /* *umax_dpp_shr_v8qi */

        case 11:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9010; /* *umax_dpp_shr_v8hi */

        case 12:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9018; /* *umax_dpp_shr_v8si */

        case 13:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9026; /* *umax_dpp_shr_v8hf */

        case 14:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9034; /* *umax_dpp_shr_v8sf */

        case 15:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9042; /* *umax_dpp_shr_v16qi */

        case 16:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9050; /* *umax_dpp_shr_v16hi */

        case 17:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9058; /* *umax_dpp_shr_v16si */

        case 18:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9066; /* *umax_dpp_shr_v16hf */

        case 19:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9074; /* *umax_dpp_shr_v16sf */

        case 20:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9082; /* *umax_dpp_shr_v32qi */

        case 21:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9090; /* *umax_dpp_shr_v32hi */

        case 22:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9098; /* *umax_dpp_shr_v32si */

        case 23:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9106; /* *umax_dpp_shr_v32hf */

        case 24:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9114; /* *umax_dpp_shr_v32sf */

        case 25:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9122; /* *umax_dpp_shr_v64qi */

        case 26:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9130; /* *umax_dpp_shr_v64hi */

        case 27:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9138; /* *umax_dpp_shr_v64si */

        case 28:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9146; /* *umax_dpp_shr_v64hf */

        case 29:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9154; /* *umax_dpp_shr_v64sf */

        default:
          return -1;
        }

    case 9:
      switch (pattern88 (x2))
        {
        case 0:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8923; /* *plus_dpp_shr_v2qi */

        case 1:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8931; /* *plus_dpp_shr_v2hi */

        case 2:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8939; /* *plus_dpp_shr_v2si */

        case 3:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8947; /* *plus_dpp_shr_v2hf */

        case 4:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8955; /* *plus_dpp_shr_v2sf */

        case 5:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8963; /* *plus_dpp_shr_v4qi */

        case 6:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8971; /* *plus_dpp_shr_v4hi */

        case 7:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8979; /* *plus_dpp_shr_v4si */

        case 8:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8987; /* *plus_dpp_shr_v4hf */

        case 9:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 8995; /* *plus_dpp_shr_v4sf */

        case 10:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9003; /* *plus_dpp_shr_v8qi */

        case 11:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9011; /* *plus_dpp_shr_v8hi */

        case 12:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9019; /* *plus_dpp_shr_v8si */

        case 13:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9027; /* *plus_dpp_shr_v8hf */

        case 14:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9035; /* *plus_dpp_shr_v8sf */

        case 15:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9043; /* *plus_dpp_shr_v16qi */

        case 16:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9051; /* *plus_dpp_shr_v16hi */

        case 17:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9059; /* *plus_dpp_shr_v16si */

        case 18:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9067; /* *plus_dpp_shr_v16hf */

        case 19:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9075; /* *plus_dpp_shr_v16sf */

        case 20:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9083; /* *plus_dpp_shr_v32qi */

        case 21:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9091; /* *plus_dpp_shr_v32hi */

        case 22:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9099; /* *plus_dpp_shr_v32si */

        case 23:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9107; /* *plus_dpp_shr_v32hf */

        case 24:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9115; /* *plus_dpp_shr_v32sf */

        case 25:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9123; /* *plus_dpp_shr_v64qi */

        case 26:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9131; /* *plus_dpp_shr_v64hi */

        case 27:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9139; /* *plus_dpp_shr_v64si */

        case 28:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9147; /* *plus_dpp_shr_v64hf */

        case 29:
          if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9155; /* *plus_dpp_shr_v64sf */

        case 30:
          return 9159; /* *plus_dpp_shr_v2di */

        case 31:
          return 9163; /* *plus_dpp_shr_v4di */

        case 32:
          return 9167; /* *plus_dpp_shr_v8di */

        case 33:
          return 9171; /* *plus_dpp_shr_v16di */

        case 34:
          return 9175; /* *plus_dpp_shr_v32di */

        case 35:
          return 9179; /* *plus_dpp_shr_v64di */

        default:
          return -1;
        }

    case 12:
      return recog_12 (x1, insn, pnum_clobbers);

    case 13:
      return recog_11 (x1, insn, pnum_clobbers);

    case 14:
      return recog_10 (x1, insn, pnum_clobbers);

    case 10:
      return recog_8 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern144 (x2, 
E_V32SImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5788; /* *truncv2qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8236; /* *truncv2qiv32si_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5792; /* *truncv2hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8242; /* *truncv2hiv32si_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5796; /* *truncv2siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8248; /* *truncv2siv32si_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5800; /* *truncv4qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8254; /* *truncv4qiv32si_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5804; /* *truncv4hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8260; /* *truncv4hiv32si_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5808; /* *truncv4siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8266; /* *truncv4siv32si_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5812; /* *truncv8qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8272; /* *truncv8qiv32si_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5816; /* *truncv8hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8278; /* *truncv8hiv32si_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5820; /* *truncv8siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8284; /* *truncv8siv32si_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5824; /* *truncv16qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8290; /* *truncv16qiv32si_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5828; /* *truncv16hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8296; /* *truncv16hiv32si_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5832; /* *truncv16siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8302; /* *truncv16siv32si_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5836; /* *truncv32qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8308; /* *truncv32qiv32si_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5840; /* *truncv32hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8314; /* *truncv32hiv32si_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5844; /* *truncv32siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8320; /* *truncv32siv32si_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5848; /* *truncv64qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8326; /* *truncv64qiv32si_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5852; /* *truncv64hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8332; /* *truncv64hiv32si_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5856; /* *truncv64siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8338; /* *truncv64siv32si_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V32DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V32SImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8699; /* truncv32div32si2_exec */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern142 (x2, 
E_V8SImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5356; /* *truncv2qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7588; /* *truncv2qiv8si_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5360; /* *truncv2hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7594; /* *truncv2hiv8si_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5364; /* *truncv2siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7600; /* *truncv2siv8si_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5368; /* *truncv4qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7606; /* *truncv4qiv8si_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5372; /* *truncv4hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7612; /* *truncv4hiv8si_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5376; /* *truncv4siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7618; /* *truncv4siv8si_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5380; /* *truncv8qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7624; /* *truncv8qiv8si_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5384; /* *truncv8hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7630; /* *truncv8hiv8si_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5388; /* *truncv8siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7636; /* *truncv8siv8si_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5392; /* *truncv16qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7642; /* *truncv16qiv8si_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5396; /* *truncv16hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7648; /* *truncv16hiv8si_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5400; /* *truncv16siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7654; /* *truncv16siv8si_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5404; /* *truncv32qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7660; /* *truncv32qiv8si_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5408; /* *truncv32hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7666; /* *truncv32hiv8si_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5412; /* *truncv32siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7672; /* *truncv32siv8si_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5416; /* *truncv64qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7678; /* *truncv64qiv8si_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5420; /* *truncv64hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7684; /* *truncv64hiv8si_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5424; /* *truncv64siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7690; /* *truncv64siv8si_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V8DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V8SImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8693; /* truncv8div8si2_exec */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x8 = XEXP (x2, 2);
      operands[4] = x8;
      if (!gcn_exec_reg_operand (operands[4], E_DImode))
        return -1;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          switch (pattern172 (x2, 
SIGN_EXTEND))
            {
            case 0:
              return 1624; /* smulv2si3_highpart_exec */

            case 1:
              return 1628; /* smulv4si3_highpart_exec */

            case 2:
              return 1632; /* smulv8si3_highpart_exec */

            case 3:
              return 1636; /* smulv16si3_highpart_exec */

            case 4:
              return 1640; /* smulv32si3_highpart_exec */

            case 5:
              return 1644; /* smulv64si3_highpart_exec */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern172 (x2, 
ZERO_EXTEND))
            {
            case 0:
              return 1626; /* umulv2si3_highpart_exec */

            case 1:
              return 1630; /* umulv4si3_highpart_exec */

            case 2:
              return 1634; /* umulv8si3_highpart_exec */

            case 3:
              return 1638; /* umulv16si3_highpart_exec */

            case 4:
              return 1642; /* umulv32si3_highpart_exec */

            case 5:
              return 1646; /* umulv64si3_highpart_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          switch (pattern140 (x2, 
E_V2QImode))
            {
            case 0:
              if (!gcn_alu_operand (operands[1], E_V2QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4780; /* *truncv2qiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6724; /* *truncv2qiv2qi_shift_exec */

            case 1:
              if (!gcn_alu_operand (operands[1], E_V2HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4784; /* *truncv2hiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6730; /* *truncv2hiv2qi_shift_exec */

            case 2:
              if (!gcn_alu_operand (operands[1], E_V2SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4788; /* *truncv2siv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6736; /* *truncv2siv2qi_shift_exec */

            case 3:
              if (!gcn_alu_operand (operands[1], E_V4QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4792; /* *truncv4qiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6742; /* *truncv4qiv2qi_shift_exec */

            case 4:
              if (!gcn_alu_operand (operands[1], E_V4HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4796; /* *truncv4hiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6748; /* *truncv4hiv2qi_shift_exec */

            case 5:
              if (!gcn_alu_operand (operands[1], E_V4SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4800; /* *truncv4siv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6754; /* *truncv4siv2qi_shift_exec */

            case 6:
              if (!gcn_alu_operand (operands[1], E_V8QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4804; /* *truncv8qiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6760; /* *truncv8qiv2qi_shift_exec */

            case 7:
              if (!gcn_alu_operand (operands[1], E_V8HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4808; /* *truncv8hiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6766; /* *truncv8hiv2qi_shift_exec */

            case 8:
              if (!gcn_alu_operand (operands[1], E_V8SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4812; /* *truncv8siv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6772; /* *truncv8siv2qi_shift_exec */

            case 9:
              if (!gcn_alu_operand (operands[1], E_V16QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4816; /* *truncv16qiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6778; /* *truncv16qiv2qi_shift_exec */

            case 10:
              if (!gcn_alu_operand (operands[1], E_V16HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4820; /* *truncv16hiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6784; /* *truncv16hiv2qi_shift_exec */

            case 11:
              if (!gcn_alu_operand (operands[1], E_V16SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4824; /* *truncv16siv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6790; /* *truncv16siv2qi_shift_exec */

            case 12:
              if (!gcn_alu_operand (operands[1], E_V32QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4828; /* *truncv32qiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6796; /* *truncv32qiv2qi_shift_exec */

            case 13:
              if (!gcn_alu_operand (operands[1], E_V32HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4832; /* *truncv32hiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6802; /* *truncv32hiv2qi_shift_exec */

            case 14:
              if (!gcn_alu_operand (operands[1], E_V32SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4836; /* *truncv32siv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6808; /* *truncv32siv2qi_shift_exec */

            case 15:
              if (!gcn_alu_operand (operands[1], E_V64QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4840; /* *truncv64qiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6814; /* *truncv64qiv2qi_shift_exec */

            case 16:
              if (!gcn_alu_operand (operands[1], E_V64HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4844; /* *truncv64hiv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6820; /* *truncv64hiv2qi_shift_exec */

            case 17:
              if (!gcn_alu_operand (operands[1], E_V64SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4848; /* *truncv64siv2qi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6826; /* *truncv64siv2qi_shift_exec */

            case 18:
              if (!gcn_alu_operand (operands[1], E_V2DImode)
                  || !gcn_alu_or_unspec_operand (operands[2], E_V2QImode)
                  || !gcn_exec_operand (operands[3], E_DImode))
                return -1;
              return 8685; /* truncv2div2qi2_exec */

            default:
              return -1;
            }

        case E_V2HImode:
          switch (pattern140 (x2, 
E_V2HImode))
            {
            case 0:
              if (!gcn_alu_operand (operands[1], E_V2QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4852; /* *truncv2qiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6832; /* *truncv2qiv2hi_shift_exec */

            case 1:
              if (!gcn_alu_operand (operands[1], E_V2HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4856; /* *truncv2hiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6838; /* *truncv2hiv2hi_shift_exec */

            case 2:
              if (!gcn_alu_operand (operands[1], E_V2SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4860; /* *truncv2siv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6844; /* *truncv2siv2hi_shift_exec */

            case 3:
              if (!gcn_alu_operand (operands[1], E_V4QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4864; /* *truncv4qiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6850; /* *truncv4qiv2hi_shift_exec */

            case 4:
              if (!gcn_alu_operand (operands[1], E_V4HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4868; /* *truncv4hiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6856; /* *truncv4hiv2hi_shift_exec */

            case 5:
              if (!gcn_alu_operand (operands[1], E_V4SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4872; /* *truncv4siv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6862; /* *truncv4siv2hi_shift_exec */

            case 6:
              if (!gcn_alu_operand (operands[1], E_V8QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4876; /* *truncv8qiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6868; /* *truncv8qiv2hi_shift_exec */

            case 7:
              if (!gcn_alu_operand (operands[1], E_V8HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4880; /* *truncv8hiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6874; /* *truncv8hiv2hi_shift_exec */

            case 8:
              if (!gcn_alu_operand (operands[1], E_V8SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4884; /* *truncv8siv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6880; /* *truncv8siv2hi_shift_exec */

            case 9:
              if (!gcn_alu_operand (operands[1], E_V16QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4888; /* *truncv16qiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6886; /* *truncv16qiv2hi_shift_exec */

            case 10:
              if (!gcn_alu_operand (operands[1], E_V16HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4892; /* *truncv16hiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6892; /* *truncv16hiv2hi_shift_exec */

            case 11:
              if (!gcn_alu_operand (operands[1], E_V16SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4896; /* *truncv16siv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6898; /* *truncv16siv2hi_shift_exec */

            case 12:
              if (!gcn_alu_operand (operands[1], E_V32QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4900; /* *truncv32qiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6904; /* *truncv32qiv2hi_shift_exec */

            case 13:
              if (!gcn_alu_operand (operands[1], E_V32HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4904; /* *truncv32hiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6910; /* *truncv32hiv2hi_shift_exec */

            case 14:
              if (!gcn_alu_operand (operands[1], E_V32SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4908; /* *truncv32siv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6916; /* *truncv32siv2hi_shift_exec */

            case 15:
              if (!gcn_alu_operand (operands[1], E_V64QImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4912; /* *truncv64qiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6922; /* *truncv64qiv2hi_shift_exec */

            case 16:
              if (!gcn_alu_operand (operands[1], E_V64HImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4916; /* *truncv64hiv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6928; /* *truncv64hiv2hi_shift_exec */

            case 17:
              if (!gcn_alu_operand (operands[1], E_V64SImode)
                  || !gcn_register_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_reg_operand (operands[3], E_DImode))
                return -1;
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4920; /* *truncv64siv2hi_sdwa_exec */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6934; /* *truncv64siv2hi_shift_exec */

            case 18:
              if (!gcn_alu_operand (operands[1], E_V2DImode)
                  || !gcn_alu_or_unspec_operand (operands[2], E_V2HImode)
                  || !gcn_exec_operand (operands[3], E_DImode))
                return -1;
              return 8686; /* truncv2div2hi2_exec */

            default:
              return -1;
            }

        case E_V2SImode:
          return recog_47 (x1, insn, pnum_clobbers);

        case E_V4QImode:
          return recog_46 (x1, insn, pnum_clobbers);

        case E_V4HImode:
          return recog_45 (x1, insn, pnum_clobbers);

        case E_V4SImode:
          return recog_44 (x1, insn, pnum_clobbers);

        case E_V8QImode:
          return recog_43 (x1, insn, pnum_clobbers);

        case E_V8HImode:
          return recog_42 (x1, insn, pnum_clobbers);

        case E_V8SImode:
          return recog_41 (x1, insn, pnum_clobbers);

        case E_V16QImode:
          return recog_40 (x1, insn, pnum_clobbers);

        case E_V16HImode:
          return recog_39 (x1, insn, pnum_clobbers);

        case E_V16SImode:
          return recog_38 (x1, insn, pnum_clobbers);

        case E_V32QImode:
          return recog_37 (x1, insn, pnum_clobbers);

        case E_V32HImode:
          return recog_36 (x1, insn, pnum_clobbers);

        case E_V32SImode:
          return recog_35 (x1, insn, pnum_clobbers);

        case E_V64QImode:
          return recog_34 (x1, insn, pnum_clobbers);

        case E_V64HImode:
          return recog_33 (x1, insn, pnum_clobbers);

        case E_V64SImode:
          return recog_32 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern63 (x2))
    {
    case 0:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3268; /* fix_truncv2hiv2hf2_exec */

    case 1:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3280; /* fix_truncv2siv2hf2_exec */

    case 2:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3292; /* fix_truncv2hfv2hf2_exec */

    case 3:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3304; /* fix_truncv2sfv2hf2_exec */

    case 4:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3316; /* fix_truncv2dfv2hf2_exec */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3328; /* fix_truncv2hiv2sf2_exec */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3340; /* fix_truncv2siv2sf2_exec */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3352; /* fix_truncv2hfv2sf2_exec */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3364; /* fix_truncv2sfv2sf2_exec */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3376; /* fix_truncv2dfv2sf2_exec */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3388; /* fix_truncv2hiv2df2_exec */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3400; /* fix_truncv2siv2df2_exec */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3412; /* fix_truncv2hfv2df2_exec */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3424; /* fix_truncv2sfv2df2_exec */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3436; /* fix_truncv2dfv2df2_exec */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3448; /* fix_truncv4hiv4hf2_exec */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3460; /* fix_truncv4siv4hf2_exec */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3472; /* fix_truncv4hfv4hf2_exec */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3484; /* fix_truncv4sfv4hf2_exec */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3496; /* fix_truncv4dfv4hf2_exec */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3508; /* fix_truncv4hiv4sf2_exec */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3520; /* fix_truncv4siv4sf2_exec */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3532; /* fix_truncv4hfv4sf2_exec */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3544; /* fix_truncv4sfv4sf2_exec */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3556; /* fix_truncv4dfv4sf2_exec */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3568; /* fix_truncv4hiv4df2_exec */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3580; /* fix_truncv4siv4df2_exec */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3592; /* fix_truncv4hfv4df2_exec */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3604; /* fix_truncv4sfv4df2_exec */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3616; /* fix_truncv4dfv4df2_exec */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3628; /* fix_truncv8hiv8hf2_exec */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3640; /* fix_truncv8siv8hf2_exec */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3652; /* fix_truncv8hfv8hf2_exec */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3664; /* fix_truncv8sfv8hf2_exec */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3676; /* fix_truncv8dfv8hf2_exec */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3688; /* fix_truncv8hiv8sf2_exec */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3700; /* fix_truncv8siv8sf2_exec */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3712; /* fix_truncv8hfv8sf2_exec */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3724; /* fix_truncv8sfv8sf2_exec */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3736; /* fix_truncv8dfv8sf2_exec */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3748; /* fix_truncv8hiv8df2_exec */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3760; /* fix_truncv8siv8df2_exec */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3772; /* fix_truncv8hfv8df2_exec */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3784; /* fix_truncv8sfv8df2_exec */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3796; /* fix_truncv8dfv8df2_exec */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3808; /* fix_truncv16hiv16hf2_exec */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3820; /* fix_truncv16siv16hf2_exec */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3832; /* fix_truncv16hfv16hf2_exec */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3844; /* fix_truncv16sfv16hf2_exec */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3856; /* fix_truncv16dfv16hf2_exec */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3868; /* fix_truncv16hiv16sf2_exec */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3880; /* fix_truncv16siv16sf2_exec */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3892; /* fix_truncv16hfv16sf2_exec */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3904; /* fix_truncv16sfv16sf2_exec */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3916; /* fix_truncv16dfv16sf2_exec */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3928; /* fix_truncv16hiv16df2_exec */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3940; /* fix_truncv16siv16df2_exec */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3952; /* fix_truncv16hfv16df2_exec */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3964; /* fix_truncv16sfv16df2_exec */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3976; /* fix_truncv16dfv16df2_exec */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3988; /* fix_truncv32hiv32hf2_exec */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4000; /* fix_truncv32siv32hf2_exec */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4012; /* fix_truncv32hfv32hf2_exec */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4024; /* fix_truncv32sfv32hf2_exec */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4036; /* fix_truncv32dfv32hf2_exec */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4048; /* fix_truncv32hiv32sf2_exec */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4060; /* fix_truncv32siv32sf2_exec */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4072; /* fix_truncv32hfv32sf2_exec */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4084; /* fix_truncv32sfv32sf2_exec */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4096; /* fix_truncv32dfv32sf2_exec */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4108; /* fix_truncv32hiv32df2_exec */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4120; /* fix_truncv32siv32df2_exec */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4132; /* fix_truncv32hfv32df2_exec */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4144; /* fix_truncv32sfv32df2_exec */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4156; /* fix_truncv32dfv32df2_exec */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4168; /* fix_truncv64hiv64hf2_exec */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4180; /* fix_truncv64siv64hf2_exec */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4192; /* fix_truncv64hfv64hf2_exec */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4204; /* fix_truncv64sfv64hf2_exec */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4216; /* fix_truncv64dfv64hf2_exec */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4228; /* fix_truncv64hiv64sf2_exec */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4240; /* fix_truncv64siv64sf2_exec */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4252; /* fix_truncv64hfv64sf2_exec */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4264; /* fix_truncv64sfv64sf2_exec */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4276; /* fix_truncv64dfv64sf2_exec */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4288; /* fix_truncv64hiv64df2_exec */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4300; /* fix_truncv64siv64df2_exec */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4312; /* fix_truncv64hfv64df2_exec */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4324; /* fix_truncv64sfv64df2_exec */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4336; /* fix_truncv64dfv64df2_exec */

    case 90:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4348; /* fix_truncv2hfv2hi2_exec */

    case 91:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4360; /* fix_truncv2sfv2hi2_exec */

    case 92:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4372; /* fix_truncv2dfv2hi2_exec */

    case 93:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4384; /* fix_truncv2hfv2si2_exec */

    case 94:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4396; /* fix_truncv2sfv2si2_exec */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4408; /* fix_truncv2dfv2si2_exec */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4420; /* fix_truncv4hfv4hi2_exec */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4432; /* fix_truncv4sfv4hi2_exec */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4444; /* fix_truncv4dfv4hi2_exec */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4456; /* fix_truncv4hfv4si2_exec */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4468; /* fix_truncv4sfv4si2_exec */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4480; /* fix_truncv4dfv4si2_exec */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4492; /* fix_truncv8hfv8hi2_exec */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4504; /* fix_truncv8sfv8hi2_exec */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4516; /* fix_truncv8dfv8hi2_exec */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4528; /* fix_truncv8hfv8si2_exec */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4540; /* fix_truncv8sfv8si2_exec */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4552; /* fix_truncv8dfv8si2_exec */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4564; /* fix_truncv16hfv16hi2_exec */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4576; /* fix_truncv16sfv16hi2_exec */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4588; /* fix_truncv16dfv16hi2_exec */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4600; /* fix_truncv16hfv16si2_exec */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4612; /* fix_truncv16sfv16si2_exec */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4624; /* fix_truncv16dfv16si2_exec */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4636; /* fix_truncv32hfv32hi2_exec */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4648; /* fix_truncv32sfv32hi2_exec */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4660; /* fix_truncv32dfv32hi2_exec */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4672; /* fix_truncv32hfv32si2_exec */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4684; /* fix_truncv32sfv32si2_exec */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4696; /* fix_truncv32dfv32si2_exec */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4708; /* fix_truncv64hfv64hi2_exec */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4720; /* fix_truncv64sfv64hi2_exec */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4732; /* fix_truncv64dfv64hi2_exec */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4744; /* fix_truncv64hfv64si2_exec */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4756; /* fix_truncv64sfv64si2_exec */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4768; /* fix_truncv64dfv64si2_exec */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern25 (x1))
    {
    case 0:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HImode,
		    floatuns_cvt)))
        return 3120; /* floatunshihi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HImode,
		    floatuns_cvt)))
        return 3126; /* floatunssihi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HImode,
		    floatuns_cvt)))
        return 3132; /* floatunshfhi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HImode,
		    floatuns_cvt)))
        return 3138; /* floatunssfhi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HImode,
		    floatuns_cvt)))
        return -1;
      return 3144; /* floatunsdfhi2 */

    case 1:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SImode,
		    floatuns_cvt)))
        return 3150; /* floatunshisi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SImode,
		    floatuns_cvt)))
        return 3156; /* floatunssisi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SImode,
		    floatuns_cvt)))
        return 3162; /* floatunshfsi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SImode,
		    floatuns_cvt)))
        return 3168; /* floatunssfsi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SImode,
		    floatuns_cvt)))
        return -1;
      return 3174; /* floatunsdfsi2 */

    case 2:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HFmode,
		    floatuns_cvt)))
        return 3180; /* floatunshihf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HFmode,
		    floatuns_cvt)))
        return 3186; /* floatunssihf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HFmode,
		    floatuns_cvt)))
        return 3192; /* floatunshfhf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HFmode,
		    floatuns_cvt)))
        return 3198; /* floatunssfhf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HFmode,
		    floatuns_cvt)))
        return -1;
      return 3204; /* floatunsdfhf2 */

    case 3:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SFmode,
		    floatuns_cvt)))
        return 3210; /* floatunshisf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SFmode,
		    floatuns_cvt)))
        return 3216; /* floatunssisf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SFmode,
		    floatuns_cvt)))
        return 3222; /* floatunshfsf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SFmode,
		    floatuns_cvt)))
        return 3228; /* floatunssfsf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SFmode,
		    floatuns_cvt)))
        return -1;
      return 3234; /* floatunsdfsf2 */

    case 4:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, DFmode,
		    floatuns_cvt)))
        return 3240; /* floatunshidf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, DFmode,
		    floatuns_cvt)))
        return 3246; /* floatunssidf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, DFmode,
		    floatuns_cvt)))
        return 3252; /* floatunshfdf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, DFmode,
		    floatuns_cvt)))
        return 3258; /* floatunssfdf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, DFmode,
		    floatuns_cvt)))
        return -1;
      return 3264; /* floatunsdfdf2 */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3273; /* floatunsv2hiv2hf2 */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3285; /* floatunsv2siv2hf2 */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3297; /* floatunsv2hfv2hf2 */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3309; /* floatunsv2sfv2hf2 */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3321; /* floatunsv2dfv2hf2 */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3333; /* floatunsv2hiv2sf2 */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3345; /* floatunsv2siv2sf2 */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3357; /* floatunsv2hfv2sf2 */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3369; /* floatunsv2sfv2sf2 */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3381; /* floatunsv2dfv2sf2 */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3393; /* floatunsv2hiv2df2 */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3405; /* floatunsv2siv2df2 */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3417; /* floatunsv2hfv2df2 */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3429; /* floatunsv2sfv2df2 */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3441; /* floatunsv2dfv2df2 */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3453; /* floatunsv4hiv4hf2 */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3465; /* floatunsv4siv4hf2 */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3477; /* floatunsv4hfv4hf2 */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3489; /* floatunsv4sfv4hf2 */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3501; /* floatunsv4dfv4hf2 */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3513; /* floatunsv4hiv4sf2 */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3525; /* floatunsv4siv4sf2 */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3537; /* floatunsv4hfv4sf2 */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3549; /* floatunsv4sfv4sf2 */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3561; /* floatunsv4dfv4sf2 */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3573; /* floatunsv4hiv4df2 */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3585; /* floatunsv4siv4df2 */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3597; /* floatunsv4hfv4df2 */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3609; /* floatunsv4sfv4df2 */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3621; /* floatunsv4dfv4df2 */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3633; /* floatunsv8hiv8hf2 */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3645; /* floatunsv8siv8hf2 */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3657; /* floatunsv8hfv8hf2 */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3669; /* floatunsv8sfv8hf2 */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3681; /* floatunsv8dfv8hf2 */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3693; /* floatunsv8hiv8sf2 */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3705; /* floatunsv8siv8sf2 */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3717; /* floatunsv8hfv8sf2 */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3729; /* floatunsv8sfv8sf2 */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3741; /* floatunsv8dfv8sf2 */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3753; /* floatunsv8hiv8df2 */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3765; /* floatunsv8siv8df2 */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3777; /* floatunsv8hfv8df2 */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3789; /* floatunsv8sfv8df2 */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3801; /* floatunsv8dfv8df2 */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3813; /* floatunsv16hiv16hf2 */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3825; /* floatunsv16siv16hf2 */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3837; /* floatunsv16hfv16hf2 */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3849; /* floatunsv16sfv16hf2 */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3861; /* floatunsv16dfv16hf2 */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3873; /* floatunsv16hiv16sf2 */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3885; /* floatunsv16siv16sf2 */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3897; /* floatunsv16hfv16sf2 */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3909; /* floatunsv16sfv16sf2 */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3921; /* floatunsv16dfv16sf2 */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3933; /* floatunsv16hiv16df2 */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3945; /* floatunsv16siv16df2 */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3957; /* floatunsv16hfv16df2 */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3969; /* floatunsv16sfv16df2 */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3981; /* floatunsv16dfv16df2 */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 3993; /* floatunsv32hiv32hf2 */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 4005; /* floatunsv32siv32hf2 */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 4017; /* floatunsv32hfv32hf2 */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 4029; /* floatunsv32sfv32hf2 */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 4041; /* floatunsv32dfv32hf2 */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4053; /* floatunsv32hiv32sf2 */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4065; /* floatunsv32siv32sf2 */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4077; /* floatunsv32hfv32sf2 */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4089; /* floatunsv32sfv32sf2 */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4101; /* floatunsv32dfv32sf2 */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4113; /* floatunsv32hiv32df2 */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4125; /* floatunsv32siv32df2 */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4137; /* floatunsv32hfv32df2 */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4149; /* floatunsv32sfv32df2 */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4161; /* floatunsv32dfv32df2 */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4173; /* floatunsv64hiv64hf2 */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4185; /* floatunsv64siv64hf2 */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4197; /* floatunsv64hfv64hf2 */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4209; /* floatunsv64sfv64hf2 */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4221; /* floatunsv64dfv64hf2 */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4233; /* floatunsv64hiv64sf2 */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4245; /* floatunsv64siv64sf2 */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4257; /* floatunsv64hfv64sf2 */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4269; /* floatunsv64sfv64sf2 */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4281; /* floatunsv64dfv64sf2 */

    case 90:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4293; /* floatunsv64hiv64df2 */

    case 91:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4305; /* floatunsv64siv64df2 */

    case 92:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4317; /* floatunsv64hfv64df2 */

    case 93:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4329; /* floatunsv64sfv64df2 */

    case 94:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4341; /* floatunsv64dfv64df2 */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       floatuns_cvt)))
        return -1;
      return 4353; /* floatunsv2hfv2hi2 */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       floatuns_cvt)))
        return -1;
      return 4365; /* floatunsv2sfv2hi2 */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       floatuns_cvt)))
        return -1;
      return 4377; /* floatunsv2dfv2hi2 */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       floatuns_cvt)))
        return -1;
      return 4389; /* floatunsv2hfv2si2 */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       floatuns_cvt)))
        return -1;
      return 4401; /* floatunsv2sfv2si2 */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       floatuns_cvt)))
        return -1;
      return 4413; /* floatunsv2dfv2si2 */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       floatuns_cvt)))
        return -1;
      return 4425; /* floatunsv4hfv4hi2 */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       floatuns_cvt)))
        return -1;
      return 4437; /* floatunsv4sfv4hi2 */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       floatuns_cvt)))
        return -1;
      return 4449; /* floatunsv4dfv4hi2 */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       floatuns_cvt)))
        return -1;
      return 4461; /* floatunsv4hfv4si2 */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       floatuns_cvt)))
        return -1;
      return 4473; /* floatunsv4sfv4si2 */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       floatuns_cvt)))
        return -1;
      return 4485; /* floatunsv4dfv4si2 */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       floatuns_cvt)))
        return -1;
      return 4497; /* floatunsv8hfv8hi2 */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       floatuns_cvt)))
        return -1;
      return 4509; /* floatunsv8sfv8hi2 */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       floatuns_cvt)))
        return -1;
      return 4521; /* floatunsv8dfv8hi2 */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       floatuns_cvt)))
        return -1;
      return 4533; /* floatunsv8hfv8si2 */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       floatuns_cvt)))
        return -1;
      return 4545; /* floatunsv8sfv8si2 */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       floatuns_cvt)))
        return -1;
      return 4557; /* floatunsv8dfv8si2 */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       floatuns_cvt)))
        return -1;
      return 4569; /* floatunsv16hfv16hi2 */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       floatuns_cvt)))
        return -1;
      return 4581; /* floatunsv16sfv16hi2 */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       floatuns_cvt)))
        return -1;
      return 4593; /* floatunsv16dfv16hi2 */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       floatuns_cvt)))
        return -1;
      return 4605; /* floatunsv16hfv16si2 */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       floatuns_cvt)))
        return -1;
      return 4617; /* floatunsv16sfv16si2 */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       floatuns_cvt)))
        return -1;
      return 4629; /* floatunsv16dfv16si2 */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       floatuns_cvt)))
        return -1;
      return 4641; /* floatunsv32hfv32hi2 */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       floatuns_cvt)))
        return -1;
      return 4653; /* floatunsv32sfv32hi2 */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       floatuns_cvt)))
        return -1;
      return 4665; /* floatunsv32dfv32hi2 */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       floatuns_cvt)))
        return -1;
      return 4677; /* floatunsv32hfv32si2 */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       floatuns_cvt)))
        return -1;
      return 4689; /* floatunsv32sfv32si2 */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       floatuns_cvt)))
        return -1;
      return 4701; /* floatunsv32dfv32si2 */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       floatuns_cvt)))
        return -1;
      return 4713; /* floatunsv64hfv64hi2 */

    case 126:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       floatuns_cvt)))
        return -1;
      return 4725; /* floatunsv64sfv64hi2 */

    case 127:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       floatuns_cvt)))
        return -1;
      return 4737; /* floatunsv64dfv64hi2 */

    case 128:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       floatuns_cvt)))
        return -1;
      return 4749; /* floatunsv64hfv64si2 */

    case 129:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       floatuns_cvt)))
        return -1;
      return 4761; /* floatunsv64sfv64si2 */

    case 130:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       floatuns_cvt)))
        return -1;
      return 4773; /* floatunsv64dfv64si2 */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !gcn_alu_operand (operands[1], E_QImode))
        return -1;
      return 369; /* vec_duplicatev2qi */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !gcn_alu_operand (operands[1], E_HImode))
        return -1;
      return 371; /* vec_duplicatev2hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 373; /* vec_duplicatev2si */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !gcn_alu_operand (operands[1], E_HFmode))
        return -1;
      return 375; /* vec_duplicatev2hf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !gcn_alu_operand (operands[1], E_SFmode))
        return -1;
      return 377; /* vec_duplicatev2sf */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !gcn_alu_operand (operands[1], E_QImode))
        return -1;
      return 379; /* vec_duplicatev4qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !gcn_alu_operand (operands[1], E_HImode))
        return -1;
      return 381; /* vec_duplicatev4hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 383; /* vec_duplicatev4si */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !gcn_alu_operand (operands[1], E_HFmode))
        return -1;
      return 385; /* vec_duplicatev4hf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gcn_alu_operand (operands[1], E_SFmode))
        return -1;
      return 387; /* vec_duplicatev4sf */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !gcn_alu_operand (operands[1], E_QImode))
        return -1;
      return 389; /* vec_duplicatev8qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !gcn_alu_operand (operands[1], E_HImode))
        return -1;
      return 391; /* vec_duplicatev8hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 393; /* vec_duplicatev8si */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !gcn_alu_operand (operands[1], E_HFmode))
        return -1;
      return 395; /* vec_duplicatev8hf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !gcn_alu_operand (operands[1], E_SFmode))
        return -1;
      return 397; /* vec_duplicatev8sf */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !gcn_alu_operand (operands[1], E_QImode))
        return -1;
      return 399; /* vec_duplicatev16qi */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !gcn_alu_operand (operands[1], E_HImode))
        return -1;
      return 401; /* vec_duplicatev16hi */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 403; /* vec_duplicatev16si */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !gcn_alu_operand (operands[1], E_HFmode))
        return -1;
      return 405; /* vec_duplicatev16hf */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !gcn_alu_operand (operands[1], E_SFmode))
        return -1;
      return 407; /* vec_duplicatev16sf */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !gcn_alu_operand (operands[1], E_QImode))
        return -1;
      return 409; /* vec_duplicatev32qi */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode
          || !gcn_alu_operand (operands[1], E_HImode))
        return -1;
      return 411; /* vec_duplicatev32hi */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x3) != E_V32SImode
          || !gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 413; /* vec_duplicatev32si */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !gcn_alu_operand (operands[1], E_HFmode))
        return -1;
      return 415; /* vec_duplicatev32hf */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !gcn_alu_operand (operands[1], E_SFmode))
        return -1;
      return 417; /* vec_duplicatev32sf */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x3) != E_V64QImode
          || !gcn_alu_operand (operands[1], E_QImode))
        return -1;
      return 419; /* vec_duplicatev64qi */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x3) != E_V64HImode
          || !gcn_alu_operand (operands[1], E_HImode))
        return -1;
      return 421; /* vec_duplicatev64hi */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x3) != E_V64SImode
          || !gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 423; /* vec_duplicatev64si */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !gcn_alu_operand (operands[1], E_HFmode))
        return -1;
      return 425; /* vec_duplicatev64hf */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !gcn_alu_operand (operands[1], E_SFmode))
        return -1;
      return 427; /* vec_duplicatev64sf */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !gcn_alu_operand (operands[1], E_DImode))
        return -1;
      return 429; /* vec_duplicatev2di */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !gcn_alu_operand (operands[1], E_DFmode))
        return -1;
      return 431; /* vec_duplicatev2df */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !gcn_alu_operand (operands[1], E_DImode))
        return -1;
      return 433; /* vec_duplicatev4di */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !gcn_alu_operand (operands[1], E_DFmode))
        return -1;
      return 435; /* vec_duplicatev4df */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !gcn_alu_operand (operands[1], E_DImode))
        return -1;
      return 437; /* vec_duplicatev8di */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !gcn_alu_operand (operands[1], E_DFmode))
        return -1;
      return 439; /* vec_duplicatev8df */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x3) != E_V16DImode
          || !gcn_alu_operand (operands[1], E_DImode))
        return -1;
      return 441; /* vec_duplicatev16di */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !gcn_alu_operand (operands[1], E_DFmode))
        return -1;
      return 443; /* vec_duplicatev16df */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x3) != E_V32DImode
          || !gcn_alu_operand (operands[1], E_DImode))
        return -1;
      return 445; /* vec_duplicatev32di */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !gcn_alu_operand (operands[1], E_DFmode))
        return -1;
      return 447; /* vec_duplicatev32df */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x3) != E_V64DImode
          || !gcn_alu_operand (operands[1], E_DImode))
        return -1;
      return 449; /* vec_duplicatev64di */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !gcn_alu_operand (operands[1], E_DFmode))
        return -1;
      return 451; /* vec_duplicatev64df */

    case E_V2TImode:
      if (!register_operand (operands[0], E_V2TImode)
          || GET_MODE (x3) != E_V2TImode
          || !gcn_alu_operand (operands[1], E_TImode))
        return -1;
      return 453; /* vec_duplicatev2ti */

    case E_V4TImode:
      if (!register_operand (operands[0], E_V4TImode)
          || GET_MODE (x3) != E_V4TImode
          || !gcn_alu_operand (operands[1], E_TImode))
        return -1;
      return 455; /* vec_duplicatev4ti */

    case E_V8TImode:
      if (!register_operand (operands[0], E_V8TImode)
          || GET_MODE (x3) != E_V8TImode
          || !gcn_alu_operand (operands[1], E_TImode))
        return -1;
      return 457; /* vec_duplicatev8ti */

    case E_V16TImode:
      if (!register_operand (operands[0], E_V16TImode)
          || GET_MODE (x3) != E_V16TImode
          || !gcn_alu_operand (operands[1], E_TImode))
        return -1;
      return 459; /* vec_duplicatev16ti */

    case E_V32TImode:
      if (!register_operand (operands[0], E_V32TImode)
          || GET_MODE (x3) != E_V32TImode
          || !gcn_alu_operand (operands[1], E_TImode))
        return -1;
      return 461; /* vec_duplicatev32ti */

    case E_V64TImode:
      if (!register_operand (operands[0], E_V64TImode)
          || GET_MODE (x3) != E_V64TImode
          || !gcn_alu_operand (operands[1], E_TImode))
        return -1;
      return 463; /* vec_duplicatev64ti */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_DUPLICATE:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern113 (x3, 
E_V2QImode, 
E_QImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1392; /* addv2qi3_dup */

        case E_V2HImode:
          if (pattern113 (x3, 
E_V2HImode, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1394; /* addv2hi3_dup */

        case E_V2SImode:
          if (pattern113 (x3, 
E_V2SImode, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1396; /* addv2si3_dup */

        case E_V4QImode:
          if (pattern113 (x3, 
E_V4QImode, 
E_QImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1398; /* addv4qi3_dup */

        case E_V4HImode:
          if (pattern113 (x3, 
E_V4HImode, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1400; /* addv4hi3_dup */

        case E_V4SImode:
          if (pattern113 (x3, 
E_V4SImode, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1402; /* addv4si3_dup */

        case E_V8QImode:
          if (pattern113 (x3, 
E_V8QImode, 
E_QImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1404; /* addv8qi3_dup */

        case E_V8HImode:
          if (pattern113 (x3, 
E_V8HImode, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1406; /* addv8hi3_dup */

        case E_V8SImode:
          if (pattern113 (x3, 
E_V8SImode, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1408; /* addv8si3_dup */

        case E_V16QImode:
          if (pattern113 (x3, 
E_V16QImode, 
E_QImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1410; /* addv16qi3_dup */

        case E_V16HImode:
          if (pattern113 (x3, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1412; /* addv16hi3_dup */

        case E_V16SImode:
          if (pattern113 (x3, 
E_V16SImode, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1414; /* addv16si3_dup */

        case E_V32QImode:
          if (pattern113 (x3, 
E_V32QImode, 
E_QImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1416; /* addv32qi3_dup */

        case E_V32HImode:
          if (pattern113 (x3, 
E_V32HImode, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1418; /* addv32hi3_dup */

        case E_V32SImode:
          if (pattern113 (x3, 
E_V32SImode, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1420; /* addv32si3_dup */

        case E_V64QImode:
          if (pattern113 (x3, 
E_V64QImode, 
E_QImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1422; /* addv64qi3_dup */

        case E_V64HImode:
          if (pattern113 (x3, 
E_V64HImode, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1424; /* addv64hi3_dup */

        case E_V64SImode:
          if (pattern113 (x3, 
E_V64SImode, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1426; /* addv64si3_dup */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern114 (x3, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1548; /* addv2di3_zext */

        case E_V4DImode:
          if (pattern114 (x3, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1549; /* addv4di3_zext */

        case E_V8DImode:
          if (pattern114 (x3, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1550; /* addv8di3_zext */

        case E_V16DImode:
          if (pattern114 (x3, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1551; /* addv16di3_zext */

        case E_V32DImode:
          if (pattern114 (x3, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1552; /* addv32di3_zext */

        case E_V64DImode:
          if (pattern114 (x3, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1553; /* addv64di3_zext */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_DUPLICATE)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern104 (x3))
        {
        case 0:
          *pnum_clobbers = 2;
          return 1584; /* addv2di3_sext_dup2 */

        case 1:
          *pnum_clobbers = 2;
          return 1585; /* addv4di3_sext_dup2 */

        case 2:
          *pnum_clobbers = 2;
          return 1586; /* addv8di3_sext_dup2 */

        case 3:
          *pnum_clobbers = 2;
          return 1587; /* addv16di3_sext_dup2 */

        case 4:
          *pnum_clobbers = 2;
          return 1588; /* addv32di3_sext_dup2 */

        case 5:
          *pnum_clobbers = 2;
          return 1589; /* addv64di3_sext_dup2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[1]))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pnum_clobbers != NULL
                  && pattern1 (x3, 
E_SImode) == 0)
                {
                  *pnum_clobbers = 2;
                  return 28; /* addsi3 */
                }
              break;

            case E_DImode:
              if (pattern115 (x3, pnum_clobbers) == 0)
                {
                  *pnum_clobbers = 2;
                  return 29; /* adddi3 */
                }
              break;

            case E_V2QImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V2QImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1356; /* addv2qi3 */
                }
              break;

            case E_V2HImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V2HImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1358; /* addv2hi3 */
                }
              break;

            case E_V2SImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V2SImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1360; /* addv2si3 */
                }
              break;

            case E_V4QImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V4QImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1362; /* addv4qi3 */
                }
              break;

            case E_V4HImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V4HImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1364; /* addv4hi3 */
                }
              break;

            case E_V4SImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V4SImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1366; /* addv4si3 */
                }
              break;

            case E_V8QImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V8QImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1368; /* addv8qi3 */
                }
              break;

            case E_V8HImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V8HImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1370; /* addv8hi3 */
                }
              break;

            case E_V8SImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V8SImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1372; /* addv8si3 */
                }
              break;

            case E_V16QImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V16QImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1374; /* addv16qi3 */
                }
              break;

            case E_V16HImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V16HImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1376; /* addv16hi3 */
                }
              break;

            case E_V16SImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V16SImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1378; /* addv16si3 */
                }
              break;

            case E_V32QImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V32QImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1380; /* addv32qi3 */
                }
              break;

            case E_V32HImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V32HImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1382; /* addv32hi3 */
                }
              break;

            case E_V32SImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V32SImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1384; /* addv32si3 */
                }
              break;

            case E_V64QImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V64QImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1386; /* addv64qi3 */
                }
              break;

            case E_V64HImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V64HImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1388; /* addv64hi3 */
                }
              break;

            case E_V64SImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V64SImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1390; /* addv64si3 */
                }
              break;

            case E_V2DImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V2DImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1524; /* addv2di3 */
                }
              break;

            case E_V4DImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V4DImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1525; /* addv4di3 */
                }
              break;

            case E_V8DImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V8DImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1526; /* addv8di3 */
                }
              break;

            case E_V16DImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V16DImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1527; /* addv16di3 */
                }
              break;

            case E_V32DImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V32DImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1528; /* addv32di3 */
                }
              break;

            case E_V64DImode:
              if (pattern116 (x3, pnum_clobbers, 
E_V64DImode) == 0)
                {
                  *pnum_clobbers = 1;
                  return 1529; /* addv64di3 */
                }
              break;

            case E_V2HFmode:
              if (pattern1 (x3, 
E_V2HFmode) == 0)
                return 2236; /* addv2hf3 */
              break;

            case E_V2SFmode:
              if (pattern1 (x3, 
E_V2SFmode) == 0)
                return 2244; /* addv2sf3 */
              break;

            case E_V2DFmode:
              if (pattern1 (x3, 
E_V2DFmode) == 0)
                return 2252; /* addv2df3 */
              break;

            case E_V4HFmode:
              if (pattern1 (x3, 
E_V4HFmode) == 0)
                return 2260; /* addv4hf3 */
              break;

            case E_V4SFmode:
              if (pattern1 (x3, 
E_V4SFmode) == 0)
                return 2268; /* addv4sf3 */
              break;

            case E_V4DFmode:
              if (pattern1 (x3, 
E_V4DFmode) == 0)
                return 2276; /* addv4df3 */
              break;

            case E_V8HFmode:
              if (pattern1 (x3, 
E_V8HFmode) == 0)
                return 2284; /* addv8hf3 */
              break;

            case E_V8SFmode:
              if (pattern1 (x3, 
E_V8SFmode) == 0)
                return 2292; /* addv8sf3 */
              break;

            case E_V8DFmode:
              if (pattern1 (x3, 
E_V8DFmode) == 0)
                return 2300; /* addv8df3 */
              break;

            case E_V16HFmode:
              if (pattern1 (x3, 
E_V16HFmode) == 0)
                return 2308; /* addv16hf3 */
              break;

            case E_V16SFmode:
              if (pattern1 (x3, 
E_V16SFmode) == 0)
                return 2316; /* addv16sf3 */
              break;

            case E_V16DFmode:
              if (pattern1 (x3, 
E_V16DFmode) == 0)
                return 2324; /* addv16df3 */
              break;

            case E_V32HFmode:
              if (pattern1 (x3, 
E_V32HFmode) == 0)
                return 2332; /* addv32hf3 */
              break;

            case E_V32SFmode:
              if (pattern1 (x3, 
E_V32SFmode) == 0)
                return 2340; /* addv32sf3 */
              break;

            case E_V32DFmode:
              if (pattern1 (x3, 
E_V32DFmode) == 0)
                return 2348; /* addv32df3 */
              break;

            case E_V64HFmode:
              if (pattern1 (x3, 
E_V64HFmode) == 0)
                return 2356; /* addv64hf3 */
              break;

            case E_V64SFmode:
              if (pattern1 (x3, 
E_V64SFmode) == 0)
                return 2364; /* addv64sf3 */
              break;

            case E_V64DFmode:
              if (pattern1 (x3, 
E_V64DFmode) == 0)
                return 2372; /* addv64df3 */
              break;

            default:
              break;
            }
          break;

        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V64SImode:
              if (pattern105 (x3, 
E_V64SImode) == 0
                  && 
#line 2117 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return 1596; /* addv64si3_ds */
              break;

            case E_V64SFmode:
              if (pattern105 (x3, 
E_V64SFmode) == 0
                  && 
#line 2117 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return 1598; /* addv64sf3_ds */
              break;

            case E_V64DImode:
              if (pattern105 (x3, 
E_V64DImode) == 0
                  && 
#line 2117 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return 1600; /* addv64di3_ds */
              break;

            case E_SImode:
              if (pattern105 (x3, 
E_SImode) == 0
                  && 
#line 2128 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return 1602; /* addsi3_ds_scalar */
              break;

            case E_SFmode:
              if (pattern105 (x3, 
E_SFmode) == 0
                  && 
#line 2128 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return 1603; /* addsf3_ds_scalar */
              break;

            case E_DImode:
              if (pattern105 (x3, 
E_DImode) == 0
                  && 
#line 2128 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return 1604; /* adddi3_ds_scalar */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (pattern5 (x3, 
E_HFmode) != 0)
            return -1;
          return 2380; /* addhf3 */

        case E_SFmode:
          if (pattern5 (x3, 
E_SFmode) != 0)
            return -1;
          return 2384; /* addsf3 */

        case E_DFmode:
          if (pattern5 (x3, 
E_DFmode) != 0)
            return -1;
          return 2388; /* adddf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_DImode))
            return 13; /* indirect_jump */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) != LABEL_REF
          || GET_CODE (x3) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      return 12; /* jump */

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (!gcn_conditional_operator (x4, E_BImode))
        return -1;
      operands[1] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != PC)
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!gcn_conditional_register_operand (operands[2], E_BImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      return 14; /* cjump */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[1]))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (!immediate_operand (operands[1], E_VOIDmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          *pnum_clobbers = 2;
          return 20; /* gcn_call_value */

        case REG:
        case SUBREG:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          *pnum_clobbers = 2;
          return 21; /* gcn_call_value_indirect */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_76 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_82 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_81 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_80 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_79 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_68 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_85 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern76 (x2, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 56; /* popcountsi2 */

        case E_V2QImode:
          if (!gcn_valu_dst_operand (operands[0], E_V2QImode)
              || GET_MODE (x2) != E_V2QImode
              || !gcn_valu_src0_operand (operands[1], E_V2QImode))
            return -1;
          return 1757; /* popcountv2qi2 */

        case E_V2HImode:
          if (!gcn_valu_dst_operand (operands[0], E_V2HImode)
              || GET_MODE (x2) != E_V2HImode
              || !gcn_valu_src0_operand (operands[1], E_V2HImode))
            return -1;
          return 1761; /* popcountv2hi2 */

        case E_V2SImode:
          if (!gcn_valu_dst_operand (operands[0], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !gcn_valu_src0_operand (operands[1], E_V2SImode))
            return -1;
          return 1765; /* popcountv2si2 */

        case E_V4QImode:
          if (!gcn_valu_dst_operand (operands[0], E_V4QImode)
              || GET_MODE (x2) != E_V4QImode
              || !gcn_valu_src0_operand (operands[1], E_V4QImode))
            return -1;
          return 1769; /* popcountv4qi2 */

        case E_V4HImode:
          if (!gcn_valu_dst_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !gcn_valu_src0_operand (operands[1], E_V4HImode))
            return -1;
          return 1773; /* popcountv4hi2 */

        case E_V4SImode:
          if (!gcn_valu_dst_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !gcn_valu_src0_operand (operands[1], E_V4SImode))
            return -1;
          return 1777; /* popcountv4si2 */

        case E_V8QImode:
          if (!gcn_valu_dst_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !gcn_valu_src0_operand (operands[1], E_V8QImode))
            return -1;
          return 1781; /* popcountv8qi2 */

        case E_V8HImode:
          if (!gcn_valu_dst_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !gcn_valu_src0_operand (operands[1], E_V8HImode))
            return -1;
          return 1785; /* popcountv8hi2 */

        case E_V8SImode:
          if (!gcn_valu_dst_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || !gcn_valu_src0_operand (operands[1], E_V8SImode))
            return -1;
          return 1789; /* popcountv8si2 */

        case E_V16QImode:
          if (!gcn_valu_dst_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !gcn_valu_src0_operand (operands[1], E_V16QImode))
            return -1;
          return 1793; /* popcountv16qi2 */

        case E_V16HImode:
          if (!gcn_valu_dst_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || !gcn_valu_src0_operand (operands[1], E_V16HImode))
            return -1;
          return 1797; /* popcountv16hi2 */

        case E_V16SImode:
          if (!gcn_valu_dst_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || !gcn_valu_src0_operand (operands[1], E_V16SImode))
            return -1;
          return 1801; /* popcountv16si2 */

        case E_V32QImode:
          if (!gcn_valu_dst_operand (operands[0], E_V32QImode)
              || GET_MODE (x2) != E_V32QImode
              || !gcn_valu_src0_operand (operands[1], E_V32QImode))
            return -1;
          return 1805; /* popcountv32qi2 */

        case E_V32HImode:
          if (!gcn_valu_dst_operand (operands[0], E_V32HImode)
              || GET_MODE (x2) != E_V32HImode
              || !gcn_valu_src0_operand (operands[1], E_V32HImode))
            return -1;
          return 1809; /* popcountv32hi2 */

        case E_V32SImode:
          if (!gcn_valu_dst_operand (operands[0], E_V32SImode)
              || GET_MODE (x2) != E_V32SImode
              || !gcn_valu_src0_operand (operands[1], E_V32SImode))
            return -1;
          return 1813; /* popcountv32si2 */

        case E_V64QImode:
          if (!gcn_valu_dst_operand (operands[0], E_V64QImode)
              || GET_MODE (x2) != E_V64QImode
              || !gcn_valu_src0_operand (operands[1], E_V64QImode))
            return -1;
          return 1817; /* popcountv64qi2 */

        case E_V64HImode:
          if (!gcn_valu_dst_operand (operands[0], E_V64HImode)
              || GET_MODE (x2) != E_V64HImode
              || !gcn_valu_src0_operand (operands[1], E_V64HImode))
            return -1;
          return 1821; /* popcountv64hi2 */

        case E_V64SImode:
          if (!gcn_valu_dst_operand (operands[0], E_V64SImode)
              || GET_MODE (x2) != E_V64SImode
              || !gcn_valu_src0_operand (operands[1], E_V64SImode))
            return -1;
          return 1825; /* popcountv64si2 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 57; /* clzsi2 */

    case CTZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 58; /* ctzsi2 */

    case AND:
      return recog_77 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern4 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 64; /* iorsi3 */

        case 1:
          *pnum_clobbers = 1;
          return 75; /* iordi3 */

        case 2:
          return 1829; /* iorv2qi3 */

        case 3:
          return 1835; /* iorv2hi3 */

        case 4:
          return 1841; /* iorv2si3 */

        case 5:
          return 1847; /* iorv4qi3 */

        case 6:
          return 1853; /* iorv4hi3 */

        case 7:
          return 1859; /* iorv4si3 */

        case 8:
          return 1865; /* iorv8qi3 */

        case 9:
          return 1871; /* iorv8hi3 */

        case 10:
          return 1877; /* iorv8si3 */

        case 11:
          return 1883; /* iorv16qi3 */

        case 12:
          return 1889; /* iorv16hi3 */

        case 13:
          return 1895; /* iorv16si3 */

        case 14:
          return 1901; /* iorv32qi3 */

        case 15:
          return 1907; /* iorv32hi3 */

        case 16:
          return 1913; /* iorv32si3 */

        case 17:
          return 1919; /* iorv64qi3 */

        case 18:
          return 1925; /* iorv64hi3 */

        case 19:
          return 1931; /* iorv64si3 */

        case 20:
          return 1936; /* iorv2di3 */

        case 21:
          return 1939; /* iorv4di3 */

        case 22:
          return 1942; /* iorv8di3 */

        case 23:
          return 1945; /* iorv16di3 */

        case 24:
          return 1948; /* iorv32di3 */

        case 25:
          return 1951; /* iorv64di3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern4 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 65; /* xorsi3 */

        case 1:
          *pnum_clobbers = 1;
          return 76; /* xordi3 */

        case 2:
          return 1831; /* xorv2qi3 */

        case 3:
          return 1837; /* xorv2hi3 */

        case 4:
          return 1843; /* xorv2si3 */

        case 5:
          return 1849; /* xorv4qi3 */

        case 6:
          return 1855; /* xorv4hi3 */

        case 7:
          return 1861; /* xorv4si3 */

        case 8:
          return 1867; /* xorv8qi3 */

        case 9:
          return 1873; /* xorv8hi3 */

        case 10:
          return 1879; /* xorv8si3 */

        case 11:
          return 1885; /* xorv16qi3 */

        case 12:
          return 1891; /* xorv16hi3 */

        case 13:
          return 1897; /* xorv16si3 */

        case 14:
          return 1903; /* xorv32qi3 */

        case 15:
          return 1909; /* xorv32hi3 */

        case 16:
          return 1915; /* xorv32si3 */

        case 17:
          return 1921; /* xorv64qi3 */

        case 18:
          return 1927; /* xorv64hi3 */

        case 19:
          return 1933; /* xorv64si3 */

        case 20:
          return 1937; /* xorv2di3 */

        case 21:
          return 1940; /* xorv4di3 */

        case 22:
          return 1943; /* xorv8di3 */

        case 23:
          return 1946; /* xorv16di3 */

        case 24:
          return 1949; /* xorv32di3 */

        case 25:
          return 1952; /* xorv64di3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern6 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 66; /* sminsi3 */

        case 1:
          return 2115; /* sminv2si3 */

        case 2:
          return 2123; /* sminv4si3 */

        case 3:
          return 2131; /* sminv8si3 */

        case 4:
          return 2139; /* sminv16si3 */

        case 5:
          return 2147; /* sminv32si3 */

        case 6:
          return 2155; /* sminv64si3 */

        case 7:
          *pnum_clobbers = 1;
          return 2163; /* sminv2di3 */

        case 8:
          *pnum_clobbers = 1;
          return 2167; /* sminv4di3 */

        case 9:
          *pnum_clobbers = 1;
          return 2171; /* sminv8di3 */

        case 10:
          *pnum_clobbers = 1;
          return 2175; /* sminv16di3 */

        case 11:
          *pnum_clobbers = 1;
          return 2179; /* sminv32di3 */

        case 12:
          *pnum_clobbers = 1;
          return 2183; /* sminv64di3 */

        case 13:
          return 2240; /* sminv2hf3 */

        case 14:
          return 2248; /* sminv2sf3 */

        case 15:
          return 2256; /* sminv2df3 */

        case 16:
          return 2264; /* sminv4hf3 */

        case 17:
          return 2272; /* sminv4sf3 */

        case 18:
          return 2280; /* sminv4df3 */

        case 19:
          return 2288; /* sminv8hf3 */

        case 20:
          return 2296; /* sminv8sf3 */

        case 21:
          return 2304; /* sminv8df3 */

        case 22:
          return 2312; /* sminv16hf3 */

        case 23:
          return 2320; /* sminv16sf3 */

        case 24:
          return 2328; /* sminv16df3 */

        case 25:
          return 2336; /* sminv32hf3 */

        case 26:
          return 2344; /* sminv32sf3 */

        case 27:
          return 2352; /* sminv32df3 */

        case 28:
          return 2360; /* sminv64hf3 */

        case 29:
          return 2368; /* sminv64sf3 */

        case 30:
          return 2376; /* sminv64df3 */

        case 31:
          return 2382; /* sminhf3 */

        case 32:
          return 2386; /* sminsf3 */

        case 33:
          return 2390; /* smindf3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern6 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 67; /* smaxsi3 */

        case 1:
          return 2117; /* smaxv2si3 */

        case 2:
          return 2125; /* smaxv4si3 */

        case 3:
          return 2133; /* smaxv8si3 */

        case 4:
          return 2141; /* smaxv16si3 */

        case 5:
          return 2149; /* smaxv32si3 */

        case 6:
          return 2157; /* smaxv64si3 */

        case 7:
          *pnum_clobbers = 1;
          return 2164; /* smaxv2di3 */

        case 8:
          *pnum_clobbers = 1;
          return 2168; /* smaxv4di3 */

        case 9:
          *pnum_clobbers = 1;
          return 2172; /* smaxv8di3 */

        case 10:
          *pnum_clobbers = 1;
          return 2176; /* smaxv16di3 */

        case 11:
          *pnum_clobbers = 1;
          return 2180; /* smaxv32di3 */

        case 12:
          *pnum_clobbers = 1;
          return 2184; /* smaxv64di3 */

        case 13:
          return 2242; /* smaxv2hf3 */

        case 14:
          return 2250; /* smaxv2sf3 */

        case 15:
          return 2258; /* smaxv2df3 */

        case 16:
          return 2266; /* smaxv4hf3 */

        case 17:
          return 2274; /* smaxv4sf3 */

        case 18:
          return 2282; /* smaxv4df3 */

        case 19:
          return 2290; /* smaxv8hf3 */

        case 20:
          return 2298; /* smaxv8sf3 */

        case 21:
          return 2306; /* smaxv8df3 */

        case 22:
          return 2314; /* smaxv16hf3 */

        case 23:
          return 2322; /* smaxv16sf3 */

        case 24:
          return 2330; /* smaxv16df3 */

        case 25:
          return 2338; /* smaxv32hf3 */

        case 26:
          return 2346; /* smaxv32sf3 */

        case 27:
          return 2354; /* smaxv32df3 */

        case 28:
          return 2362; /* smaxv64hf3 */

        case 29:
          return 2370; /* smaxv64sf3 */

        case 30:
          return 2378; /* smaxv64df3 */

        case 31:
          return 2383; /* smaxhf3 */

        case 32:
          return 2387; /* smaxsf3 */

        case 33:
          return 2391; /* smaxdf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern7 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 68; /* uminsi3 */

        case 1:
          return 2119; /* uminv2si3 */

        case 2:
          return 2127; /* uminv4si3 */

        case 3:
          return 2135; /* uminv8si3 */

        case 4:
          return 2143; /* uminv16si3 */

        case 5:
          return 2151; /* uminv32si3 */

        case 6:
          return 2159; /* uminv64si3 */

        case 7:
          *pnum_clobbers = 1;
          return 2165; /* uminv2di3 */

        case 8:
          *pnum_clobbers = 1;
          return 2169; /* uminv4di3 */

        case 9:
          *pnum_clobbers = 1;
          return 2173; /* uminv8di3 */

        case 10:
          *pnum_clobbers = 1;
          return 2177; /* uminv16di3 */

        case 11:
          *pnum_clobbers = 1;
          return 2181; /* uminv32di3 */

        case 12:
          *pnum_clobbers = 1;
          return 2185; /* uminv64di3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern7 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 69; /* umaxsi3 */

        case 1:
          return 2121; /* umaxv2si3 */

        case 2:
          return 2129; /* umaxv4si3 */

        case 3:
          return 2137; /* umaxv8si3 */

        case 4:
          return 2145; /* umaxv16si3 */

        case 5:
          return 2153; /* umaxv32si3 */

        case 6:
          return 2161; /* umaxv64si3 */

        case 7:
          *pnum_clobbers = 1;
          return 2166; /* umaxv2di3 */

        case 8:
          *pnum_clobbers = 1;
          return 2170; /* umaxv4di3 */

        case 9:
          *pnum_clobbers = 1;
          return 2174; /* umaxv8di3 */

        case 10:
          *pnum_clobbers = 1;
          return 2178; /* umaxv16di3 */

        case 11:
          *pnum_clobbers = 1;
          return 2182; /* umaxv32di3 */

        case 12:
          *pnum_clobbers = 1;
          return 2186; /* umaxv64di3 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern12 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 70; /* ashlsi3 */

        case 1:
          *pnum_clobbers = 1;
          return 77; /* ashldi3 */

        case 2:
          return 2043; /* vashlv2si3 */

        case 3:
          return 2049; /* vashlv2di3 */

        case 4:
          return 2055; /* vashlv4si3 */

        case 5:
          return 2061; /* vashlv4di3 */

        case 6:
          return 2067; /* vashlv8si3 */

        case 7:
          return 2073; /* vashlv8di3 */

        case 8:
          return 2079; /* vashlv16si3 */

        case 9:
          return 2085; /* vashlv16di3 */

        case 10:
          return 2091; /* vashlv32si3 */

        case 11:
          return 2097; /* vashlv32di3 */

        case 12:
          return 2103; /* vashlv64si3 */

        case 13:
          return 2109; /* vashlv64di3 */

        case 14:
          return 1971; /* ashlv2si3 */

        case 15:
          return 1977; /* ashlv2di3 */

        case 16:
          return 1983; /* ashlv4si3 */

        case 17:
          return 1989; /* ashlv4di3 */

        case 18:
          return 1995; /* ashlv8si3 */

        case 19:
          return 2001; /* ashlv8di3 */

        case 20:
          return 2007; /* ashlv16si3 */

        case 21:
          return 2013; /* ashlv16di3 */

        case 22:
          return 2019; /* ashlv32si3 */

        case 23:
          return 2025; /* ashlv32di3 */

        case 24:
          return 2031; /* ashlv64si3 */

        case 25:
          return 2037; /* ashlv64di3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern12 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 71; /* lshrsi3 */

        case 1:
          *pnum_clobbers = 1;
          return 78; /* lshrdi3 */

        case 2:
          return 2045; /* vlshrv2si3 */

        case 3:
          return 2051; /* vlshrv2di3 */

        case 4:
          return 2057; /* vlshrv4si3 */

        case 5:
          return 2063; /* vlshrv4di3 */

        case 6:
          return 2069; /* vlshrv8si3 */

        case 7:
          return 2075; /* vlshrv8di3 */

        case 8:
          return 2081; /* vlshrv16si3 */

        case 9:
          return 2087; /* vlshrv16di3 */

        case 10:
          return 2093; /* vlshrv32si3 */

        case 11:
          return 2099; /* vlshrv32di3 */

        case 12:
          return 2105; /* vlshrv64si3 */

        case 13:
          return 2111; /* vlshrv64di3 */

        case 14:
          return 1973; /* lshrv2si3 */

        case 15:
          return 1979; /* lshrv2di3 */

        case 16:
          return 1985; /* lshrv4si3 */

        case 17:
          return 1991; /* lshrv4di3 */

        case 18:
          return 1997; /* lshrv8si3 */

        case 19:
          return 2003; /* lshrv8di3 */

        case 20:
          return 2009; /* lshrv16si3 */

        case 21:
          return 2015; /* lshrv16di3 */

        case 22:
          return 2021; /* lshrv32si3 */

        case 23:
          return 2027; /* lshrv32di3 */

        case 24:
          return 2033; /* lshrv64si3 */

        case 25:
          return 2039; /* lshrv64di3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          switch (pattern9 (x2, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 72; /* ashrsi3 */

            case 1:
              *pnum_clobbers = 1;
              return 79; /* ashrdi3 */

            case 2:
              return 2047; /* vashrv2si3 */

            case 3:
              return 2053; /* vashrv2di3 */

            case 4:
              return 2059; /* vashrv4si3 */

            case 5:
              return 2065; /* vashrv4di3 */

            case 6:
              return 2071; /* vashrv8si3 */

            case 7:
              return 2077; /* vashrv8di3 */

            case 8:
              return 2083; /* vashrv16si3 */

            case 9:
              return 2089; /* vashrv16di3 */

            case 10:
              return 2095; /* vashrv32si3 */

            case 11:
              return 2101; /* vashrv32di3 */

            case 12:
              return 2107; /* vashrv64si3 */

            case 13:
              return 2113; /* vashrv64di3 */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x6, 0);
          operands[2] = x9;
          if (!gcn_alu_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern10 (x2, 
E_V2SImode) != 0)
                return -1;
              return 1975; /* ashrv2si3 */

            case E_V2DImode:
              if (pattern11 (x2, 
E_V2DImode, 
E_V2SImode) != 0)
                return -1;
              return 1981; /* ashrv2di3 */

            case E_V4SImode:
              if (pattern10 (x2, 
E_V4SImode) != 0)
                return -1;
              return 1987; /* ashrv4si3 */

            case E_V4DImode:
              if (pattern11 (x2, 
E_V4DImode, 
E_V4SImode) != 0)
                return -1;
              return 1993; /* ashrv4di3 */

            case E_V8SImode:
              if (pattern10 (x2, 
E_V8SImode) != 0)
                return -1;
              return 1999; /* ashrv8si3 */

            case E_V8DImode:
              if (pattern11 (x2, 
E_V8DImode, 
E_V8SImode) != 0)
                return -1;
              return 2005; /* ashrv8di3 */

            case E_V16SImode:
              if (pattern10 (x2, 
E_V16SImode) != 0)
                return -1;
              return 2011; /* ashrv16si3 */

            case E_V16DImode:
              if (pattern11 (x2, 
E_V16DImode, 
E_V16SImode) != 0)
                return -1;
              return 2017; /* ashrv16di3 */

            case E_V32SImode:
              if (pattern10 (x2, 
E_V32SImode) != 0)
                return -1;
              return 2023; /* ashrv32si3 */

            case E_V32DImode:
              if (pattern11 (x2, 
E_V32DImode, 
E_V32SImode) != 0)
                return -1;
              return 2029; /* ashrv32di3 */

            case E_V64SImode:
              if (pattern11 (x2, 
E_V64SImode, 
E_V64SImode) != 0)
                return -1;
              return 2035; /* ashrv64si3 */

            case E_V64DImode:
              if (pattern11 (x2, 
E_V64DImode, 
E_V64SImode) != 0)
                return -1;
              return 2041; /* ashrv64di3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 2
          || GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x10 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 92; /* *gcn_wavefront_barrier */

    case VEC_MERGE:
      return recog_69 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_78 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_67 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_86 (x1, insn, pnum_clobbers);

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[0], E_V2HFmode)
              || GET_MODE (x2) != E_V2HFmode
              || !register_operand (operands[1], E_V2HFmode))
            return -1;
          return 2457; /* negv2hf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x2) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode))
            return -1;
          return 2459; /* negv2sf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode))
            return -1;
          return 2461; /* negv2df2 */

        case E_V4HFmode:
          if (!register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x2) != E_V4HFmode
              || !register_operand (operands[1], E_V4HFmode))
            return -1;
          return 2463; /* negv4hf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode))
            return -1;
          return 2465; /* negv4sf2 */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !register_operand (operands[1], E_V4DFmode))
            return -1;
          return 2467; /* negv4df2 */

        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x2) != E_V8HFmode
              || !register_operand (operands[1], E_V8HFmode))
            return -1;
          return 2469; /* negv8hf2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || !register_operand (operands[1], E_V8SFmode))
            return -1;
          return 2471; /* negv8sf2 */

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x2) != E_V8DFmode
              || !register_operand (operands[1], E_V8DFmode))
            return -1;
          return 2473; /* negv8df2 */

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x2) != E_V16HFmode
              || !register_operand (operands[1], E_V16HFmode))
            return -1;
          return 2475; /* negv16hf2 */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x2) != E_V16SFmode
              || !register_operand (operands[1], E_V16SFmode))
            return -1;
          return 2477; /* negv16sf2 */

        case E_V16DFmode:
          if (!register_operand (operands[0], E_V16DFmode)
              || GET_MODE (x2) != E_V16DFmode
              || !register_operand (operands[1], E_V16DFmode))
            return -1;
          return 2479; /* negv16df2 */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x2) != E_V32HFmode
              || !register_operand (operands[1], E_V32HFmode))
            return -1;
          return 2481; /* negv32hf2 */

        case E_V32SFmode:
          if (!register_operand (operands[0], E_V32SFmode)
              || GET_MODE (x2) != E_V32SFmode
              || !register_operand (operands[1], E_V32SFmode))
            return -1;
          return 2483; /* negv32sf2 */

        case E_V32DFmode:
          if (!register_operand (operands[0], E_V32DFmode)
              || GET_MODE (x2) != E_V32DFmode
              || !register_operand (operands[1], E_V32DFmode))
            return -1;
          return 2485; /* negv32df2 */

        case E_V64HFmode:
          if (!register_operand (operands[0], E_V64HFmode)
              || GET_MODE (x2) != E_V64HFmode
              || !register_operand (operands[1], E_V64HFmode))
            return -1;
          return 2487; /* negv64hf2 */

        case E_V64SFmode:
          if (!register_operand (operands[0], E_V64SFmode)
              || GET_MODE (x2) != E_V64SFmode
              || !register_operand (operands[1], E_V64SFmode))
            return -1;
          return 2489; /* negv64sf2 */

        case E_V64DFmode:
          if (!register_operand (operands[0], E_V64DFmode)
              || GET_MODE (x2) != E_V64DFmode
              || !register_operand (operands[1], E_V64DFmode))
            return -1;
          return 2491; /* negv64df2 */

        default:
          return -1;
        }

    case SQRT:
      return recog_84 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_83 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_75 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_74 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_73 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_72 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_71 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_70 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_66 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_65 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}
