/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x3, pnum_clobbers); /* [-1, 0] */

    case E_V2SImode:
      if (pattern2 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern2 (x3, 
E_V8SImode) != 0)
        return -1;
      return 3;

    case E_V16SImode:
      if (pattern2 (x3, 
E_V16SImode) != 0)
        return -1;
      return 4;

    case E_V32SImode:
      if (pattern2 (x3, 
E_V32SImode) != 0)
        return -1;
      return 5;

    case E_V64SImode:
      if (pattern2 (x3, 
E_V64SImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V4DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V4DImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V8DImode) != 0)
        return -1;
      return 9;

    case E_V16DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V16DImode) != 0)
        return -1;
      return 10;

    case E_V32DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V32DImode) != 0)
        return -1;
      return 11;

    case E_V64DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V64DImode) != 0)
        return -1;
      return 12;

    case E_V2HFmode:
      if (pattern1 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 13;

    case E_V2SFmode:
      if (pattern1 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 14;

    case E_V2DFmode:
      if (pattern1 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 15;

    case E_V4HFmode:
      if (pattern1 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 16;

    case E_V4SFmode:
      if (pattern1 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 17;

    case E_V4DFmode:
      if (pattern1 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 18;

    case E_V8HFmode:
      if (pattern1 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 19;

    case E_V8SFmode:
      if (pattern1 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 20;

    case E_V8DFmode:
      if (pattern1 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 21;

    case E_V16HFmode:
      if (pattern1 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 22;

    case E_V16SFmode:
      if (pattern1 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 23;

    case E_V16DFmode:
      if (pattern1 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 24;

    case E_V32HFmode:
      if (pattern1 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 25;

    case E_V32SFmode:
      if (pattern1 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 26;

    case E_V32DFmode:
      if (pattern1 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 27;

    case E_V64HFmode:
      if (pattern1 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 28;

    case E_V64SFmode:
      if (pattern1 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 29;

    case E_V64DFmode:
      if (pattern1 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 30;

    case E_HFmode:
      if (pattern5 (x3, 
E_HFmode) != 0)
        return -1;
      return 31;

    case E_SFmode:
      if (pattern5 (x3, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_DFmode:
      if (pattern5 (x3, 
E_DFmode) != 0)
        return -1;
      return 33;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i2)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!gcn_alu_operand (operands[1], E_V4HFmode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!gcn_alu_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!gcn_alu_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 0;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 1;

    case E_V32HFmode:
      if (!gcn_alu_operand (operands[1], E_V32HFmode))
        return -1;
      return 2;

    case E_V32SFmode:
      if (!gcn_alu_operand (operands[1], E_V32SFmode))
        return -1;
      return 3;

    case E_V32DFmode:
      if (!gcn_alu_operand (operands[1], E_V32DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!gcn_alu_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!gcn_alu_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    case E_V16DFmode:
      if (!gcn_alu_operand (operands[1], E_V16DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern68 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  if (!gcn_exec_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V2DImode))
        return -1;
      return pattern65 (); /* [-1, 2] */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V4DImode))
        return -1;
      res = pattern66 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V8DImode))
        return -1;
      res = pattern67 ();
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V16DImode))
        return -1;
      res = pattern68 ();
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V32DImode))
        return -1;
      res = pattern69 ();
      if (res >= 0)
        return res + 12; /* [12, 14] */
      return -1;

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V64DImode))
        return -1;
      res = pattern70 ();
      if (res >= 0)
        return res + 15; /* [15, 17] */
      return -1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 6;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 13;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 14;

    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 15;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 16;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 17;

    case E_V4DImode:
      if (!gcn_alu_operand (operands[1], E_V4DImode))
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern101 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IOR)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !gcn_register_or_unspec_operand (operands[3], i2)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_DUPLICATE)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!gcn_alu_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x8, 1);
  operands[2] = x12;
  x13 = XEXP (x2, 0);
  operands[3] = x13;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x14 = XEXP (x6, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x4, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x3, 1);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern111 (x1, 
E_V2SImode, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern111 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern111 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern111 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern111 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern111 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x5, 0, 2);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      return 0;

    case E_V2HImode:
      return 1;

    case E_V2SImode:
      return 2;

    case E_V4QImode:
      return 3;

    case E_V4HImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V8QImode:
      return 6;

    case E_V8HImode:
      return 7;

    case E_V8SImode:
      return 8;

    case E_V16QImode:
      return 9;

    case E_V16HImode:
      return 10;

    case E_V16SImode:
      return 11;

    case E_V32QImode:
      return 12;

    case E_V32HImode:
      return 13;

    case E_V32SImode:
      return 14;

    case E_V64QImode:
      return 15;

    case E_V64HImode:
      return 16;

    case E_V64SImode:
      return 17;

    case E_V16DImode:
      return 18;

    default:
      return -1;
    }
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!gcn_alu_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern169 (x1, 
E_V2DImode, 
E_V2SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern169 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern169 (x1, 
E_V8DImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern169 (x1, 
E_V16DImode, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern169 (x1, 
E_V32DImode, 
E_V32SImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern169 (x1, 
E_V64DImode, 
E_V64SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1)
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !gcn_alu_operand (operands[1], E_SImode)
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1)
      || !gcn_alu_or_unspec_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !register_operand (operands[3], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V4DImode)
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V32QImode:
      if (!register_operand (operands[2], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[2], E_V32HImode))
        return -1;
      return 1;

    case E_V32HFmode:
      if (!register_operand (operands[2], E_V32HFmode))
        return -1;
      return 2;

    case E_V32SImode:
      if (!register_operand (operands[2], E_V32SImode))
        return -1;
      return 3;

    case E_V32SFmode:
      if (!register_operand (operands[2], E_V32SFmode))
        return -1;
      return 4;

    case E_V32DImode:
      if (!register_operand (operands[2], E_V32DImode))
        return -1;
      return 5;

    case E_V32DFmode:
      if (!register_operand (operands[2], E_V32DFmode))
        return -1;
      return 6;

    case E_V32TImode:
      if (!register_operand (operands[2], E_V32TImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern232 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V16DImode:
      if (!register_operand (operands[1], E_V16DImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V16DImode)
        return -1;
      return 0;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V16SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x8, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 40)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (pattern136 (x2, 
E_HFmode) != 0)
        return -1;
      return 3078; /* div_fixuphf */

    case E_SFmode:
      if (pattern136 (x2, 
E_SFmode) != 0)
        return -1;
      return 3079; /* div_fixupsf */

    case E_DFmode:
      if (pattern136 (x2, 
E_DFmode) != 0)
        return -1;
      return 3080; /* div_fixupdf */

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[1] = x4;
  if (!gcn_exec_reg_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (pattern155 (x2, 
E_V2QImode, 
E_V2SImode) != 0)
        return -1;
      return 1194; /* ds_bpermutev2qi */

    case E_V2HImode:
      if (pattern155 (x2, 
E_V2HImode, 
E_V2SImode) != 0)
        return -1;
      return 1195; /* ds_bpermutev2hi */

    case E_V2SImode:
      if (pattern156 (x2, 
E_V2SImode) != 0)
        return -1;
      return 1196; /* ds_bpermutev2si */

    case E_V2HFmode:
      if (pattern155 (x2, 
E_V2HFmode, 
E_V2SImode) != 0)
        return -1;
      return 1197; /* ds_bpermutev2hf */

    case E_V2SFmode:
      if (pattern155 (x2, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      return 1198; /* ds_bpermutev2sf */

    case E_V4QImode:
      if (pattern155 (x2, 
E_V4QImode, 
E_V4SImode) != 0)
        return -1;
      return 1199; /* ds_bpermutev4qi */

    case E_V4HImode:
      if (pattern155 (x2, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1200; /* ds_bpermutev4hi */

    case E_V4SImode:
      if (pattern156 (x2, 
E_V4SImode) != 0)
        return -1;
      return 1201; /* ds_bpermutev4si */

    case E_V4HFmode:
      if (pattern155 (x2, 
E_V4HFmode, 
E_V4SImode) != 0)
        return -1;
      return 1202; /* ds_bpermutev4hf */

    case E_V4SFmode:
      if (pattern155 (x2, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1203; /* ds_bpermutev4sf */

    case E_V8QImode:
      if (pattern155 (x2, 
E_V8QImode, 
E_V8SImode) != 0)
        return -1;
      return 1204; /* ds_bpermutev8qi */

    case E_V8HImode:
      if (pattern155 (x2, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 1205; /* ds_bpermutev8hi */

    case E_V8SImode:
      if (pattern156 (x2, 
E_V8SImode) != 0)
        return -1;
      return 1206; /* ds_bpermutev8si */

    case E_V8HFmode:
      if (pattern155 (x2, 
E_V8HFmode, 
E_V8SImode) != 0)
        return -1;
      return 1207; /* ds_bpermutev8hf */

    case E_V8SFmode:
      if (pattern155 (x2, 
E_V8SFmode, 
E_V8SImode) != 0)
        return -1;
      return 1208; /* ds_bpermutev8sf */

    case E_V16QImode:
      if (pattern155 (x2, 
E_V16QImode, 
E_V16SImode) != 0)
        return -1;
      return 1209; /* ds_bpermutev16qi */

    case E_V16HImode:
      if (pattern155 (x2, 
E_V16HImode, 
E_V16SImode) != 0)
        return -1;
      return 1210; /* ds_bpermutev16hi */

    case E_V16SImode:
      if (pattern156 (x2, 
E_V16SImode) != 0)
        return -1;
      return 1211; /* ds_bpermutev16si */

    case E_V16HFmode:
      if (pattern155 (x2, 
E_V16HFmode, 
E_V16SImode) != 0)
        return -1;
      return 1212; /* ds_bpermutev16hf */

    case E_V16SFmode:
      if (pattern155 (x2, 
E_V16SFmode, 
E_V16SImode) != 0)
        return -1;
      return 1213; /* ds_bpermutev16sf */

    case E_V32QImode:
      if (pattern155 (x2, 
E_V32QImode, 
E_V32SImode) != 0)
        return -1;
      return 1214; /* ds_bpermutev32qi */

    case E_V32HImode:
      if (pattern155 (x2, 
E_V32HImode, 
E_V32SImode) != 0)
        return -1;
      return 1215; /* ds_bpermutev32hi */

    case E_V32SImode:
      if (pattern156 (x2, 
E_V32SImode) != 0)
        return -1;
      return 1216; /* ds_bpermutev32si */

    case E_V32HFmode:
      if (pattern155 (x2, 
E_V32HFmode, 
E_V32SImode) != 0)
        return -1;
      return 1217; /* ds_bpermutev32hf */

    case E_V32SFmode:
      if (pattern155 (x2, 
E_V32SFmode, 
E_V32SImode) != 0)
        return -1;
      return 1218; /* ds_bpermutev32sf */

    case E_V64QImode:
      if (pattern155 (x2, 
E_V64QImode, 
E_V64SImode) != 0)
        return -1;
      return 1219; /* ds_bpermutev64qi */

    case E_V64HImode:
      if (pattern155 (x2, 
E_V64HImode, 
E_V64SImode) != 0)
        return -1;
      return 1220; /* ds_bpermutev64hi */

    case E_V64SImode:
      if (pattern156 (x2, 
E_V64SImode) != 0)
        return -1;
      return 1221; /* ds_bpermutev64si */

    case E_V64HFmode:
      if (pattern155 (x2, 
E_V64HFmode, 
E_V64SImode) != 0)
        return -1;
      return 1222; /* ds_bpermutev64hf */

    case E_V64SFmode:
      if (pattern155 (x2, 
E_V64SFmode, 
E_V64SImode) != 0)
        return -1;
      return 1223; /* ds_bpermutev64sf */

    case E_V2DImode:
      if (pattern155 (x2, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 1224; /* ds_bpermutev2di */

    case E_V2DFmode:
      if (pattern155 (x2, 
E_V2DFmode, 
E_V2SImode) != 0)
        return -1;
      return 1225; /* ds_bpermutev2df */

    case E_V4DImode:
      if (pattern155 (x2, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 1226; /* ds_bpermutev4di */

    case E_V4DFmode:
      if (pattern155 (x2, 
E_V4DFmode, 
E_V4SImode) != 0)
        return -1;
      return 1227; /* ds_bpermutev4df */

    case E_V8DImode:
      if (pattern155 (x2, 
E_V8DImode, 
E_V8SImode) != 0)
        return -1;
      return 1228; /* ds_bpermutev8di */

    case E_V8DFmode:
      if (pattern155 (x2, 
E_V8DFmode, 
E_V8SImode) != 0)
        return -1;
      return 1229; /* ds_bpermutev8df */

    case E_V16DImode:
      if (pattern155 (x2, 
E_V16DImode, 
E_V16SImode) != 0)
        return -1;
      return 1230; /* ds_bpermutev16di */

    case E_V16DFmode:
      if (pattern155 (x2, 
E_V16DFmode, 
E_V16SImode) != 0)
        return -1;
      return 1231; /* ds_bpermutev16df */

    case E_V32DImode:
      if (pattern155 (x2, 
E_V32DImode, 
E_V32SImode) != 0)
        return -1;
      return 1232; /* ds_bpermutev32di */

    case E_V32DFmode:
      if (pattern155 (x2, 
E_V32DFmode, 
E_V32SImode) != 0)
        return -1;
      return 1233; /* ds_bpermutev32df */

    case E_V64DImode:
      if (pattern155 (x2, 
E_V64DImode, 
E_V64SImode) != 0)
        return -1;
      return 1234; /* ds_bpermutev64di */

    case E_V64DFmode:
      if (pattern155 (x2, 
E_V64DFmode, 
E_V64SImode) != 0)
        return -1;
      return 1235; /* ds_bpermutev64df */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern99 (x2, 
E_V64HImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5931; /* *truncv2qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8451; /* *truncv2qiv64hi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5935; /* *truncv2hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8457; /* *truncv2hiv64hi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5939; /* *truncv2siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8463; /* *truncv2siv64hi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5943; /* *truncv4qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8469; /* *truncv4qiv64hi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5947; /* *truncv4hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8475; /* *truncv4hiv64hi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5951; /* *truncv4siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8481; /* *truncv4siv64hi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5955; /* *truncv8qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8487; /* *truncv8qiv64hi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5959; /* *truncv8hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8493; /* *truncv8hiv64hi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5963; /* *truncv8siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8499; /* *truncv8siv64hi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5967; /* *truncv16qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8505; /* *truncv16qiv64hi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5971; /* *truncv16hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8511; /* *truncv16hiv64hi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5975; /* *truncv16siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8517; /* *truncv16siv64hi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5979; /* *truncv32qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8523; /* *truncv32qiv64hi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5983; /* *truncv32hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8529; /* *truncv32hiv64hi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5987; /* *truncv32siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8535; /* *truncv32siv64hi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5991; /* *truncv64qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8541; /* *truncv64qiv64hi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5995; /* *truncv64hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8547; /* *truncv64hiv64hi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5999; /* *truncv64siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8553; /* *truncv64siv64hi_shift */

    case 18:
      return 8683; /* truncv64div64hi2 */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern98 (x2, 
E_V32QImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5643; /* *truncv2qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8019; /* *truncv2qiv32qi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5647; /* *truncv2hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8025; /* *truncv2hiv32qi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5651; /* *truncv2siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8031; /* *truncv2siv32qi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5655; /* *truncv4qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8037; /* *truncv4qiv32qi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5659; /* *truncv4hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8043; /* *truncv4hiv32qi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5663; /* *truncv4siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8049; /* *truncv4siv32qi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5667; /* *truncv8qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8055; /* *truncv8qiv32qi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5671; /* *truncv8hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8061; /* *truncv8hiv32qi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5675; /* *truncv8siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8067; /* *truncv8siv32qi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5679; /* *truncv16qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8073; /* *truncv16qiv32qi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5683; /* *truncv16hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8079; /* *truncv16hiv32qi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5687; /* *truncv16siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8085; /* *truncv16siv32qi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5691; /* *truncv32qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8091; /* *truncv32qiv32qi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5695; /* *truncv32hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8097; /* *truncv32hiv32qi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5699; /* *truncv32siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8103; /* *truncv32siv32qi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5703; /* *truncv64qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8109; /* *truncv64qiv32qi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5707; /* *truncv64hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8115; /* *truncv64hiv32qi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5711; /* *truncv64siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8121; /* *truncv64siv32qi_shift */

    case 18:
      return 8679; /* truncv32div32qi2 */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern96 (x2, 
E_V8SImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5355; /* *truncv2qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7587; /* *truncv2qiv8si_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5359; /* *truncv2hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7593; /* *truncv2hiv8si_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5363; /* *truncv2siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7599; /* *truncv2siv8si_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5367; /* *truncv4qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7605; /* *truncv4qiv8si_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5371; /* *truncv4hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7611; /* *truncv4hiv8si_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5375; /* *truncv4siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7617; /* *truncv4siv8si_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5379; /* *truncv8qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7623; /* *truncv8qiv8si_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5383; /* *truncv8hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7629; /* *truncv8hiv8si_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5387; /* *truncv8siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7635; /* *truncv8siv8si_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5391; /* *truncv16qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7641; /* *truncv16qiv8si_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5395; /* *truncv16hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7647; /* *truncv16hiv8si_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5399; /* *truncv16siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7653; /* *truncv16siv8si_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5403; /* *truncv32qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7659; /* *truncv32qiv8si_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5407; /* *truncv32hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7665; /* *truncv32hiv8si_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5411; /* *truncv32siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7671; /* *truncv32siv8si_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5415; /* *truncv64qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7677; /* *truncv64qiv8si_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5419; /* *truncv64hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7683; /* *truncv64hiv8si_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5423; /* *truncv64siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7689; /* *truncv64siv8si_shift */

    case 18:
      return 8675; /* truncv8div8si2 */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[3] = x8;
  x9 = XVECEXP (x3, 0, 2);
  operands[4] = x9;
  x10 = XEXP (x2, 1);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[6] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      switch (pattern229 (x2, 
E_V2QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 619; /* gatherv2qi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 715; /* gatherv2qi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V2HImode:
      switch (pattern229 (x2, 
E_V2HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 621; /* gatherv2hi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 717; /* gatherv2hi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V2HFmode:
      switch (pattern229 (x2, 
E_V2HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 623; /* gatherv2hf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 719; /* gatherv2hf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V2SImode:
      switch (pattern229 (x2, 
E_V2SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 625; /* gatherv2si_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 721; /* gatherv2si_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V2SFmode:
      switch (pattern229 (x2, 
E_V2SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 627; /* gatherv2sf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 723; /* gatherv2sf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern229 (x2, 
E_V2DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 629; /* gatherv2di_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 725; /* gatherv2di_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V2DFmode:
      switch (pattern229 (x2, 
E_V2DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 631; /* gatherv2df_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 727; /* gatherv2df_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V2TImode:
      switch (pattern229 (x2, 
E_V2TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 633; /* gatherv2ti_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 729; /* gatherv2ti_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V4QImode:
      switch (pattern230 (x2, 
E_V4QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 635; /* gatherv4qi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 731; /* gatherv4qi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V4HImode:
      switch (pattern230 (x2, 
E_V4HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 637; /* gatherv4hi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 733; /* gatherv4hi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V4HFmode:
      switch (pattern230 (x2, 
E_V4HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 639; /* gatherv4hf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 735; /* gatherv4hf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern230 (x2, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 641; /* gatherv4si_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 737; /* gatherv4si_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V4SFmode:
      switch (pattern230 (x2, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 643; /* gatherv4sf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 739; /* gatherv4sf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern230 (x2, 
E_V4DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 645; /* gatherv4di_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 741; /* gatherv4di_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V4DFmode:
      switch (pattern230 (x2, 
E_V4DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 647; /* gatherv4df_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 743; /* gatherv4df_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V4TImode:
      switch (pattern230 (x2, 
E_V4TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 649; /* gatherv4ti_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 745; /* gatherv4ti_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V8QImode:
      switch (pattern231 (x2, 
E_V8QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 651; /* gatherv8qi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 747; /* gatherv8qi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V8HImode:
      switch (pattern231 (x2, 
E_V8HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 653; /* gatherv8hi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 749; /* gatherv8hi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V8HFmode:
      switch (pattern231 (x2, 
E_V8HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 655; /* gatherv8hf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 751; /* gatherv8hf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern231 (x2, 
E_V8SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 657; /* gatherv8si_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 753; /* gatherv8si_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V8SFmode:
      switch (pattern231 (x2, 
E_V8SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 659; /* gatherv8sf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 755; /* gatherv8sf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern231 (x2, 
E_V8DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 661; /* gatherv8di_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 757; /* gatherv8di_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V8DFmode:
      switch (pattern231 (x2, 
E_V8DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 663; /* gatherv8df_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 759; /* gatherv8df_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V8TImode:
      switch (pattern231 (x2, 
E_V8TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 665; /* gatherv8ti_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 761; /* gatherv8ti_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V16QImode:
      switch (pattern232 (x2, 
E_V16QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 667; /* gatherv16qi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 763; /* gatherv16qi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V16HImode:
      switch (pattern232 (x2, 
E_V16HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 669; /* gatherv16hi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 765; /* gatherv16hi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V16HFmode:
      switch (pattern232 (x2, 
E_V16HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 671; /* gatherv16hf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 767; /* gatherv16hf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern232 (x2, 
E_V16SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 673; /* gatherv16si_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 769; /* gatherv16si_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V16SFmode:
      switch (pattern232 (x2, 
E_V16SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 675; /* gatherv16sf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 771; /* gatherv16sf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V16DImode:
      switch (pattern232 (x2, 
E_V16DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 677; /* gatherv16di_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 773; /* gatherv16di_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V16DFmode:
      switch (pattern232 (x2, 
E_V16DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 679; /* gatherv16df_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 775; /* gatherv16df_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V16TImode:
      switch (pattern232 (x2, 
E_V16TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 681; /* gatherv16ti_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 777; /* gatherv16ti_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V32QImode:
      switch (pattern233 (x2, 
E_V32QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 683; /* gatherv32qi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 779; /* gatherv32qi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V32HImode:
      switch (pattern233 (x2, 
E_V32HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 685; /* gatherv32hi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 781; /* gatherv32hi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V32HFmode:
      switch (pattern233 (x2, 
E_V32HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 687; /* gatherv32hf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 783; /* gatherv32hf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V32SImode:
      switch (pattern233 (x2, 
E_V32SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 689; /* gatherv32si_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 785; /* gatherv32si_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V32SFmode:
      switch (pattern233 (x2, 
E_V32SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 691; /* gatherv32sf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 787; /* gatherv32sf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V32DImode:
      switch (pattern233 (x2, 
E_V32DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 693; /* gatherv32di_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 789; /* gatherv32di_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V32DFmode:
      switch (pattern233 (x2, 
E_V32DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 695; /* gatherv32df_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 791; /* gatherv32df_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V32TImode:
      switch (pattern233 (x2, 
E_V32TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 697; /* gatherv32ti_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 793; /* gatherv32ti_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V64QImode:
      switch (pattern234 (x2, 
E_V64QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 699; /* gatherv64qi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 795; /* gatherv64qi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V64HImode:
      switch (pattern234 (x2, 
E_V64HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 701; /* gatherv64hi_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 797; /* gatherv64hi_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V64HFmode:
      switch (pattern234 (x2, 
E_V64HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 703; /* gatherv64hf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 799; /* gatherv64hf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V64SImode:
      switch (pattern234 (x2, 
E_V64SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 705; /* gatherv64si_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 801; /* gatherv64si_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V64SFmode:
      switch (pattern234 (x2, 
E_V64SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 707; /* gatherv64sf_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 803; /* gatherv64sf_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V64DImode:
      switch (pattern234 (x2, 
E_V64DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 709; /* gatherv64di_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 805; /* gatherv64di_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V64DFmode:
      switch (pattern234 (x2, 
E_V64DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 711; /* gatherv64df_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 807; /* gatherv64df_insn_1offset_ds_exec */

        default:
          return -1;
        }

    case E_V64TImode:
      switch (pattern234 (x2, 
E_V64TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 713; /* gatherv64ti_insn_1offset_exec */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 809; /* gatherv64ti_insn_1offset_ds_exec */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern63 (x2))
    {
    case 0:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3270; /* fixuns_truncv2hiv2hf2_exec */

    case 1:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3282; /* fixuns_truncv2siv2hf2_exec */

    case 2:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3294; /* fixuns_truncv2hfv2hf2_exec */

    case 3:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3306; /* fixuns_truncv2sfv2hf2_exec */

    case 4:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3318; /* fixuns_truncv2dfv2hf2_exec */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3330; /* fixuns_truncv2hiv2sf2_exec */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3342; /* fixuns_truncv2siv2sf2_exec */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3354; /* fixuns_truncv2hfv2sf2_exec */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3366; /* fixuns_truncv2sfv2sf2_exec */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3378; /* fixuns_truncv2dfv2sf2_exec */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3390; /* fixuns_truncv2hiv2df2_exec */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3402; /* fixuns_truncv2siv2df2_exec */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3414; /* fixuns_truncv2hfv2df2_exec */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3426; /* fixuns_truncv2sfv2df2_exec */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3438; /* fixuns_truncv2dfv2df2_exec */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3450; /* fixuns_truncv4hiv4hf2_exec */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3462; /* fixuns_truncv4siv4hf2_exec */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3474; /* fixuns_truncv4hfv4hf2_exec */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3486; /* fixuns_truncv4sfv4hf2_exec */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3498; /* fixuns_truncv4dfv4hf2_exec */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3510; /* fixuns_truncv4hiv4sf2_exec */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3522; /* fixuns_truncv4siv4sf2_exec */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3534; /* fixuns_truncv4hfv4sf2_exec */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3546; /* fixuns_truncv4sfv4sf2_exec */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3558; /* fixuns_truncv4dfv4sf2_exec */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3570; /* fixuns_truncv4hiv4df2_exec */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3582; /* fixuns_truncv4siv4df2_exec */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3594; /* fixuns_truncv4hfv4df2_exec */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3606; /* fixuns_truncv4sfv4df2_exec */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3618; /* fixuns_truncv4dfv4df2_exec */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3630; /* fixuns_truncv8hiv8hf2_exec */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3642; /* fixuns_truncv8siv8hf2_exec */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3654; /* fixuns_truncv8hfv8hf2_exec */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3666; /* fixuns_truncv8sfv8hf2_exec */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3678; /* fixuns_truncv8dfv8hf2_exec */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3690; /* fixuns_truncv8hiv8sf2_exec */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3702; /* fixuns_truncv8siv8sf2_exec */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3714; /* fixuns_truncv8hfv8sf2_exec */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3726; /* fixuns_truncv8sfv8sf2_exec */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3738; /* fixuns_truncv8dfv8sf2_exec */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3750; /* fixuns_truncv8hiv8df2_exec */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3762; /* fixuns_truncv8siv8df2_exec */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3774; /* fixuns_truncv8hfv8df2_exec */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3786; /* fixuns_truncv8sfv8df2_exec */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3798; /* fixuns_truncv8dfv8df2_exec */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3810; /* fixuns_truncv16hiv16hf2_exec */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3822; /* fixuns_truncv16siv16hf2_exec */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3834; /* fixuns_truncv16hfv16hf2_exec */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3846; /* fixuns_truncv16sfv16hf2_exec */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3858; /* fixuns_truncv16dfv16hf2_exec */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3870; /* fixuns_truncv16hiv16sf2_exec */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3882; /* fixuns_truncv16siv16sf2_exec */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3894; /* fixuns_truncv16hfv16sf2_exec */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3906; /* fixuns_truncv16sfv16sf2_exec */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3918; /* fixuns_truncv16dfv16sf2_exec */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3930; /* fixuns_truncv16hiv16df2_exec */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3942; /* fixuns_truncv16siv16df2_exec */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3954; /* fixuns_truncv16hfv16df2_exec */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3966; /* fixuns_truncv16sfv16df2_exec */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3978; /* fixuns_truncv16dfv16df2_exec */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3990; /* fixuns_truncv32hiv32hf2_exec */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4002; /* fixuns_truncv32siv32hf2_exec */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4014; /* fixuns_truncv32hfv32hf2_exec */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4026; /* fixuns_truncv32sfv32hf2_exec */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4038; /* fixuns_truncv32dfv32hf2_exec */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4050; /* fixuns_truncv32hiv32sf2_exec */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4062; /* fixuns_truncv32siv32sf2_exec */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4074; /* fixuns_truncv32hfv32sf2_exec */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4086; /* fixuns_truncv32sfv32sf2_exec */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4098; /* fixuns_truncv32dfv32sf2_exec */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4110; /* fixuns_truncv32hiv32df2_exec */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4122; /* fixuns_truncv32siv32df2_exec */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4134; /* fixuns_truncv32hfv32df2_exec */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4146; /* fixuns_truncv32sfv32df2_exec */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4158; /* fixuns_truncv32dfv32df2_exec */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4170; /* fixuns_truncv64hiv64hf2_exec */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4182; /* fixuns_truncv64siv64hf2_exec */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4194; /* fixuns_truncv64hfv64hf2_exec */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4206; /* fixuns_truncv64sfv64hf2_exec */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4218; /* fixuns_truncv64dfv64hf2_exec */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4230; /* fixuns_truncv64hiv64sf2_exec */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4242; /* fixuns_truncv64siv64sf2_exec */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4254; /* fixuns_truncv64hfv64sf2_exec */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4266; /* fixuns_truncv64sfv64sf2_exec */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4278; /* fixuns_truncv64dfv64sf2_exec */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4290; /* fixuns_truncv64hiv64df2_exec */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4302; /* fixuns_truncv64siv64df2_exec */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4314; /* fixuns_truncv64hfv64df2_exec */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4326; /* fixuns_truncv64sfv64df2_exec */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4338; /* fixuns_truncv64dfv64df2_exec */

    case 90:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4350; /* fixuns_truncv2hfv2hi2_exec */

    case 91:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4362; /* fixuns_truncv2sfv2hi2_exec */

    case 92:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4374; /* fixuns_truncv2dfv2hi2_exec */

    case 93:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4386; /* fixuns_truncv2hfv2si2_exec */

    case 94:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4398; /* fixuns_truncv2sfv2si2_exec */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4410; /* fixuns_truncv2dfv2si2_exec */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4422; /* fixuns_truncv4hfv4hi2_exec */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4434; /* fixuns_truncv4sfv4hi2_exec */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4446; /* fixuns_truncv4dfv4hi2_exec */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4458; /* fixuns_truncv4hfv4si2_exec */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4470; /* fixuns_truncv4sfv4si2_exec */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4482; /* fixuns_truncv4dfv4si2_exec */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4494; /* fixuns_truncv8hfv8hi2_exec */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4506; /* fixuns_truncv8sfv8hi2_exec */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4518; /* fixuns_truncv8dfv8hi2_exec */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4530; /* fixuns_truncv8hfv8si2_exec */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4542; /* fixuns_truncv8sfv8si2_exec */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4554; /* fixuns_truncv8dfv8si2_exec */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4566; /* fixuns_truncv16hfv16hi2_exec */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4578; /* fixuns_truncv16sfv16hi2_exec */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4590; /* fixuns_truncv16dfv16hi2_exec */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4602; /* fixuns_truncv16hfv16si2_exec */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4614; /* fixuns_truncv16sfv16si2_exec */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4626; /* fixuns_truncv16dfv16si2_exec */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4638; /* fixuns_truncv32hfv32hi2_exec */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4650; /* fixuns_truncv32sfv32hi2_exec */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4662; /* fixuns_truncv32dfv32hi2_exec */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4674; /* fixuns_truncv32hfv32si2_exec */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4686; /* fixuns_truncv32sfv32si2_exec */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4698; /* fixuns_truncv32dfv32si2_exec */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4710; /* fixuns_truncv64hfv64hi2_exec */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4722; /* fixuns_truncv64sfv64hi2_exec */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4734; /* fixuns_truncv64dfv64hi2_exec */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4746; /* fixuns_truncv64hfv64si2_exec */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4758; /* fixuns_truncv64sfv64si2_exec */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4770; /* fixuns_truncv64dfv64si2_exec */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4781; /* *zero_extendv2qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6725; /* *zero_extendv2qiv2qi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4785; /* *zero_extendv2hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6731; /* *zero_extendv2hiv2qi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4789; /* *zero_extendv2siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6737; /* *zero_extendv2siv2qi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4793; /* *zero_extendv4qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6743; /* *zero_extendv4qiv2qi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4797; /* *zero_extendv4hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6749; /* *zero_extendv4hiv2qi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4801; /* *zero_extendv4siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6755; /* *zero_extendv4siv2qi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4805; /* *zero_extendv8qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6761; /* *zero_extendv8qiv2qi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4809; /* *zero_extendv8hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6767; /* *zero_extendv8hiv2qi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4813; /* *zero_extendv8siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6773; /* *zero_extendv8siv2qi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4817; /* *zero_extendv16qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6779; /* *zero_extendv16qiv2qi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4821; /* *zero_extendv16hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6785; /* *zero_extendv16hiv2qi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4825; /* *zero_extendv16siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6791; /* *zero_extendv16siv2qi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4829; /* *zero_extendv32qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6797; /* *zero_extendv32qiv2qi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4833; /* *zero_extendv32hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6803; /* *zero_extendv32hiv2qi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4837; /* *zero_extendv32siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6809; /* *zero_extendv32siv2qi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4841; /* *zero_extendv64qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6815; /* *zero_extendv64qiv2qi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4845; /* *zero_extendv64hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6821; /* *zero_extendv64hiv2qi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4849; /* *zero_extendv64siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6827; /* *zero_extendv64siv2qi_shift */

    case 18:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4853; /* *zero_extendv2qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6833; /* *zero_extendv2qiv2hi_shift */

    case 19:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4857; /* *zero_extendv2hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6839; /* *zero_extendv2hiv2hi_shift */

    case 20:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4861; /* *zero_extendv2siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6845; /* *zero_extendv2siv2hi_shift */

    case 21:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4865; /* *zero_extendv4qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6851; /* *zero_extendv4qiv2hi_shift */

    case 22:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4869; /* *zero_extendv4hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6857; /* *zero_extendv4hiv2hi_shift */

    case 23:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4873; /* *zero_extendv4siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6863; /* *zero_extendv4siv2hi_shift */

    case 24:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4877; /* *zero_extendv8qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6869; /* *zero_extendv8qiv2hi_shift */

    case 25:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4881; /* *zero_extendv8hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6875; /* *zero_extendv8hiv2hi_shift */

    case 26:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4885; /* *zero_extendv8siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6881; /* *zero_extendv8siv2hi_shift */

    case 27:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4889; /* *zero_extendv16qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6887; /* *zero_extendv16qiv2hi_shift */

    case 28:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4893; /* *zero_extendv16hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6893; /* *zero_extendv16hiv2hi_shift */

    case 29:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4897; /* *zero_extendv16siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6899; /* *zero_extendv16siv2hi_shift */

    case 30:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4901; /* *zero_extendv32qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6905; /* *zero_extendv32qiv2hi_shift */

    case 31:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4905; /* *zero_extendv32hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6911; /* *zero_extendv32hiv2hi_shift */

    case 32:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4909; /* *zero_extendv32siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6917; /* *zero_extendv32siv2hi_shift */

    case 33:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4913; /* *zero_extendv64qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6923; /* *zero_extendv64qiv2hi_shift */

    case 34:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4917; /* *zero_extendv64hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6929; /* *zero_extendv64hiv2hi_shift */

    case 35:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4921; /* *zero_extendv64siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6935; /* *zero_extendv64siv2hi_shift */

    case 36:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4925; /* *zero_extendv2qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6941; /* *zero_extendv2qiv2si_shift */

    case 37:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4929; /* *zero_extendv2hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6947; /* *zero_extendv2hiv2si_shift */

    case 38:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4933; /* *zero_extendv2siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6953; /* *zero_extendv2siv2si_shift */

    case 39:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4937; /* *zero_extendv4qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6959; /* *zero_extendv4qiv2si_shift */

    case 40:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4941; /* *zero_extendv4hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6965; /* *zero_extendv4hiv2si_shift */

    case 41:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4945; /* *zero_extendv4siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6971; /* *zero_extendv4siv2si_shift */

    case 42:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4949; /* *zero_extendv8qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6977; /* *zero_extendv8qiv2si_shift */

    case 43:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4953; /* *zero_extendv8hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6983; /* *zero_extendv8hiv2si_shift */

    case 44:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4957; /* *zero_extendv8siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6989; /* *zero_extendv8siv2si_shift */

    case 45:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4961; /* *zero_extendv16qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6995; /* *zero_extendv16qiv2si_shift */

    case 46:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4965; /* *zero_extendv16hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7001; /* *zero_extendv16hiv2si_shift */

    case 47:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4969; /* *zero_extendv16siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7007; /* *zero_extendv16siv2si_shift */

    case 48:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4973; /* *zero_extendv32qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7013; /* *zero_extendv32qiv2si_shift */

    case 49:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4977; /* *zero_extendv32hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7019; /* *zero_extendv32hiv2si_shift */

    case 50:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4981; /* *zero_extendv32siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7025; /* *zero_extendv32siv2si_shift */

    case 51:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4985; /* *zero_extendv64qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7031; /* *zero_extendv64qiv2si_shift */

    case 52:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4989; /* *zero_extendv64hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7037; /* *zero_extendv64hiv2si_shift */

    case 53:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4993; /* *zero_extendv64siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7043; /* *zero_extendv64siv2si_shift */

    case 54:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4997; /* *zero_extendv2qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7049; /* *zero_extendv2qiv4qi_shift */

    case 55:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5001; /* *zero_extendv2hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7055; /* *zero_extendv2hiv4qi_shift */

    case 56:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5005; /* *zero_extendv2siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7061; /* *zero_extendv2siv4qi_shift */

    case 57:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5009; /* *zero_extendv4qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7067; /* *zero_extendv4qiv4qi_shift */

    case 58:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5013; /* *zero_extendv4hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7073; /* *zero_extendv4hiv4qi_shift */

    case 59:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5017; /* *zero_extendv4siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7079; /* *zero_extendv4siv4qi_shift */

    case 60:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5021; /* *zero_extendv8qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7085; /* *zero_extendv8qiv4qi_shift */

    case 61:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5025; /* *zero_extendv8hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7091; /* *zero_extendv8hiv4qi_shift */

    case 62:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5029; /* *zero_extendv8siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7097; /* *zero_extendv8siv4qi_shift */

    case 63:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5033; /* *zero_extendv16qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7103; /* *zero_extendv16qiv4qi_shift */

    case 64:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5037; /* *zero_extendv16hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7109; /* *zero_extendv16hiv4qi_shift */

    case 65:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5041; /* *zero_extendv16siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7115; /* *zero_extendv16siv4qi_shift */

    case 66:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5045; /* *zero_extendv32qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7121; /* *zero_extendv32qiv4qi_shift */

    case 67:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5049; /* *zero_extendv32hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7127; /* *zero_extendv32hiv4qi_shift */

    case 68:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5053; /* *zero_extendv32siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7133; /* *zero_extendv32siv4qi_shift */

    case 69:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5057; /* *zero_extendv64qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7139; /* *zero_extendv64qiv4qi_shift */

    case 70:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5061; /* *zero_extendv64hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7145; /* *zero_extendv64hiv4qi_shift */

    case 71:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5065; /* *zero_extendv64siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7151; /* *zero_extendv64siv4qi_shift */

    case 72:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5069; /* *zero_extendv2qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7157; /* *zero_extendv2qiv4hi_shift */

    case 73:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5073; /* *zero_extendv2hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7163; /* *zero_extendv2hiv4hi_shift */

    case 74:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5077; /* *zero_extendv2siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7169; /* *zero_extendv2siv4hi_shift */

    case 75:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5081; /* *zero_extendv4qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7175; /* *zero_extendv4qiv4hi_shift */

    case 76:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5085; /* *zero_extendv4hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7181; /* *zero_extendv4hiv4hi_shift */

    case 77:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5089; /* *zero_extendv4siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7187; /* *zero_extendv4siv4hi_shift */

    case 78:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5093; /* *zero_extendv8qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7193; /* *zero_extendv8qiv4hi_shift */

    case 79:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5097; /* *zero_extendv8hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7199; /* *zero_extendv8hiv4hi_shift */

    case 80:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5101; /* *zero_extendv8siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7205; /* *zero_extendv8siv4hi_shift */

    case 81:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5105; /* *zero_extendv16qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7211; /* *zero_extendv16qiv4hi_shift */

    case 82:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5109; /* *zero_extendv16hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7217; /* *zero_extendv16hiv4hi_shift */

    case 83:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5113; /* *zero_extendv16siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7223; /* *zero_extendv16siv4hi_shift */

    case 84:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5117; /* *zero_extendv32qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7229; /* *zero_extendv32qiv4hi_shift */

    case 85:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5121; /* *zero_extendv32hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7235; /* *zero_extendv32hiv4hi_shift */

    case 86:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5125; /* *zero_extendv32siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7241; /* *zero_extendv32siv4hi_shift */

    case 87:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5129; /* *zero_extendv64qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7247; /* *zero_extendv64qiv4hi_shift */

    case 88:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5133; /* *zero_extendv64hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7253; /* *zero_extendv64hiv4hi_shift */

    case 89:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5137; /* *zero_extendv64siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7259; /* *zero_extendv64siv4hi_shift */

    case 90:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5141; /* *zero_extendv2qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7265; /* *zero_extendv2qiv4si_shift */

    case 91:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5145; /* *zero_extendv2hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7271; /* *zero_extendv2hiv4si_shift */

    case 92:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5149; /* *zero_extendv2siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7277; /* *zero_extendv2siv4si_shift */

    case 93:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5153; /* *zero_extendv4qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7283; /* *zero_extendv4qiv4si_shift */

    case 94:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5157; /* *zero_extendv4hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7289; /* *zero_extendv4hiv4si_shift */

    case 95:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5161; /* *zero_extendv4siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7295; /* *zero_extendv4siv4si_shift */

    case 96:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5165; /* *zero_extendv8qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7301; /* *zero_extendv8qiv4si_shift */

    case 97:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5169; /* *zero_extendv8hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7307; /* *zero_extendv8hiv4si_shift */

    case 98:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5173; /* *zero_extendv8siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7313; /* *zero_extendv8siv4si_shift */

    case 99:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5177; /* *zero_extendv16qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7319; /* *zero_extendv16qiv4si_shift */

    case 100:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5181; /* *zero_extendv16hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7325; /* *zero_extendv16hiv4si_shift */

    case 101:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5185; /* *zero_extendv16siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7331; /* *zero_extendv16siv4si_shift */

    case 102:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5189; /* *zero_extendv32qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7337; /* *zero_extendv32qiv4si_shift */

    case 103:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5193; /* *zero_extendv32hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7343; /* *zero_extendv32hiv4si_shift */

    case 104:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5197; /* *zero_extendv32siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7349; /* *zero_extendv32siv4si_shift */

    case 105:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5201; /* *zero_extendv64qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7355; /* *zero_extendv64qiv4si_shift */

    case 106:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5205; /* *zero_extendv64hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7361; /* *zero_extendv64hiv4si_shift */

    case 107:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5209; /* *zero_extendv64siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7367; /* *zero_extendv64siv4si_shift */

    case 108:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5213; /* *zero_extendv2qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7373; /* *zero_extendv2qiv8qi_shift */

    case 109:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5217; /* *zero_extendv2hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7379; /* *zero_extendv2hiv8qi_shift */

    case 110:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5221; /* *zero_extendv2siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7385; /* *zero_extendv2siv8qi_shift */

    case 111:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5225; /* *zero_extendv4qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7391; /* *zero_extendv4qiv8qi_shift */

    case 112:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5229; /* *zero_extendv4hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7397; /* *zero_extendv4hiv8qi_shift */

    case 113:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5233; /* *zero_extendv4siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7403; /* *zero_extendv4siv8qi_shift */

    case 114:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5237; /* *zero_extendv8qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7409; /* *zero_extendv8qiv8qi_shift */

    case 115:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5241; /* *zero_extendv8hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7415; /* *zero_extendv8hiv8qi_shift */

    case 116:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5245; /* *zero_extendv8siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7421; /* *zero_extendv8siv8qi_shift */

    case 117:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5249; /* *zero_extendv16qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7427; /* *zero_extendv16qiv8qi_shift */

    case 118:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5253; /* *zero_extendv16hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7433; /* *zero_extendv16hiv8qi_shift */

    case 119:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5257; /* *zero_extendv16siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7439; /* *zero_extendv16siv8qi_shift */

    case 120:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5261; /* *zero_extendv32qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7445; /* *zero_extendv32qiv8qi_shift */

    case 121:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5265; /* *zero_extendv32hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7451; /* *zero_extendv32hiv8qi_shift */

    case 122:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5269; /* *zero_extendv32siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7457; /* *zero_extendv32siv8qi_shift */

    case 123:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5273; /* *zero_extendv64qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7463; /* *zero_extendv64qiv8qi_shift */

    case 124:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5277; /* *zero_extendv64hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7469; /* *zero_extendv64hiv8qi_shift */

    case 125:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5281; /* *zero_extendv64siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7475; /* *zero_extendv64siv8qi_shift */

    case 126:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5285; /* *zero_extendv2qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7481; /* *zero_extendv2qiv8hi_shift */

    case 127:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5289; /* *zero_extendv2hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7487; /* *zero_extendv2hiv8hi_shift */

    case 128:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5293; /* *zero_extendv2siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7493; /* *zero_extendv2siv8hi_shift */

    case 129:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5297; /* *zero_extendv4qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7499; /* *zero_extendv4qiv8hi_shift */

    case 130:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5301; /* *zero_extendv4hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7505; /* *zero_extendv4hiv8hi_shift */

    case 131:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5305; /* *zero_extendv4siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7511; /* *zero_extendv4siv8hi_shift */

    case 132:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5309; /* *zero_extendv8qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7517; /* *zero_extendv8qiv8hi_shift */

    case 133:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5313; /* *zero_extendv8hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7523; /* *zero_extendv8hiv8hi_shift */

    case 134:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5317; /* *zero_extendv8siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7529; /* *zero_extendv8siv8hi_shift */

    case 135:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5321; /* *zero_extendv16qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7535; /* *zero_extendv16qiv8hi_shift */

    case 136:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5325; /* *zero_extendv16hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7541; /* *zero_extendv16hiv8hi_shift */

    case 137:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5329; /* *zero_extendv16siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7547; /* *zero_extendv16siv8hi_shift */

    case 138:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5333; /* *zero_extendv32qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7553; /* *zero_extendv32qiv8hi_shift */

    case 139:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5337; /* *zero_extendv32hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7559; /* *zero_extendv32hiv8hi_shift */

    case 140:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5341; /* *zero_extendv32siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7565; /* *zero_extendv32siv8hi_shift */

    case 141:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5345; /* *zero_extendv64qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7571; /* *zero_extendv64qiv8hi_shift */

    case 142:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5349; /* *zero_extendv64hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7577; /* *zero_extendv64hiv8hi_shift */

    case 143:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5353; /* *zero_extendv64siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7583; /* *zero_extendv64siv8hi_shift */

    case 144:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5357; /* *zero_extendv2qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7589; /* *zero_extendv2qiv8si_shift */

    case 145:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5361; /* *zero_extendv2hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7595; /* *zero_extendv2hiv8si_shift */

    case 146:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5365; /* *zero_extendv2siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7601; /* *zero_extendv2siv8si_shift */

    case 147:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5369; /* *zero_extendv4qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7607; /* *zero_extendv4qiv8si_shift */

    case 148:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5373; /* *zero_extendv4hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7613; /* *zero_extendv4hiv8si_shift */

    case 149:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5377; /* *zero_extendv4siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7619; /* *zero_extendv4siv8si_shift */

    case 150:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5381; /* *zero_extendv8qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7625; /* *zero_extendv8qiv8si_shift */

    case 151:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5385; /* *zero_extendv8hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7631; /* *zero_extendv8hiv8si_shift */

    case 152:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5389; /* *zero_extendv8siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7637; /* *zero_extendv8siv8si_shift */

    case 153:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5393; /* *zero_extendv16qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7643; /* *zero_extendv16qiv8si_shift */

    case 154:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5397; /* *zero_extendv16hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7649; /* *zero_extendv16hiv8si_shift */

    case 155:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5401; /* *zero_extendv16siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7655; /* *zero_extendv16siv8si_shift */

    case 156:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5405; /* *zero_extendv32qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7661; /* *zero_extendv32qiv8si_shift */

    case 157:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5409; /* *zero_extendv32hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7667; /* *zero_extendv32hiv8si_shift */

    case 158:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5413; /* *zero_extendv32siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7673; /* *zero_extendv32siv8si_shift */

    case 159:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5417; /* *zero_extendv64qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7679; /* *zero_extendv64qiv8si_shift */

    case 160:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5421; /* *zero_extendv64hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7685; /* *zero_extendv64hiv8si_shift */

    case 161:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5425; /* *zero_extendv64siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7691; /* *zero_extendv64siv8si_shift */

    case 162:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5429; /* *zero_extendv2qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7697; /* *zero_extendv2qiv16qi_shift */

    case 163:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5433; /* *zero_extendv2hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7703; /* *zero_extendv2hiv16qi_shift */

    case 164:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5437; /* *zero_extendv2siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7709; /* *zero_extendv2siv16qi_shift */

    case 165:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5441; /* *zero_extendv4qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7715; /* *zero_extendv4qiv16qi_shift */

    case 166:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5445; /* *zero_extendv4hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7721; /* *zero_extendv4hiv16qi_shift */

    case 167:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5449; /* *zero_extendv4siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7727; /* *zero_extendv4siv16qi_shift */

    case 168:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5453; /* *zero_extendv8qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7733; /* *zero_extendv8qiv16qi_shift */

    case 169:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5457; /* *zero_extendv8hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7739; /* *zero_extendv8hiv16qi_shift */

    case 170:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5461; /* *zero_extendv8siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7745; /* *zero_extendv8siv16qi_shift */

    case 171:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5465; /* *zero_extendv16qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7751; /* *zero_extendv16qiv16qi_shift */

    case 172:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5469; /* *zero_extendv16hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7757; /* *zero_extendv16hiv16qi_shift */

    case 173:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5473; /* *zero_extendv16siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7763; /* *zero_extendv16siv16qi_shift */

    case 174:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5477; /* *zero_extendv32qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7769; /* *zero_extendv32qiv16qi_shift */

    case 175:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5481; /* *zero_extendv32hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7775; /* *zero_extendv32hiv16qi_shift */

    case 176:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5485; /* *zero_extendv32siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7781; /* *zero_extendv32siv16qi_shift */

    case 177:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5489; /* *zero_extendv64qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7787; /* *zero_extendv64qiv16qi_shift */

    case 178:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5493; /* *zero_extendv64hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7793; /* *zero_extendv64hiv16qi_shift */

    case 179:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5497; /* *zero_extendv64siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7799; /* *zero_extendv64siv16qi_shift */

    case 180:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5501; /* *zero_extendv2qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7805; /* *zero_extendv2qiv16hi_shift */

    case 181:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5505; /* *zero_extendv2hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7811; /* *zero_extendv2hiv16hi_shift */

    case 182:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5509; /* *zero_extendv2siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7817; /* *zero_extendv2siv16hi_shift */

    case 183:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5513; /* *zero_extendv4qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7823; /* *zero_extendv4qiv16hi_shift */

    case 184:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5517; /* *zero_extendv4hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7829; /* *zero_extendv4hiv16hi_shift */

    case 185:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5521; /* *zero_extendv4siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7835; /* *zero_extendv4siv16hi_shift */

    case 186:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5525; /* *zero_extendv8qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7841; /* *zero_extendv8qiv16hi_shift */

    case 187:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5529; /* *zero_extendv8hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7847; /* *zero_extendv8hiv16hi_shift */

    case 188:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5533; /* *zero_extendv8siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7853; /* *zero_extendv8siv16hi_shift */

    case 189:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5537; /* *zero_extendv16qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7859; /* *zero_extendv16qiv16hi_shift */

    case 190:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5541; /* *zero_extendv16hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7865; /* *zero_extendv16hiv16hi_shift */

    case 191:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5545; /* *zero_extendv16siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7871; /* *zero_extendv16siv16hi_shift */

    case 192:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5549; /* *zero_extendv32qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7877; /* *zero_extendv32qiv16hi_shift */

    case 193:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5553; /* *zero_extendv32hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7883; /* *zero_extendv32hiv16hi_shift */

    case 194:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5557; /* *zero_extendv32siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7889; /* *zero_extendv32siv16hi_shift */

    case 195:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5561; /* *zero_extendv64qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7895; /* *zero_extendv64qiv16hi_shift */

    case 196:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5565; /* *zero_extendv64hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7901; /* *zero_extendv64hiv16hi_shift */

    case 197:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5569; /* *zero_extendv64siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7907; /* *zero_extendv64siv16hi_shift */

    case 198:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5573; /* *zero_extendv2qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7913; /* *zero_extendv2qiv16si_shift */

    case 199:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5577; /* *zero_extendv2hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7919; /* *zero_extendv2hiv16si_shift */

    case 200:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5581; /* *zero_extendv2siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7925; /* *zero_extendv2siv16si_shift */

    case 201:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5585; /* *zero_extendv4qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7931; /* *zero_extendv4qiv16si_shift */

    case 202:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5589; /* *zero_extendv4hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7937; /* *zero_extendv4hiv16si_shift */

    case 203:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5593; /* *zero_extendv4siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7943; /* *zero_extendv4siv16si_shift */

    case 204:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5597; /* *zero_extendv8qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7949; /* *zero_extendv8qiv16si_shift */

    case 205:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5601; /* *zero_extendv8hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7955; /* *zero_extendv8hiv16si_shift */

    case 206:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5605; /* *zero_extendv8siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7961; /* *zero_extendv8siv16si_shift */

    case 207:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5609; /* *zero_extendv16qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7967; /* *zero_extendv16qiv16si_shift */

    case 208:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5613; /* *zero_extendv16hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7973; /* *zero_extendv16hiv16si_shift */

    case 209:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5617; /* *zero_extendv16siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7979; /* *zero_extendv16siv16si_shift */

    case 210:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5621; /* *zero_extendv32qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7985; /* *zero_extendv32qiv16si_shift */

    case 211:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5625; /* *zero_extendv32hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7991; /* *zero_extendv32hiv16si_shift */

    case 212:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5629; /* *zero_extendv32siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7997; /* *zero_extendv32siv16si_shift */

    case 213:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5633; /* *zero_extendv64qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8003; /* *zero_extendv64qiv16si_shift */

    case 214:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5637; /* *zero_extendv64hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8009; /* *zero_extendv64hiv16si_shift */

    case 215:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5641; /* *zero_extendv64siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8015; /* *zero_extendv64siv16si_shift */

    case 216:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5645; /* *zero_extendv2qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8021; /* *zero_extendv2qiv32qi_shift */

    case 217:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5649; /* *zero_extendv2hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8027; /* *zero_extendv2hiv32qi_shift */

    case 218:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5653; /* *zero_extendv2siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8033; /* *zero_extendv2siv32qi_shift */

    case 219:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5657; /* *zero_extendv4qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8039; /* *zero_extendv4qiv32qi_shift */

    case 220:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5661; /* *zero_extendv4hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8045; /* *zero_extendv4hiv32qi_shift */

    case 221:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5665; /* *zero_extendv4siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8051; /* *zero_extendv4siv32qi_shift */

    case 222:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5669; /* *zero_extendv8qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8057; /* *zero_extendv8qiv32qi_shift */

    case 223:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5673; /* *zero_extendv8hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8063; /* *zero_extendv8hiv32qi_shift */

    case 224:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5677; /* *zero_extendv8siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8069; /* *zero_extendv8siv32qi_shift */

    case 225:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5681; /* *zero_extendv16qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8075; /* *zero_extendv16qiv32qi_shift */

    case 226:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5685; /* *zero_extendv16hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8081; /* *zero_extendv16hiv32qi_shift */

    case 227:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5689; /* *zero_extendv16siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8087; /* *zero_extendv16siv32qi_shift */

    case 228:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5693; /* *zero_extendv32qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8093; /* *zero_extendv32qiv32qi_shift */

    case 229:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5697; /* *zero_extendv32hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8099; /* *zero_extendv32hiv32qi_shift */

    case 230:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5701; /* *zero_extendv32siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8105; /* *zero_extendv32siv32qi_shift */

    case 231:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5705; /* *zero_extendv64qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8111; /* *zero_extendv64qiv32qi_shift */

    case 232:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5709; /* *zero_extendv64hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8117; /* *zero_extendv64hiv32qi_shift */

    case 233:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5713; /* *zero_extendv64siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8123; /* *zero_extendv64siv32qi_shift */

    case 234:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5717; /* *zero_extendv2qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8129; /* *zero_extendv2qiv32hi_shift */

    case 235:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5721; /* *zero_extendv2hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8135; /* *zero_extendv2hiv32hi_shift */

    case 236:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5725; /* *zero_extendv2siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8141; /* *zero_extendv2siv32hi_shift */

    case 237:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5729; /* *zero_extendv4qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8147; /* *zero_extendv4qiv32hi_shift */

    case 238:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5733; /* *zero_extendv4hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8153; /* *zero_extendv4hiv32hi_shift */

    case 239:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5737; /* *zero_extendv4siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8159; /* *zero_extendv4siv32hi_shift */

    case 240:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5741; /* *zero_extendv8qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8165; /* *zero_extendv8qiv32hi_shift */

    case 241:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5745; /* *zero_extendv8hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8171; /* *zero_extendv8hiv32hi_shift */

    case 242:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5749; /* *zero_extendv8siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8177; /* *zero_extendv8siv32hi_shift */

    case 243:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5753; /* *zero_extendv16qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8183; /* *zero_extendv16qiv32hi_shift */

    case 244:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5757; /* *zero_extendv16hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8189; /* *zero_extendv16hiv32hi_shift */

    case 245:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5761; /* *zero_extendv16siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8195; /* *zero_extendv16siv32hi_shift */

    case 246:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5765; /* *zero_extendv32qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8201; /* *zero_extendv32qiv32hi_shift */

    case 247:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5769; /* *zero_extendv32hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8207; /* *zero_extendv32hiv32hi_shift */

    case 248:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5773; /* *zero_extendv32siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8213; /* *zero_extendv32siv32hi_shift */

    case 249:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5777; /* *zero_extendv64qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8219; /* *zero_extendv64qiv32hi_shift */

    case 250:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5781; /* *zero_extendv64hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8225; /* *zero_extendv64hiv32hi_shift */

    case 251:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5785; /* *zero_extendv64siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8231; /* *zero_extendv64siv32hi_shift */

    case 252:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5789; /* *zero_extendv2qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8237; /* *zero_extendv2qiv32si_shift */

    case 253:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5793; /* *zero_extendv2hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8243; /* *zero_extendv2hiv32si_shift */

    case 254:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5797; /* *zero_extendv2siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8249; /* *zero_extendv2siv32si_shift */

    case 255:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5801; /* *zero_extendv4qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8255; /* *zero_extendv4qiv32si_shift */

    case 256:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5805; /* *zero_extendv4hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8261; /* *zero_extendv4hiv32si_shift */

    case 257:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5809; /* *zero_extendv4siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8267; /* *zero_extendv4siv32si_shift */

    case 258:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5813; /* *zero_extendv8qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8273; /* *zero_extendv8qiv32si_shift */

    case 259:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5817; /* *zero_extendv8hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8279; /* *zero_extendv8hiv32si_shift */

    case 260:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5821; /* *zero_extendv8siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8285; /* *zero_extendv8siv32si_shift */

    case 261:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5825; /* *zero_extendv16qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8291; /* *zero_extendv16qiv32si_shift */

    case 262:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5829; /* *zero_extendv16hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8297; /* *zero_extendv16hiv32si_shift */

    case 263:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5833; /* *zero_extendv16siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8303; /* *zero_extendv16siv32si_shift */

    case 264:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5837; /* *zero_extendv32qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8309; /* *zero_extendv32qiv32si_shift */

    case 265:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5841; /* *zero_extendv32hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8315; /* *zero_extendv32hiv32si_shift */

    case 266:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5845; /* *zero_extendv32siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8321; /* *zero_extendv32siv32si_shift */

    case 267:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5849; /* *zero_extendv64qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8327; /* *zero_extendv64qiv32si_shift */

    case 268:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5853; /* *zero_extendv64hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8333; /* *zero_extendv64hiv32si_shift */

    case 269:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5857; /* *zero_extendv64siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8339; /* *zero_extendv64siv32si_shift */

    case 270:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5861; /* *zero_extendv2qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8345; /* *zero_extendv2qiv64qi_shift */

    case 271:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5865; /* *zero_extendv2hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8351; /* *zero_extendv2hiv64qi_shift */

    case 272:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5869; /* *zero_extendv2siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8357; /* *zero_extendv2siv64qi_shift */

    case 273:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5873; /* *zero_extendv4qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8363; /* *zero_extendv4qiv64qi_shift */

    case 274:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5877; /* *zero_extendv4hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8369; /* *zero_extendv4hiv64qi_shift */

    case 275:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5881; /* *zero_extendv4siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8375; /* *zero_extendv4siv64qi_shift */

    case 276:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5885; /* *zero_extendv8qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8381; /* *zero_extendv8qiv64qi_shift */

    case 277:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5889; /* *zero_extendv8hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8387; /* *zero_extendv8hiv64qi_shift */

    case 278:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5893; /* *zero_extendv8siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8393; /* *zero_extendv8siv64qi_shift */

    case 279:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5897; /* *zero_extendv16qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8399; /* *zero_extendv16qiv64qi_shift */

    case 280:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5901; /* *zero_extendv16hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8405; /* *zero_extendv16hiv64qi_shift */

    case 281:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5905; /* *zero_extendv16siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8411; /* *zero_extendv16siv64qi_shift */

    case 282:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5909; /* *zero_extendv32qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8417; /* *zero_extendv32qiv64qi_shift */

    case 283:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5913; /* *zero_extendv32hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8423; /* *zero_extendv32hiv64qi_shift */

    case 284:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5917; /* *zero_extendv32siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8429; /* *zero_extendv32siv64qi_shift */

    case 285:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5921; /* *zero_extendv64qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8435; /* *zero_extendv64qiv64qi_shift */

    case 286:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5925; /* *zero_extendv64hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8441; /* *zero_extendv64hiv64qi_shift */

    case 287:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5929; /* *zero_extendv64siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8447; /* *zero_extendv64siv64qi_shift */

    case 288:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5933; /* *zero_extendv2qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8453; /* *zero_extendv2qiv64hi_shift */

    case 289:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5937; /* *zero_extendv2hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8459; /* *zero_extendv2hiv64hi_shift */

    case 290:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5941; /* *zero_extendv2siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8465; /* *zero_extendv2siv64hi_shift */

    case 291:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5945; /* *zero_extendv4qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8471; /* *zero_extendv4qiv64hi_shift */

    case 292:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5949; /* *zero_extendv4hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8477; /* *zero_extendv4hiv64hi_shift */

    case 293:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5953; /* *zero_extendv4siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8483; /* *zero_extendv4siv64hi_shift */

    case 294:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5957; /* *zero_extendv8qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8489; /* *zero_extendv8qiv64hi_shift */

    case 295:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5961; /* *zero_extendv8hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8495; /* *zero_extendv8hiv64hi_shift */

    case 296:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5965; /* *zero_extendv8siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8501; /* *zero_extendv8siv64hi_shift */

    case 297:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5969; /* *zero_extendv16qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8507; /* *zero_extendv16qiv64hi_shift */

    case 298:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5973; /* *zero_extendv16hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8513; /* *zero_extendv16hiv64hi_shift */

    case 299:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5977; /* *zero_extendv16siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8519; /* *zero_extendv16siv64hi_shift */

    case 300:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5981; /* *zero_extendv32qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8525; /* *zero_extendv32qiv64hi_shift */

    case 301:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5985; /* *zero_extendv32hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8531; /* *zero_extendv32hiv64hi_shift */

    case 302:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5989; /* *zero_extendv32siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8537; /* *zero_extendv32siv64hi_shift */

    case 303:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5993; /* *zero_extendv64qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8543; /* *zero_extendv64qiv64hi_shift */

    case 304:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5997; /* *zero_extendv64hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8549; /* *zero_extendv64hiv64hi_shift */

    case 305:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6001; /* *zero_extendv64siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8555; /* *zero_extendv64siv64hi_shift */

    case 306:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6005; /* *zero_extendv2qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8561; /* *zero_extendv2qiv64si_shift */

    case 307:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6009; /* *zero_extendv2hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8567; /* *zero_extendv2hiv64si_shift */

    case 308:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6013; /* *zero_extendv2siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8573; /* *zero_extendv2siv64si_shift */

    case 309:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6017; /* *zero_extendv4qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8579; /* *zero_extendv4qiv64si_shift */

    case 310:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6021; /* *zero_extendv4hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8585; /* *zero_extendv4hiv64si_shift */

    case 311:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6025; /* *zero_extendv4siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8591; /* *zero_extendv4siv64si_shift */

    case 312:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6029; /* *zero_extendv8qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8597; /* *zero_extendv8qiv64si_shift */

    case 313:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6033; /* *zero_extendv8hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8603; /* *zero_extendv8hiv64si_shift */

    case 314:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6037; /* *zero_extendv8siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8609; /* *zero_extendv8siv64si_shift */

    case 315:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6041; /* *zero_extendv16qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8615; /* *zero_extendv16qiv64si_shift */

    case 316:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6045; /* *zero_extendv16hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8621; /* *zero_extendv16hiv64si_shift */

    case 317:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6049; /* *zero_extendv16siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8627; /* *zero_extendv16siv64si_shift */

    case 318:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6053; /* *zero_extendv32qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8633; /* *zero_extendv32qiv64si_shift */

    case 319:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6057; /* *zero_extendv32hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8639; /* *zero_extendv32hiv64si_shift */

    case 320:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6061; /* *zero_extendv32siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8645; /* *zero_extendv32siv64si_shift */

    case 321:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6065; /* *zero_extendv64qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8651; /* *zero_extendv64qiv64si_shift */

    case 322:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6069; /* *zero_extendv64hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8657; /* *zero_extendv64hiv64si_shift */

    case 323:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6073; /* *zero_extendv64siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8663; /* *zero_extendv64siv64si_shift */

    case 324:
      return 8704; /* zero_extendv2qiv2di2 */

    case 325:
      return 8706; /* zero_extendv2hiv2di2 */

    case 326:
      return 8708; /* zero_extendv2siv2di2 */

    case 327:
      return 8710; /* zero_extendv4qiv4di2 */

    case 328:
      return 8712; /* zero_extendv4hiv4di2 */

    case 329:
      return 8714; /* zero_extendv4siv4di2 */

    case 330:
      return 8716; /* zero_extendv8qiv8di2 */

    case 331:
      return 8718; /* zero_extendv8hiv8di2 */

    case 332:
      return 8720; /* zero_extendv8siv8di2 */

    case 333:
      return 8722; /* zero_extendv16qiv16di2 */

    case 334:
      return 8724; /* zero_extendv16hiv16di2 */

    case 335:
      return 8726; /* zero_extendv16siv16di2 */

    case 336:
      return 8728; /* zero_extendv32qiv32di2 */

    case 337:
      return 8730; /* zero_extendv32hiv32di2 */

    case 338:
      return 8732; /* zero_extendv32siv32di2 */

    case 339:
      return 8734; /* zero_extendv64qiv64di2 */

    case 340:
      return 8736; /* zero_extendv64hiv64di2 */

    case 341:
      return 8738; /* zero_extendv64siv64di2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x2) != E_V2QImode
          || !gcn_alu_operand (operands[1], E_V2DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_431 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x2) != E_V2HImode
          || !gcn_alu_operand (operands[1], E_V2DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_432 (insn, operands);

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || !gcn_alu_operand (operands[1], E_V2DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_433 (insn, operands);

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x2) != E_V4QImode
          || !gcn_alu_operand (operands[1], E_V4DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_434 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !gcn_alu_operand (operands[1], E_V4DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_435 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !gcn_alu_operand (operands[1], E_V4DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_436 (insn, operands);

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || !gcn_alu_operand (operands[1], E_V8DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_437 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !gcn_alu_operand (operands[1], E_V8DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_438 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x2) != E_V8SImode
          || !gcn_alu_operand (operands[1], E_V8DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_439 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !gcn_alu_operand (operands[1], E_V16DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_440 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !gcn_alu_operand (operands[1], E_V16DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_441 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode
          || !gcn_alu_operand (operands[1], E_V16DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_442 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || !gcn_alu_operand (operands[1], E_V32DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_443 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !gcn_alu_operand (operands[1], E_V32DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_444 (insn, operands);

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x2) != E_V32SImode
          || !gcn_alu_operand (operands[1], E_V32DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_445 (insn, operands);

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x2) != E_V64QImode
          || !gcn_alu_operand (operands[1], E_V64DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_446 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x2) != E_V64HImode
          || !gcn_alu_operand (operands[1], E_V64DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_447 (insn, operands);

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x2) != E_V64SImode
          || !gcn_alu_operand (operands[1], E_V64DImode)
          || !
#line 3613 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
        return NULL;
      return gen_split_448 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32HImode
      || !scratch_operand (operands[2], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32HImode)
      && general_operand (operands[1], E_V32HImode))
    return gen_split_56 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32HImode)
      || !memory_operand (operands[1], E_V32HImode))
    return NULL;
  return gen_split_152 (insn, operands);
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64SFmode
      || !scratch_operand (operands[4], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64SFmode)
      && general_operand (operands[1], E_V64SFmode))
    return gen_split_115 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64SFmode)
      || !memory_operand (operands[1], E_V64SFmode))
    return NULL;
  return gen_split_211 (insn, operands);
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32TImode
      || !scratch_operand (operands[4], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32TImode)
      && general_operand (operands[1], E_V32TImode))
    return gen_split_110 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32TImode)
      || !memory_operand (operands[1], E_V32TImode))
    return NULL;
  return gen_split_206 (insn, operands);
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32HFmode
      || !scratch_operand (operands[4], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32HFmode)
      && general_operand (operands[1], E_V32HFmode))
    return gen_split_105 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32HFmode)
      || !memory_operand (operands[1], E_V32HFmode))
    return NULL;
  return gen_split_201 (insn, operands);
}

 rtx_insn *
split_37 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_BImode:
          if (!nonimmediate_operand (operands[0], E_BImode)
              || !general_operand (operands[1], E_BImode)
              || !
#line 497 "../../gcc/config/gcn/gcn.md"
(!reload_completed && !lra_in_progress
   && !gcn_valid_move_p (BImode, operands[0], operands[1])))
            return NULL;
          return gen_split_1 (insn, operands);

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !general_operand (operands[1], E_QImode)
              || !
#line 497 "../../gcc/config/gcn/gcn.md"
(!reload_completed && !lra_in_progress
   && !gcn_valid_move_p (QImode, operands[0], operands[1])))
            return NULL;
          return gen_split_2 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !general_operand (operands[1], E_HImode)
              || !
#line 497 "../../gcc/config/gcn/gcn.md"
(!reload_completed && !lra_in_progress
   && !gcn_valid_move_p (HImode, operands[0], operands[1])))
            return NULL;
          return gen_split_3 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !general_operand (operands[1], E_SImode)
              || !
#line 497 "../../gcc/config/gcn/gcn.md"
(!reload_completed && !lra_in_progress
   && !gcn_valid_move_p (SImode, operands[0], operands[1])))
            return NULL;
          return gen_split_4 (insn, operands);

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !general_operand (operands[1], E_DImode))
            return NULL;
          if (
#line 497 "../../gcc/config/gcn/gcn.md"
(!reload_completed && !lra_in_progress
   && !gcn_valid_move_p (DImode, operands[0], operands[1])))
            return gen_split_5 (insn, operands);
          if (!
#line 671 "../../gcc/config/gcn/gcn.md"
(reload_completed
   && ((!MEM_P (operands[0]) && !MEM_P (operands[1])
        && !gcn_sgpr_move_p (operands[0], operands[1]))
       || (GET_CODE (operands[1]) == CONST_INT
	   && !gcn_constant64_p (operands[1])))))
            return NULL;
          return gen_split_9 (insn, operands);

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || !general_operand (operands[1], E_TImode))
            return NULL;
          if (
#line 497 "../../gcc/config/gcn/gcn.md"
(!reload_completed && !lra_in_progress
   && !gcn_valid_move_p (TImode, operands[0], operands[1])))
            return gen_split_6 (insn, operands);
          if (!
#line 733 "../../gcc/config/gcn/gcn.md"
(reload_completed
   && REG_P (operands[0])
   && (REG_P (operands[1]) || GET_CODE (operands[1]) == CONST_INT)))
            return NULL;
          return gen_split_11 (insn, operands);

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || !general_operand (operands[1], E_SFmode)
              || !
#line 497 "../../gcc/config/gcn/gcn.md"
(!reload_completed && !lra_in_progress
   && !gcn_valid_move_p (SFmode, operands[0], operands[1])))
            return NULL;
          return gen_split_7 (insn, operands);

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || !general_operand (operands[1], E_DFmode))
            return NULL;
          if (
#line 497 "../../gcc/config/gcn/gcn.md"
(!reload_completed && !lra_in_progress
   && !gcn_valid_move_p (DFmode, operands[0], operands[1])))
            return gen_split_8 (insn, operands);
          if (!
#line 671 "../../gcc/config/gcn/gcn.md"
(reload_completed
   && ((!MEM_P (operands[0]) && !MEM_P (operands[1])
        && !gcn_sgpr_move_p (operands[0], operands[1]))
       || (GET_CODE (operands[1]) == CONST_INT
	   && !gcn_constant64_p (operands[1])))))
            return NULL;
          return gen_split_10 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return NULL;
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_DImode)
                return NULL;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 1539 "../../gcc/config/gcn/gcn.md"
(reload_completed))
                return NULL;
              return gen_split_14 (insn, operands);

            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[2] = x6;
              if (!gcn_32bit_immediate_operand (operands[2], E_DImode)
                  || !
#line 1557 "../../gcc/config/gcn/gcn.md"
( reload_completed))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode)
                return NULL;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 1539 "../../gcc/config/gcn/gcn.md"
(reload_completed))
                return NULL;
              return gen_split_15 (insn, operands);

            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[2] = x6;
              if (!gcn_32bit_immediate_operand (operands[2], E_DImode)
                  || !
#line 1557 "../../gcc/config/gcn/gcn.md"
( reload_completed))
                return NULL;
              return gen_split_17 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3)
        return NULL;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      switch (XINT (x3, 1))
        {
        case 2:
          x9 = XVECEXP (x3, 0, 0);
          operands[2] = x9;
          x10 = XVECEXP (x3, 0, 1);
          operands[1] = x10;
          if (!gcn_exec_reg_operand (operands[3], E_DImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern155 (x3, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_215 (insn, operands);

            case E_V2DFmode:
              if (pattern155 (x3, 
E_V2DFmode, 
E_V2SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_216 (insn, operands);

            case E_V4DImode:
              if (pattern155 (x3, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_217 (insn, operands);

            case E_V4DFmode:
              if (pattern155 (x3, 
E_V4DFmode, 
E_V4SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_218 (insn, operands);

            case E_V8DImode:
              if (pattern155 (x3, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_219 (insn, operands);

            case E_V8DFmode:
              if (pattern155 (x3, 
E_V8DFmode, 
E_V8SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_220 (insn, operands);

            case E_V16DImode:
              if (pattern155 (x3, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_221 (insn, operands);

            case E_V16DFmode:
              if (pattern155 (x3, 
E_V16DFmode, 
E_V16SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_222 (insn, operands);

            case E_V32DImode:
              if (pattern155 (x3, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_223 (insn, operands);

            case E_V32DFmode:
              if (pattern155 (x3, 
E_V32DFmode, 
E_V32SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_224 (insn, operands);

            case E_V64DImode:
              if (pattern155 (x3, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_225 (insn, operands);

            case E_V64DFmode:
              if (pattern155 (x3, 
E_V64DFmode, 
E_V64SImode) != 0
                  || !
#line 1386 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_226 (insn, operands);

            default:
              return NULL;
            }

        case 9:
          switch (pattern102 (x3))
            {
            case 0:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_539 (insn, operands);

            case 1:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_543 (insn, operands);

            case 2:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_547 (insn, operands);

            case 3:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_551 (insn, operands);

            case 4:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_555 (insn, operands);

            case 5:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_559 (insn, operands);

            default:
              return NULL;
            }

        case 12:
          switch (pattern102 (x3))
            {
            case 0:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_540 (insn, operands);

            case 1:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_544 (insn, operands);

            case 2:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_548 (insn, operands);

            case 3:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_552 (insn, operands);

            case 4:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_556 (insn, operands);

            case 5:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_560 (insn, operands);

            default:
              return NULL;
            }

        case 13:
          switch (pattern102 (x3))
            {
            case 0:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_541 (insn, operands);

            case 1:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_545 (insn, operands);

            case 2:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_549 (insn, operands);

            case 3:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_553 (insn, operands);

            case 4:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_557 (insn, operands);

            case 5:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_561 (insn, operands);

            default:
              return NULL;
            }

        case 14:
          switch (pattern102 (x3))
            {
            case 0:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_542 (insn, operands);

            case 1:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_546 (insn, operands);

            case 2:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_550 (insn, operands);

            case 3:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_554 (insn, operands);

            case 4:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_558 (insn, operands);

            case 5:
              if (!
#line 4304 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_562 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case AND:
      switch (pattern36 (x3))
        {
        case 0:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V2DImode))))
            return NULL;
          return gen_split_335 (insn, operands);

        case 1:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V4DImode))))
            return NULL;
          return gen_split_338 (insn, operands);

        case 2:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V8DImode))))
            return NULL;
          return gen_split_341 (insn, operands);

        case 3:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V16DImode))))
            return NULL;
          return gen_split_344 (insn, operands);

        case 4:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V32DImode))))
            return NULL;
          return gen_split_347 (insn, operands);

        case 5:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V64DImode))))
            return NULL;
          return gen_split_350 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern36 (x3))
        {
        case 0:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V2DImode))))
            return NULL;
          return gen_split_336 (insn, operands);

        case 1:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V4DImode))))
            return NULL;
          return gen_split_339 (insn, operands);

        case 2:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V8DImode))))
            return NULL;
          return gen_split_342 (insn, operands);

        case 3:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V16DImode))))
            return NULL;
          return gen_split_345 (insn, operands);

        case 4:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V32DImode))))
            return NULL;
          return gen_split_348 (insn, operands);

        case 5:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V64DImode))))
            return NULL;
          return gen_split_351 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern36 (x3))
        {
        case 0:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V2DImode))))
            return NULL;
          return gen_split_337 (insn, operands);

        case 1:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V4DImode))))
            return NULL;
          return gen_split_340 (insn, operands);

        case 2:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V8DImode))))
            return NULL;
          return gen_split_343 (insn, operands);

        case 3:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V16DImode))))
            return NULL;
          return gen_split_346 (insn, operands);

        case 4:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V32DImode))))
            return NULL;
          return gen_split_349 (insn, operands);

        case 5:
          if (!
#line 2652 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V64DImode))))
            return NULL;
          return gen_split_352 (insn, operands);

        default:
          return NULL;
        }

    case VEC_MERGE:
      return split_1 (x1, insn);

    case NOT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !gcn_alu_operand (operands[1], E_V2DImode)
              || !
#line 2912 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_419 (insn, operands);

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !gcn_alu_operand (operands[1], E_V4DImode)
              || !
#line 2912 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_421 (insn, operands);

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x3) != E_V8DImode
              || !gcn_alu_operand (operands[1], E_V8DImode)
              || !
#line 2912 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_423 (insn, operands);

        case E_V16DImode:
          if (!register_operand (operands[0], E_V16DImode)
              || GET_MODE (x3) != E_V16DImode
              || !gcn_alu_operand (operands[1], E_V16DImode)
              || !
#line 2912 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_425 (insn, operands);

        case E_V32DImode:
          if (!register_operand (operands[0], E_V32DImode)
              || GET_MODE (x3) != E_V32DImode
              || !gcn_alu_operand (operands[1], E_V32DImode)
              || !
#line 2912 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_427 (insn, operands);

        case E_V64DImode:
          if (!register_operand (operands[0], E_V64DImode)
              || GET_MODE (x3) != E_V64DImode
              || !gcn_alu_operand (operands[1], E_V64DImode)
              || !
#line 2912 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_429 (insn, operands);

        default:
          return NULL;
        }

    case TRUNCATE:
      return split_2 (x1, insn);

    case SIGN_EXTEND:
      switch (pattern37 (x3))
        {
        case 0:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_467 (insn, operands);

        case 1:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_469 (insn, operands);

        case 2:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_471 (insn, operands);

        case 3:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_473 (insn, operands);

        case 4:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_475 (insn, operands);

        case 5:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_477 (insn, operands);

        case 6:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_479 (insn, operands);

        case 7:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_481 (insn, operands);

        case 8:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_483 (insn, operands);

        case 9:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_485 (insn, operands);

        case 10:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_487 (insn, operands);

        case 11:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_489 (insn, operands);

        case 12:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_491 (insn, operands);

        case 13:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_493 (insn, operands);

        case 14:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_495 (insn, operands);

        case 15:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_497 (insn, operands);

        case 16:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_499 (insn, operands);

        case 17:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_501 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern37 (x3))
        {
        case 0:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_468 (insn, operands);

        case 1:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_470 (insn, operands);

        case 2:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_472 (insn, operands);

        case 3:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_474 (insn, operands);

        case 4:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_476 (insn, operands);

        case 5:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_478 (insn, operands);

        case 6:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_480 (insn, operands);

        case 7:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_482 (insn, operands);

        case 8:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_484 (insn, operands);

        case 9:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_486 (insn, operands);

        case 10:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_488 (insn, operands);

        case 11:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_490 (insn, operands);

        case 12:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_492 (insn, operands);

        case 13:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_494 (insn, operands);

        case 14:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_496 (insn, operands);

        case 15:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_498 (insn, operands);

        case 16:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_500 (insn, operands);

        case 17:
          if (!
#line 3658 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_502 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
