/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_mmxmem_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern16 (x1); /* [-1, 1] */
}

int
pattern21 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern6 (x3, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern6 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern25 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern25 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern25 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern25 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern25 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern25 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern25 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern25 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern25 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    case E_V32QImode:
      if (pattern5 (x3, 
E_V32QImode) != 0)
        return -1;
      return 9;

    case E_V16HImode:
      if (pattern5 (x3, 
E_V16HImode) != 0)
        return -1;
      return 10;

    case E_V8SImode:
      if (pattern5 (x3, 
E_V8SImode) != 0)
        return -1;
      return 11;

    case E_V16SImode:
      if (pattern5 (x3, 
E_V16SImode) != 0)
        return -1;
      return 12;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 13;

    case E_V8DImode:
      if (pattern5 (x3, 
E_V8DImode) != 0)
        return -1;
      return 14;

    case E_V4DImode:
      if (pattern5 (x3, 
E_V4DImode) != 0)
        return -1;
      return 15;

    case E_V2DImode:
      if (pattern5 (x3, 
E_V2DImode) != 0)
        return -1;
      return 16;

    case E_V64QImode:
      if (pattern5 (x3, 
E_V64QImode) != 0)
        return -1;
      return 17;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 18;

    case E_V32HImode:
      if (pattern5 (x3, 
E_V32HImode) != 0)
        return -1;
      return 19;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 20;

    case E_V32BFmode:
      if (pattern14 (x3, 
E_V32BFmode) != 0)
        return -1;
      return 21;

    case E_V16BFmode:
      if (pattern14 (x3, 
E_V16BFmode) != 0)
        return -1;
      return 22;

    case E_V8BFmode:
      if (pattern14 (x3, 
E_V8BFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern25 (x1, 
E_V64QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern25 (x1, 
E_V32QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern25 (x1, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern25 (x1, 
E_V32HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern25 (x1, 
E_V16HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern25 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x5 = XEXP (x3, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i2))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!nonimmediate_operand (operands[4], i2))
    return -1;
  x9 = XEXP (x1, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], i1))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x9) != i1)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], i2))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern104 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern104 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern122 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern127 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern127 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern127 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern127 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern127 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern127 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i3))
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern152 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern152 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern152 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern152 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern152 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern152 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern152 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern152 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern152 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      return pattern168 (x3, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SFmode:
      if (pattern168 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SFmode:
      if (pattern168 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern182 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern182 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern182 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern182 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern182 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern182 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern182 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern182 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern182 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    case E_V64QImode:
      if (pattern182 (x1, 
E_V64QImode) != 0)
        return -1;
      return 9;

    case E_V32QImode:
      if (pattern182 (x1, 
E_V32QImode) != 0)
        return -1;
      return 10;

    case E_V16QImode:
      if (pattern182 (x1, 
E_V16QImode) != 0)
        return -1;
      return 11;

    case E_V32HImode:
      if (pattern182 (x1, 
E_V32HImode) != 0)
        return -1;
      return 12;

    case E_V16HImode:
      if (pattern182 (x1, 
E_V16HImode) != 0)
        return -1;
      return 13;

    case E_V8HImode:
      if (pattern182 (x1, 
E_V8HImode) != 0)
        return -1;
      return 14;

    case E_V16SImode:
      if (pattern182 (x1, 
E_V16SImode) != 0)
        return -1;
      return 15;

    case E_V8SImode:
      if (pattern182 (x1, 
E_V8SImode) != 0)
        return -1;
      return 16;

    case E_V4SImode:
      if (pattern182 (x1, 
E_V4SImode) != 0)
        return -1;
      return 17;

    case E_V8DImode:
      if (pattern182 (x1, 
E_V8DImode) != 0)
        return -1;
      return 18;

    case E_V4DImode:
      if (pattern182 (x1, 
E_V4DImode) != 0)
        return -1;
      return 19;

    case E_V2DImode:
      if (pattern182 (x1, 
E_V2DImode) != 0)
        return -1;
      return 20;

    case E_V32BFmode:
      if (pattern14 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 21;

    case E_V16BFmode:
      if (pattern14 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 22;

    case E_V8BFmode:
      if (pattern14 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern205 (x1); /* [-1, 3] */
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern206 (x1); /* [-1, 3] */
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonimmediate_operand (operands[2], E_QImode))
    return -1;
  return pattern205 (x1); /* [-1, 3] */
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern211 (x6, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern211 (x6, 
E_TImode) != 0)
        return -1;
      return 1;

    case E_QImode:
      if (pattern211 (x6, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_HImode:
      if (pattern211 (x6, 
E_HImode) != 0)
        return -1;
      return 3;

    case E_SImode:
      if (pattern211 (x6, 
E_SImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  return 0;
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 8L)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XEXP (x4, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x4, 0);
  operands[0] = x7;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern271 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 0;

        case E_HImode:
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 2;

        case E_HImode:
          return 3;

        case E_SImode:
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern292 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern163 (x1, 
E_DImode, 
E_V64QImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern314 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != VEC_SELECT)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL)
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x7, 0);
  operands[2] = x10;
  x11 = XEXP (x1, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[4] = x12;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 8:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x15 = XVECEXP (x5, 0, 2);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x16 = XVECEXP (x5, 0, 3);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x5, 0, 4);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x18 = XVECEXP (x5, 0, 5);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x19 = XVECEXP (x5, 0, 6);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x20 = XVECEXP (x5, 0, 7);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x8, 0) != 8)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x23 = XVECEXP (x8, 0, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x24 = XVECEXP (x8, 0, 3);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x25 = XVECEXP (x8, 0, 4);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x26 = XVECEXP (x8, 0, 5);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x27 = XVECEXP (x8, 0, 6);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x28 = XVECEXP (x8, 0, 7);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || pattern313 (x1, 
E_V8DImode, 
E_V16SImode, 
E_V8SImode) != 0)
        return -1;
      return 0;

    case 4:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x15 = XVECEXP (x5, 0, 2);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x16 = XVECEXP (x5, 0, 3);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x8, 0) != 4)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x23 = XVECEXP (x8, 0, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x24 = XVECEXP (x8, 0, 3);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || pattern313 (x1, 
E_V4DImode, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case 2:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x8, 0) != 2)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || GET_MODE (x3) != E_V2DImode
          || GET_MODE (x4) != E_V2SImode
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x6) != E_V2DImode
          || GET_MODE (x7) != E_V2SImode
          || !vector_operand (operands[2], E_V4SImode)
          || !nonimm_or_0_operand (operands[3], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern348 (x1, 
E_QImode, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern363 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !memory_operand (operands[0], i1)
      || !nonmemory_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !ix86_comparison_operator (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !ix86_comparison_operator (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern380 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern385 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern384 (x6, 
37); /* [-1, 0] */
}

int
pattern395 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 21
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != CONST
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x13 = XVECEXP (x4, 0, 0);
  operands[1] = x13;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x14 = XVECEXP (x4, 0, 1);
  operands[2] = x14;
  if (!constant_call_address_operand (operands[2], E_VOIDmode))
    return -1;
  x15 = XVECEXP (x7, 0, 0);
  operands[3] = x15;
  if (!tls_symbolic_operand (operands[3], E_VOIDmode))
    return -1;
  x16 = XEXP (x8, 0);
  operands[4] = x16;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x17 = XEXP (x9, 0);
  operands[5] = x17;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern417 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LTU)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode
      || !nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || GET_MODE (x2) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern259 (x5, 
E_DImode, 
E_TImode); /* [-1, 1] */
}

int
pattern434 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern442 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      operands[3] = x3;
      x4 = XEXP (x1, 0);
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      return pattern440 (x1); /* [-1, 1] */

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_QImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      x6 = XEXP (x4, 1);
      if (!nonmemory_operand (x6, E_QImode))
        return -1;
      switch (XWINT (x8, 0))
        {
        case 64L:
          if (pattern441 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case 32L:
          if (pattern441 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i3)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern478 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern486 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  x7 = XEXP (x1, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          return pattern480 (x1, 
E_V16SImode, 
E_HImode); /* [-1, 0] */

        case E_V8SImode:
          if (pattern480 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern480 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[5] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern485 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SImode:
          if (pattern485 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern485 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern498 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || GET_MODE (x2) != E_V2HFmode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_MODE (x7) != E_V2HFmode
          || !vector_operand (operands[1], i1)
          || GET_MODE (x3) != E_V2HFmode
          || !nonimm_or_0_operand (operands[2], E_V8HFmode)
          || !const0_operand (operands[4], E_V6HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (pattern497 (x1, 
E_V2SFmode, 
E_V4SFmode, 
i1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern506 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern511 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!nonimmediate_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !permvar_truncate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1)
      || !regmem_or_bitnot_regmem_operand (operands[3], i1)
      || !regmem_or_bitnot_regmem_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern533 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern532 (x1); /* [-1, 11] */

    case IOR:
      res = pattern532 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    case XOR:
      res = pattern532 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern528 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 36;

        case E_V16HFmode:
          if (pattern528 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 37;

        case E_V8HFmode:
          if (pattern528 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 38;

        case E_V32BFmode:
          if (pattern528 (x1, 
E_V32BFmode) != 0)
            return -1;
          return 39;

        case E_V16BFmode:
          if (pattern528 (x1, 
E_V16BFmode) != 0)
            return -1;
          return 40;

        case E_V8BFmode:
          if (pattern528 (x1, 
E_V8BFmode) != 0)
            return -1;
          return 41;

        case E_V16SFmode:
          if (pattern528 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 42;

        case E_V8SFmode:
          if (pattern528 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 43;

        case E_V4SFmode:
          if (pattern528 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 44;

        case E_V8DFmode:
          if (pattern528 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 45;

        case E_V4DFmode:
          if (pattern528 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 46;

        case E_V2DFmode:
          if (pattern528 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern546 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern552 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern551 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern551 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern562 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !nonimmediate_operand (operands[1], E_SImode)
      || !x86_64_general_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern573 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const123_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern430 (x1); /* [-1, 1] */
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x2), 0))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          return pattern575 (x1); /* [-1, 3] */

        case PLUS:
          res = pattern575 (x1);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        case MINUS:
          x4 = XEXP (x3, 0);
          operands[3] = x4;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern574 (x1);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        default:
          return -1;
        }

    case AND:
      res = pattern576 (x1);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    case PLUS:
      res = pattern576 (x1);
      if (res >= 0)
        return res + 16; /* [16, 19] */
      return -1;

    case MINUS:
      x3 = XEXP (x2, 0);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      res = pattern574 (x1);
      if (res >= 0)
        return res + 20; /* [20, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (!commutative_operator (x2, E_VOIDmode))
    return -1;
  operands[3] = x2;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!memory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XEXP (x1, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern599 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_CCZmode
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !vector_operand (operands[1], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !vector_operand (operands[1], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !vector_operand (operands[1], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !vector_operand (operands[1], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode)
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !vector_operand (operands[1], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 5;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !vector_operand (operands[1], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      return 6;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || !vector_operand (operands[1], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode)
        return -1;
      return 7;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || !vector_operand (operands[1], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      return 8;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || !vector_operand (operands[1], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      return 9;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || !vector_operand (operands[1], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      return 10;

    case E_V2TImode:
      if (!register_operand (operands[0], E_V2TImode)
          || !vector_operand (operands[1], E_V2TImode)
          || GET_MODE (x3) != E_V2TImode)
        return -1;
      return 11;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !vector_operand (operands[1], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode)
        return -1;
      return 12;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !vector_operand (operands[1], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[4] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern642 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern642 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern642 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern642 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern642 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern642 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern642 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern642 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern642 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern644 (x1);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern665 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern670 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  return pattern669 (x2); /* [-1, 0] */
}

int
pattern673 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  return 0;
}

int
pattern679 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCZmode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER
      || GET_MODE (x3) != E_CCZmode)
    return -1;
  return 0;
}

int
pattern686 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern684 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern684 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern685 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern685 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern695 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern245 (x1); /* [-1, 1] */
}

int
pattern702 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_DImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern710 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const_scalar_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern718 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern722 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      return 0;

    case PARALLEL:
      return 1;

    default:
      return -1;
    }
}

int
pattern728 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern731 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern730 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern730 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern739 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern744 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4SImode
          || GET_MODE (x3) != E_V4SImode
          || GET_MODE (x5) != E_V4SImode
          || !register_mmxmem_operand (operands[1], E_V4HImode)
          || GET_MODE (x4) != E_V4SImode
          || !register_mmxmem_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || GET_MODE (x2) != E_V2SImode
          || GET_MODE (x3) != E_V2SImode
          || GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[1], E_V2HImode)
          || GET_MODE (x4) != E_V2SImode
          || !register_operand (operands[2], E_V2HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern768 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern772 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern771 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern771 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern771 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern780 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern788 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern795 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_uns_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern804 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern813 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  return pattern812 (x9, pnum_clobbers); /* [-1, 1] */
}

int
pattern820 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x11 = XEXP (x2, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern830 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern839 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || !nonmemory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || !nonmemory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || !x86_64_szext_nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      return 3;

    case E_TImode:
      if (GET_MODE (x2) != E_TImode
          || !nonimmediate_operand (operands[0], E_TImode)
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern851 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !binary_fp_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern861 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern867 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern866 (x1, 
E_DImode, 
E_V64QImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[3], E_SImode))
        return -1;
      res = pattern863 ();
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern875 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern852 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern852 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern884 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern894 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || GET_MODE (x3) != i2)
    return -1;
  x9 = XEXP (x3, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern137 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern137 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern906 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern908 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern912 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern914 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern918 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  return 0;
}

int
pattern926 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  return pattern812 (x6, pnum_clobbers); /* [-1, 1] */
}

int
pattern934 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern941 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern203 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern203 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern948 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 4)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x3 = XEXP (x1, 1);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 2)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != ASHIFTRT
          || GET_MODE (x6) != i1)
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x9 = XEXP (x6, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 0);
      operands[3] = x13;
      if (!memory_operand (operands[3], i1))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      return 0;

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x15 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x15) != SET)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != ASHIFTRT
          || GET_MODE (x16) != i1)
        return -1;
      x17 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x17) != CLOBBER)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 17
          || GET_MODE (x18) != E_CCmode)
        return -1;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x20 = XEXP (x16, 1);
      operands[4] = x20;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x21 = XEXP (x16, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != SET)
        return -1;
      x22 = XEXP (x4, 0);
      operands[3] = x22;
      if (!memory_operand (operands[3], i1))
        return -1;
      x23 = XEXP (x4, 1);
      if (!rtx_equal_p (x23, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern971 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern977 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[2], E_V32HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !nonimmediate_operand (operands[2], E_V32QImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern988 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern990 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern1001 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case NOT:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!const_0_to_7_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (pattern1000 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 1;

        case E_V16QImode:
          if (pattern1000 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1017 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1024 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1032 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern1031 (x6) != 0)
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern1092 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1097 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1105 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1110 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i3
      || !vector_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V32HFmode
      || !register_operand (operands[0], E_V32HFmode)
      || GET_MODE (x1) != E_V32HFmode
      || !register_operand (operands[1], E_V32HFmode)
      || !register_operand (operands[2], E_V32HFmode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  if (!register_operand (operands[3], E_V32HFmode)
      || !const_4_or_8_to_11_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern1131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !palignr_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 3);
  operands[4] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1136 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1136 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1149 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      return pattern1155 (x1); /* [-1, 3] */

    case PLUS:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern1155 (x1);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern205 (x1);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1173 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !const0_operand (operands[2], i2)
      || !vector_all_ones_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case REG:
      if (peep2_current_count < 4)
        return -1;
      operands[5] = x3;
      if (!general_reg_operand (operands[5], i1))
        return -1;
      x4 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (!rtx_equal_p (x5, operands[5]))
        return -1;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1188 (rtx x1, machine_mode i1, rtx_code i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_unset_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1198 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern1212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0))
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !vector_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || GET_MODE (x5) != E_V16QImode
          || !register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (GET_MODE (x4) != E_V4SImode
              || !vector_all_ones_operand (operands[4], E_V4SImode))
            return -1;
          return 0;

        case E_V2DImode:
          if (GET_MODE (x4) != E_V2DImode
              || !vector_all_ones_operand (operands[4], E_V2DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !vector_operand (operands[1], E_V32QImode)
          || !register_operand (operands[2], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || GET_MODE (x5) != E_V32QImode
          || !register_operand (operands[3], E_V32QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8SImode:
          if (GET_MODE (x4) != E_V8SImode
              || !vector_all_ones_operand (operands[4], E_V8SImode))
            return -1;
          return 2;

        case E_V4DImode:
          if (GET_MODE (x4) != E_V4DImode
              || !vector_all_ones_operand (operands[4], E_V4DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1240 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 7
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern1245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (x1))
        {
        case E_V32QImode:
          if (!vector_all_ones_operand (operands[0], E_V32QImode)
              || !const0_operand (operands[3], E_V32QImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!vector_all_ones_operand (operands[0], E_V16QImode)
              || !const0_operand (operands[3], E_V16QImode)
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 59)
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 1);
      operands[4] = x4;
      x6 = XVECEXP (x2, 0, 0);
      operands[0] = x6;
      x7 = XVECEXP (x2, 0, 1);
      operands[1] = x7;
      switch (GET_MODE (x1))
        {
        case E_V32QImode:
          if (pattern1244 (x2, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern1244 (x2, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1272 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vector_all_ones_operand (operands[1], i2)
      || !const0_operand (operands[2], i2)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1280 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V16SImode
      || !nonimm_or_0_operand (operands[2], E_V16SImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XVECEXP (x4, 0, 4);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x10 = XVECEXP (x4, 0, 5);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x11 = XVECEXP (x4, 0, 6);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x12 = XVECEXP (x4, 0, 7);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x13 = XEXP (x1, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 1);
  return pattern1299 (x15, 
8); /* [-1, 0] */
}

int
pattern1313 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1321 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  return 0;
}

int
pattern1338 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_255_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1358 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!bcst_vector_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1364 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!bcst_vector_operand (operands[2], i2)
      || GET_MODE (x1) != i2
      || !bcst_vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1373 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1384 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V8HFmode)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 223
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 2);
  if (XWINT (x6, 0) != 3L
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || GET_MODE (x3) != E_V8HFmode
      || !register_operand (operands[1], E_V8HFmode)
      || !register_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_V8HFmode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  if (!register_operand (x7, E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x8, E_SImode))
    return -1;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x3, 1);
  switch (GET_CODE (x10))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x10;
      if (!const0_operand (operands[4], E_V8HFmode))
        return -1;
      operands[5] = x7;
      operands[6] = x8;
      return 0;

    case REG:
    case SUBREG:
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      operands[4] = x7;
      operands[5] = x8;
      return 1;

    default:
      return -1;
    }
}

int
pattern1407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return pattern1139 (x1); /* [-1, 5] */
}

int
pattern1414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_QImode:
          return pattern1409 (x3, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern1409 (x3, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern1410 (x3, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern1410 (x3, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      if (GET_MODE (x8) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode)
          || !x86_64_zext_immediate_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern1441 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1450 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!const_0_to_31_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern1447 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern1447 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern1447 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern1447 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern1447 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern1447 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern1447 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern1447 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern1447 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      if (!const_0_to_7_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1448 (x1, 
E_V8SImode, 
E_V8SFmode) != 0)
            return -1;
          return 9;

        case E_V4SFmode:
          if (pattern1448 (x1, 
E_V4SImode, 
E_V4SFmode) != 0)
            return -1;
          return 10;

        case E_V4DFmode:
          if (pattern1448 (x1, 
E_V4DImode, 
E_V4DFmode) != 0)
            return -1;
          return 11;

        case E_V2DFmode:
          if (pattern1448 (x1, 
E_V2DImode, 
E_V2DFmode) != 0)
            return -1;
          return 12;

        case E_V4SImode:
          if (pattern1449 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 13;

        case E_V2DImode:
          if (pattern1449 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 14;

        case E_V8SImode:
          if (pattern1449 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 15;

        case E_V4DImode:
          if (pattern1449 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern1449 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 17;

        case E_V16QImode:
          if (pattern1449 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 18;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1511 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[3] = x9;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  return 0;
}

int
pattern1523 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1529 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1539 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8SFmode
      || !nonimmediate_operand (operands[1], E_V4SFmode))
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern1550 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1559 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !general_reg_operand (operands[4], i1)
      || !general_reg_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1575 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x3, 2);
  return pattern1574 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1583 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  return 0;
}

int
pattern1597 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1605 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1613 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1623 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_4_to_7_operand (operands[5], E_VOIDmode)
      || !const_4_to_7_operand (operands[6], E_VOIDmode)
      || !nonimm_or_0_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1634 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1646 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !x86_64_hilo_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 2);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1663 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_63_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1676 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode)
          || !register_operand (operands[2], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !register_operand (operands[2], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1688 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1687 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1687 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1698 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1706 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1713 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x1, 0);
      switch (GET_MODE (x9))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !extract_operator (operands[3], E_DImode)
              || !extract_operator (operands[4], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1733 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1740 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1749 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1757 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1764 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !general_reg_operand (operands[4], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[2]))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  return 0;
}

int
pattern1771 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  return 0;
}

int
pattern1778 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1777 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1786 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  if (!register_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  return 0;
}

int
pattern1794 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern1804 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || pattern1528 (x1, 
E_V8SFmode, 
E_V16SFmode) != 0)
        return -1;
      return 0;

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || pattern1528 (x1, 
E_V8SImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1811 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i4
      || !vector_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1818 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i2))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1825 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 22);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 23);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 24);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 25);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 26);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1835 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_0_to_15_operand (operands[11], E_VOIDmode)
      || !const_0_to_15_operand (operands[12], E_VOIDmode)
      || !const_0_to_15_operand (operands[13], E_VOIDmode)
      || !const_0_to_15_operand (operands[14], E_VOIDmode)
      || !const_0_to_15_operand (operands[15], E_VOIDmode)
      || !const_0_to_15_operand (operands[16], E_VOIDmode)
      || !const_0_to_15_operand (operands[17], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1843 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 28);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 29);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 30);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 31);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1848 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = PATTERN (peep2_next_insn (4));
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  return 0;
}

int
pattern1855 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1853 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1863 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case COMPARE:
      if (GET_MODE (x6) != E_CCmode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 1
          || XINT (x9, 1) != 109
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!flags_reg_operand (operands[0], E_CCmode)
          || GET_MODE (x2) != E_CCmode
          || !comparison_operator (operands[1], E_VOIDmode)
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x11 = XEXP (x7, 0);
      operands[2] = x11;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      x13 = XVECEXP (x9, 0, 0);
      operands[4] = x13;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[2], E_QImode)
              || !general_operand (operands[3], E_QImode)
              || !
#line 1539 "../../../gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 1; /* ccmpqi */

        case E_HImode:
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !general_operand (operands[3], E_HImode)
              || !
#line 1539 "../../../gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 2; /* ccmphi */

        case E_SImode:
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !x86_64_general_operand (operands[3], E_SImode)
              || !
#line 1539 "../../../gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 3; /* ccmpsi */

        case E_DImode:
          if (!nonimmediate_operand (operands[2], E_DImode)
              || !x86_64_general_operand (operands[3], E_DImode)
              || !(
#line 1539 "../../../gcc/config/i386/i386.md"
(TARGET_APX_CCMP) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4; /* ccmpdi */

        default:
          return -1;
        }

    case LABEL_REF:
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != PC
          || !ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      return 1458; /* *jcc */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x6;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1185 (x2, 
E_HImode) != 0
              || !
#line 26339 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1803; /* *movhicc_noc */

        case E_QImode:
          if (pattern1186 (x2) != 0
              || !
#line 26413 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL))
            return -1;
          return 1808; /* *movqicc_noc */

        case E_XFmode:
          if (!register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !fcmov_comparison_operator (operands[1], E_VOIDmode)
              || !register_operand (operands[2], E_XFmode)
              || !register_operand (operands[3], E_XFmode)
              || !
#line 26607 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
            return -1;
          return 1810; /* *movxfcc_1 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || pattern1243 (x2, 
E_DFmode) != 0
              || !
#line 26622 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1811; /* *movdfcc_1 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || pattern1243 (x2, 
E_SFmode) != 0
              || !
#line 26657 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1812; /* *movsfcc_1_387 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      return recog_13 (x1, insn, pnum_clobbers);

    case 2:
      return recog_12 (x1, insn, pnum_clobbers);

    case 3:
      switch (XINT (x2, 1))
        {
        case 39:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_CCGZmode)
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x3) != LTU)
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 17
              || GET_MODE (x4) != E_CCmode)
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17
              || GET_MODE (x6) != E_CCGZmode)
            return -1;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 521; /* subsi3_carry_ccgz */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !x86_64_general_operand (operands[2], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 522; /* subdi3_carry_ccgz */

            default:
              return -1;
            }

        case 59:
          return recog_11 (x1, insn, pnum_clobbers);

        case 48:
          if (GET_MODE (x2) != E_HFmode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          if (!nonimmediate_operand (operands[0], E_HFmode))
            return -1;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          if (!nonimm_or_0_operand (operands[2], E_HFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          operands[3] = x3;
          if (!register_operand (operands[3], E_QImode)
              || !
#line 26573 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1809; /* movhf_mask */

        case 51:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          x3 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x3))
            {
            case LT:
              switch (pattern731 (x2))
                {
                case 0:
                  if (
#line 26806 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()))
                    return 1827; /* *ieee_maxsf3_1 */
                  if (!
#line 26827 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()))
                    return -1;
                  return 1829; /* *ieee_minsf3_1 */

                case 1:
                  if (
#line 26806 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()))
                    return 1828; /* *ieee_maxdf3_1 */
                  if (!
#line 26827 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()))
                    return -1;
                  return 1830; /* *ieee_mindf3_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SFmode:
                  if (pattern957 (x2, 
E_V2SFmode) == 0
                      && 
#line 1317 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                    return 2075; /* mmx_blendvps */
                  break;

                case E_V8QImode:
                  if (pattern957 (x2, 
E_V8QImode) == 0
                      && 
#line 4314 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                    return 2241; /* mmx_pblendvb_v8qi */
                  break;

                case E_V4QImode:
                  if (pattern957 (x2, 
E_V4QImode) == 0
                      && 
#line 4390 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                    return 2245; /* mmx_pblendvb_v4qi */
                  break;

                case E_V2QImode:
                  if (pattern957 (x2, 
E_V2QImode) == 0
                      && 
#line 4390 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                    return 2246; /* mmx_pblendvb_v2qi */
                  break;

                case E_V2HImode:
                  if (pattern957 (x2, 
E_V2HImode) == 0
                      && 
#line 4390 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                    return 2247; /* mmx_pblendvb_v2hi */
                  break;

                case E_SFmode:
                  if (pattern957 (x2, 
E_SFmode) == 0
                      && 
#line 23534 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return 8614; /* sse4_1_blendvss */
                  break;

                case E_DFmode:
                  if (pattern957 (x2, 
E_DFmode) == 0
                      && 
#line 23534 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return 8615; /* sse4_1_blendvsd */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x3) != SUBREG)
                return -1;
              switch (pattern842 (x2))
                {
                case 0:
                  if (!
#line 4366 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
                    return -1;
                  return 2243; /* *mmx_pblendvb_v8qi_2 */

                case 1:
                  if (!
#line 4366 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
                    return -1;
                  return 2244; /* *mmx_pblendvb_v8qi_2 */

                case 2:
                  if (!
#line 4442 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                    return -1;
                  return 2251; /* *mmx_pblendvb_v4qi_2 */

                default:
                  return -1;
                }

            case EQ:
              switch (pattern733 (x2))
                {
                case 0:
                  if (!
#line 4338 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()))
                    return -1;
                  return 2242; /* *mmx_pblendvb_v8qi_1 */

                case 1:
                  if (!
#line 4414 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                    return -1;
                  return 2248; /* *mmx_pblendvb_v4qi_1 */

                case 2:
                  if (!
#line 4414 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                    return -1;
                  return 2249; /* *mmx_pblendvb_v2qi_1 */

                case 3:
                  if (!
#line 4414 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                    return -1;
                  return 2250; /* *mmx_pblendvb_v2hi_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 50:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XVECEXP (x2, 0, 0);
          operands[2] = x7;
          x8 = XVECEXP (x2, 0, 1);
          operands[1] = x8;
          x3 = XVECEXP (x2, 0, 2);
          operands[3] = x3;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern958 (x2, 
E_V2SFmode) != 0
                  || !
#line 1261 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                return -1;
              return 2072; /* sse4_1_insertps_v2sf */

            case E_V2SImode:
              if (pattern958 (x2, 
E_V2SImode) != 0
                  || !
#line 1261 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                return -1;
              return 2073; /* sse4_1_insertps_v2si */

            default:
              return -1;
            }

        case 53:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          x3 = XVECEXP (x2, 0, 2);
          operands[3] = x3;
          if (!nonimmediate_operand (operands[3], E_V16QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern959 (x2, 
E_V8QImode) != 0
                  || !
#line 4512 "../../../gcc/config/i386/mmx.md"
(TARGET_XOP && TARGET_MMX_WITH_SSE))
                return -1;
              return 2263; /* mmx_ppermv64 */

            case E_V4QImode:
              if (pattern959 (x2, 
E_V4QImode) != 0
                  || !
#line 4524 "../../../gcc/config/i386/mmx.md"
(TARGET_XOP))
                return -1;
              return 2264; /* mmx_ppermv32 */

            default:
              return -1;
            }

        case 47:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_V8QImode)
            return -1;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_V8QImode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          switch (pattern1060 (x2, 
E_V8QImode))
            {
            case 0:
              if (!(
#line 6860 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE || TARGET_3DNOW_A) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 2385; /* *mmx_maskmovq */

            case 1:
              if (!(
#line 6860 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE || TARGET_3DNOW_A) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 2386; /* *mmx_maskmovq */

            default:
              return -1;
            }

        case 157:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x7;
              x3 = XVECEXP (x2, 0, 2);
              if (GET_CODE (x3) != CONST_INT)
                return -1;
              x8 = XVECEXP (x2, 0, 1);
              operands[2] = x8;
              if (XWINT (x3, 0) == 0L)
                {
                  switch (pattern956 (x2))
                    {
                    case 0:
                      if ((
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3462; /* *avx512vl_eqv16qi3_1 */
                      break;

                    case 1:
                      if ((
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3474; /* *avx512vl_eqv16hi3_1 */
                      break;

                    case 2:
                      if ((
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 3530; /* *avx512f_eqv16si3_1 */
                      break;

                    case 3:
                      if ((
#line 4585 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3478; /* *avx512vl_eqv8hi3_1 */
                      break;

                    case 4:
                      if ((
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3534; /* *avx512vl_eqv8si3_1 */
                      break;

                    case 5:
                      if ((
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3538; /* *avx512vl_eqv4si3_1 */
                      break;

                    case 6:
                      if ((
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 3542; /* *avx512f_eqv8di3_1 */
                      break;

                    case 7:
                      if ((
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3546; /* *avx512vl_eqv4di3_1 */
                      break;

                    case 8:
                      if ((
#line 4674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return 3550; /* *avx512vl_eqv2di3_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x3;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              switch (pattern67 (x2))
                {
                case 0:
                  if (!(
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3482; /* avx512vl_ucmpv16qi3 */

                case 1:
                  if (!(
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3488; /* avx512vl_ucmpv16hi3 */

                case 2:
                  if (!(
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3552; /* avx512f_ucmpv16si3 */

                case 3:
                  if (!(
#line 4600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3490; /* avx512vl_ucmpv8hi3 */

                case 4:
                  if (!(
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3554; /* avx512vl_ucmpv8si3 */

                case 5:
                  if (!(
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3556; /* avx512vl_ucmpv4si3 */

                case 6:
                  if (!(
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3558; /* avx512f_ucmpv8di3 */

                case 7:
                  if (!(
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3560; /* avx512vl_ucmpv4di3 */

                case 8:
                  if (!(
#line 4689 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3562; /* avx512vl_ucmpv2di3 */

                default:
                  return -1;
                }

            case US_MINUS:
              switch (pattern420 (x2))
                {
                case 0:
                  if (!(
#line 4792 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3609; /* *avx512vl_ucmpv16qi3_1 */

                case 1:
                  if (!(
#line 4792 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3615; /* *avx512vl_ucmpv16hi3_1 */

                case 2:
                  if (!(
#line 4792 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3617; /* *avx512vl_ucmpv8hi3_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 52:
          if (pattern59 (x1, pnum_clobbers, 
E_V8QImode) != 0)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          if (!register_mmxmem_operand (operands[2], E_V8QImode))
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          operands[4] = x3;
          if (!reg_or_const_vector_operand (operands[4], E_V4SImode)
              || !
#line 23140 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          *pnum_clobbers = 1;
          return 8557; /* *ssse3_pshufbv8qi3 */

        case 132:
          if (pnum_clobbers == NULL
              || pattern251 (x1) != 0
              || !nonimmediate_operand (operands[3], E_V16QImode))
            return -1;
          x3 = XVECEXP (x2, 0, 2);
          operands[4] = x3;
          if (!const_0_to_255_operand (operands[4], E_SImode)
              || !
#line 26061 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          *pnum_clobbers = 2;
          return 8911; /* sse4_2_pcmpistr_cconly */

        default:
          return -1;
        }

    case 5:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 131
          || pattern251 (x1) != 0
          || !register_operand (operands[3], E_SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      operands[4] = x3;
      if (!nonimmediate_operand (operands[4], E_V16QImode))
        return -1;
      x10 = XVECEXP (x2, 0, 3);
      operands[5] = x10;
      if (!register_operand (operands[5], E_SImode))
        return -1;
      x11 = XVECEXP (x2, 0, 4);
      operands[6] = x11;
      if (!const_0_to_255_operand (operands[6], E_SImode)
          || !
#line 25936 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
        return -1;
      *pnum_clobbers = 2;
      return 8907; /* sse4_2_pcmpestr_cconly */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (nonimm_ssenomem_operand (operands[0], E_DFmode)
          && nonimmediate_operand (operands[1], E_SFmode)
          && 
#line 5295 "../../../gcc/config/i386/i386.md"
(TARGET_80387 || (TARGET_SSE2 && TARGET_SSE_MATH)))
        return 200; /* *extendsfdf2 */
      if (!register_operand (operands[0], E_DFmode)
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 5451 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 202; /* *extendhfdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 5451 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 201; /* *extendhfsf2 */

    case E_XFmode:
      if (!nonimmediate_operand (operands[0], E_XFmode))
        return -1;
      switch (pattern425 (x3, 
E_XFmode))
        {
        case 0:
          if (!
#line 5513 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 204; /* *extendsfxf2_i387 */

        case 1:
          if (!
#line 5513 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 205; /* *extenddfxf2_i387 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (register_operand (operands[0], E_SImode))
        {
          switch (pattern263 ())
            {
            case 0:
              if (
#line 5769 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return 212; /* fix_trunchfsi2 */
              break;

            case 1:
              if (
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 225; /* fix_truncsfsi_sse */
              break;

            case 2:
              if (
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 227; /* fix_truncdfsi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 230; /* fix_truncsi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 233; /* *fix_truncsi_i387_1 */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (register_operand (operands[0], E_DImode))
        {
          switch (pattern263 ())
            {
            case 0:
              if ((
#line 5769 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 214; /* fix_trunchfdi2 */
              break;

            case 1:
              if ((
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 226; /* fix_truncsfdi_sse */
              break;

            case 2:
              if ((
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 228; /* fix_truncdfdi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 231; /* fix_truncdi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 234; /* *fix_truncdi_i387_1 */

    case E_HImode:
      if (pattern262 (x3, pnum_clobbers, 
E_VOIDmode, 
E_HImode) != 0)
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 229; /* fix_trunchi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 232; /* *fix_trunchi_i387_1 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !vector_operand (operands[1], E_V2DFmode)
          || !
#line 8922 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4828; /* sse2_cvttpd2pi */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern739 (x2, 
E_HImode) != 0
              || !
#line 13609 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 835; /* *notxorhi_1 */

        case E_QImode:
          if (pattern739 (x2, 
E_QImode) != 0
              || !
#line 13809 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 871; /* *notxorqi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !(
#line 14978 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1031; /* *one_cmplti2_doubleword */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 14991 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1032; /* *one_cmplhi2_1 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 15035 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1041; /* *one_cmplqi2_1 */

            case E_V4QImode:
              if (!register_operand (operands[0], E_V4QImode)
                  || GET_MODE (x2) != E_V4QImode
                  || !register_operand (operands[1], E_V4QImode))
                return -1;
              return 2265; /* one_cmplv4qi2 */

            case E_V2QImode:
              if (!register_operand (operands[0], E_V2QImode)
                  || GET_MODE (x2) != E_V2QImode
                  || !register_operand (operands[1], E_V2QImode))
                return -1;
              return 2266; /* one_cmplv2qi2 */

            case E_V2HImode:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x2) != E_V2HImode
                  || !register_operand (operands[1], E_V2HImode))
                return -1;
              return 2267; /* one_cmplv2hi2 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 15061 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1042; /* *one_cmplqi_1_slp */

        case 2:
          if (!
#line 15061 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1043; /* *one_cmplhi_1_slp */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      if (!const_0_to_63_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      x10 = XEXP (x3, 2);
      if (!rtx_equal_p (x10, operands[1])
          || !
#line 19060 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
        return -1;
      *pnum_clobbers = 1;
      return 1415; /* *btcq_imm */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[2] = x12;
      x13 = XVECEXP (x3, 0, 2);
      operands[3] = x13;
      switch (XINT (x3, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern961 (x2))
                {
                case 0:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3381; /* *avx512f_cmpv16si3 */

                case 1:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 3388; /* *avx512vl_cmpv16hf3 */

                case 2:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3390; /* *avx512f_cmpv16sf3 */

                case 3:
                  if (!(
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3446; /* *avx512vl_cmpv16qi3 */

                case 4:
                  if (!(
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3452; /* *avx512vl_cmpv16hi3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern962 (x2))
                {
                case 0:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3382; /* *avx512vl_cmpv8si3 */

                case 1:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3383; /* *avx512vl_cmpv4si3 */

                case 2:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3384; /* *avx512f_cmpv8di3 */

                case 3:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3385; /* *avx512vl_cmpv4di3 */

                case 4:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3386; /* *avx512vl_cmpv2di3 */

                case 5:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 3389; /* *avx512fp16_cmpv8hf3 */

                case 6:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3391; /* *avx512vl_cmpv8sf3 */

                case 7:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3392; /* *avx512vl_cmpv4sf3 */

                case 8:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3393; /* *avx512f_cmpv8df3 */

                case 9:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3394; /* *avx512vl_cmpv4df3 */

                case 10:
                  if (!(
#line 4472 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3395; /* *avx512vl_cmpv2df3 */

                case 11:
                  if (!(
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3454; /* *avx512vl_cmpv8hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern1065 (x2))
                {
                case 0:
                  if (!(
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3447; /* *avx512vl_cmpv16qi3 */

                case 1:
                  if (!(
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3453; /* *avx512vl_cmpv16hi3 */

                case 2:
                  if (!(
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3600; /* *avx512f_ucmpv16si3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern1066 (x2))
                {
                case 0:
                  if (!(
#line 4567 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3455; /* *avx512vl_cmpv8hi3 */

                case 1:
                  if (!(
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3601; /* *avx512vl_ucmpv8si3 */

                case 2:
                  if (!(
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3602; /* *avx512vl_ucmpv4si3 */

                case 3:
                  if (!(
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3603; /* *avx512f_ucmpv8di3 */

                case 4:
                  if (!(
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3604; /* *avx512vl_ucmpv4di3 */

                case 5:
                  if (!(
#line 4765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3605; /* *avx512vl_ucmpv2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_54 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x2, 1);
          if (pattern597 (x7) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (pattern1250 (x1))
            {
            case 0:
              if (!
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* *subqi_exthi_2_slp */

            case 1:
              if (!
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* *subqi_extsi_2_slp */

            case 2:
              if (!(
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 410; /* *subqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 419; /* *subqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 420; /* *subqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *subqi_ext2di_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x11 = XEXP (x1, 0);
      operands[0] = x11;
      switch (pattern291 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1344 (x2, 
E_QImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 487; /* subqi3_carry */

            case E_HImode:
              if (pattern1344 (x2, 
E_HImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 488; /* subhi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1255 (x2, 
E_QImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 570; /* *subqi3_eq */

            case E_HImode:
              if (pattern1255 (x2, 
E_HImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *subhi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern91 (x1))
        {
        case 0:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (pattern963 (x2) != 0)
            return -1;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1493 (x2, 
E_SFmode, 
E_V2SFmode) != 0
                  || !
#line 1058 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE3 && TARGET_MMX_WITH_SSE && ix86_partial_vec_fp_math
   && ix86_pre_reload_split ()))
                return -1;
              return 2067; /* *mmx_hsubv2sf3_low */

            case E_DFmode:
              if (pattern1493 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3772 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_V2DF_REDUCTION_PREFER_HADDPD))
                return -1;
              return 3154; /* *sse3_hsubv2df3_low */

            default:
              return -1;
            }

        case 1:
          switch (pattern848 (x2))
            {
            case 0:
              if (!
#line 22605 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8524; /* ssse3_phsubwv4hi3 */

            case 1:
              if (!
#line 22692 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8531; /* ssse3_phsubdv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_61 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (pattern275 (x2))
        {
        case 0:
          x6 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x6) == CONST_INT)
            {
              switch (pattern967 (x2))
                {
                case 0:
                  if (
#line 1691 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2087; /* *vec_interleave_lowv2sf */
                  break;

                case 1:
                  if (
#line 4991 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return 2303; /* mmx_punpckldq */
                  break;

                case 2:
                  if (
#line 1708 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
                    return 2088; /* *vec_interleave_highv2sf */
                  break;

                case 3:
                  if (
#line 4970 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                    return 2302; /* mmx_punpckhdq */
                  break;

                default:
                  break;
                }
            }
          x7 = XVECEXP (x3, 0, 0);
          operands[3] = x7;
          switch (pattern968 (x2))
            {
            case 0:
              if (!
#line 6197 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2368; /* *punpckwd */

            case 1:
              if (!
#line 6197 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2369; /* *punpckwd */

            case 2:
              if (!
#line 6197 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2370; /* *punpckwd */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4850 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2296; /* mmx_punpckhbw */

        case 2:
          if (!
#line 4890 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2298; /* mmx_punpcklbw */

        case 3:
          if (!
#line 4871 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2297; /* mmx_punpckhbw_low */

        case 4:
          if (!
#line 4928 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2300; /* mmx_punpckhwd */

        case 5:
          if (!
#line 4911 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2299; /* mmx_punpcklbw_low */

        case 6:
          if (!
#line 4949 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2301; /* mmx_punpcklwd */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern276 (x2) != 0
          || !
#line 8409 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4716; /* sse_cvtps2pi */

    case FIX:
      if (pattern278 (x2) != 0
          || !
#line 8473 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4718; /* sse_cvttps2pi */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 5918 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3760; /* *fma_fmadd_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 5946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3775; /* *fma_fmadd_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 5918 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3761; /* *fma_fmadd_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 5946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3784; /* *fma_fmadd_df */

            case E_HFmode:
              if (pattern858 (x3, 
E_HFmode) != 0
                  || !(
#line 5946 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3774; /* *fma_fmadd_hf */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || GET_MODE (x6) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6017 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3823; /* *fma_fmsub_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3838; /* *fma_fmsub_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || GET_MODE (x6) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6017 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3824; /* *fma_fmsub_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3847; /* *fma_fmsub_df */

            case E_HFmode:
              if (pattern859 (x3, 
E_HFmode) != 0
                  || !(
#line 6049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3837; /* *fma_fmsub_hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || GET_MODE (x5) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6123 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3886; /* *fma_fnmadd_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3901; /* *fma_fnmadd_sf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || GET_MODE (x5) != E_DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6123 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3887; /* *fma_fnmadd_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3910; /* *fma_fnmadd_df */

            case E_HFmode:
              if (pattern860 (x3, 
E_HFmode) != 0
                  || !(
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3900; /* *fma_fnmadd_hf */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern861 (x3, 
E_SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && 
#line 6230 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3943; /* *fma_fnmsub_sf */
              if (!bcst_vector_operand (operands[1], E_SFmode)
                  || !bcst_vector_operand (operands[2], E_SFmode)
                  || !bcst_vector_operand (operands[3], E_SFmode)
                  || !
#line 6263 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3972; /* *fma_fnmsub_sf */

            case E_DFmode:
              if (pattern861 (x3, 
E_DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && nonimmediate_operand (operands[2], E_DFmode)
                  && nonimmediate_operand (operands[3], E_DFmode)
                  && 
#line 6230 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3945; /* *fma_fnmsub_df */
              if (!bcst_vector_operand (operands[1], E_DFmode)
                  || !bcst_vector_operand (operands[2], E_DFmode)
                  || !bcst_vector_operand (operands[3], E_DFmode)
                  || !
#line 6263 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1))
                return -1;
              return 3981; /* *fma_fnmsub_df */

            case E_HFmode:
              if (pattern862 (x3, 
E_HFmode) != 0
                  || !(
#line 6263 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3971; /* *fma_fnmsub_hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern974 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 5437 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return 2324; /* *mmx_pextrw_zext */
          break;

        case 1:
          if (
#line 6098 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2362; /* *pextrw_zext */
          break;

        case 2:
          if (
#line 21102 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8389; /* *vec_extractv8hi_zext */
          break;

        case 3:
          if (
#line 5474 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2328; /* *mmx_pextrb_zext */
          break;

        case 4:
          if (
#line 6130 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2366; /* *pextrb_zext */
          break;

        case 5:
          if ((
#line 21102 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 21045 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
            return 8387; /* *vec_extractv16qi_zext */
          break;

        default:
          break;
        }
      break;

    case E_DImode:
      switch (pattern974 (x2, 
E_DImode))
        {
        case 0:
          if ((
#line 5437 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2325; /* *mmx_pextrw_zext */
          break;

        case 1:
          if ((
#line 6098 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2363; /* *pextrw_zext */
          break;

        case 2:
          if ((
#line 21102 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 8390; /* *vec_extractv8hi_zext */
          break;

        case 3:
          if ((
#line 5474 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2329; /* *mmx_pextrb_zext */
          break;

        case 4:
          if ((
#line 6130 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 2367; /* *pextrb_zext */
          break;

        case 5:
          if ((
#line 21102 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && (
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21045 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))))
            return 8388; /* *vec_extractv16qi_zext */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode
      || GET_MODE (x3) != E_SImode)
    return -1;
  operands[1] = x6;
  switch (XWINT (x5, 0))
    {
    case 0L:
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (register_operand (operands[1], E_V2SImode))
            {
              if (
#line 5749 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE4_1))
                return 2350; /* *vec_extractv2si_0_zext_sse4 */
              if (
#line 5764 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_FROM_VEC))
                return 2351; /* *vec_extractv2si_0_zext */
            }
          break;

        case E_V4SImode:
          if (register_operand (operands[1], E_V4SImode))
            {
              if (
#line 21202 "../../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE4_1))
                return 8397; /* *vec_extractv4si_0_zext_sse4 */
              if (
#line 21217 "../../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_FROM_VEC))
                return 8398; /* *vec_extractv4si_0_zext */
            }
          break;

        default:
          break;
        }
      break;

    case 1L:
      if (register_operand (operands[1], E_V2SImode)
          && 
#line 5826 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_64BIT && TARGET_SSE4_1))
        return 2353; /* *vec_extractv2si_1_zext */
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!memory_operand (operands[1], E_V2SImode)
          || !const_0_to_1_operand (operands[2], E_SImode)
          || !
#line 5842 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_64BIT))
        return -1;
      return 2354; /* *vec_extractv2si_zext_mem */

    case E_V4SImode:
      if (!const_0_to_3_operand (operands[2], E_SImode))
        return -1;
      if (register_operand (operands[1], E_V4SImode)
          && 
#line 21278 "../../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE4_1))
        return 8400; /* *vec_extractv4si_zext */
      if (!memory_operand (operands[1], E_V4SImode)
          || !
#line 21301 "../../../gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE))
        return -1;
      return 8402; /* *vec_extractv4si_zext_mem */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x6;
              operands[1] = x4;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern600 (x2, 
E_SImode) != 0
                      || !
#line 8039 "../../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))))
                    return -1;
                  return 376; /* *leasi_general_4 */

                case E_DImode:
                  if (GET_MODE (x2) != E_DImode
                      || GET_MODE (x3) != E_DImode)
                    return -1;
                  if (register_operand (operands[0], E_DImode)
                      && register_no_SP_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && const_int_operand (operands[3], E_VOIDmode)
                      && (
#line 8039 "../../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 378; /* *leadi_general_4 */
                  if (!nonimmediate_operand (operands[0], E_DImode)
                      || !register_operand (operands[1], E_DImode)
                      || !const_int_operand (operands[2], E_QImode)
                      || !const_scalar_int_operand (operands[3], E_DImode)
                      || !(
#line 14139 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return -1;
                  return 929; /* *concatsidi3_5 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              operands[1] = x4;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x5;
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !(
#line 14062 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 893; /* *concatsidi3_1 */

            case SUBREG:
              switch (pattern439 (x2, 
LSHIFTRT))
                {
                case 0:
                  operands[2] = x5;
                  if (pattern1346 (x2) == 0)
                    {
                      if (
#line 15439 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && TARGET_APX_NF))
                        return 1066; /* x86_64_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15439 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                        {
                          *pnum_clobbers = 1;
                          return 1067; /* x86_64_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1347 (x2) != 0)
                    return -1;
                  if (
#line 15461 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1068; /* x86_64_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15461 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1069; /* x86_64_shld_ndd_1 */

                case 1:
                  operands[2] = x5;
                  if (pattern1348 (x2) == 0)
                    {
                      if (
#line 15671 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && TARGET_APX_NF))
                        return 1078; /* x86_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15671 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && true))
                        {
                          *pnum_clobbers = 1;
                          return 1079; /* x86_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1349 (x2) != 0)
                    return -1;
                  if (
#line 15693 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1080; /* x86_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15693 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1081; /* x86_shld_ndd_1 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern442 (x2, pnum_clobbers))
                {
                case 0:
                  if (
#line 15477 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1070; /* *x86_64_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15533 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1071; /* *x86_64_shld_shrd_1_nozext */

                case 1:
                  if (
#line 15709 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1082; /* *x86_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15765 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1083; /* *x86_shld_shrd_1_nozext */

                case 2:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_DImode))
                    {
                      operands[2] = x5;
                      if (rtx_equal_p (x4, operands[0]))
                        {
                          x8 = XEXP (x6, 1);
                          x9 = XEXP (x8, 1);
                          if (rtx_equal_p (x9, operands[2])
                              && 
#line 15586 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1072; /* *x86_64_shld_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15607 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1073; /* *x86_64_shld_ndd_2 */

                case 3:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_SImode))
                    {
                      operands[2] = x5;
                      if (rtx_equal_p (x4, operands[0]))
                        {
                          x8 = XEXP (x6, 1);
                          x9 = XEXP (x8, 1);
                          if (rtx_equal_p (x9, operands[2])
                              && 
#line 15817 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1084; /* *x86_shld_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15838 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1085; /* *x86_shld_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          switch (pattern290 (x2, 
LSHIFTRT))
            {
            case 0:
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (nonimmediate_operand (operands[0], E_DImode))
                {
                  res = recog_77 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[2] = x11;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15424 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1064; /* x86_64_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15424 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1065; /* x86_64_shld_ndd */

            case 1:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || pattern289 (x2, 
E_SImode, 
E_DImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (rtx_equal_p (x4, operands[0]))
                {
                  x13 = XEXP (x7, 1);
                  x14 = XEXP (x13, 1);
                  x15 = XEXP (x14, 0);
                  if (rtx_equal_p (x15, operands[2]))
                    {
                      if (
#line 15633 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF))
                        return 1074; /* x86_shld_nf */
                      if (pnum_clobbers != NULL)
                        {
                          *pnum_clobbers = 1;
                          return 1075; /* x86_shld */
                        }
                    }
                }
              operands[2] = x11;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15655 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1076; /* x86_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15655 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1077; /* x86_shld_ndd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern260 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14098 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 905; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14171 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 935; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern260 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14098 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 908; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14171 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 938; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case CONST_INT:
      switch (pattern288 (x2, pnum_clobbers))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern748 (x2))
                {
                case 0:
                  if (
#line 18825 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    {
                      *pnum_clobbers = 1;
                      return 1391; /* *btssi */
                    }
                  break;

                case 1:
                  if ((
#line 18825 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1393; /* *btsdi */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern757 (x2))
            {
            case 0:
              if (!
#line 18844 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1395; /* *btssi_mask */

            case 1:
              if (!(
#line 18844 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1397; /* *btsdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18872 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1399; /* *btssi_mask_1 */

        case 2:
          if (!(
#line 18872 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1401; /* *btsdi_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers != NULL)
        {
          x2 = XEXP (x1, 1);
          if (pattern734 (x2, 
E_DImode, 
E_QImode) == 0
              && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 1;
              return 1131; /* ashrdi3_doubleword */
            }
        }
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_DImode)
          && const_int_operand (operands[2], E_QImode))
        {
          if ((
#line 17246 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1168; /* ashrdi3_cvt_nf */
          if (pnum_clobbers != NULL
              && (
#line 17246 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1169; /* ashrdi3_cvt */
            }
        }
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[2], E_DImode)
          && (
#line 17315 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1174; /* *bmi2_ashrdi3_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonmemory_operand (operands[2], E_QImode))
        return -1;
      if ((
#line 17325 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1177; /* *ashrdi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 17325 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1178; /* *ashrdi3_1 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern620 (x2, 
E_SImode) != 0)
        return -1;
      if (
#line 17325 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 1175; /* *ashrsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 17325 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 1176; /* *ashrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == SUBREG
      && known_eq (SUBREG_BYTE (x2), 0))
    {
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x1, 1);
          x5 = XEXP (x4, 2);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (x2))
                {
                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1434; /* *btsi_setcqi */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 19344 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1435; /* *btdi_setcqi */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND)
    return -1;
  operands[0] = x2;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1438 (x4, 
E_SImode) != 0
          || !
#line 19425 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1442; /* *btsi_setcsi_mask */

    case E_DImode:
      if (pattern1438 (x4, 
E_DImode) != 0
          || !(
#line 19425 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1443; /* *btdi_setcdi_mask */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !ix86_comparison_operator (operands[1], E_SImode))
        return -1;
      if (
#line 19493 "../../../gcc/config/i386/i386.md"
(TARGET_APX_ZU))
        return 1445; /* *setcc_si_zu */
      if (pnum_clobbers != NULL
          && 
#line 19517 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
        {
          *pnum_clobbers = 1;
          return 1449; /* *setcc_si_1_and */
        }
      if (!
#line 19534 "../../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))))
        return -1;
      return 1451; /* *setcc_si_1_movzbl */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !ix86_comparison_operator (operands[1], E_DImode))
        return -1;
      if ((
#line 19493 "../../../gcc/config/i386/i386.md"
(TARGET_APX_ZU) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1446; /* *setcc_di_zu */
      if (!
#line 19501 "../../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && TARGET_64BIT && !TARGET_PARTIAL_REG_STALL))
        return -1;
      return 1447; /* *setcc_di_1 */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 45:
      if (pattern298 (x3) != 0
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 19576 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
        return -1;
      return 1454; /* *setcc_si_slp */

    case 98:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern777 (x3, 
E_SImode) != 0
              || !
#line 21754 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          *pnum_clobbers = 1;
          return 1566; /* bmi_bextr_si */

        case E_DImode:
          if (pattern777 (x3, 
E_DImode) != 0
              || !(
#line 21754 "../../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1567; /* bmi_bextr_di */

        default:
          return -1;
        }

    case 99:
      switch (pattern299 (x3))
        {
        case 0:
          if (!
#line 22147 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          return 1600; /* bmi2_pdep_si3 */

        case 1:
          if (!(
#line 22147 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1601; /* bmi2_pdep_di3 */

        default:
          return -1;
        }

    case 100:
      switch (pattern299 (x3))
        {
        case 0:
          if (!
#line 22158 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          return 1602; /* bmi2_pext_si3 */

        case 1:
          if (!(
#line 22158 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1603; /* bmi2_pext_di3 */

        default:
          return -1;
        }

    case 93:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_CCZmode
          || !flags_reg_operand (operands[0], E_CCZmode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!memory_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          *pnum_clobbers = 1;
          return 1883; /* stack_protect_test_1_si */

        case E_DImode:
          if (!memory_operand (operands[1], E_DImode)
              || !memory_operand (operands[2], E_DImode)
              || !
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          *pnum_clobbers = 1;
          return 1884; /* stack_protect_test_1_di */

        default:
          return -1;
        }

    case 95:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[2], E_QImode)
              || !
#line 29056 "../../../gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1891; /* sse4_2_crc32qi */

        case E_HImode:
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !
#line 29056 "../../../gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1892; /* sse4_2_crc32hi */

        case E_SImode:
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 29056 "../../../gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1893; /* sse4_2_crc32si */

        default:
          return -1;
        }

    case 178:
      x5 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          switch (XVECLEN (x5, 0))
            {
            case 3:
              if (XINT (x5, 1) != 59
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x6 = XVECEXP (x5, 0, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_V32HFmode))
                return -1;
              x7 = XVECEXP (x5, 0, 1);
              operands[2] = x7;
              if (!nonimmediate_operand (operands[2], E_V32HFmode))
                return -1;
              x8 = XVECEXP (x5, 0, 2);
              operands[3] = x8;
              if (!const_0_to_31_operand (operands[3], E_SImode))
                return -1;
              x4 = XVECEXP (x3, 0, 1);
              operands[4] = x4;
              if (!const48_operand (operands[4], E_SImode)
                  || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3268; /* avx512bw_cmpv32hf3_round */

            case 1:
              x4 = XVECEXP (x3, 0, 1);
              operands[2] = x4;
              switch (XINT (x5, 1))
                {
                case 156:
                  switch (pattern869 (x3))
                    {
                    case 0:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7815 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4475; /* avx512fp16_vcvtsh2usi_round */

                    case 1:
                      if (!
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4835; /* avx512f_vcvtss2usi_round */

                    case 2:
                      if (!
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4847; /* avx512f_vcvtsd2usi_round */

                    case 3:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7815 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4479; /* avx512fp16_vcvtsh2usiq_round */

                    case 4:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4837; /* avx512f_vcvtss2usiq_round */

                    case 5:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4849; /* avx512f_vcvtsd2usiq_round */

                    default:
                      return -1;
                    }

                case 46:
                  switch (pattern869 (x3))
                    {
                    case 0:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7815 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4477; /* avx512fp16_vcvtsh2si_round */

                    case 1:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8542 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                        return -1;
                      return 4724; /* sse_cvtss2si_round */

                    case 2:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9085 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 4859; /* sse2_cvtsd2si_round */

                    case 3:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7815 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4481; /* avx512fp16_vcvtsh2siq_round */

                    case 4:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8542 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4726; /* sse_cvtss2siq_round */

                    case 5:
                      if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9085 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4861; /* sse2_cvtsd2siq_round */

                    default:
                      return -1;
                    }

                case 172:
                  switch (pattern871 (x3))
                    {
                    case 0:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7980 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4627; /* unspec_avx512fp16_fix_truncsi2_round */

                    case 1:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8570 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                        return -1;
                      return 4730; /* unspec_sse_cvttss2si_round */

                    case 2:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9114 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 4865; /* unspec_sse2_cvttsd2si_round */

                    case 3:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7980 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4631; /* unspec_avx512fp16_fix_truncdi2_round */

                    case 4:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8570 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4732; /* unspec_sse_cvttss2siq_round */

                    case 5:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9114 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4867; /* unspec_sse2_cvttsd2siq_round */

                    default:
                      return -1;
                    }

                case 173:
                  switch (pattern871 (x3))
                    {
                    case 0:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7980 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4629; /* unspec_avx512fp16_fixuns_truncsi2_round */

                    case 1:
                      if (!
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4839; /* unspec_avx512f_vcvttss2usi_round */

                    case 2:
                      if (!
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4851; /* unspec_avx512f_vcvttsd2usi_round */

                    case 3:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7980 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4633; /* unspec_avx512fp16_fixuns_truncdi2_round */

                    case 4:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9024 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4841; /* unspec_avx512f_vcvttss2usiq_round */

                    case 5:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9060 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4853; /* unspec_avx512f_vcvttsd2usiq_round */

                    default:
                      return -1;
                    }

                case 275:
                  switch (pattern873 (x3))
                    {
                    case 0:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                        return -1;
                      return 10809; /* avx10_2_vcvttsd2sissi_round */

                    case 1:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                        return -1;
                      return 10817; /* avx10_2_vcvttss2sissi_round */

                    case 2:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10813; /* avx10_2_vcvttsd2sisdi_round */

                    case 3:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10821; /* avx10_2_vcvttss2sisdi_round */

                    default:
                      return -1;
                    }

                case 276:
                  switch (pattern873 (x3))
                    {
                    case 0:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                        return -1;
                      return 10811; /* avx10_2_vcvttsd2usissi_round */

                    case 1:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                        return -1;
                      return 10819; /* avx10_2_vcvttss2usissi_round */

                    case 2:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32605 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10815; /* avx10_2_vcvttsd2usisdi_round */

                    case 3:
                      if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10823; /* avx10_2_vcvttss2usisdi_round */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != UNSPEC
              || XVECLEN (x9, 0) != 3
              || XINT (x9, 1) != 59
              || GET_MODE (x9) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_V32HFmode))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          x12 = XVECEXP (x9, 0, 2);
          operands[3] = x12;
          if (!const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x5, 1);
          operands[4] = x13;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 1);
          operands[5] = x4;
          if (!const48_operand (operands[5], E_SImode)
              || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 3270; /* avx512bw_cmpv32hf3_mask_round */

        case FIX:
          switch (pattern452 (x3))
            {
            case 0:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7992 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4635; /* avx512fp16_fix_truncsi2_round */

            case 1:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8586 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 4734; /* sse_cvttss2si_round */

            case 2:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9131 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 4869; /* sse2_cvttsd2si_round */

            case 3:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7992 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4639; /* avx512fp16_fix_truncdi2_round */

            case 4:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8586 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4736; /* sse_cvttss2siq_round */

            case 5:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9131 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4871; /* sse2_cvttsd2siq_round */

            default:
              return -1;
            }

        case UNSIGNED_FIX:
          switch (pattern452 (x3))
            {
            case 0:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7992 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4637; /* avx512fp16_fixuns_truncsi2_round */

            case 1:
              if (!
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 4843; /* avx512f_vcvttss2usi_round */

            case 2:
              if (!
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 4855; /* avx512f_vcvttsd2usi_round */

            case 3:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7992 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4641; /* avx512fp16_fixuns_truncdi2_round */

            case 4:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9036 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4845; /* avx512f_vcvttss2usiq_round */

            case 5:
              if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9072 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4857; /* avx512f_vcvttsd2usiq_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 158:
      switch (pattern301 (x3))
        {
        case 0:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8036; /* avx512bw_testmv64qi3 */

        case 1:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8038; /* avx512vl_testmv32qi3 */

        case 2:
          if (!(
#line 19038 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8042; /* avx512bw_testmv32hi3 */

        default:
          return -1;
        }

    case 159:
      switch (pattern301 (x3))
        {
        case 0:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8060; /* avx512bw_testnmv64qi3 */

        case 1:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8062; /* avx512vl_testnmv32qi3 */

        case 2:
          if (!(
#line 19049 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8066; /* avx512bw_testnmv32hi3 */

        default:
          return -1;
        }

    case 193:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!vector_operand (operands[1], E_V32HFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode)
          || !(
#line 29844 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V32HFmode)) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 9908; /* avx512dq_fpclassv32hf */

    case 214:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern163 (x3, 
E_DImode, 
E_V64QImode) != 0
              || !(
#line 30927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10250; /* avx512vl_vpshufbitqmbv64qi */

        case E_SImode:
          if (pattern163 (x3, 
E_SImode, 
E_V32QImode) != 0
              || !(
#line 30927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10254; /* avx512vl_vpshufbitqmbv32qi */

        default:
          return -1;
        }

    case 262:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode)
          || !
#line 32443 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10644; /* avx10_2_fpclassbf16_v32bf */

    case 288:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !x86_64_nonmemory_operand (operands[1], E_SImode))
            return -1;
          return 10909; /* atomic_storesi_1 */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !x86_64_nonmemory_operand (operands[1], E_DImode)
              || !
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 10910; /* atomic_storedi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 2);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 1L)
            return -1;
          switch (pattern998 (x2))
            {
            case 0:
              if (!
#line 12023 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5206; /* *vec_setv8hi_0_1 */

            case 1:
              if (!
#line 12023 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5207; /* *vec_setv8hf_0_1 */

            case 2:
              if (!
#line 12023 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5208; /* *vec_setv8bf_0_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x7;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x9 = XEXP (x2, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1270 (x2, 
E_V16SImode, 
E_HImode, 
E_V4SImode, 
E_SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9113; /* avx512f_vec_dupv16si_mask */

            case E_V8SImode:
              if (pattern1270 (x2, 
E_V8SImode, 
E_QImode, 
E_V4SImode, 
E_SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9115; /* avx512vl_vec_dupv8si_mask */

            case E_V4SImode:
              if (pattern1271 (x2, 
E_V4SImode, 
E_SImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9117; /* avx512vl_vec_dupv4si_mask */

            case E_V8DImode:
              if (pattern1270 (x2, 
E_V8DImode, 
E_QImode, 
E_V2DImode, 
E_DImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9119; /* avx512f_vec_dupv8di_mask */

            case E_V4DImode:
              if (pattern1270 (x2, 
E_V4DImode, 
E_QImode, 
E_V2DImode, 
E_DImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9121; /* avx512vl_vec_dupv4di_mask */

            case E_V2DImode:
              if (pattern1271 (x2, 
E_V2DImode, 
E_DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9123; /* avx512vl_vec_dupv2di_mask */

            case E_V16SFmode:
              if (pattern1270 (x2, 
E_V16SFmode, 
E_HImode, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9125; /* avx512f_vec_dupv16sf_mask */

            case E_V8SFmode:
              if (pattern1270 (x2, 
E_V8SFmode, 
E_QImode, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9127; /* avx512vl_vec_dupv8sf_mask */

            case E_V4SFmode:
              if (pattern1271 (x2, 
E_V4SFmode, 
E_SFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9129; /* avx512vl_vec_dupv4sf_mask */

            case E_V8DFmode:
              if (pattern1270 (x2, 
E_V8DFmode, 
E_QImode, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9131; /* avx512f_vec_dupv8df_mask */

            case E_V4DFmode:
              if (pattern1270 (x2, 
E_V4DFmode, 
E_QImode, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9133; /* avx512vl_vec_dupv4df_mask */

            case E_V2DFmode:
              if (pattern1271 (x2, 
E_V2DFmode, 
E_DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9135; /* avx512vl_vec_dupv2df_mask */

            case E_V64QImode:
              if (pattern1270 (x2, 
E_V64QImode, 
E_DImode, 
E_V16QImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9137; /* avx512bw_vec_dupv64qi_mask */

            case E_V16QImode:
              if (pattern1271 (x2, 
E_V16QImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9139; /* avx512vl_vec_dupv16qi_mask */

            case E_V32QImode:
              if (pattern1270 (x2, 
E_V32QImode, 
E_SImode, 
E_V16QImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9141; /* avx512vl_vec_dupv32qi_mask */

            case E_V32HImode:
              if (pattern1270 (x2, 
E_V32HImode, 
E_SImode, 
E_V8HImode, 
E_HImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9143; /* avx512bw_vec_dupv32hi_mask */

            case E_V16HImode:
              if (pattern768 (x2, 
E_HImode, 
E_V16HImode) != 0
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || !nonimm_or_0_operand (operands[2], E_V16HImode)
                  || !register_operand (operands[3], E_HImode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9145; /* avx512vl_vec_dupv16hi_mask */

            case E_V8HImode:
              if (pattern1271 (x2, 
E_V8HImode, 
E_HImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9147; /* avx512vl_vec_dupv8hi_mask */

            case E_V32HFmode:
              if (pattern1270 (x2, 
E_V32HFmode, 
E_SImode, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9149; /* avx512bw_vec_dupv32hf_mask */

            case E_V16HFmode:
              if (pattern1270 (x2, 
E_V16HFmode, 
E_HImode, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9151; /* avx512vl_vec_dupv16hf_mask */

            case E_V8HFmode:
              if (pattern1271 (x2, 
E_V8HFmode, 
E_HFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9153; /* avx512fp16_vec_dupv8hf_mask */

            case E_V32BFmode:
              if (pattern1270 (x2, 
E_V32BFmode, 
E_SImode, 
E_V8BFmode, 
E_BFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9155; /* avx512bw_vec_dupv32bf_mask */

            case E_V16BFmode:
              if (pattern1270 (x2, 
E_V16BFmode, 
E_HImode, 
E_V8BFmode, 
E_BFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9157; /* avx512vl_vec_dupv16bf_mask */

            case E_V8BFmode:
              if (pattern1271 (x2, 
E_V8BFmode, 
E_BFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9159; /* avx512vl_vec_dupv8bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x5, 0, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1270 (x2, 
E_V16SImode, 
E_HImode, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9247; /* avx512dq_broadcastv16si_mask */

        case E_V8SImode:
          if (pattern1270 (x2, 
E_V8SImode, 
E_QImode, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9249; /* avx512dq_broadcastv8si_mask */

        case E_V4SImode:
          if (pattern1271 (x2, 
E_V4SImode, 
E_V2SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9251; /* avx512dq_broadcastv4si_mask */

        case E_V16SFmode:
          if (pattern1270 (x2, 
E_V16SFmode, 
E_HImode, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9253; /* avx512dq_broadcastv16sf_mask */

        case E_V8SFmode:
          if (pattern1270 (x2, 
E_V8SFmode, 
E_QImode, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9255; /* avx512dq_broadcastv8sf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 2);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_154 (x1, insn, pnum_clobbers);

        case CONST_INT:
          if (XWINT (x4, 0) == 1L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (GET_MODE (x2) == E_V2DImode)
                    {
                      x5 = XEXP (x2, 0);
                      if (nonimmediate_operand (x5, E_V2DImode))
                        {
                          operands[1] = x5;
                          if (register_operand (operands[0], E_V2DImode))
                            {
                              operands[2] = x3;
                              if (const0_operand (operands[2], E_V2DImode)
                                  && 
#line 1861 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 2556; /* *sse2_movq128_v2di_1 */
                            }
                          operands[2] = x5;
                          if (nonimmediate_operand (operands[0], E_V2DImode))
                            {
                              operands[1] = x3;
                              if (nonimmediate_operand (operands[1], E_V2DImode)
                                  && 
#line 14832 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 7143; /* sse2_movsd_v2di */
                            }
                        }
                    }
                  break;

                case E_V2DFmode:
                  if (GET_MODE (x2) == E_V2DFmode)
                    {
                      x5 = XEXP (x2, 0);
                      if (nonimmediate_operand (x5, E_V2DFmode))
                        {
                          operands[1] = x5;
                          if (register_operand (operands[0], E_V2DFmode))
                            {
                              operands[2] = x3;
                              if (const0_operand (operands[2], E_V2DFmode)
                                  && 
#line 1861 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 2557; /* *sse2_movq128_v2df_1 */
                            }
                          operands[2] = x5;
                          if (nonimmediate_operand (operands[0], E_V2DFmode))
                            {
                              operands[1] = x3;
                              if (nonimmediate_operand (operands[1], E_V2DFmode)
                                  && 
#line 14832 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 7144; /* sse2_movsd_v2df */
                            }
                        }
                    }
                  break;

                case E_V4SImode:
                  if (pattern884 (x2, 
E_V4SImode) == 0
                      && 
#line 11683 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return 5183; /* sse_movss_v4si */
                  break;

                case E_V4SFmode:
                  if (pattern884 (x2, 
E_V4SFmode) == 0
                      && 
#line 11683 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return 5184; /* sse_movss_v4sf */
                  break;

                case E_V8HImode:
                  if (pattern884 (x2, 
E_V8HImode) == 0
                      && 
#line 12101 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2 && const0_operand (operands[1], V8HImode))))
                    return 5222; /* avx512fp16_movv8hi */
                  break;

                case E_V8HFmode:
                  if (pattern884 (x2, 
E_V8HFmode) == 0
                      && 
#line 12101 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2 && const0_operand (operands[1], V8HFmode))))
                    return 5223; /* avx512fp16_movv8hf */
                  break;

                case E_V8BFmode:
                  if (pattern884 (x2, 
E_V8BFmode) == 0
                      && 
#line 12101 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2 && const0_operand (operands[1], V8BFmode))))
                    return 5224; /* avx512fp16_movv8bf */
                  break;

                default:
                  break;
                }
            }
          operands[3] = x4;
          x5 = XEXP (x2, 0);
          operands[2] = x5;
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SFmode:
              if (pattern1105 (x2, 
E_V8SFmode) != 0
                  || !(
#line 23486 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8606; /* avx_blendps256 */

            case E_V4SFmode:
              if (pattern1106 (x2, 
E_V4SFmode) != 0
                  || !
#line 23486 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8607; /* sse4_1_blendps */

            case E_V4DFmode:
              if (pattern1106 (x2, 
E_V4DFmode) != 0
                  || !(
#line 23486 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8608; /* avx_blendpd256 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !vector_operand (operands[2], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !const_0_to_3_operand (operands[3], E_SImode)
                  || !(
#line 23486 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8609; /* sse4_1_blendpd */

            case E_V8HImode:
              if (pattern1105 (x2, 
E_V8HImode) != 0
                  || !
#line 23991 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8671; /* sse4_1_pblendw */

            case E_V8HFmode:
              if (pattern1105 (x2, 
E_V8HFmode) != 0
                  || !
#line 23991 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8672; /* sse4_1_pblendph */

            case E_V8BFmode:
              if (pattern1105 (x2, 
E_V8BFmode) != 0
                  || !
#line 23991 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8673; /* sse4_1_pblendbf */

            case E_V16HImode:
              if (pattern1107 (x2, 
E_V16HImode) != 0
                  || !
#line 24064 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8674; /* *avx2_pblendw */

            case E_V16HFmode:
              if (pattern1107 (x2, 
E_V16HFmode) != 0
                  || !
#line 24064 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8675; /* *avx2_pblendph */

            case E_V16BFmode:
              if (pattern1107 (x2, 
E_V16BFmode) != 0
                  || !
#line 24064 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8676; /* *avx2_pblendbf */

            case E_V8SImode:
              if (pattern1108 (x2, 
E_V8SImode) != 0
                  || !
#line 24082 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8677; /* avx2_pblenddv8si */

            case E_V4SImode:
              if (pattern1108 (x2, 
E_V4SImode) != 0
                  || !
#line 24082 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8678; /* avx2_pblenddv4si */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 3
              || XINT (x4, 1) != 59)
            return -1;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (pattern1001 (x2))
            {
            case 0:
              x6 = XVECEXP (x4, 0, 0);
              operands[3] = x6;
              switch (pattern1450 (x2))
                {
                case 0:
                  if ((
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                    return 3030; /* *minmaxv32hf3_1 */
                  break;

                case 1:
                  if ((
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 3031; /* *minmaxv16hf3_1 */
                  break;

                case 2:
                  if ((
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 3032; /* *minmaxv8hf3_1 */
                  break;

                case 3:
                  if ((
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return 3033; /* *minmaxv16sf3_1 */
                  break;

                case 4:
                  if ((
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3034; /* *minmaxv8sf3_1 */
                  break;

                case 5:
                  if (
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)))
                    return 3035; /* *minmaxv4sf3_1 */
                  break;

                case 6:
                  if ((
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return 3036; /* *minmaxv8df3_1 */
                  break;

                case 7:
                  if ((
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3037; /* *minmaxv4df3_1 */
                  break;

                case 8:
                  if ((
#line 3332 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3038; /* *minmaxv2df3_1 */
                  break;

                case 9:
                  if ((
#line 4217 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3227; /* *avx_cmpv8sf3_lt */
                  break;

                case 10:
                  if (
#line 4217 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3228; /* *avx_cmpv4sf3_lt */
                  break;

                case 11:
                  if ((
#line 4217 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3229; /* *avx_cmpv4df3_lt */
                  break;

                case 12:
                  if ((
#line 4217 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3230; /* *avx_cmpv2df3_lt */
                  break;

                case 13:
                  if (
#line 4246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3231; /* *avx_cmpv4si3_ltint */
                  break;

                case 14:
                  if (
#line 4246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3232; /* *avx_cmpv2di3_ltint */
                  break;

                case 15:
                  if ((
#line 4246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3233; /* *avx_cmpv8si3_ltint */
                  break;

                case 16:
                  if ((
#line 4246 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3234; /* *avx_cmpv4di3_ltint */
                  break;

                case 17:
                  if ((
#line 18013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))) && 
#line 629 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return 7833; /* *avx2_pcmpv32qi3_3 */
                  break;

                case 18:
                  if (
#line 18013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))))
                    return 7834; /* *avx2_pcmpv16qi3_3 */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x6) != SUBREG)
                return -1;
              switch (pattern1453 (x2))
                {
                case 0:
                  if (!
#line 4281 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return -1;
                  return 3235; /* *avx_cmpv4si3_ltint_not */

                case 1:
                  if (!
#line 4281 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return -1;
                  return 3236; /* *avx_cmpv2di3_ltint_not */

                case 2:
                  if (!(
#line 4281 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return -1;
                  return 3237; /* *avx_cmpv8si3_ltint_not */

                case 3:
                  if (!(
#line 4281 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return -1;
                  return 3238; /* *avx_cmpv4di3_ltint_not */

                case 4:
                  if (!(
#line 18042 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 7835; /* *avx2_pcmpv32qi3_4 */

                case 5:
                  if (!
#line 18042 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))))
                    return -1;
                  return 7836; /* *avx2_pcmpv16qi3_4 */

                default:
                  return -1;
                }

            case 1:
              if (!(
#line 18074 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7837; /* *avx2_pcmpv32qi3_5 */

            case 2:
              if (!
#line 18074 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))))
                return -1;
              return 7838; /* *avx2_pcmpv16qi3_5 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1109 (x2, 
E_V2DFmode, 
E_V8DFmode) != 0
              || !(
#line 20025 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12379 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
            return -1;
          return 8316; /* *avx512dq_vinsertf64x2_1 */

        case E_V8DImode:
          if (pattern1109 (x2, 
E_V2DImode, 
E_V8DImode) != 0
              || !(
#line 20025 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
            return -1;
          return 8318; /* *avx512dq_vinserti64x2_1 */

        case E_V16SFmode:
          if (pattern1109 (x2, 
E_V4SFmode, 
E_V16SFmode) != 0
              || !(
#line 20025 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12381 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8320; /* *avx512f_vinsertf32x4_1 */

        case E_V16SImode:
          if (pattern1109 (x2, 
E_V4SImode, 
E_V16SImode) != 0
              || !(
#line 20025 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12381 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8322; /* *avx512f_vinserti32x4_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (pattern918 (x4) != 0)
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  switch (XWINT (x7, 0))
    {
    case 8L:
      x8 = XVECEXP (x4, 0, 1);
      if (XWINT (x8, 0) != 9L)
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (XWINT (x9, 0) != 10L)
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (XWINT (x10, 0) != 11L)
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (XWINT (x11, 0) != 12L)
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (XWINT (x12, 0) != 13L)
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (XWINT (x13, 0) != 14L)
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (XWINT (x14, 0) != 15L)
        return -1;
      switch (pattern1804 (x2))
        {
        case 0:
          if (!(
#line 12677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5256; /* vec_extract_hi_v16sf_mask */

        case 1:
          if (!(
#line 12677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5257; /* vec_extract_hi_v16si_mask */

        default:
          return -1;
        }

    case 0L:
      x8 = XVECEXP (x4, 0, 1);
      if (XWINT (x8, 0) != 1L
          || pattern1538 (x4) != 0)
        return -1;
      switch (pattern1804 (x2))
        {
        case 0:
          if (!(
#line 12781 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5260; /* vec_extract_lo_v16sf_mask */

        case 1:
          if (!(
#line 12781 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5261; /* vec_extract_lo_v16si_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) == CONST_INT)
    {
      res = recog_169 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x5;
  res = recog_171 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 0L
      || x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern1285 (x2, 
E_V8HImode) != 0
      || pattern1529 (x4) != 0)
    return -1;
  x9 = XEXP (x2, 1);
  operands[6] = x9;
  if (!nonimm_or_0_operand (operands[6], E_V8HImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[7] = x10;
  if (!register_operand (operands[7], E_QImode)
      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20991 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512BW && TARGET_AVX512VL)))
    return -1;
  return 8381; /* sse2_pshufhw_1_mask */
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != CONST_VECTOR
      || XVECLEN (x6, 0) != 32
      || GET_MODE (x6) != E_V32HImode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x11 = XVECEXP (x6, 0, 4);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x6, 0, 5);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x6, 0, 6);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x6, 0, 7);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x15 = XVECEXP (x6, 0, 8);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XVECEXP (x6, 0, 9);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XVECEXP (x6, 0, 10);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x18 = XVECEXP (x6, 0, 11);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x19 = XVECEXP (x6, 0, 12);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x20 = XVECEXP (x6, 0, 13);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x21 = XVECEXP (x6, 0, 14);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x22 = XVECEXP (x6, 0, 15);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x23 = XVECEXP (x6, 0, 16);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x24 = XVECEXP (x6, 0, 17);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x25 = XVECEXP (x6, 0, 18);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x26 = XVECEXP (x6, 0, 19);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x27 = XVECEXP (x6, 0, 20);
  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x28 = XVECEXP (x6, 0, 21);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x29 = XVECEXP (x6, 0, 22);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x30 = XVECEXP (x6, 0, 23);
  if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x31 = XVECEXP (x6, 0, 24);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x32 = XVECEXP (x6, 0, 25);
  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x33 = XVECEXP (x6, 0, 26);
  if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x34 = XVECEXP (x6, 0, 27);
  if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x35 = XVECEXP (x6, 0, 28);
  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x36 = XVECEXP (x6, 0, 29);
  if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x37 = XVECEXP (x6, 0, 30);
  if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x38 = XVECEXP (x6, 0, 31);
  if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V32HImode)
      || GET_MODE (x2) != E_V32HImode
      || GET_MODE (x3) != E_V32HImode
      || GET_MODE (x4) != E_V32SImode
      || GET_MODE (x5) != E_V32SImode)
    return -1;
  x39 = XEXP (x5, 0);
  if (GET_MODE (x39) != E_V32SImode)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != E_V32SImode)
    return -1;
  x41 = XEXP (x40, 0);
  if (GET_MODE (x41) != E_V32SImode)
    return -1;
  x42 = XEXP (x40, 1);
  if (GET_MODE (x42) != E_V32SImode)
    return -1;
  x43 = XEXP (x42, 0);
  operands[2] = x43;
  if (!nonimmediate_operand (operands[2], E_V32HImode))
    return -1;
  x44 = XEXP (x2, 1);
  operands[3] = x44;
  if (!nonimm_or_0_operand (operands[3], E_V32HImode))
    return -1;
  x45 = XEXP (x2, 2);
  operands[4] = x45;
  if (!register_operand (operands[4], E_SImode)
      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 22817 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
    return -1;
  return 8540; /* avx512bw_umulhrswv32hi3_mask */
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[4] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern487 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 2787; /* *mulv32hf3_mask */

            case E_V16HFmode:
              if (pattern487 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2791; /* *mulv16hf3_mask */

            case E_V8HFmode:
              if (pattern487 (x2, 
E_V8HFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2795; /* *mulv8hf3_mask */

            case E_V16SFmode:
              if (pattern487 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2799; /* *mulv16sf3_mask */

            case E_V8SFmode:
              if (pattern487 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 2803; /* *mulv8sf3_mask */

            case E_V4SFmode:
              if (pattern487 (x2, 
E_V4SFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1)))
                return -1;
              return 2807; /* *mulv4sf3_mask */

            case E_V8DFmode:
              if (pattern487 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2811; /* *mulv8df3_mask */

            case E_V4DFmode:
              if (pattern487 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 2815; /* *mulv4df3_mask */

            case E_V2DFmode:
              if (pattern487 (x2, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2819; /* *mulv2df3_mask */

            case E_V32HImode:
              if (pattern127 (x2, 
E_V32HImode, 
E_SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16371 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                return -1;
              return 7486; /* *mulv32hi3_mask */

            case E_V16HImode:
              if (pattern127 (x2, 
E_V16HImode, 
E_HImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16371 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
                return -1;
              return 7488; /* *mulv16hi3_mask */

            case E_V8HImode:
              if (pattern127 (x2, 
E_V8HImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16371 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
                return -1;
              return 7490; /* *mulv8hi3_mask */

            case E_V8DImode:
              if (pattern487 (x2, 
E_V8DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (64 == 64 || TARGET_AVX512VL)
  && ix86_binary_operator_ok (MULT, V8DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7524; /* *avx512dq_mulv8di3_mask */

            case E_V4DImode:
              if (pattern487 (x2, 
E_V4DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (32 == 64 || TARGET_AVX512VL)
  && ix86_binary_operator_ok (MULT, V4DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 7526; /* *avx512dq_mulv4di3_mask */

            case E_V2DImode:
              if (pattern487 (x2, 
E_V2DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (16 == 64 || TARGET_AVX512VL)
  && ix86_binary_operator_ok (MULT, V2DImode, operands)) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 7528; /* *avx512dq_mulv2di3_mask */

            case E_V16SImode:
              if (pattern487 (x2, 
E_V16SImode, 
E_HImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16884 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V16SImode, operands)
  && (64 == 64 || TARGET_AVX512VL)) && 
#line 671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 7530; /* *avx512f_mulv16si3_mask */

            case E_V8SImode:
              if (pattern487 (x2, 
E_V8SImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16884 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V8SImode, operands)
  && (32 == 64 || TARGET_AVX512VL)) && 
#line 671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
                return -1;
              return 7532; /* *avx2_mulv8si3_mask */

            case E_V4SImode:
              if (pattern487 (x2, 
E_V4SImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16884 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V4SImode, operands)
  && (16 == 64 || TARGET_AVX512VL))))
                return -1;
              return 7534; /* *sse4_1_mulv4si3_mask */

            case E_V32BFmode:
              if (pattern130 (x2, 
E_V32BFmode, 
E_SImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10535; /* avx10_2_mulbf16_v32bf_mask */

            case E_V16BFmode:
              if (pattern130 (x2, 
E_V16BFmode, 
E_HImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10543; /* avx10_2_mulbf16_v16bf_mask */

            case E_V8BFmode:
              if (pattern130 (x2, 
E_V8BFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10551; /* avx10_2_mulbf16_v8bf_mask */

            default:
              return -1;
            }

        case CONST_INT:
          switch (pattern132 (x2))
            {
            case 0:
              if (!(
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 2827; /* avx512fp16_vmmulv8hf3 */

            case 1:
              if (!
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 2835; /* sse_vmmulv4sf3 */

            case 2:
              if (!(
#line 2804 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2843; /* sse2_vmmulv2df3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern314 (x2, 
ZERO_EXTEND))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16454 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7504; /* *vec_widen_umult_even_v16si_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16490 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7506; /* *vec_widen_umult_even_v8si_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16522 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7508; /* *vec_widen_umult_even_v4si_mask */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern314 (x2, 
SIGN_EXTEND))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7510; /* *vec_widen_smult_even_v16si_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16606 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7512; /* *vec_widen_smult_even_v8si_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16638 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7514; /* *sse4_1_mulv2siv2di3_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 2);
  operands[4] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case NOT:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1003 (x2, 
E_V8SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3660; /* avx_andnotv8sf3_mask */

        case E_V4SFmode:
          if (pattern1003 (x2, 
E_V4SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16))))
            return -1;
          return 3662; /* sse_andnotv4sf3_mask */

        case E_V4DFmode:
          if (pattern1003 (x2, 
E_V4DFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3664; /* avx_andnotv4df3_mask */

        case E_V2DFmode:
          if (pattern1003 (x2, 
E_V2DFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3666; /* sse2_andnotv2df3_mask */

        case E_V16SFmode:
          if (pattern1004 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!true || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3670; /* avx512f_andnotv16sf3_mask */

        case E_V8DFmode:
          if (pattern1004 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!true || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3672; /* avx512f_andnotv8df3_mask */

        case E_V16SImode:
          if (pattern1004 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 18666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7925; /* *andnotv16si3_mask */

        case E_V8SImode:
          if (pattern1004 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7926; /* *andnotv8si3_mask */

        case E_V4SImode:
          if (pattern1004 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7927; /* *andnotv4si3_mask */

        case E_V8DImode:
          if (pattern1004 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7928; /* *andnotv8di3_mask */

        case E_V4DImode:
          if (pattern1004 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7929; /* *andnotv4di3_mask */

        case E_V2DImode:
          if (pattern1004 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7930; /* *andnotv2di3_mask */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern127 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3686; /* *andv8sf3_mask */

        case E_V4SFmode:
          if (pattern127 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 3692; /* *andv4sf3_mask */

        case E_V4DFmode:
          if (pattern127 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3698; /* *andv4df3_mask */

        case E_V2DFmode:
          if (pattern127 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3704; /* *andv2df3_mask */

        case E_V16SFmode:
          if (pattern128 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3716; /* *andv16sf3_mask */

        case E_V8DFmode:
          if (pattern128 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5436 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3722; /* *andv8df3_mask */

        case E_V16SImode:
          if (pattern487 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V16SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7932; /* *andv16si3_mask */

        case E_V8SImode:
          if (pattern487 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V8SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7938; /* *andv8si3_mask */

        case E_V4SImode:
          if (pattern487 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V4SImode, operands))))
            return -1;
          return 7944; /* *andv4si3_mask */

        case E_V8DImode:
          if (pattern487 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V8DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7950; /* *andv8di3_mask */

        case E_V4DImode:
          if (pattern487 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V4DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7956; /* *andv4di3_mask */

        case E_V2DImode:
          if (pattern487 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18717 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V2DImode, operands))))
            return -1;
          return 7962; /* *andv2di3_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern134 (x2))
    {
    case 0:
      switch (pattern885 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4410; /* avx512fp16_vcvtw2ph_v8hi_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4434; /* avx512fp16_vcvtdq2ph_v8si_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4450; /* avx512fp16_vcvtqq2ph_v8di_mask */

        default:
          return -1;
        }

    case 1:
      switch (pattern886 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4418; /* avx512fp16_vcvtw2ph_v16hi_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4442; /* avx512fp16_vcvtdq2ph_v16si_mask */

        default:
          return -1;
        }

    case 2:
      if (pattern135 (x2, 
E_V32HFmode, 
E_SImode, 
E_V32HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4426; /* avx512fp16_vcvtw2ph_v32hi_mask */

    case 3:
      if (pattern135 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16SImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8628 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 4746; /* floatv16siv16sf2_mask */

    case 4:
      if (pattern136 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!vector_operand (operands[1], E_V8SImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8628 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 4749; /* floatv8siv8sf2_mask */

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4902; /* floatv8div8sf2_mask */

        default:
          return -1;
        }

    case 5:
      if (pattern136 (x2, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!vector_operand (operands[1], E_V4SImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8628 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && 1)))
            return -1;
          return 4751; /* floatv4siv4sf2_mask */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4909; /* floatv4div4sf2_mask */

        default:
          return -1;
        }

    case 6:
      switch (pattern887 (x2, 
E_V8DFmode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL)) && 
#line 467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4873; /* floatv8siv8df2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4878; /* floatv8div8df2_mask */

        default:
          return -1;
        }

    case 7:
      switch (pattern888 (x2, 
E_V4DFmode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL))))
            return -1;
          return 4875; /* floatv4siv4df2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4886; /* floatv4div4df2_mask */

        default:
          return -1;
        }

    case 8:
      if (pattern149 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4894; /* floatv2div2df2_mask */

    case 9:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9377 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
        return -1;
      return 4927; /* sse2_cvtdq2pd_mask */

    default:
      return -1;
    }
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4498; /* unspec_avx512fp16_fixuns_truncv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4506; /* unspec_avx512fp16_fixuns_truncv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4514; /* unspec_avx512fp16_fixuns_truncv32hi2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x2) != E_V8SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4522; /* unspec_avx512fp16_fixuns_truncv8si2 */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !
#line 9547 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4953; /* unspec_fixuns_truncv8dfv8si2 */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 9890 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5058; /* *unspec_fixuns_truncv8sfv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern638 (x2, 
E_V16SImode))
        {
        case 0:
          if (!(
#line 7859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4530; /* unspec_avx512fp16_fixuns_truncv16si2 */

        case 1:
          if (!
#line 8754 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4804; /* unspec_fixuns_truncv16sfv16si2 */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern639 (x2))
        {
        case 0:
          if (!(
#line 7859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4538; /* unspec_avx512fp16_fixuns_truncv8di2 */

        case 1:
          if (!(
#line 9676 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4982; /* unspec_fixuns_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5030; /* unspec_fixuns_truncv8sfv8di2 */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !
#line 7897 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4592; /* unspec_avx512fp16_fixuns_truncv4si2 */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9656 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F))
            return -1;
          return 4974; /* unspec_fixuns_truncv4dfv4si2 */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 9890 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5060; /* *unspec_fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern640 (x2))
        {
        case 0:
          if (!
#line 7897 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4596; /* unspec_avx512fp16_fixuns_truncv4di2 */

        case 1:
          if (!(
#line 9676 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4988; /* unspec_fixuns_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5036; /* unspec_fixuns_truncv4sfv4di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern641 (x2))
        {
        case 0:
          if (!
#line 7947 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4616; /* unspec_avx512fp16_fixuns_truncv2di2 */

        case 1:
          if (!(
#line 9676 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4992; /* unspec_fixuns_truncv2dfv2di2 */

        case 2:
          if (!
#line 9740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 5052; /* unspec_avx512dq_fixuns_truncv2sfv2di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 1);
  if (!const_4_or_8_to_11_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_220 (x1, insn, pnum_clobbers);

    case NEG:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x9;
          x10 = XEXP (x3, 1);
          switch (GET_CODE (x10))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[4] = x10;
              x11 = XEXP (x3, 2);
              operands[5] = x11;
              operands[6] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1578 (x2, 
E_SImode, 
E_V32HFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 5931 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 3895; /* fma_fnmadd_v32hf_maskz_1_round */

                case E_V16SFmode:
                  if (pattern1578 (x2, 
E_HImode, 
E_V16SFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 5935 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3905; /* fma_fnmadd_v16sf_maskz_1_round */

                case E_V8DFmode:
                  if (pattern1578 (x2, 
E_QImode, 
E_V8DFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6155 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 5937 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3914; /* fma_fnmadd_v8df_maskz_1_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              x11 = XEXP (x3, 2);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  operands[4] = x11;
                  operands[5] = x6;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V32HFmode:
                      if (pattern1579 (x2, 
E_SImode, 
E_V32HFmode) != 0)
                        return -1;
                      if (nonimmediate_operand (operands[1], E_V32HFmode)
                          && register_operand (operands[3], E_V32HFmode)
                          && rtx_equal_p (x10, operands[1])
                          && (
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                        return 3920; /* avx512bw_fnmadd_v32hf_mask_round */
                      if (!register_operand (operands[1], E_V32HFmode)
                          || !nonimmediate_operand (operands[3], E_V32HFmode)
                          || !rtx_equal_p (x10, operands[3])
                          || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                        return -1;
                      return 3932; /* avx512bw_fnmadd_v32hf_mask3_round */

                    case E_V16SFmode:
                      if (pattern1579 (x2, 
E_HImode, 
E_V16SFmode) != 0)
                        return -1;
                      if (nonimmediate_operand (operands[1], E_V16SFmode)
                          && register_operand (operands[3], E_V16SFmode)
                          && rtx_equal_p (x10, operands[1])
                          && (
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 3924; /* avx512f_fnmadd_v16sf_mask_round */
                      if (!register_operand (operands[1], E_V16SFmode)
                          || !nonimmediate_operand (operands[3], E_V16SFmode)
                          || !rtx_equal_p (x10, operands[3])
                          || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3936; /* avx512f_fnmadd_v16sf_mask3_round */

                    case E_V8DFmode:
                      if (pattern1579 (x2, 
E_QImode, 
E_V8DFmode) != 0)
                        return -1;
                      if (nonimmediate_operand (operands[1], E_V8DFmode)
                          && register_operand (operands[3], E_V8DFmode)
                          && rtx_equal_p (x10, operands[1])
                          && (
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 3928; /* avx512f_fnmadd_v8df_mask_round */
                      if (!register_operand (operands[1], E_V8DFmode)
                          || !nonimmediate_operand (operands[3], E_V8DFmode)
                          || !rtx_equal_p (x10, operands[3])
                          || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6216 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3940; /* avx512f_fnmadd_v8df_mask3_round */

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x11, 0) != 1L)
                    return -1;
                  operands[4] = x6;
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HFmode:
                      if (pattern1633 (x2, 
E_V8HFmode) != 0
                          || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6636 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                        return -1;
                      return 4161; /* *fmai_fnmadd_v8hf_round */

                    case E_V4SFmode:
                      if (pattern1633 (x2, 
E_V4SFmode) != 0
                          || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6636 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F)))
                        return -1;
                      return 4163; /* *fmai_fnmadd_v4sf_round */

                    case E_V2DFmode:
                      if (pattern1633 (x2, 
E_V2DFmode) != 0
                          || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6636 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                        return -1;
                      return 4165; /* *fmai_fnmadd_v2df_round */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x12 = XEXP (x9, 0);
          operands[3] = x12;
          x10 = XEXP (x3, 1);
          switch (GET_CODE (x10))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[4] = x10;
              x11 = XEXP (x3, 2);
              operands[5] = x11;
              operands[6] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1580 (x2, 
E_V4SFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6230 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                    return -1;
                  return 3950; /* *fma_fnmsub_v4sf */

                case E_V2DFmode:
                  if (pattern1580 (x2, 
E_V2DFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6230 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                    return -1;
                  return 3954; /* *fma_fnmsub_v2df */

                case E_V8SFmode:
                  if (pattern1580 (x2, 
E_V8SFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6230 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                    return -1;
                  return 3958; /* *fma_fnmsub_v8sf */

                case E_V4DFmode:
                  if (pattern1580 (x2, 
E_V4DFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6230 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
                    return -1;
                  return 3962; /* *fma_fnmsub_v4df */

                case E_V32HFmode:
                  if (pattern1581 (x2, 
E_SImode, 
E_V32HFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6263 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 5931 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 3966; /* fma_fnmsub_v32hf_maskz_1_round */

                case E_V16SFmode:
                  if (pattern1581 (x2, 
E_HImode, 
E_V16SFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6263 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 5935 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3976; /* fma_fnmsub_v16sf_maskz_1_round */

                case E_V8DFmode:
                  if (pattern1581 (x2, 
E_QImode, 
E_V8DFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6263 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 5937 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3985; /* fma_fnmsub_v8df_maskz_1_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              switch (pattern1394 (x2))
                {
                case 0:
                  if (pattern1582 (x2, 
E_SImode, 
E_V32HFmode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V32HFmode)
                      && register_operand (operands[3], E_V32HFmode)
                      && rtx_equal_p (x10, operands[1])
                      && (
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return 3991; /* avx512bw_fnmsub_v32hf_mask_round */
                  if (!register_operand (operands[1], E_V32HFmode)
                      || !nonimmediate_operand (operands[3], E_V32HFmode)
                      || !rtx_equal_p (x10, operands[3])
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 4003; /* avx512bw_fnmsub_v32hf_mask3_round */

                case 1:
                  if (pattern1582 (x2, 
E_HImode, 
E_V16SFmode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V16SFmode)
                      && register_operand (operands[3], E_V16SFmode)
                      && rtx_equal_p (x10, operands[1])
                      && (
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return 3995; /* avx512f_fnmsub_v16sf_mask_round */
                  if (!register_operand (operands[1], E_V16SFmode)
                      || !nonimmediate_operand (operands[3], E_V16SFmode)
                      || !rtx_equal_p (x10, operands[3])
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 4009; /* avx512f_fnmsub_v16sf_mask3_round */

                case 2:
                  if (pattern1582 (x2, 
E_QImode, 
E_V8DFmode) != 0)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V8DFmode)
                      && register_operand (operands[3], E_V8DFmode)
                      && rtx_equal_p (x10, operands[1])
                      && (
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return 3999; /* avx512f_fnmsub_v8df_mask_round */
                  if (!register_operand (operands[1], E_V8DFmode)
                      || !nonimmediate_operand (operands[3], E_V8DFmode)
                      || !rtx_equal_p (x10, operands[3])
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 4015; /* avx512f_fnmsub_v8df_mask3_round */

                case 3:
                  if (pattern1583 (x2, 
E_V16HFmode, 
E_HImode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                    return -1;
                  return 4005; /* avx512vl_fnmsub_v16hf_mask3_round */

                case 4:
                  if (pattern1583 (x2, 
E_V8HFmode, 
E_QImode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                    return -1;
                  return 4007; /* avx512fp16_fnmsub_v8hf_mask3_round */

                case 5:
                  if (pattern1583 (x2, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 4011; /* avx512vl_fnmsub_v8sf_mask3_round */

                case 6:
                  if (pattern1583 (x2, 
E_V4SFmode, 
E_QImode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 4013; /* avx512vl_fnmsub_v4sf_mask3_round */

                case 7:
                  if (pattern1583 (x2, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 4017; /* avx512vl_fnmsub_v4df_mask3_round */

                case 8:
                  if (pattern1583 (x2, 
E_V2DFmode, 
E_QImode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 4019; /* avx512vl_fnmsub_v2df_mask3_round */

                case 9:
                  if (pattern1634 (x2, 
E_V8HFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6655 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 4167; /* *fmai_fnmsub_v8hf_round */

                case 10:
                  if (pattern1634 (x2, 
E_V4SFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6655 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F)))
                    return -1;
                  return 4169; /* *fmai_fnmsub_v4sf_round */

                case 11:
                  if (pattern1634 (x2, 
E_V2DFmode) != 0
                      || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6655 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 4171; /* *fmai_fnmsub_v2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      switch (pattern490 (x3))
        {
        case 0:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2684; /* *addv32hf3_round */

        case 1:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && 1 && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2692; /* *addv16hf3_round */

        case 2:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && 1 && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2700; /* *addv8hf3_round */

        case 3:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && 1 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2708; /* *addv16sf3_round */

        case 4:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && 1 && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2716; /* *addv8sf3_round */

        case 5:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && 1 && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode))))
            return -1;
          return 2724; /* *addv4sf3_round */

        case 6:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && 1 && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2732; /* *addv8df3_round */

        case 7:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && 1 && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2740; /* *addv4df3_round */

        case 8:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && 1 && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2748; /* *addv2df3_round */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_226 (x1, insn, pnum_clobbers);

    case MINUS:
      switch (pattern490 (x3))
        {
        case 0:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V32HFmode, operands)
   && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2688; /* *subv32hf3_round */

        case 1:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16HFmode, operands)
   && 1 && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2696; /* *subv16hf3_round */

        case 2:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8HFmode, operands)
   && 1 && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2704; /* *subv8hf3_round */

        case 3:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16SFmode, operands)
   && 1 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2712; /* *subv16sf3_round */

        case 4:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8SFmode, operands)
   && 1 && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2720; /* *subv8sf3_round */

        case 5:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4SFmode, operands)
   && 1 && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode))))
            return -1;
          return 2728; /* *subv4sf3_round */

        case 6:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8DFmode, operands)
   && 1 && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2736; /* *subv8df3_round */

        case 7:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4DFmode, operands)
   && 1 && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2744; /* *subv4df3_round */

        case 8:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V2DFmode, operands)
   && 1 && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2752; /* *subv2df3_round */

        default:
          return -1;
        }

    case MULT:
      switch (pattern490 (x3))
        {
        case 0:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2786; /* *mulv32hf3_round */

        case 1:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && 1 && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2790; /* *mulv16hf3_round */

        case 2:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && 1 && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2794; /* *mulv8hf3_round */

        case 3:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && 1 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2798; /* *mulv16sf3_round */

        case 4:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && 1 && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2802; /* *mulv8sf3_round */

        case 5:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && 1 && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode))))
            return -1;
          return 2806; /* *mulv4sf3_round */

        case 6:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && 1 && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2810; /* *mulv8df3_round */

        case 7:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && 1 && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2814; /* *mulv4df3_round */

        case 8:
          if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && 1 && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2818; /* *mulv2df3_round */

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[3] = x7;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern489 (x3, 
E_V32HFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2852; /* avx512fp16_divv32hf3_round */

        case E_V16SFmode:
          if (pattern489 (x3, 
E_V16SFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2860; /* avx512f_divv16sf3_round */

        case E_V8DFmode:
          if (pattern489 (x3, 
E_V8DFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2868; /* avx512f_divv8df3_round */

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1007 (x3, 
E_V32HFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2905; /* avx512fp16_sqrtv32hf2_round */

        case E_V16SFmode:
          if (pattern1007 (x3, 
E_V16SFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2913; /* avx512f_sqrtv16sf2_round */

        case E_V8DFmode:
          if (pattern1007 (x3, 
E_V8DFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2921; /* avx512f_sqrtv8df2_round */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern491 (x3))
        {
        case 0:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2983; /* *smaxv32hf3_round */

        case 1:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2999; /* *smaxv16sf3_round */

        case 2:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 3015; /* *smaxv8df3_round */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern491 (x3))
        {
        case 0:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2987; /* *sminv32hf3_round */

        case 1:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 3003; /* *sminv16sf3_round */

        case 2:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 3019; /* *sminv8df3_round */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_227 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_228 (x1, insn, pnum_clobbers);

    case FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern1015 (x3))
            {
            case 0:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4409; /* avx512fp16_vcvtw2ph_v8hi_round */

            case 1:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4433; /* avx512fp16_vcvtdq2ph_v8si_round */

            case 2:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4449; /* avx512fp16_vcvtqq2ph_v8di_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern1016 (x3))
            {
            case 0:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4417; /* avx512fp16_vcvtw2ph_v16hi_round */

            case 1:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4441; /* avx512fp16_vcvtdq2ph_v16si_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern492 (x3, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4425; /* avx512fp16_vcvtw2ph_v32hi_round */

        case E_V16SFmode:
          if (pattern492 (x3, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8628 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4745; /* floatv16siv16sf2_round */

        case E_V8DFmode:
          if (pattern1017 (x3, 
E_V8DImode, 
E_V8DFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4877; /* floatv8div8df2_round */

        case E_V4DFmode:
          if (pattern1017 (x3, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4885; /* floatv4div4df2_round */

        case E_V2DFmode:
          if (pattern1017 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4893; /* floatv2div2df2_round */

        case E_V8SFmode:
          if (pattern1017 (x3, 
E_V8DImode, 
E_V8SFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4901; /* floatv8div8sf2_round */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern1015 (x3))
            {
            case 0:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4413; /* avx512fp16_vcvtuw2ph_v8hi_round */

            case 1:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4437; /* avx512fp16_vcvtudq2ph_v8si_round */

            case 2:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4453; /* avx512fp16_vcvtuqq2ph_v8di_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern1016 (x3))
            {
            case 0:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4421; /* avx512fp16_vcvtuw2ph_v16hi_round */

            case 1:
              if (!(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4445; /* avx512fp16_vcvtudq2ph_v16si_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern492 (x3, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4429; /* avx512fp16_vcvtuw2ph_v32hi_round */

        case E_V16SFmode:
          if (pattern1017 (x3, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4753; /* *floatunsv16siv16sf2_round */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x4) != E_V8SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4757; /* *floatunsv8siv8sf2_round */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4905; /* floatunsv8div8sf2_round */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern1017 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4761; /* *floatunsv4siv4sf2_round */

        case E_V8DFmode:
          if (pattern1017 (x3, 
E_V8DImode, 
E_V8DFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4881; /* floatunsv8div8df2_round */

        case E_V4DFmode:
          if (pattern1017 (x3, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4889; /* floatunsv4div4df2_round */

        case E_V2DFmode:
          if (pattern1017 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4897; /* floatunsv2div2df2_round */

        default:
          return -1;
        }

    case FIX:
      switch (pattern493 (x3))
        {
        case 0:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4543; /* avx512fp16_fix_truncv8hi2_round */

        case 1:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4551; /* avx512fp16_fix_truncv16hi2_round */

        case 2:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4559; /* avx512fp16_fix_truncv32hi2_round */

        case 3:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4567; /* avx512fp16_fix_truncv8si2_round */

        case 4:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4958; /* fix_truncv8dfv8si2_round */

        case 5:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4575; /* avx512fp16_fix_truncv16si2_round */

        case 6:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8764 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4809; /* fix_truncv16sfv16si2_round */

        case 7:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4583; /* avx512fp16_fix_truncv8di2_round */

        case 8:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4995; /* fix_truncv8dfv8di2_round */

        case 9:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9729 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5039; /* fix_truncv8sfv8di2_round */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern493 (x3))
        {
        case 0:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4547; /* avx512fp16_fixuns_truncv8hi2_round */

        case 1:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4555; /* avx512fp16_fixuns_truncv16hi2_round */

        case 2:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4563; /* avx512fp16_fixuns_truncv32hi2_round */

        case 3:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4571; /* avx512fp16_fixuns_truncv8si2_round */

        case 4:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4962; /* fixuns_truncv8dfv8si2_round */

        case 5:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4579; /* avx512fp16_fixuns_truncv16si2_round */

        case 6:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8764 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4813; /* fixuns_truncv16sfv16si2_round */

        case 7:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4587; /* avx512fp16_fixuns_truncv8di2_round */

        case 8:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4999; /* fixuns_truncv8dfv8di2_round */

        case 9:
          if (!(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9729 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5043; /* fixuns_truncv8sfv8di2_round */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x3) != E_V8DFmode
              || GET_MODE (x4) != E_V8DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4647; /* avx512fp16_float_extend_phv8df2_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 10207 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1 && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 5092; /* avx512f_cvtps2pd512_round */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern492 (x3, 
E_V16HFmode, 
E_V16SFmode) != 0
              || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4651; /* avx512fp16_float_extend_phv16sf2_round */

        case E_V8SFmode:
          if (pattern492 (x3, 
E_V8HFmode, 
E_V8SFmode) != 0
              || !(
#line 263 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4655; /* avx512fp16_float_extend_phv8sf2_round */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || GET_MODE (x4) != E_V8HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4671; /* avx512fp16_vcvtpd2ph_v8df_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4679; /* avx512fp16_vcvtps2ph_v8sf_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (pattern492 (x3, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4675; /* avx512fp16_vcvtps2ph_v16sf_round */

        case E_V8SFmode:
          if (pattern492 (x3, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10073 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5082; /* *avx512f_cvtpd2ps512_round */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V32HFmode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != FLOAT_TRUNCATE
          || GET_MODE (x5) != E_V16HFmode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != FLOAT_TRUNCATE
          || GET_MODE (x6) != E_V16HFmode
          || !register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V16SFmode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      operands[3] = x7;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode)
          || !(
#line 221 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31714 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10364; /* avx10_2_cvt2ps2phx_v32hf_round */

    default:
      return -1;
    }
}

 int
recog_271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  switch (XWINT (x6, 0))
    {
    case 6L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 7L
          || XWINT (x4, 0) != 2L
          || XWINT (x5, 0) != 3L
          || pattern1539 (x2) != 0
          || !
#line 11046 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 5145; /* sse_movhlps */

    case 0L:
      x7 = XVECEXP (x3, 0, 1);
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x4, 0) != 4L
              || XWINT (x5, 0) != 5L
              || pattern1539 (x2) != 0
              || !
#line 11091 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (UNKNOWN, V4SFmode, operands)))
            return -1;
          return 5146; /* sse_movlhps */

        case 4L:
          switch (XWINT (x4, 0))
            {
            case 1L:
              if (XWINT (x5, 0) != 5L
                  || pattern1302 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                  || !
#line 11308 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 5161; /* vec_interleave_lowv4sf */

            case 2L:
              if (XWINT (x5, 0) != 6L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4DFmode:
                  if (!register_operand (operands[0], E_V4DFmode)
                      || GET_MODE (x2) != E_V4DFmode)
                    return -1;
                  x8 = XEXP (x2, 0);
                  if (GET_MODE (x8) != E_V8DFmode)
                    return -1;
                  if (nonimmediate_operand (operands[1], E_V4DFmode))
                    {
                      x9 = XEXP (x8, 1);
                      if (rtx_equal_p (x9, operands[1])
                          && 
#line 13455 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                        return 5314; /* avx_movddup256 */
                    }
                  if (!register_operand (operands[1], E_V4DFmode))
                    return -1;
                  x9 = XEXP (x8, 1);
                  operands[2] = x9;
                  if (!nonimmediate_operand (operands[2], E_V4DFmode)
                      || !
#line 13469 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                    return -1;
                  return 5316; /* avx_unpcklpd256 */

                case E_V4DImode:
                  if (pattern1601 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                      || !
#line 14501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
                    return -1;
                  return 7129; /* avx2_interleave_lowv4di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          if (XWINT (x4, 0) != 6L
              || XWINT (x5, 0) != 6L
              || pattern1540 (x2) != 0
              || !
#line 11398 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && 1))
            return -1;
          return 5170; /* sse3_movsldup */

        default:
          return -1;
        }

    case 2L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 6L
          || XWINT (x4, 0) != 3L
          || XWINT (x5, 0) != 7L
          || pattern1302 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 11203 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1))
        return -1;
      return 5154; /* vec_interleave_highv4sf */

    case 1L:
      if (XWINT (x5, 0) != 7L)
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x4, 0) != 7L
              || pattern1540 (x2) != 0
              || !
#line 11345 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && 1))
            return -1;
          return 5164; /* sse3_movshdup */

        case 5L:
          if (XWINT (x4, 0) != 3L)
            return -1;
          x8 = XEXP (x2, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DFmode:
              if (pattern1400 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
                  || !
#line 13325 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                return -1;
              return 5306; /* avx_unpckhpd256 */

            case E_V4DImode:
              if (pattern1400 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                  || !
#line 14451 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
                return -1;
              return 7123; /* avx2_interleave_highv4di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern920 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 2L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 18L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 3L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 19L
          || pattern1812 (x3) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 8);
      if (XWINT (x8, 0) != 10L)
        return -1;
      x9 = XVECEXP (x3, 0, 9);
      if (XWINT (x9, 0) != 26L)
        return -1;
      x10 = XVECEXP (x3, 0, 10);
      if (XWINT (x10, 0) != 11L)
        return -1;
      x11 = XVECEXP (x3, 0, 11);
      if (XWINT (x11, 0) != 27L
          || pattern1847 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1400 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !
#line 11138 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 5150; /* *avx512f_unpckhps512 */

        case E_V16SImode:
          if (pattern1400 (x2, 
E_V16SImode, 
E_V32SImode) != 0
              || !
#line 19730 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 8296; /* *avx512f_interleave_highv16si */

        default:
          return -1;
        }

    case 0L:
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 16L:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 1L)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 17L)
            return -1;
          x12 = XEXP (x2, 0);
          x13 = XEXP (x12, 1);
          operands[2] = x13;
          x14 = XVECEXP (x3, 0, 4);
          switch (XWINT (x14, 0))
            {
            case 4L:
              x15 = XVECEXP (x3, 0, 5);
              if (XWINT (x15, 0) != 20L)
                return -1;
              x16 = XVECEXP (x3, 0, 6);
              if (XWINT (x16, 0) != 5L)
                return -1;
              x17 = XVECEXP (x3, 0, 7);
              if (XWINT (x17, 0) != 21L)
                return -1;
              x8 = XVECEXP (x3, 0, 8);
              if (XWINT (x8, 0) != 8L)
                return -1;
              x9 = XVECEXP (x3, 0, 9);
              if (XWINT (x9, 0) != 24L)
                return -1;
              x10 = XVECEXP (x3, 0, 10);
              if (XWINT (x10, 0) != 9L)
                return -1;
              x11 = XVECEXP (x3, 0, 11);
              if (XWINT (x11, 0) != 25L)
                return -1;
              x18 = XVECEXP (x3, 0, 12);
              if (XWINT (x18, 0) != 12L)
                return -1;
              x19 = XVECEXP (x3, 0, 13);
              if (XWINT (x19, 0) != 28L)
                return -1;
              x20 = XVECEXP (x3, 0, 14);
              if (XWINT (x20, 0) != 13L)
                return -1;
              x21 = XVECEXP (x3, 0, 15);
              if (XWINT (x21, 0) != 29L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1400 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
                      || !
#line 11226 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                    return -1;
                  return 5156; /* *avx512f_unpcklps512 */

                case E_V16SImode:
                  if (pattern1400 (x2, 
E_V16SImode, 
E_V32SImode) != 0
                      || !
#line 19785 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                    return -1;
                  return 8302; /* *avx512f_interleave_lowv16si */

                default:
                  return -1;
                }

            case 2L:
              x15 = XVECEXP (x3, 0, 5);
              if (XWINT (x15, 0) != 18L)
                return -1;
              x16 = XVECEXP (x3, 0, 6);
              if (XWINT (x16, 0) != 3L)
                return -1;
              x17 = XVECEXP (x3, 0, 7);
              if (XWINT (x17, 0) != 19L)
                return -1;
              x8 = XVECEXP (x3, 0, 8);
              switch (XWINT (x8, 0))
                {
                case 4L:
                  x9 = XVECEXP (x3, 0, 9);
                  if (XWINT (x9, 0) != 20L)
                    return -1;
                  x10 = XVECEXP (x3, 0, 10);
                  if (XWINT (x10, 0) != 5L)
                    return -1;
                  x11 = XVECEXP (x3, 0, 11);
                  if (XWINT (x11, 0) != 21L)
                    return -1;
                  x18 = XVECEXP (x3, 0, 12);
                  if (XWINT (x18, 0) != 6L)
                    return -1;
                  x19 = XVECEXP (x3, 0, 13);
                  if (XWINT (x19, 0) != 22L)
                    return -1;
                  x20 = XVECEXP (x3, 0, 14);
                  if (XWINT (x20, 0) != 7L)
                    return -1;
                  x21 = XVECEXP (x3, 0, 15);
                  if (XWINT (x21, 0) != 23L
                      || pattern1468 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 19554 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                    return -1;
                  return 8256; /* vec_interleave_lowv16qi */

                case 8L:
                  x9 = XVECEXP (x3, 0, 9);
                  if (XWINT (x9, 0) != 24L)
                    return -1;
                  x10 = XVECEXP (x3, 0, 10);
                  if (XWINT (x10, 0) != 9L)
                    return -1;
                  x11 = XVECEXP (x3, 0, 11);
                  if (XWINT (x11, 0) != 25L)
                    return -1;
                  x18 = XVECEXP (x3, 0, 12);
                  if (XWINT (x18, 0) != 10L)
                    return -1;
                  x19 = XVECEXP (x3, 0, 13);
                  if (XWINT (x19, 0) != 26L)
                    return -1;
                  x20 = XVECEXP (x3, 0, 14);
                  if (XWINT (x20, 0) != 11L)
                    return -1;
                  x21 = XVECEXP (x3, 0, 15);
                  if (XWINT (x21, 0) != 27L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16HImode:
                      if (pattern1400 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                          || !
#line 19674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
                        return -1;
                      return 8282; /* avx2_interleave_lowv16hi */

                    case E_V16HFmode:
                      if (pattern1400 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
                          || !
#line 19674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
                        return -1;
                      return 8284; /* avx2_interleave_lowv16hf */

                    case E_V16BFmode:
                      if (pattern1400 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
                          || !
#line 19674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
                        return -1;
                      return 8286; /* avx2_interleave_lowv16bf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          if (pattern1642 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 8);
          if (XWINT (x8, 0) != 8L)
            return -1;
          x9 = XVECEXP (x3, 0, 9);
          if (XWINT (x9, 0) != 8L)
            return -1;
          x10 = XVECEXP (x3, 0, 10);
          if (XWINT (x10, 0) != 10L)
            return -1;
          x11 = XVECEXP (x3, 0, 11);
          if (XWINT (x11, 0) != 10L)
            return -1;
          x18 = XVECEXP (x3, 0, 12);
          if (XWINT (x18, 0) != 12L)
            return -1;
          x19 = XVECEXP (x3, 0, 13);
          if (XWINT (x19, 0) != 12L)
            return -1;
          x20 = XVECEXP (x3, 0, 14);
          if (XWINT (x20, 0) != 14L)
            return -1;
          x21 = XVECEXP (x3, 0, 15);
          if (XWINT (x21, 0) != 14L
              || pattern1771 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !
#line 11419 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 5172; /* *avx512f_movsldup512 */

        default:
          return -1;
        }

    case 1L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 1L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 3L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 3L)
        return -1;
      x14 = XVECEXP (x3, 0, 4);
      if (XWINT (x14, 0) != 5L)
        return -1;
      x15 = XVECEXP (x3, 0, 5);
      if (XWINT (x15, 0) != 5L)
        return -1;
      x16 = XVECEXP (x3, 0, 6);
      if (XWINT (x16, 0) != 7L)
        return -1;
      x17 = XVECEXP (x3, 0, 7);
      if (XWINT (x17, 0) != 7L)
        return -1;
      x8 = XVECEXP (x3, 0, 8);
      if (XWINT (x8, 0) != 9L)
        return -1;
      x9 = XVECEXP (x3, 0, 9);
      if (XWINT (x9, 0) != 9L)
        return -1;
      x10 = XVECEXP (x3, 0, 10);
      if (XWINT (x10, 0) != 11L)
        return -1;
      x11 = XVECEXP (x3, 0, 11);
      if (XWINT (x11, 0) != 11L)
        return -1;
      x18 = XVECEXP (x3, 0, 12);
      if (XWINT (x18, 0) != 13L)
        return -1;
      x19 = XVECEXP (x3, 0, 13);
      if (XWINT (x19, 0) != 13L)
        return -1;
      x20 = XVECEXP (x3, 0, 14);
      if (XWINT (x20, 0) != 15L)
        return -1;
      x21 = XVECEXP (x3, 0, 15);
      if (XWINT (x21, 0) != 15L
          || pattern1771 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
          || !
#line 11366 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 5166; /* *avx512f_movshdup512 */

    case 8L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 24L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 9L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 25L)
        return -1;
      x14 = XVECEXP (x3, 0, 4);
      if (XWINT (x14, 0) != 10L)
        return -1;
      x15 = XVECEXP (x3, 0, 5);
      if (XWINT (x15, 0) != 26L)
        return -1;
      x16 = XVECEXP (x3, 0, 6);
      if (XWINT (x16, 0) != 11L)
        return -1;
      x17 = XVECEXP (x3, 0, 7);
      if (XWINT (x17, 0) != 27L
          || pattern1832 (x3) != 0)
        return -1;
      x18 = XVECEXP (x3, 0, 12);
      if (XWINT (x18, 0) != 14L)
        return -1;
      x19 = XVECEXP (x3, 0, 13);
      if (XWINT (x19, 0) != 30L)
        return -1;
      x20 = XVECEXP (x3, 0, 14);
      if (XWINT (x20, 0) != 15L)
        return -1;
      x21 = XVECEXP (x3, 0, 15);
      if (XWINT (x21, 0) != 31L
          || pattern1302 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 19458 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
        return -1;
      return 8250; /* vec_interleave_highv16qi */

    case 4L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 20L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 5L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 21L
          || pattern1812 (x3) != 0
          || pattern1832 (x3) != 0
          || pattern1847 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern1400 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !
#line 19606 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
            return -1;
          return 8264; /* avx2_interleave_highv16hi */

        case E_V16HFmode:
          if (pattern1400 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
              || !
#line 19606 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
            return -1;
          return 8266; /* avx2_interleave_highv16hf */

        case E_V16BFmode:
          if (pattern1400 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
              || !
#line 19606 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
            return -1;
          return 8268; /* avx2_interleave_highv16bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[2] = x4;
  res = recog_283 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      if (XWINT (x5, 0) != 1L
          || XWINT (x6, 0) != 2L
          || XWINT (x7, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !nonimmediate_operand (operands[1], E_V8DFmode)
              || !(
#line 12623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5250; /* vec_extract_lo_v8df */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !nonimmediate_operand (operands[1], E_V8DImode)
              || !(
#line 12623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5251; /* vec_extract_lo_v8di */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V8SImode)
              || !
#line 12956 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 5274; /* vec_extract_lo_v8si */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 12956 "../../../gcc/config/i386/sse.md"
(TARGET_AVX
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 5275; /* vec_extract_lo_v8sf */

        default:
          return -1;
        }

    case 4L:
      if (XWINT (x5, 0) != 5L
          || XWINT (x6, 0) != 6L
          || XWINT (x7, 0) != 7L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !register_operand (operands[1], E_V8DFmode)
              || !(
#line 12659 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5254; /* vec_extract_hi_v8df */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !register_operand (operands[1], E_V8DImode)
              || !(
#line 12659 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5255; /* vec_extract_hi_v8di */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V8SImode)
              || !
#line 12988 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5278; /* vec_extract_hi_v8si */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 12988 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5279; /* vec_extract_hi_v8sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      res = recog_282 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 4:
      res = recog_284 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 8:
      res = recog_288 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 16:
      res = recog_292 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 32:
      res = recog_293 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (XVECLEN (x3, 0) >= 1)
    {
      operands[2] = x3;
      res = recog_294 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (XVECLEN (x3, 0))
    {
    case 4:
      if (pattern670 (x2, 
E_V4DFmode) != 0
          || !
#line 27542 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9098; /* avx2_permv4df_1 */

    case 8:
      if (pattern670 (x2, 
E_V8DFmode) != 0)
        return -1;
      x4 = XVECEXP (x3, 0, 4);
      operands[6] = x4;
      if (!const_4_to_7_operand (operands[6], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x3, 0, 5);
      operands[7] = x5;
      if (!const_4_to_7_operand (operands[7], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x3, 0, 6);
      operands[8] = x6;
      if (!const_4_to_7_operand (operands[8], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x3, 0, 7);
      operands[9] = x7;
      if (!const_4_to_7_operand (operands[9], E_VOIDmode)
          || !(
#line 27613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1
   && (INTVAL (operands[2]) == (INTVAL (operands[6]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4))) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9100; /* avx512f_permv8df_1 */

    default:
      return -1;
    }
}

 int
recog_300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      switch (pattern337 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_V16BFmode:
              if (pattern609 (x2, 
E_V16BFmode) != 0
                  || !(
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 426 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3655; /* avx512bf16_andnotv16bf3 */

            case E_V8BFmode:
              if (pattern609 (x2, 
E_V8BFmode) != 0
                  || !(
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 426 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3656; /* avx512bf16_andnotv8bf3 */

            case E_V16HFmode:
              if (pattern609 (x2, 
E_V16HFmode) != 0
                  || !(
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3657; /* avx512fp16_andnotv16hf3 */

            case E_V8HFmode:
              if (pattern609 (x2, 
E_V8HFmode) != 0
                  || !(
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 427 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3658; /* avx512fp16_andnotv8hf3 */

            case E_V8SFmode:
              if (pattern609 (x2, 
E_V8SFmode) != 0
                  || !(
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3659; /* avx_andnotv8sf3 */

            case E_V4SFmode:
              if (pattern609 (x2, 
E_V4SFmode) != 0
                  || !
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)))
                return -1;
              return 3661; /* sse_andnotv4sf3 */

            case E_V4DFmode:
              if (pattern609 (x2, 
E_V4DFmode) != 0
                  || !(
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3663; /* avx_andnotv4df3 */

            case E_V2DFmode:
              if (pattern609 (x2, 
E_V2DFmode) != 0
                  || !(
#line 5239 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3665; /* sse2_andnotv2df3 */

            case E_V32BFmode:
              if (pattern735 (x2, 
E_V32BFmode) != 0
                  || !(
#line 5314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 16 != 16)) && 
#line 491 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3667; /* avx512bf16_andnotv32bf3 */

            case E_V32HFmode:
              if (pattern735 (x2, 
E_V32HFmode) != 0
                  || !(
#line 5314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 16 != 16)) && 
#line 492 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3668; /* avx512fp16_andnotv32hf3 */

            case E_V16SFmode:
              if (pattern735 (x2, 
E_V16SFmode) != 0
                  || !(
#line 5314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3669; /* avx512f_andnotv16sf3 */

            case E_V8DFmode:
              if (pattern735 (x2, 
E_V8DFmode) != 0
                  || !(
#line 5314 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3671; /* avx512f_andnotv8df3 */

            case E_V1TImode:
              if (pattern609 (x2, 
E_V1TImode) != 0
                  || !
#line 5605 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 3744; /* *andnotv1ti3 */

            case E_V16SImode:
              if (pattern922 (x2, 
E_V16SImode) != 0
                  || !(
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7913; /* *andnotv16si3 */

            case E_V8DImode:
              if (pattern922 (x2, 
E_V8DImode) != 0
                  || !(
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7914; /* *andnotv8di3 */

            case E_V64QImode:
              if (pattern922 (x2, 
E_V64QImode) != 0
                  || !(
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7915; /* *andnotv64qi3 */

            case E_V32QImode:
              if (pattern922 (x2, 
E_V32QImode) != 0
                  || !(
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7916; /* *andnotv32qi3 */

            case E_V16QImode:
              if (pattern922 (x2, 
E_V16QImode) != 0
                  || !
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
                return -1;
              return 7917; /* *andnotv16qi3 */

            case E_V32HImode:
              if (pattern922 (x2, 
E_V32HImode) != 0
                  || !(
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7918; /* *andnotv32hi3 */

            case E_V16HImode:
              if (pattern922 (x2, 
E_V16HImode) != 0
                  || !(
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7919; /* *andnotv16hi3 */

            case E_V8HImode:
              if (pattern922 (x2, 
E_V8HImode) != 0
                  || !
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
                return -1;
              return 7920; /* *andnotv8hi3 */

            case E_V8SImode:
              if (pattern922 (x2, 
E_V8SImode) != 0
                  || !(
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7921; /* *andnotv8si3 */

            case E_V4SImode:
              if (pattern922 (x2, 
E_V4SImode) != 0
                  || !
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
                return -1;
              return 7922; /* *andnotv4si3 */

            case E_V4DImode:
              if (pattern922 (x2, 
E_V4DImode) != 0
                  || !(
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7923; /* *andnotv4di3 */

            case E_V2DImode:
              if (pattern922 (x2, 
E_V2DImode) != 0
                  || !
#line 18473 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
                return -1;
              return 7924; /* *andnotv2di3 */

            default:
              return -1;
            }

        case 1:
          if (!(
#line 19007 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8012; /* *norv16si3 */

        case 2:
          if (!(
#line 19007 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8014; /* *norv8di3 */

        case 3:
          if (!(
#line 19007 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8016; /* *norv64qi3 */

        case 4:
          if (!(
#line 19007 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8018; /* *norv32qi3 */

        case 5:
          if (!
#line 19007 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
            return -1;
          return 8020; /* *norv16qi3 */

        case 6:
          if (!(
#line 19007 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8022; /* *norv32hi3 */

        case 7:
          if (!(
#line 19007 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8024; /* *norv16hi3 */

        case 8:
          if (!
#line 19007 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
            return -1;
          return 8026; /* *norv8hi3 */

        case 9:
          if (!(
#line 19007 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8028; /* *norv8si3 */

        case 10:
          if (!
#line 19007 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
            return -1;
          return 8030; /* *norv4si3 */

        case 11:
          if (!(
#line 19007 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8032; /* *norv4di3 */

        case 12:
          if (!
#line 19007 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
            return -1;
          return 8034; /* *norv2di3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      return recog_297 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern529 (x2))
            {
            case 0:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5428; /* *avx512bw_vpternlogv64qi_1 */

            case 1:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5455; /* *avx512vl_vpternlogv32qi_1 */

            case 2:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5482; /* *avx512vl_vpternlogv16qi_1 */

            case 3:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5509; /* *avx512bw_vpternlogv32hi_1 */

            case 4:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5536; /* *avx512vl_vpternlogv16hi_1 */

            case 5:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5563; /* *avx512vl_vpternlogv8hi_1 */

            case 6:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5590; /* *avx512f_vpternlogv16si_1 */

            case 7:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5617; /* *avx512vl_vpternlogv8si_1 */

            case 8:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5644; /* *avx512vl_vpternlogv4si_1 */

            case 9:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5671; /* *avx512f_vpternlogv8di_1 */

            case 10:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5698; /* *avx512vl_vpternlogv4di_1 */

            case 11:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5725; /* *avx512vl_vpternlogv2di_1 */

            case 12:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5431; /* *avx512bw_vpternlogv64qi_1 */

            case 13:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5458; /* *avx512vl_vpternlogv32qi_1 */

            case 14:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5485; /* *avx512vl_vpternlogv16qi_1 */

            case 15:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5512; /* *avx512bw_vpternlogv32hi_1 */

            case 16:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5539; /* *avx512vl_vpternlogv16hi_1 */

            case 17:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5566; /* *avx512vl_vpternlogv8hi_1 */

            case 18:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5593; /* *avx512f_vpternlogv16si_1 */

            case 19:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5620; /* *avx512vl_vpternlogv8si_1 */

            case 20:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5647; /* *avx512vl_vpternlogv4si_1 */

            case 21:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5674; /* *avx512f_vpternlogv8di_1 */

            case 22:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5701; /* *avx512vl_vpternlogv4di_1 */

            case 23:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5728; /* *avx512vl_vpternlogv2di_1 */

            case 24:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5434; /* *avx512bw_vpternlogv64qi_1 */

            case 25:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5461; /* *avx512vl_vpternlogv32qi_1 */

            case 26:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5488; /* *avx512vl_vpternlogv16qi_1 */

            case 27:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5515; /* *avx512bw_vpternlogv32hi_1 */

            case 28:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5542; /* *avx512vl_vpternlogv16hi_1 */

            case 29:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5569; /* *avx512vl_vpternlogv8hi_1 */

            case 30:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5596; /* *avx512f_vpternlogv16si_1 */

            case 31:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5623; /* *avx512vl_vpternlogv8si_1 */

            case 32:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5650; /* *avx512vl_vpternlogv4si_1 */

            case 33:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5677; /* *avx512f_vpternlogv8di_1 */

            case 34:
              if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5704; /* *avx512vl_vpternlogv4di_1 */

            case 35:
              if (!
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5731; /* *avx512vl_vpternlogv2di_1 */

            case 36:
              if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6724; /* *avx512bw_vpternlogv64qi_3 */

            case 37:
              if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6733; /* *avx512vl_vpternlogv32qi_3 */

            case 38:
              if (!
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6742; /* *avx512vl_vpternlogv16qi_3 */

            case 39:
              if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6751; /* *avx512bw_vpternlogv32hi_3 */

            case 40:
              if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6760; /* *avx512vl_vpternlogv16hi_3 */

            case 41:
              if (!
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6769; /* *avx512vl_vpternlogv8hi_3 */

            case 42:
              if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6778; /* *avx512f_vpternlogv16si_3 */

            case 43:
              if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6787; /* *avx512vl_vpternlogv8si_3 */

            case 44:
              if (!
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6796; /* *avx512vl_vpternlogv4si_3 */

            case 45:
              if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6805; /* *avx512f_vpternlogv8di_3 */

            case 46:
              if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6814; /* *avx512vl_vpternlogv4di_3 */

            case 47:
              if (!
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6823; /* *avx512vl_vpternlogv2di_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern531 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6076; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6103; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6130; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6157; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6184; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6211; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6238; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6265; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6292; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6319; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6346; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6373; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern531 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6079; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6106; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6133; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6160; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6187; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6214; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6241; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6268; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6295; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6322; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6349; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6376; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern531 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6082; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6109; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6136; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6163; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6190; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6217; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6244; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6271; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6298; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6325; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6352; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6379; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      return recog_299 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_298 (x1, insn, pnum_clobbers);

    case GT:
      switch (pattern339 (x2))
        {
        case 0:
          if (!(
#line 17311 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()) && 
#line 704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7606; /* *avx2_lshrv4di3_1 */

        case 1:
          if (!
#line 17311 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()))
            return -1;
          return 7607; /* *avx2_lshrv2di3_1 */

        default:
          return -1;
        }

    case LT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DImode:
          if (pattern923 (x2, 
E_V4DImode) != 0
              || !(
#line 17328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 704 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7608; /* *avx2_lshrv4di3_2 */

        case E_V2DImode:
          if (pattern923 (x2, 
E_V2DImode) != 0
              || !
#line 17328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 7609; /* *avx2_lshrv2di3_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_316 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      switch (pattern183 (x3))
        {
        case 0:
          if (!(
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && 1 && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2683; /* *addv32hf3 */

        case 1:
          if (!(
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && 1 && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2691; /* *addv16hf3 */

        case 2:
          if (!(
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && 1 && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2699; /* *addv8hf3 */

        case 3:
          if (!(
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2707; /* *addv16sf3 */

        case 4:
          if (!(
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2715; /* *addv8sf3 */

        case 5:
          if (!
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2723; /* *addv4sf3 */

        case 6:
          if (!(
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2731; /* *addv8df3 */

        case 7:
          if (!(
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2739; /* *addv4df3 */

        case 8:
          if (!(
#line 2664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2747; /* *addv2df3 */

        case 9:
          if (!(
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V64QImode, operands)) && 
#line 587 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7389; /* *addv64qi3 */

        case 10:
          if (!(
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V32QImode, operands)) && 
#line 587 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7391; /* *addv32qi3 */

        case 11:
          if (!
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16QImode, operands)))
            return -1;
          return 7393; /* *addv16qi3 */

        case 12:
          if (!(
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V32HImode, operands)) && 
#line 588 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7395; /* *addv32hi3 */

        case 13:
          if (!(
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16HImode, operands)) && 
#line 588 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7397; /* *addv16hi3 */

        case 14:
          if (!
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8HImode, operands)))
            return -1;
          return 7399; /* *addv8hi3 */

        case 15:
          if (!(
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16SImode, operands)) && 
#line 589 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7401; /* *addv16si3 */

        case 16:
          if (!(
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8SImode, operands)) && 
#line 589 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7403; /* *addv8si3 */

        case 17:
          if (!
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V4SImode, operands)))
            return -1;
          return 7405; /* *addv4si3 */

        case 18:
          if (!(
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8DImode, operands)) && 
#line 590 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7407; /* *addv8di3 */

        case 19:
          if (!(
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V4DImode, operands)) && 
#line 590 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7409; /* *addv4di3 */

        case 20:
          if (!
#line 16253 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V2DImode, operands)))
            return -1;
          return 7411; /* *addv2di3 */

        case 21:
          if (!
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10530; /* avx10_2_addbf16_v32bf */

        case 22:
          if (!
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10538; /* avx10_2_addbf16_v16bf */

        case 23:
          if (!
#line 32118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10546; /* avx10_2_addbf16_v8bf */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern186 (x3))
        {
        case 0:
          if (!(
#line 7178 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4268; /* fma_v32hf_fadd_fmul */

        case 1:
          if (!(
#line 7178 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4269; /* fma_v16hf_fadd_fmul */

        case 2:
          if (!(
#line 7178 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4270; /* fma_v8hf_fadd_fmul */

        case 3:
          if (!(
#line 7195 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4271; /* fma_v32hf_fadd_fcmul */

        case 4:
          if (!(
#line 7195 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4272; /* fma_v16hf_fadd_fcmul */

        case 5:
          if (!(
#line 7195 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4273; /* fma_v8hf_fadd_fcmul */

        case 6:
          if (!(
#line 7213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4274; /* fma_fmaddc_v32hf_fma_zero */

        case 7:
          if (!(
#line 7213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4276; /* fma_fmaddc_v16hf_fma_zero */

        case 8:
          if (!(
#line 7213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4278; /* fma_fmaddc_v8hf_fma_zero */

        case 9:
          if (!(
#line 7213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4275; /* fma_fcmaddc_v32hf_fma_zero */

        case 10:
          if (!(
#line 7213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4277; /* fma_fcmaddc_v16hf_fma_zero */

        case 11:
          if (!(
#line 7213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4279; /* fma_fcmaddc_v8hf_fma_zero */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern329 (x4) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 1);
          switch (XVECLEN (x7, 0))
            {
            case 8:
              if (pattern1300 (x4) != 0)
                return -1;
              x8 = XEXP (x3, 1);
              if (GET_CODE (x8) != MULT
                  || GET_MODE (x8) != E_V8SImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_V8SImode)
                return -1;
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != VEC_SELECT
                  || GET_MODE (x10) != E_V8HImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != PARALLEL
                  || pattern1846 (x11, 
8) != 0)
                return -1;
              x12 = XEXP (x8, 1);
              if (pattern1826 (x12, 
E_V8HImode, 
E_V8SImode) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              x14 = XEXP (x13, 1);
              if (pattern1863 (x14, 
8) != 0
                  || !register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x3) != E_V8SImode
                  || GET_MODE (x4) != E_V8SImode
                  || GET_MODE (x5) != E_V8SImode
                  || GET_MODE (x6) != E_V8HImode
                  || !nonimmediate_operand (operands[1], E_V16HImode))
                return -1;
              x15 = XEXP (x4, 1);
              if (GET_MODE (x15) != E_V8SImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_MODE (x16) != E_V8HImode
                  || !nonimmediate_operand (operands[2], E_V16HImode))
                return -1;
              x17 = XEXP (x10, 0);
              if (!rtx_equal_p (x17, operands[1]))
                return -1;
              x18 = XEXP (x13, 0);
              if (!rtx_equal_p (x18, operands[2])
                  || !
#line 16728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 7521; /* *avx2_pmaddwd */

            case 4:
              x19 = XVECEXP (x7, 0, 0);
              if (GET_CODE (x19) != CONST_INT)
                return -1;
              x20 = XVECEXP (x7, 0, 1);
              if (GET_CODE (x20) != CONST_INT)
                return -1;
              x21 = XVECEXP (x7, 0, 2);
              if (GET_CODE (x21) != CONST_INT)
                return -1;
              x22 = XVECEXP (x7, 0, 3);
              if (GET_CODE (x22) != CONST_INT)
                return -1;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x23 = XEXP (x16, 1);
              if (XVECLEN (x23, 0) != 4)
                return -1;
              x24 = XVECEXP (x23, 0, 0);
              if (GET_CODE (x24) != CONST_INT)
                return -1;
              x25 = XVECEXP (x23, 0, 1);
              if (GET_CODE (x25) != CONST_INT)
                return -1;
              x26 = XVECEXP (x23, 0, 2);
              if (GET_CODE (x26) != CONST_INT)
                return -1;
              x27 = XVECEXP (x23, 0, 3);
              if (GET_CODE (x27) != CONST_INT
                  || pattern877 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                  || GET_MODE (x15) != E_V4SImode
                  || GET_MODE (x16) != E_V4HImode)
                return -1;
              switch (XWINT (x19, 0))
                {
                case 0L:
                  if (XWINT (x20, 0) != 2L
                      || XWINT (x21, 0) != 4L
                      || XWINT (x22, 0) != 6L
                      || XWINT (x24, 0) != 0L
                      || XWINT (x25, 0) != 2L
                      || XWINT (x26, 0) != 4L
                      || XWINT (x27, 0) != 6L)
                    return -1;
                  x8 = XEXP (x3, 1);
                  if (pattern1766 (x8, 
E_V4HImode, 
E_V4SImode, 
SIGN_EXTEND) != 0
                      || !vector_operand (operands[1], E_V8HImode)
                      || !vector_operand (operands[2], E_V8HImode))
                    return -1;
                  x9 = XEXP (x8, 0);
                  x10 = XEXP (x9, 0);
                  x17 = XEXP (x10, 0);
                  if (!rtx_equal_p (x17, operands[1]))
                    return -1;
                  x12 = XEXP (x8, 1);
                  x13 = XEXP (x12, 0);
                  x18 = XEXP (x13, 0);
                  if (!rtx_equal_p (x18, operands[2])
                      || !
#line 16783 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 7522; /* *sse2_pmaddwd */

                case 1L:
                  if (XWINT (x20, 0) != 3L
                      || XWINT (x21, 0) != 5L
                      || XWINT (x22, 0) != 7L
                      || XWINT (x24, 0) != 1L
                      || XWINT (x25, 0) != 3L
                      || XWINT (x26, 0) != 5L
                      || XWINT (x27, 0) != 7L
                      || !nonimmediate_operand (operands[1], E_V8HImode)
                      || !nonimmediate_operand (operands[2], E_V8HImode))
                    return -1;
                  x8 = XEXP (x3, 1);
                  operands[3] = x8;
                  if (!register_operand (operands[3], E_V4SImode)
                      || !
#line 26156 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8920; /* xop_pmacswd */

                default:
                  return -1;
                }

            case 2:
              if (pattern1301 (x3) != 0)
                return -1;
              x15 = XEXP (x4, 1);
              if (GET_MODE (x15) != E_V2DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_MODE (x16) != E_V2SImode
                  || !nonimmediate_operand (operands[2], E_V4SImode))
                return -1;
              x8 = XEXP (x3, 1);
              operands[3] = x8;
              switch (pattern1810 (x4))
                {
                case 0:
                  if (!
#line 26115 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8916; /* xop_pmacsdql */

                case 1:
                  if (!
#line 26134 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8918; /* xop_pmacsdqh */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern331 (x3))
            {
            case 0:
              if (!
#line 26096 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8912; /* xop_pmacsww */

            case 1:
              if (!
#line 26096 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8914; /* xop_pmacsdd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern190 (x3))
        {
        case 0:
          if (!
#line 22557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8514; /* avx2_phaddwv16hi3 */

        case 1:
          if (!
#line 22580 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8518; /* ssse3_phaddwv8hi3 */

        case 2:
          if (!
#line 22647 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8526; /* avx2_phadddv8si3 */

        case 3:
          if (!
#line 22668 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8528; /* ssse3_phadddv4si3 */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case MULT:
          if (pattern332 (x5) != 0)
            return -1;
          x28 = XEXP (x5, 1);
          if (GET_MODE (x28) != E_V4SImode)
            return -1;
          x29 = XEXP (x28, 0);
          if (GET_CODE (x29) != VEC_SELECT
              || GET_MODE (x29) != E_V4HImode)
            return -1;
          x30 = XEXP (x29, 1);
          if (GET_CODE (x30) != PARALLEL
              || XVECLEN (x30, 0) != 4)
            return -1;
          x31 = XVECEXP (x30, 0, 0);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x32 = XVECEXP (x30, 0, 1);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x33 = XVECEXP (x30, 0, 2);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x34 = XVECEXP (x30, 0, 3);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_CODE (x15) != MULT
              || GET_MODE (x15) != E_V4SImode)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != SIGN_EXTEND
              || GET_MODE (x16) != E_V4SImode)
            return -1;
          x35 = XEXP (x16, 0);
          if (GET_CODE (x35) != VEC_SELECT
              || GET_MODE (x35) != E_V4HImode)
            return -1;
          x36 = XEXP (x35, 1);
          if (GET_CODE (x36) != PARALLEL
              || XVECLEN (x36, 0) != 4)
            return -1;
          x37 = XVECEXP (x36, 0, 0);
          if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x38 = XVECEXP (x36, 0, 1);
          if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x39 = XVECEXP (x36, 0, 2);
          if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x40 = XVECEXP (x36, 0, 3);
          if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
            return -1;
          x41 = XEXP (x15, 1);
          if (GET_CODE (x41) != SIGN_EXTEND
              || GET_MODE (x41) != E_V4SImode)
            return -1;
          x42 = XEXP (x41, 0);
          if (GET_CODE (x42) != VEC_SELECT
              || GET_MODE (x42) != E_V4HImode)
            return -1;
          x43 = XEXP (x42, 1);
          if (GET_CODE (x43) != PARALLEL
              || XVECLEN (x43, 0) != 4)
            return -1;
          x44 = XVECEXP (x43, 0, 0);
          if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x45 = XVECEXP (x43, 0, 1);
          if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x46 = XVECEXP (x43, 0, 2);
          if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x47 = XVECEXP (x43, 0, 3);
          if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode
              || pattern1866 (x3) != 0
              || !
#line 26189 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8922; /* xop_pmadcswd */

        case SIGN_EXTEND:
          switch (pattern335 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 26283 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8942; /* xop_phaddbd */

            case 1:
              if (!
#line 26379 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8948; /* xop_phaddwq */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern335 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 26283 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8943; /* xop_phaddubd */

            case 1:
              if (!
#line 26379 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8949; /* xop_phadduwq */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x5) != E_V2DImode)
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_CODE (x15) != PLUS
              || GET_MODE (x15) != E_V2DImode)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_V2DImode
              || pattern1023 (x8, 
E_V2DImode, 
PLUS) != 0
              || !register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || pattern1535 (x3, 
E_V2DImode) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              if (pattern1799 (x3, 
SIGN_EXTEND) != 0
                  || !
#line 26331 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8944; /* xop_phaddbq */

            case ZERO_EXTEND:
              if (pattern1799 (x3, 
ZERO_EXTEND) != 0
                  || !
#line 26331 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8945; /* xop_phaddubq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern192 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 26251 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8940; /* xop_phaddbw */

        case 1:
          if (!
#line 26351 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8946; /* xop_phaddwd */

        case 2:
          if (!
#line 26397 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8950; /* xop_phadddq */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern192 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 26251 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8941; /* xop_phaddubw */

        case 1:
          if (!
#line 26351 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8947; /* xop_phadduwd */

        case 2:
          if (!
#line 26397 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8951; /* xop_phaddudq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (nonimmediate_operand (operands[0], E_V64QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V64QImode)
          && (
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2395; /* movv64qi_internal */
      if (!register_operand (operands[0], E_V64QImode)
          || !ternlog_operand (operands[1], E_V64QImode)
          || !(
#line 13733 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5404; /* *avx512bw_vpternlogv64qi_0 */

    case E_V32QImode:
      if (nonimmediate_operand (operands[0], E_V32QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V32QImode)
          && (
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2396; /* movv32qi_internal */
      if (!register_operand (operands[0], E_V32QImode)
          || !ternlog_operand (operands[1], E_V32QImode)
          || !(
#line 13733 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 5405; /* *avx512vl_vpternlogv32qi_0 */

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16QImode)
          && 
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 2397; /* movv16qi_internal */
      if (!register_operand (operands[0], E_V16QImode)
          || !ternlog_operand (operands[1], E_V16QImode)
          || !
#line 13733 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 5406; /* *avx512vl_vpternlogv16qi_0 */

    case E_V32HImode:
      if (nonimmediate_operand (operands[0], E_V32HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V32HImode)
          && (
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2398; /* movv32hi_internal */
      if (!register_operand (operands[0], E_V32HImode)
          || !ternlog_operand (operands[1], E_V32HImode)
          || !(
#line 13733 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5407; /* *avx512bw_vpternlogv32hi_0 */

    case E_V16HImode:
      if (nonimmediate_operand (operands[0], E_V16HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16HImode)
          && (
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16HImode)
       || register_operand (operands[1], V16HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2399; /* movv16hi_internal */
      if (!register_operand (operands[0], E_V16HImode)
          || !ternlog_operand (operands[1], E_V16HImode)
          || !(
#line 13733 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 5408; /* *avx512vl_vpternlogv16hi_0 */

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8HImode)
          && 
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 2400; /* movv8hi_internal */
      if (!register_operand (operands[0], E_V8HImode)
          || !ternlog_operand (operands[1], E_V8HImode)
          || !
#line 13733 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 5409; /* *avx512vl_vpternlogv8hi_0 */

    case E_V16SImode:
      if (nonimmediate_operand (operands[0], E_V16SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16SImode)
          && (
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 284 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2401; /* movv16si_internal */
      if (!register_operand (operands[0], E_V16SImode)
          || !ternlog_operand (operands[1], E_V16SImode)
          || !(
#line 13733 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5410; /* *avx512f_vpternlogv16si_0 */

    case E_V8SImode:
      if (nonimmediate_operand (operands[0], E_V8SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8SImode)
          && (
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8SImode)
       || register_operand (operands[1], V8SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 284 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2402; /* movv8si_internal */
      if (!register_operand (operands[0], E_V8SImode)
          || !ternlog_operand (operands[1], E_V8SImode)
          || !(
#line 13733 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 5411; /* *avx512vl_vpternlogv8si_0 */

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V4SImode)
          && 
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 2403; /* movv4si_internal */
      if (!register_operand (operands[0], E_V4SImode)
          || !ternlog_operand (operands[1], E_V4SImode)
          || !
#line 13733 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 5412; /* *avx512vl_vpternlogv4si_0 */

    case E_V8DImode:
      if (nonimmediate_operand (operands[0], E_V8DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8DImode)
          && (
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8DImode)
       || register_operand (operands[1], V8DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 2404; /* movv8di_internal */
      if (!register_operand (operands[0], E_V8DImode)
          || !ternlog_operand (operands[1], E_V8DImode)
          || !(
#line 13733 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 5413; /* *avx512f_vpternlogv8di_0 */

    case E_V4DImode:
      if (nonimmediate_operand (operands[0], E_V4DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V4DImode)
          && (
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 285 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 2405; /* movv4di_internal */
      if (!register_operand (operands[0], E_V4DImode)
          || !ternlog_operand (operands[1], E_V4DImode)
          || !(
#line 13733 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 5414; /* *avx512vl_vpternlogv4di_0 */

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V2DImode)
          && 
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 2406; /* movv2di_internal */
      if (!register_operand (operands[0], E_V2DImode)
          || !ternlog_operand (operands[1], E_V2DImode)
          || !
#line 13733 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 5415; /* *avx512vl_vpternlogv2di_0 */

    case E_V4TImode:
      if (!nonimmediate_operand (operands[0], E_V4TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4TImode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4TImode)
       || register_operand (operands[1], V4TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 286 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2407; /* movv4ti_internal */

    case E_V2TImode:
      if (!nonimmediate_operand (operands[0], E_V2TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V2TImode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2TImode)
       || register_operand (operands[1], V2TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 286 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2408; /* movv2ti_internal */

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V1TImode)
          || !
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V1TImode)
       || register_operand (operands[1], V1TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2409; /* movv1ti_internal */

    case E_V32HFmode:
      if (!nonimmediate_operand (operands[0], E_V32HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V32HFmode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 287 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2410; /* movv32hf_internal */

    case E_V16HFmode:
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16HFmode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 287 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2411; /* movv16hf_internal */

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8HFmode)
          || !
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[1], V8HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2412; /* movv8hf_internal */

    case E_V32BFmode:
      if (!nonimmediate_operand (operands[0], E_V32BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V32BFmode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32BFmode)
       || register_operand (operands[1], V32BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 288 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2413; /* movv32bf_internal */

    case E_V16BFmode:
      if (!nonimmediate_operand (operands[0], E_V16BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16BFmode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16BFmode)
       || register_operand (operands[1], V16BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 288 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2414; /* movv16bf_internal */

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8BFmode)
          || !
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[1], V8BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2415; /* movv8bf_internal */

    case E_V16SFmode:
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16SFmode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16SFmode)
       || register_operand (operands[1], V16SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 289 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2416; /* movv16sf_internal */

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8SFmode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 289 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2417; /* movv8sf_internal */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4SFmode)
          || !
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2418; /* movv4sf_internal */

    case E_V8DFmode:
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8DFmode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8DFmode)
       || register_operand (operands[1], V8DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 290 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2419; /* movv8df_internal */

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4DFmode)
          || !(
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 290 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2420; /* movv4df_internal */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V2DFmode)
          || !
#line 1507 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[1], V2DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 2421; /* movv2df_internal */

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern29 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7570; /* *ashlv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 774 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7594; /* ashlv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9525; /* avx512vl_ashlvv16hi */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7574; /* *ashlv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7596; /* ashlv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9521; /* avx512vl_ashlvv8hi */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7578; /* *ashlv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 775 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7598; /* ashlv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9501; /* avx2_ashlvv8si */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7582; /* *ashlv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7600; /* ashlv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9505; /* avx2_ashlvv4si */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7586; /* *ashlv4di3 */
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7602; /* ashlv4di3 */
      if (!nonimmediate_operand (operands[2], E_V4DImode)
          || !
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9513; /* avx2_ashlvv4di */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7590; /* *ashlv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7604; /* ashlv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9517; /* avx2_ashlvv2di */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7610; /* ashlv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28925 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9529; /* avx512bw_ashlvv32hi */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7614; /* ashlv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 803 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9497; /* avx512f_ashlvv16si */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7618; /* ashlv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28914 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 804 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9509; /* avx512f_ashlvv8di */

    case 9:
      if (register_operand (operands[1], E_V1TImode)
          && const_0_to_255_not_mul_8_operand (operands[2], E_SImode)
          && 
#line 17439 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return 7622; /* *ashlv1ti3_internal */
      if (!const_0_to_255_mul_8_operand (operands[2], E_SImode))
        return -1;
      if (nonimmediate_operand (operands[1], E_V1TImode)
          && (
#line 17583 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7631; /* avx512bw_ashlv1ti3 */
      if (!register_operand (operands[1], E_V1TImode)
          || !
#line 17598 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7635; /* sse2_ashlv1ti3 */

    case 10:
      if (!(
#line 17583 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7627; /* avx512bw_ashlv4ti3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V2TImode)
          && (
#line 17583 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7629; /* avx512bw_ashlv2ti3 */
      if (!register_operand (operands[1], E_V2TImode)
          || !(
#line 17598 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 7633; /* avx2_ashlv2ti3 */

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !nonimmediate_operand (operands[1], E_V16SImode)
          || !(
#line 30276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10059; /* vpopcountv16si */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V8SImode)
          || !(
#line 30276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10061; /* vpopcountv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode)
          || !(
#line 30276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10063; /* vpopcountv4si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !nonimmediate_operand (operands[1], E_V8DImode)
          || !(
#line 30276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10065; /* vpopcountv8di */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V4DImode)
          || !(
#line 30276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10067; /* vpopcountv4di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode)
          || !(
#line 30276 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10069; /* vpopcountv2di */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x3) != E_V64QImode
          || !nonimmediate_operand (operands[1], E_V64QImode)
          || !(
#line 30326 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10079; /* vpopcountv64qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16QImode)
          || !(
#line 30326 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10081; /* vpopcountv16qi */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !nonimmediate_operand (operands[1], E_V32QImode)
          || !(
#line 30326 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10083; /* vpopcountv32qi */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode
          || !nonimmediate_operand (operands[1], E_V32HImode)
          || !(
#line 30326 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10085; /* vpopcountv32hi */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !nonimmediate_operand (operands[1], E_V16HImode)
          || !(
#line 30326 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10087; /* vpopcountv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V8HImode)
          || !(
#line 30326 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10089; /* vpopcountv8hi */

    default:
      return -1;
    }
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern50 (x3))
        {
        case 0:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7151; /* *avx512f_truncatev16siv16qi2 */

        case 1:
          if (!(
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15210 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7193; /* *avx512vl_truncatev16hiv16qi2 */

        case 2:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7154; /* *avx512f_truncatev16siv16hi2 */

        case 3:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7157; /* *avx512f_truncatev8div8si2 */

        case 4:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7160; /* *avx512f_truncatev8div8hi2 */

        case 5:
          if (!
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7190; /* *avx512vl_truncatev8siv8hi2 */

        case 6:
          if (!
#line 15147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7180; /* avx512bw_truncatev32hiv32qi2 */

        case 7:
          if (!
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7187; /* *avx512vl_truncatev4div4si2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          if (XWINT (x5, 0) != 16L)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern805 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!(
#line 16406 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7491; /* *smulv32hi3_highpart */

                case 1:
                  if (!(
#line 16406 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 7495; /* *smulv16hi3_highpart */

                case 2:
                  if (!
#line 16406 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
                    return -1;
                  return 7499; /* *smulv8hi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern805 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!(
#line 16406 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7493; /* *umulv32hi3_highpart */

                case 1:
                  if (!(
#line 16406 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 7497; /* *umulv16hi3_highpart */

                case 2:
                  if (!
#line 16406 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
                    return -1;
                  return 7501; /* *umulv8hi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (XWINT (x5, 0) != 1L)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case PLUS:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              x12 = XEXP (x6, 1);
              operands[3] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_V64QImode:
                  if (pattern1402 (x3, 
E_V64HImode, 
E_V64QImode) != 0
                      || !(
#line 21876 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8420; /* *avx512bw_uavgv64qi3 */

                case E_V32QImode:
                  if (pattern1402 (x3, 
E_V32HImode, 
E_V32QImode) != 0
                      || !(
#line 21876 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 8422; /* *avx2_uavgv32qi3 */

                case E_V16QImode:
                  if (pattern1402 (x3, 
E_V16HImode, 
E_V16QImode) != 0
                      || !
#line 21876 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8424; /* *sse2_uavgv16qi3 */

                case E_V32HImode:
                  if (pattern1402 (x3, 
E_V32SImode, 
E_V32HImode) != 0
                      || !(
#line 21876 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8426; /* *avx512bw_uavgv32hi3 */

                case E_V16HImode:
                  if (pattern1402 (x3, 
E_V16SImode, 
E_V16HImode) != 0
                      || !(
#line 21876 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 8428; /* *avx2_uavgv16hi3 */

                case E_V8HImode:
                  if (pattern1402 (x3, 
E_V8SImode, 
E_V8HImode) != 0
                      || !
#line 21876 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8430; /* *sse2_uavgv8hi3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (pattern613 (x7) != 0)
                return -1;
              x8 = XEXP (x7, 0);
              x10 = XEXP (x8, 0);
              x13 = XEXP (x10, 0);
              operands[1] = x13;
              if (nonimmediate_operand (operands[1], E_V32HImode))
                {
                  res = recog_313 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              x14 = XEXP (x8, 1);
              x15 = XEXP (x14, 0);
              operands[2] = x15;
              x12 = XEXP (x6, 1);
              operands[3] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HImode:
                  if (pattern1505 (x3, 
E_V32HImode, 
E_V32SImode) != 0
                      || !(
#line 22982 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8543; /* *avx512bw_pmulhrswv32hi3 */

                case E_V16HImode:
                  if (pattern1505 (x3, 
E_V16HImode, 
E_V16SImode) != 0
                      || !(
#line 22982 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 8545; /* *avx2_pmulhrswv16hi3 */

                case E_V8HImode:
                  if (pattern1505 (x3, 
E_V8HImode, 
E_V8SImode) != 0
                      || !
#line 22982 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8547; /* *ssse3_pmulhrswv8hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 8116 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4670; /* avx512fp16_vcvtpd2ph_v8df */

        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode)
              || !(
#line 8116 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4678; /* avx512fp16_vcvtps2ph_v8sf */

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 8116 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4674; /* avx512fp16_vcvtps2ph_v16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !
#line 10073 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 5081; /* *avx512f_cvtpd2ps512 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !
#line 10083 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
        return -1;
      return 5085; /* avx_cvtpd2ps256 */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      if (
#line 31135 "../../../gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT || (TARGET_AVX512BF16 && TARGET_AVX512VL)))
        return 10272; /* vcvtneps2bf16_v8sf */
      if (!(
#line 31173 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31101 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10275; /* avx512f_cvtneps2bf16_v8sf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x3) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode)
          || !(
#line 31173 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31101 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10273; /* avx512f_cvtneps2bf16_v16sf */

    default:
      return -1;
    }
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern32 (x1))
    {
    case 0:
      if (!
#line 17539 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return -1;
      return 7625; /* *rotlv1ti3_internal */

    case 1:
      if (!(
#line 17635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7661; /* avx512f_rolv16si */

    case 2:
      if (!(
#line 17635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7665; /* avx512vl_rolv8si */

    case 3:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7669; /* avx512vl_rolv4si */
      if (!const_0_to_31_operand (operands[2], E_SImode)
          || !
#line 26589 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8961; /* xop_rotlv4si3 */

    case 4:
      if (!(
#line 17635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7673; /* avx512f_rolv8di */

    case 5:
      if (!(
#line 17635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7677; /* avx512vl_rolv4di */

    case 6:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7681; /* avx512vl_rolv2di */
      if (!const_0_to_63_operand (operands[2], E_SImode)
          || !
#line 26589 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8962; /* xop_rotlv2di3 */

    case 7:
      if (!
#line 26589 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8959; /* xop_rotlv16qi3 */

    case 8:
      if (!
#line 26589 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8960; /* xop_rotlv8hi3 */

    case 9:
      if (!(
#line 17625 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7637; /* avx512f_rolvv16si */

    case 10:
      if (!(
#line 17625 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7641; /* avx512vl_rolvv8si */

    case 11:
      if (!(
#line 17625 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7645; /* avx512vl_rolvv4si */

    case 12:
      if (!(
#line 17625 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7649; /* avx512f_rolvv8di */

    case 13:
      if (!(
#line 17625 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7653; /* avx512vl_rolvv4di */

    case 14:
      if (!(
#line 17625 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7657; /* avx512vl_rolvv2di */

    default:
      return -1;
    }
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 39:
      if (GET_MODE (x3) != E_CCGZmode)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != LTU)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCGZmode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern1657 (x4, 
E_SImode) != 0
              || !
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 521; /* subsi3_carry_ccgz */

        case E_DImode:
          if (pattern1657 (x4, 
E_DImode) != 0
              || !
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 522; /* subdi3_carry_ccgz */

        default:
          return -1;
        }

    case 22:
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 7
          || pattern546 (x1) != 0)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[1] = x9;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1541 (x3, 
E_SImode) != 0
              || !(
#line 23368 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode)))
            return -1;
          return 1669; /* *tls_dynamic_gnu2_call_64_si */

        case E_DImode:
          if (pattern1541 (x3, 
E_DImode) != 0
              || !(
#line 23368 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode)))
            return -1;
          return 1670; /* *tls_dynamic_gnu2_call_64_di */

        default:
          return -1;
        }

    case 52:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (pattern925 (x1) != 0
          || !
#line 23140 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 8557; /* *ssse3_pshufbv8qi3 */

    case 132:
      if (pattern549 (x1, 
132, 
3) != 0)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      if (!nonimmediate_operand (operands[2], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      operands[3] = x4;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x8, 1);
      x13 = XVECEXP (x12, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x12, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XVECEXP (x12, 0, 2);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      switch (pattern1754 (x3))
        {
        case 0:
          if (!
#line 26017 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8909; /* sse4_2_pcmpistri */

        case 1:
          if (!
#line 26041 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8910; /* sse4_2_pcmpistrm */

        default:
          return -1;
        }

    case 153:
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 154)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x16 = XVECEXP (x5, 0, 2);
      if (!const1248_operand (x16, E_SImode))
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[1] = x9;
          x10 = XVECEXP (x3, 0, 1);
          operands[7] = x10;
          operands[6] = x4;
          x17 = XVECEXP (x5, 0, 0);
          operands[4] = x17;
          x18 = XVECEXP (x5, 0, 1);
          operands[3] = x18;
          operands[5] = x16;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (!register_operand (operands[0], E_V16SImode)
                  || GET_MODE (x3) != E_V16SImode
                  || !vsib_mem_operator (operands[6], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SImode:
                  if (!register_operand (operands[1], E_V16SImode))
                    return -1;
                  switch (pattern1806 (x5, 
E_HImode, 
E_V16SImode))
                    {
                    case 0:
                      if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9668; /* *avx512f_gathersiv16si */

                    case 1:
                      if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9680; /* *avx512f_gathersiv16si */

                    default:
                      return -1;
                    }

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  switch (pattern1806 (x5, 
E_QImode, 
E_V8DImode))
                    {
                    case 0:
                      if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9716; /* *avx512f_gatherdiv16si */

                    case 1:
                      if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9728; /* *avx512f_gatherdiv16si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V16SFmode:
              if (!register_operand (operands[0], E_V16SFmode)
                  || GET_MODE (x3) != E_V16SFmode
                  || !vsib_mem_operator (operands[6], E_SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SFmode:
                  if (!register_operand (operands[1], E_V16SFmode))
                    return -1;
                  switch (pattern1806 (x5, 
E_HImode, 
E_V16SImode))
                    {
                    case 0:
                      if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9669; /* *avx512f_gathersiv16sf */

                    case 1:
                      if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9681; /* *avx512f_gathersiv16sf */

                    default:
                      return -1;
                    }

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode))
                    return -1;
                  switch (pattern1806 (x5, 
E_QImode, 
E_V8DImode))
                    {
                    case 0:
                      if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9717; /* *avx512f_gatherdiv16sf */

                    case 1:
                      if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9729; /* *avx512f_gatherdiv16sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8DImode:
              switch (pattern1727 (x3, 
E_DImode, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9670; /* *avx512f_gathersiv8di */

                case 1:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9718; /* *avx512f_gatherdiv8di */

                case 2:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9682; /* *avx512f_gathersiv8di */

                case 3:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9730; /* *avx512f_gatherdiv8di */

                default:
                  return -1;
                }

            case E_V8DFmode:
              switch (pattern1727 (x3, 
E_DFmode, 
E_V8DFmode))
                {
                case 0:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9671; /* *avx512f_gathersiv8df */

                case 1:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9719; /* *avx512f_gatherdiv8df */

                case 2:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9683; /* *avx512f_gathersiv8df */

                case 3:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9731; /* *avx512f_gatherdiv8df */

                default:
                  return -1;
                }

            case E_V8SImode:
              if (pattern1728 (x3, 
E_SImode, 
E_V8SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  switch (pattern1815 (x5, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9672; /* *avx512f_gathersiv8si */

                    case 1:
                      if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9684; /* *avx512f_gathersiv8si */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode))
                    return -1;
                  switch (pattern1815 (x5, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9720; /* *avx512f_gatherdiv8si */

                    case 1:
                      if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9732; /* *avx512f_gatherdiv8si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8SFmode:
              if (pattern1728 (x3, 
E_SFmode, 
E_V8SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode))
                    return -1;
                  switch (pattern1815 (x5, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9673; /* *avx512f_gathersiv8sf */

                    case 1:
                      if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9685; /* *avx512f_gathersiv8sf */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode))
                    return -1;
                  switch (pattern1815 (x5, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9721; /* *avx512f_gatherdiv8sf */

                    case 1:
                      if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9733; /* *avx512f_gatherdiv8sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1730 (x3, 
E_DImode, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9674; /* *avx512f_gathersiv4di */

                case 1:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9722; /* *avx512f_gatherdiv4di */

                case 2:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9686; /* *avx512f_gathersiv4di */

                case 3:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9734; /* *avx512f_gatherdiv4di */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1730 (x3, 
E_DFmode, 
E_V4DFmode))
                {
                case 0:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9675; /* *avx512f_gathersiv4df */

                case 1:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9723; /* *avx512f_gatherdiv4df */

                case 2:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9687; /* *avx512f_gathersiv4df */

                case 3:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9735; /* *avx512f_gatherdiv4df */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1732 (x3, 
E_SImode, 
E_V4SImode))
                {
                case 0:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9676; /* *avx512f_gathersiv4si */

                case 1:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9724; /* *avx512f_gatherdiv4si */

                case 2:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9688; /* *avx512f_gathersiv4si */

                case 3:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9736; /* *avx512f_gatherdiv4si */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1732 (x3, 
E_SFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9677; /* *avx512f_gathersiv4sf */

                case 1:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9725; /* *avx512f_gatherdiv4sf */

                case 2:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9689; /* *avx512f_gathersiv4sf */

                case 3:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9737; /* *avx512f_gatherdiv4sf */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern1732 (x3, 
E_DImode, 
E_V2DImode))
                {
                case 0:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9678; /* *avx512f_gathersiv2di */

                case 1:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9726; /* *avx512f_gatherdiv2di */

                case 2:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9690; /* *avx512f_gathersiv2di */

                case 3:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9738; /* *avx512f_gatherdiv2di */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1732 (x3, 
E_DFmode, 
E_V2DFmode))
                {
                case 0:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9679; /* *avx512f_gathersiv2df */

                case 1:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9727; /* *avx512f_gatherdiv2df */

                case 2:
                  if (!(
#line 29457 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9691; /* *avx512f_gathersiv2df */

                case 3:
                  if (!(
#line 29519 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9739; /* *avx512f_gatherdiv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PC:
          x10 = XVECEXP (x3, 0, 1);
          operands[6] = x10;
          operands[5] = x4;
          x17 = XVECEXP (x5, 0, 0);
          operands[3] = x17;
          x18 = XVECEXP (x5, 0, 1);
          operands[2] = x18;
          operands[4] = x16;
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              switch (pattern1701 (x3, 
E_SImode, 
E_V16SImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9692; /* *avx512f_gathersiv16si_2 */

                case 1:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9704; /* *avx512f_gathersiv16si_2 */

                case 2:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9740; /* *avx512f_gatherdiv16si_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9752; /* *avx512f_gatherdiv16si_2 */

                default:
                  return -1;
                }

            case E_V16SFmode:
              switch (pattern1701 (x3, 
E_SFmode, 
E_V16SFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9693; /* *avx512f_gathersiv16sf_2 */

                case 1:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9705; /* *avx512f_gathersiv16sf_2 */

                case 2:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9741; /* *avx512f_gatherdiv16sf_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9753; /* *avx512f_gatherdiv16sf_2 */

                default:
                  return -1;
                }

            case E_V8DImode:
              switch (pattern1703 (x3, 
E_DImode, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9694; /* *avx512f_gathersiv8di_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9742; /* *avx512f_gatherdiv8di_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9706; /* *avx512f_gathersiv8di_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9754; /* *avx512f_gatherdiv8di_2 */

                default:
                  return -1;
                }

            case E_V8DFmode:
              switch (pattern1703 (x3, 
E_DFmode, 
E_V8DFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9695; /* *avx512f_gathersiv8df_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9743; /* *avx512f_gatherdiv8df_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9707; /* *avx512f_gathersiv8df_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9755; /* *avx512f_gatherdiv8df_2 */

                default:
                  return -1;
                }

            case E_V8SImode:
              switch (pattern1705 (x3, 
E_SImode, 
E_V8SImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9696; /* *avx512f_gathersiv8si_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9744; /* *avx512f_gatherdiv8si_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9708; /* *avx512f_gathersiv8si_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9756; /* *avx512f_gatherdiv8si_2 */

                default:
                  return -1;
                }

            case E_V8SFmode:
              switch (pattern1705 (x3, 
E_SFmode, 
E_V8SFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9697; /* *avx512f_gathersiv8sf_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9745; /* *avx512f_gatherdiv8sf_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9709; /* *avx512f_gathersiv8sf_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9757; /* *avx512f_gatherdiv8sf_2 */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1707 (x3, 
E_DImode, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9698; /* *avx512f_gathersiv4di_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9746; /* *avx512f_gatherdiv4di_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9710; /* *avx512f_gathersiv4di_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9758; /* *avx512f_gatherdiv4di_2 */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1707 (x3, 
E_DFmode, 
E_V4DFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9699; /* *avx512f_gathersiv4df_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9747; /* *avx512f_gatherdiv4df_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9711; /* *avx512f_gathersiv4df_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9759; /* *avx512f_gatherdiv4df_2 */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1709 (x3, 
E_SImode, 
E_V4SImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9700; /* *avx512f_gathersiv4si_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9748; /* *avx512f_gatherdiv4si_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9712; /* *avx512f_gathersiv4si_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9760; /* *avx512f_gatherdiv4si_2 */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1709 (x3, 
E_SFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9701; /* *avx512f_gathersiv4sf_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9749; /* *avx512f_gatherdiv4sf_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9713; /* *avx512f_gathersiv4sf_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9761; /* *avx512f_gatherdiv4sf_2 */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern1709 (x3, 
E_DImode, 
E_V2DImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9702; /* *avx512f_gathersiv2di_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9750; /* *avx512f_gatherdiv2di_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9714; /* *avx512f_gathersiv2di_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9762; /* *avx512f_gatherdiv2di_2 */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1709 (x3, 
E_DFmode, 
E_V2DFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9703; /* *avx512f_gathersiv2df_2 */

                case 1:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9751; /* *avx512f_gatherdiv2df_2 */

                case 2:
                  if (!(
#line 29478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9715; /* *avx512f_gathersiv2df_2 */

                case 3:
                  if (!(
#line 29540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9763; /* *avx512f_gatherdiv2df_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern697 (x1))
        {
        case 0:
          if ((
#line 16584 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 1122; /* *lshrdi3_doubleword_mask */
          break;

        case 1:
          if ((
#line 16584 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1124; /* *lshrti3_doubleword_mask */
          break;

        case 2:
          if ((
#line 2271 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return 2602; /* klshiftrtqi */
          break;

        case 3:
          if (
#line 2271 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2604; /* klshiftrthi */
          break;

        case 4:
          if ((
#line 2271 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2606; /* klshiftrtsi */
          break;

        case 5:
          if ((
#line 2271 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2608; /* klshiftrtdi */
          break;

        default:
          break;
        }
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern698 (x1))
        {
        case 0:
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x4) == E_DImode
                  && register_operand (operands[1], E_DImode)
                  && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                return 1130; /* lshrdi3_doubleword */
              break;

            case E_TImode:
              if (register_operand (operands[0], E_TImode)
                  && GET_MODE (x4) == E_TImode
                  && register_operand (operands[1], E_TImode)
                  && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return 1132; /* lshrti3_doubleword */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 17387 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
                return 1181; /* *lshrsi3_1 */
              break;

            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && GET_MODE (x4) == E_QImode
                  && nonimmediate_operand (operands[1], E_QImode)
                  && 
#line 17563 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
                return 1213; /* *lshrqi3_1 */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && nonimmediate_operand (operands[1], E_HImode)
                  && 
#line 17601 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
                return 1215; /* *lshrhi3_1 */
              break;

            case E_V2QImode:
              if (register_operand (operands[0], E_V2QImode)
                  && GET_MODE (x4) == E_V2QImode
                  && register_operand (operands[1], E_V2QImode)
                  && 
#line 4007 "../../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                return 2215; /* lshrv2qi3 */
              break;

            default:
              break;
            }
          break;

        case 1:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          switch (pattern376 (x4))
            {
            case 0:
              if (
#line 17640 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 1216; /* *lshrqi3_1_slp */
              break;

            case 1:
              if (
#line 17640 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 1218; /* *lshrhi3_1_slp */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (pattern1151 (x2) == 0
              && GET_MODE (x4) == E_DImode
              && nonimmediate_operand (operands[1], E_DImode)
              && 
#line 17363 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return 1179; /* *highpartdisi2 */
          break;

        case SUBREG:
          switch (pattern1154 (x2, 
E_SImode))
            {
            case 0:
              if (
#line 17842 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                return 1245; /* *lshrsi3_mask */
              break;

            case 1:
              if (
#line 17890 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1257; /* *lshrsi3_add */
              break;

            case 2:
              if (
#line 17936 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1269; /* *lshrsi3_sub */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      operands[2] = x5;
      if (nonmemory_operand (operands[2], E_QImode)
          && (
#line 17387 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1183; /* *lshrdi3_1 */
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_QImode)
        return -1;
      x9 = XEXP (x5, 0);
      switch (pattern1152 (x9))
        {
        case 0:
          if (!(
#line 17842 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1248; /* *lshrdi3_mask */

        case 1:
          if (!(
#line 17890 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1260; /* *lshrdi3_add */

        case 2:
          if (!(
#line 17936 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1272; /* *lshrdi3_sub */

        default:
          return -1;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 16645 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 1126; /* *lshrdi3_doubleword_mask_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !(
#line 17867 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1254; /* *lshrdi3_mask_1 */

    case 2:
      if (!(
#line 16645 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1128; /* *lshrti3_doubleword_mask_1 */

    case 3:
      if (!
#line 17867 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
        return -1;
      return 1251; /* *lshrsi3_mask_1 */

    case 4:
      if (!
#line 17914 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      return 1263; /* *lshrsi3_add_1 */

    case 5:
      if (!(
#line 17914 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1266; /* *lshrdi3_add_1 */

    case 6:
      if (!
#line 17966 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      return 1275; /* *lshrsi3_sub_1 */

    case 7:
      if (!(
#line 17966 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1278; /* *lshrdi3_sub_1 */

    default:
      return -1;
    }
}

 int
recog_414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (pattern383 (x5, 
174, 
0) != 0)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8DImode:
      if (pattern1230 (x3, 
E_V8DImode, 
E_QImode, 
E_DImode) != 0
          || !(
#line 28088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9272; /* avx512cd_maskb_vec_dupv8di */

    case E_V4DImode:
      if (pattern1230 (x3, 
E_V4DImode, 
E_QImode, 
E_DImode) != 0
          || !(
#line 28088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9273; /* avx512cd_maskb_vec_dupv4di */

    case E_V2DImode:
      if (pattern1230 (x3, 
E_V2DImode, 
E_QImode, 
E_DImode) != 0
          || !(
#line 28088 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 623 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9274; /* avx512cd_maskb_vec_dupv2di */

    case E_V16SImode:
      if (pattern1230 (x3, 
E_V16SImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 28100 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 674 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9275; /* avx512cd_maskw_vec_dupv16si */

    case E_V8SImode:
      if (pattern1230 (x3, 
E_V8SImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 28100 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9276; /* avx512cd_maskw_vec_dupv8si */

    case E_V4SImode:
      if (pattern1230 (x3, 
E_V4SImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 28100 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 674 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9277; /* avx512cd_maskw_vec_dupv4si */

    default:
      return -1;
    }
}

 int
recog_420 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (!register_operand (x4, E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case SMUL_HIGHPART:
      if (pattern820 (x1) != 0
          || !
#line 11150 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 631; /* *smulsi3_highpart_zext */

    case UMUL_HIGHPART:
      if (pattern820 (x1) != 0
          || !
#line 11150 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 632; /* *umulsi3_highpart_zext */

    case TRUNCATE:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MULT
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER
          || pattern822 (x1) != 0)
        return -1;
      x10 = XEXP (x7, 0);
      if (GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x7, 1);
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x9, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 11198 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 635; /* *smulsi3_highpart_zext */

        case ZERO_EXTEND:
          if (GET_CODE (x11) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 11198 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 636; /* *umulsi3_highpart_zext */

        default:
          return -1;
        }

    case DIV:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != MOD
          || GET_MODE (x15) != E_SImode)
        return -1;
      operands[0] = x4;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[3] = x16;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1615 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 11485 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 643; /* divmodsi4_zext_1 */

        case 1:
          if (!
#line 11684 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 655; /* *divmodsi4_zext_1 */

        case 2:
          if (!
#line 11880 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 673; /* *divmodsi4_noext_zext_1 */

        default:
          return -1;
        }

    case UDIV:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != UMOD
          || GET_MODE (x15) != E_SImode)
        return -1;
      operands[0] = x4;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[3] = x16;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1553 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 11521 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 644; /* udivmodsi4_zext_1 */

        case 1:
          if (!
#line 11719 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 656; /* *udivmodsi4_zext_1 */

        case 2:
          if (!
#line 11880 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 674; /* *udivmodsi4_noext_zext_1 */

        case 3:
          if (!
#line 11741 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
            return -1;
          return 657; /* *udivmodsi4_pow2_zext_1 */

        default:
          return -1;
        }

    case MOD:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != DIV
          || GET_MODE (x15) != E_SImode)
        return -1;
      operands[1] = x4;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[3] = x16;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern1615 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 11544 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 645; /* divmodsi4_zext_2 */

        case 1:
          if (!
#line 11767 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 658; /* *divmodsi4_zext_2 */

        case 2:
          if (!
#line 11894 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 675; /* *divmodsi4_noext_zext_2 */

        default:
          return -1;
        }

    case UMOD:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != UDIV
          || GET_MODE (x15) != E_SImode)
        return -1;
      operands[1] = x4;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[3] = x16;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern1553 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 11581 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 646; /* udivmodsi4_zext_2 */

        case 1:
          if (!
#line 11803 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 659; /* *udivmodsi4_zext_2 */

        case 2:
          if (!
#line 11894 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 676; /* *udivmodsi4_noext_zext_2 */

        case 3:
          if (!
#line 11825 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
            return -1;
          return 660; /* *udivmodsi4_pow2_zext_2 */

        default:
          return -1;
        }

    case CTZ:
      if (pattern821 (x1) != 0
          || !
#line 21221 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 1523; /* *ctzsidi2_uext_falsedep */

    case CLZ:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 1
          || XINT (x9, 1) != 38)
        return -1;
      x17 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x17) != CLOBBER)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 17
          || GET_MODE (x18) != E_CCmode)
        return -1;
      operands[0] = x4;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x19 = XVECEXP (x9, 0, 0);
      switch (pattern1408 (x19))
        {
        case 0:
          if (!
#line 21641 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          return 1544; /* *clzsi2_lzcnt_zext_2_falsedep */

        case 1:
          if (!(
#line 21641 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1545; /* *clzsi2_lzcnt_zext_2_falsedep */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pattern821 (x1) != 0
          || !
#line 22484 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
        return -1;
      return 1635; /* *popcountsi2_zext_2_falsedep */

    default:
      return -1;
    }
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case COMPARE:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSPEC:
      res = recog_14 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      res = recog_20 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LSHIFTRT:
      res = recog_21 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFTRT:
      res = recog_22 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
      res = recog_23 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      res = recog_24 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FLOAT_EXTEND:
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FLOAT_TRUNCATE:
      res = recog_29 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FIX:
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSIGNED_FIX:
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FLOAT:
      res = recog_32 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSIGNED_FLOAT:
      res = recog_33 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case AND:
      res = recog_37 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NOT:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NEG:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ABS:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFT:
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATE:
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATERT:
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case POPCOUNT:
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case BSWAP:
      if (GET_MODE (x2) == E_HImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (nonimmediate_operand (operands[1], E_HImode)
              && nonimmediate_operand (operands[0], E_HImode)
              && 
#line 22615 "../../../gcc/config/i386/i386.md"
(TARGET_MOVBE
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return 1644; /* *bswaphi2_movbe */
          if (register_operand (operands[1], E_HImode)
              && register_operand (operands[0], E_HImode)
              && 
#line 22634 "../../../gcc/config/i386/i386.md"
(!TARGET_MOVBE))
            return 1645; /* *bswaphi2 */
        }
      break;

    case PLUS:
    case MINUS:
    case MULT:
    case DIV:
      res = recog_57 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SQRT:
      res = recog_351 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMAX:
      switch (pattern9 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 26743 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
            return 1815; /* smaxsf3 */
          break;

        case 1:
          if (
#line 26743 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return 1817; /* smaxdf3 */
          break;

        case 2:
          if (
#line 26757 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return 1819; /* smaxhf3 */
          break;

        case 3:
          if ((
#line 26920 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1835; /* *smaxti3_doubleword */
            }
          break;

        case 4:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1839; /* *smaxqi3_1 */
            }
          break;

        case 5:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1843; /* *smaxhi3_1 */
            }
          break;

        case 6:
          if (
#line 3659 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2168; /* smaxv8qi3 */
          break;

        case 7:
          if (
#line 3659 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2170; /* smaxv2si3 */
          break;

        case 8:
          if (
#line 3684 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (SMAX, V4HImode, operands)))
            return 2172; /* *mmx_smaxv4hi3 */
          break;

        case 9:
          if (
#line 3708 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2174; /* smaxv4qi3 */
          break;

        case 10:
          if (
#line 3708 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2176; /* smaxv2qi3 */
          break;

        case 11:
          if (
#line 3724 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2178; /* smaxv2hi3 */
          break;

        default:
          break;
        }
      break;

    case SMIN:
      switch (pattern9 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 26743 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
            return 1816; /* sminsf3 */
          break;

        case 1:
          if (
#line 26743 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return 1818; /* smindf3 */
          break;

        case 2:
          if (
#line 26757 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return 1820; /* sminhf3 */
          break;

        case 3:
          if ((
#line 26920 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1836; /* *sminti3_doubleword */
            }
          break;

        case 4:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1840; /* *sminqi3_1 */
            }
          break;

        case 5:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1844; /* *sminhi3_1 */
            }
          break;

        case 6:
          if (
#line 3659 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2169; /* sminv8qi3 */
          break;

        case 7:
          if (
#line 3659 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2171; /* sminv2si3 */
          break;

        case 8:
          if (
#line 3684 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (SMIN, V4HImode, operands)))
            return 2173; /* *mmx_sminv4hi3 */
          break;

        case 9:
          if (
#line 3708 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2175; /* sminv4qi3 */
          break;

        case 10:
          if (
#line 3708 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2177; /* sminv2qi3 */
          break;

        case 11:
          if (
#line 3724 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2179; /* sminv2hi3 */
          break;

        default:
          break;
        }
      break;

    case UMAX:
      switch (pattern10 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26920 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1837; /* *umaxti3_doubleword */
            }
          break;

        case 1:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1841; /* *umaxqi3_1 */
            }
          break;

        case 2:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1845; /* *umaxhi3_1 */
            }
          break;

        case 3:
          if (
#line 3737 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2180; /* umaxv4hi3 */
          break;

        case 4:
          if (
#line 3737 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2182; /* umaxv2si3 */
          break;

        case 5:
          if (
#line 3762 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (UMAX, V8QImode, operands)))
            return 2184; /* *mmx_umaxv8qi3 */
          break;

        case 6:
          if (
#line 3786 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2186; /* umaxv4qi3 */
          break;

        case 7:
          if (
#line 3786 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2188; /* umaxv2qi3 */
          break;

        case 8:
          if (
#line 3799 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2190; /* umaxv2hi3 */
          break;

        default:
          break;
        }
      break;

    case UMIN:
      switch (pattern10 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26920 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1838; /* *uminti3_doubleword */
            }
          break;

        case 1:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1842; /* *uminqi3_1 */
            }
          break;

        case 2:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1846; /* *uminhi3_1 */
            }
          break;

        case 3:
          if (
#line 3737 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2181; /* uminv4hi3 */
          break;

        case 4:
          if (
#line 3737 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2183; /* uminv2si3 */
          break;

        case 5:
          if (
#line 3762 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (UMIN, V8QImode, operands)))
            return 2185; /* *mmx_uminv8qi3 */
          break;

        case 6:
          if (
#line 3786 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2187; /* uminv4qi3 */
          break;

        case 7:
          if (
#line 3786 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2189; /* uminv2qi3 */
          break;

        case 8:
          if (
#line 3799 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2191; /* uminv2hi3 */
          break;

        default:
          break;
        }
      break;

    case UNSPEC_VOLATILE:
      res = recog_58 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_CONCAT:
      res = recog_59 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_MERGE:
      res = recog_60 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_SELECT:
      res = recog_62 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_DUPLICATE:
      res = recog_63 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SS_PLUS:
      res = recog_64 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (
#line 3323 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (US_PLUS, V8QImode, operands)))
            return 2139; /* *mmx_usaddv8qi3 */
          break;

        case 1:
          if (
#line 3323 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (US_PLUS, V4HImode, operands)))
            return 2143; /* *mmx_usaddv4hi3 */
          break;

        case 2:
          if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2147; /* usaddv4qi3 */
          break;

        case 3:
          if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2151; /* usaddv2qi3 */
          break;

        case 4:
          if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2155; /* usaddv2hi3 */
          break;

        default:
          break;
        }
      break;

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern45 (x2))
            {
            case 0:
              if (
#line 3323 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (SS_MINUS, V8QImode, operands)))
                return 2140; /* *mmx_sssubv8qi3 */
              break;

            case 1:
              if (
#line 3323 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (SS_MINUS, V4HImode, operands)))
                return 2144; /* *mmx_sssubv4hi3 */
              break;

            case 2:
              if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return 2148; /* sssubv4qi3 */
              break;

            case 3:
              if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return 2152; /* sssubv2qi3 */
              break;

            case 4:
              if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return 2156; /* sssubv2hi3 */
              break;

            default:
              break;
            }
          break;

        case VEC_SELECT:
          if (pattern101 (x2) == 0
              && 
#line 22605 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return 8525; /* ssse3_phsubswv4hi3 */
          break;

        default:
          break;
        }
      break;

    case US_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (
#line 3323 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (US_MINUS, V8QImode, operands)))
            return 2141; /* *mmx_ussubv8qi3 */
          break;

        case 1:
          if (
#line 3323 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (US_MINUS, V4HImode, operands)))
            return 2145; /* *mmx_ussubv4hi3 */
          break;

        case 2:
          if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2149; /* ussubv4qi3 */
          break;

        case 3:
          if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2153; /* ussubv2qi3 */
          break;

        case 4:
          if (
#line 3339 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2157; /* ussubv2hi3 */
          break;

        default:
          break;
        }
      break;

    case TRUNCATE:
      res = recog_65 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FMA:
      res = recog_66 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SS_TRUNCATE:
      switch (pattern13 (x1))
        {
        case 0:
          if (
#line 15386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7222; /* *avx512vl_ss_truncatev2div2qi2_store_1 */
          break;

        case 1:
          if (
#line 15481 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7237; /* *avx512vl_ss_truncatev4siv4qi2_store_1 */
          break;

        case 2:
          if (
#line 15481 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7240; /* *avx512vl_ss_truncatev4div4qi2_store_1 */
          break;

        case 3:
          if ((
#line 15579 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 7267; /* *avx512vl_ss_truncatev8hiv8qi2_store_1 */
          break;

        case 4:
          if (
#line 15579 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7270; /* *avx512vl_ss_truncatev8siv8qi2_store_1 */
          break;

        case 5:
          if (
#line 16095 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 7374; /* *avx512f_ss_truncatev8div16qi2_store_1 */
          break;

        case 6:
          if (
#line 15741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7307; /* *avx512vl_ss_truncatev4siv4hi2_store_1 */
          break;

        case 7:
          if (
#line 15741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7310; /* *avx512vl_ss_truncatev4div4hi2_store_1 */
          break;

        case 8:
          if (
#line 15832 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7337; /* *avx512vl_ss_truncatev2div2hi2_store_1 */
          break;

        case 9:
          if (
#line 15982 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7356; /* *avx512vl_ss_truncatev2div2si2_store_1 */
          break;

        default:
          break;
        }
      break;

    case US_TRUNCATE:
      switch (pattern13 (x1))
        {
        case 0:
          if (
#line 15386 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7224; /* *avx512vl_us_truncatev2div2qi2_store_1 */
          break;

        case 1:
          if (
#line 15481 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7239; /* *avx512vl_us_truncatev4siv4qi2_store_1 */
          break;

        case 2:
          if (
#line 15481 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7242; /* *avx512vl_us_truncatev4div4qi2_store_1 */
          break;

        case 3:
          if ((
#line 15579 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 7269; /* *avx512vl_us_truncatev8hiv8qi2_store_1 */
          break;

        case 4:
          if (
#line 15579 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7272; /* *avx512vl_us_truncatev8siv8qi2_store_1 */
          break;

        case 5:
          if (
#line 16095 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 7376; /* *avx512f_us_truncatev8div16qi2_store_1 */
          break;

        case 6:
          if (
#line 15741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7309; /* *avx512vl_us_truncatev4siv4hi2_store_1 */
          break;

        case 7:
          if (
#line 15741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7312; /* *avx512vl_us_truncatev4div4hi2_store_1 */
          break;

        case 8:
          if (
#line 15832 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7339; /* *avx512vl_us_truncatev2div2hi2_store_1 */
          break;

        case 9:
          if (
#line 15982 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7358; /* *avx512vl_us_truncatev2div2si2_store_1 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_XImode:
      if (nonimmediate_operand (operands[0], E_XImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_XImode)
          && 
#line 2453 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (register_operand (operands[0], XImode)
       || register_operand (operands[1], XImode))))
        return 92; /* *movxi_internal_avx512f */
      break;

    case E_OImode:
      if (nonimmediate_operand (operands[0], E_OImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_OImode)
          && 
#line 2476 "../../../gcc/config/i386/i386.md"
(TARGET_AVX
   && (register_operand (operands[0], OImode)
       || register_operand (operands[1], OImode))))
        return 93; /* *movoi_internal_avx */
      break;

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && address_no_seg_operand (operands[1], E_SImode)
          && 
#line 6372 "../../../gcc/config/i386/i386.md"
(ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 264; /* *leasi */
      break;

    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && address_no_seg_operand (operands[1], E_DImode)
          && (
#line 6372 "../../../gcc/config/i386/i386.md"
(ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 265; /* *leadi */
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_67 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      res = recog_75 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case COMPARE:
      res = recog_76 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
      res = recog_80 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      res = recog_81 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_83 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IF_THEN_ELSE:
      res = recog_86 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_87 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMUL_HIGHPART:
      switch (pattern15 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 627; /* smulsi3_highpart */
            }
          break;

        case 1:
          if (
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 629; /* smuldi3_highpart */
            }
          break;

        default:
          break;
        }
      break;

    case UMUL_HIGHPART:
      switch (pattern15 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 628; /* umulsi3_highpart */
            }
          break;

        case 1:
          if (
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 630; /* umuldi3_highpart */
            }
          break;

        default:
          break;
        }
      break;

    case TRUNCATE:
      res = recog_88 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case AND:
      res = recog_90 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NOT:
      res = recog_91 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NEG:
      res = recog_92 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ABS:
      res = recog_93 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFT:
      res = recog_95 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LSHIFTRT:
      res = recog_97 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFTRT:
      res = recog_99 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      res = recog_100 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATE:
      res = recog_101 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATERT:
      res = recog_102 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_104 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      res = recog_105 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSPEC:
      res = recog_109 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CALL:
      res = recog_110 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FFS:
      if (pnum_clobbers != NULL
          && GET_MODE (x2) == E_SImode)
        {
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 20985 "../../../gcc/config/i386/i386.md"
(!TARGET_CMOVE))
                {
                  *pnum_clobbers = 2;
                  return 1507; /* ffssi2_no_cmove */
                }
            }
        }
      break;

    case CTZ:
      res = recog_111 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_112 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CLZ:
      res = recog_113 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case POPCOUNT:
      res = recog_114 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case BSWAP:
      res = recog_352 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTRACT:
      res = recog_115 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMAX:
      switch (pattern21 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26920 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1831; /* *smaxdi3_doubleword */
            }
          if ((
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1851; /* *smaxdi3_1 */
            }
          break;

        case 1:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1847; /* *smaxsi3_1 */
            }
          break;

        default:
          break;
        }
      break;

    case SMIN:
      switch (pattern21 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26920 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1832; /* *smindi3_doubleword */
            }
          if ((
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1852; /* *smindi3_1 */
            }
          break;

        case 1:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1848; /* *sminsi3_1 */
            }
          break;

        default:
          break;
        }
      break;

    case UMAX:
      switch (pattern21 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26920 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1833; /* *umaxdi3_doubleword */
            }
          if ((
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1853; /* *umaxdi3_1 */
            }
          break;

        case 1:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1849; /* *umaxsi3_1 */
            }
          break;

        default:
          break;
        }
      break;

    case UMIN:
      switch (pattern21 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26920 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1834; /* *umindi3_doubleword */
            }
          if ((
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1854; /* *umindi3_1 */
            }
          break;

        case 1:
          if (
#line 26978 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1850; /* *uminsi3_1 */
            }
          break;

        default:
          break;
        }
      break;

    case UNSPEC_VOLATILE:
      res = recog_116 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_SELECT:
      res = recog_119 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FIX:
      switch (pattern24 (x1))
        {
        case 0:
          if (
#line 7992 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return 4634; /* avx512fp16_fix_truncsi2 */
          break;

        case 1:
          if (
#line 8586 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 4733; /* sse_cvttss2si */
          break;

        case 2:
          if (
#line 9131 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 4868; /* sse2_cvttsd2si */
          break;

        case 3:
          if ((
#line 7992 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4638; /* avx512fp16_fix_truncdi2 */
          break;

        case 4:
          if ((
#line 8586 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4735; /* sse_cvttss2siq */
          break;

        case 5:
          if ((
#line 9131 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4870; /* sse2_cvttsd2siq */
          break;

        case 6:
          if (
#line 8002 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return 4642; /* avx512fp16_fix_truncsi2_mem */
          break;

        case 7:
          if ((
#line 8002 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4644; /* avx512fp16_fix_truncdi2_mem */
          break;

        default:
          break;
        }
      break;

    case UNSIGNED_FIX:
      switch (pattern24 (x1))
        {
        case 0:
          if (
#line 7992 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return 4636; /* avx512fp16_fixuns_truncsi2 */
          break;

        case 1:
          if (
#line 9036 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 4842; /* avx512f_vcvttss2usi */
          break;

        case 2:
          if (
#line 9072 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 4854; /* avx512f_vcvttsd2usi */
          break;

        case 3:
          if ((
#line 7992 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4640; /* avx512fp16_fixuns_truncdi2 */
          break;

        case 4:
          if ((
#line 9036 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4844; /* avx512f_vcvttss2usiq */
          break;

        case 5:
          if ((
#line 9072 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4856; /* avx512f_vcvttsd2usiq */
          break;

        case 6:
          if (
#line 8002 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return 4643; /* avx512fp16_fixuns_truncsi2_mem */
          break;

        case 7:
          if ((
#line 8002 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4645; /* avx512fp16_fixuns_truncdi2_mem */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[0] = x3;
  res = recog_321 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  switch (GET_CODE (x2))
    {
    case VEC_MERGE:
      return recog_318 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_314 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_315 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_316 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_340 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_329 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_347 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_334 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_336 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_337 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_350 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_322 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_328 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_333 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_342 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_341 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_323 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_345 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_317 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_319 (x1, insn, pnum_clobbers);

    case AND:
    case IOR:
    case XOR:
    case NOT:
      return recog_339 (x1, insn, pnum_clobbers);

    case SS_TRUNCATE:
      operands[0] = x3;
      switch (pattern50 (x2))
        {
        case 0:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7150; /* *avx512f_ss_truncatev16siv16qi2 */

        case 1:
          if (!(
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15210 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7192; /* *avx512vl_ss_truncatev16hiv16qi2 */

        case 2:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7153; /* *avx512f_ss_truncatev16siv16hi2 */

        case 3:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7156; /* *avx512f_ss_truncatev8div8si2 */

        case 4:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7159; /* *avx512f_ss_truncatev8div8hi2 */

        case 5:
          if (!
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7189; /* *avx512vl_ss_truncatev8siv8hi2 */

        case 6:
          if (!
#line 15147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7179; /* avx512bw_ss_truncatev32hiv32qi2 */

        case 7:
          if (!
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7186; /* *avx512vl_ss_truncatev4div4si2 */

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_335 (x1, insn, pnum_clobbers);

    case US_TRUNCATE:
      operands[0] = x3;
      switch (pattern50 (x2))
        {
        case 0:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7152; /* *avx512f_us_truncatev16siv16qi2 */

        case 1:
          if (!(
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15210 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7194; /* *avx512vl_us_truncatev16hiv16qi2 */

        case 2:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7155; /* *avx512f_us_truncatev16siv16hi2 */

        case 3:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7158; /* *avx512f_us_truncatev8div8si2 */

        case 4:
          if (!
#line 14974 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7161; /* *avx512f_us_truncatev8div8hi2 */

        case 5:
          if (!
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7191; /* *avx512vl_us_truncatev8siv8hi2 */

        case 6:
          if (!
#line 15147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7181; /* avx512bw_us_truncatev32hiv32qi2 */

        case 7:
          if (!
#line 15236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7188; /* *avx512vl_us_truncatev4div4si2 */

        default:
          return -1;
        }

    case SS_PLUS:
      return recog_320 (x1, insn, pnum_clobbers);

    case US_PLUS:
      operands[0] = x3;
      switch (pattern51 (x2))
        {
        case 0:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7439; /* *avx512bw_usaddv64qi3 */

        case 1:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7447; /* *avx2_usaddv32qi3 */

        case 2:
          if (!
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V16QImode, operands)))
            return -1;
          return 7455; /* *sse2_usaddv16qi3 */

        case 3:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7463; /* *avx512bw_usaddv32hi3 */

        case 4:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7471; /* *avx2_usaddv16hi3 */

        case 5:
          if (!
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V8HImode, operands)))
            return -1;
          return 7479; /* *sse2_usaddv8hi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern51 (x2))
            {
            case 0:
              if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7441; /* *avx512bw_sssubv64qi3 */

            case 1:
              if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7449; /* *avx2_sssubv32qi3 */

            case 2:
              if (!
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V16QImode, operands)))
                return -1;
              return 7457; /* *sse2_sssubv16qi3 */

            case 3:
              if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7465; /* *avx512bw_sssubv32hi3 */

            case 4:
              if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7473; /* *avx2_sssubv16hi3 */

            case 5:
              if (!
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V8HImode, operands)))
                return -1;
              return 7481; /* *sse2_sssubv8hi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          switch (pattern196 (x2))
            {
            case 0:
              if (!
#line 22557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8517; /* avx2_phsubswv16hi3 */

            case 1:
              if (!
#line 22580 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3))
                return -1;
              return 8521; /* ssse3_phsubswv8hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_MINUS:
      operands[0] = x3;
      switch (pattern51 (x2))
        {
        case 0:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7443; /* *avx512bw_ussubv64qi3 */

        case 1:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7451; /* *avx2_ussubv32qi3 */

        case 2:
          if (!
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)))
            return -1;
          return 7459; /* *sse2_ussubv16qi3 */

        case 3:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7467; /* *avx512bw_ussubv32hi3 */

        case 4:
          if (!(
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7475; /* *avx2_ussubv16hi3 */

        case 5:
          if (!
#line 16304 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)))
            return -1;
          return 7483; /* *sse2_ussubv8hi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_324 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_326 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_325 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_349 (x1, insn, pnum_clobbers);

    case ROTATERT:
      return recog_348 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_344 (x1, insn, pnum_clobbers);

    case UMIN:
      return recog_343 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_332 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_338 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_330 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_327 (x1, insn, pnum_clobbers);

    case CLZ:
      return recog_346 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      return recog_331 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_37 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case LSHIFTRT:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern231 (x6, 
E_CCmode, 
17) != 0
          || !mask_reg_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!mask_reg_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!const_0_to_31_operand (operands[2], E_VOIDmode)
          || !
#line 2323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && reload_completed))
        return NULL;
      return gen_split_1232 (insn, operands);

    case UNSPEC:
      if (pattern352 (x1) != 0)
        return NULL;
      switch (pattern1034 (x1))
        {
        case 0:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1344 (insn, operands);

        case 1:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1365 (insn, operands);

        case 2:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1371 (insn, operands);

        case 3:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1407 (insn, operands);

        case 4:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1416 (insn, operands);

        case 5:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1347 (insn, operands);

        case 6:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1350 (insn, operands);

        case 7:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1353 (insn, operands);

        case 8:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1356 (insn, operands);

        case 9:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1359 (insn, operands);

        case 10:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1368 (insn, operands);

        case 11:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1374 (insn, operands);

        case 12:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1377 (insn, operands);

        case 13:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1380 (insn, operands);

        case 14:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1383 (insn, operands);

        case 15:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1386 (insn, operands);

        case 16:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1419 (insn, operands);

        case 17:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1362 (insn, operands);

        case 18:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1410 (insn, operands);

        case 19:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1413 (insn, operands);

        case 20:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1404 (insn, operands);

        case 21:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1345 (insn, operands);

        case 22:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1366 (insn, operands);

        case 23:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1372 (insn, operands);

        case 24:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1408 (insn, operands);

        case 25:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1417 (insn, operands);

        case 26:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1348 (insn, operands);

        case 27:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1351 (insn, operands);

        case 28:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1354 (insn, operands);

        case 29:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1357 (insn, operands);

        case 30:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1360 (insn, operands);

        case 31:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1369 (insn, operands);

        case 32:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1375 (insn, operands);

        case 33:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1378 (insn, operands);

        case 34:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1381 (insn, operands);

        case 35:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1384 (insn, operands);

        case 36:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1387 (insn, operands);

        case 37:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1420 (insn, operands);

        case 38:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1363 (insn, operands);

        case 39:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1411 (insn, operands);

        case 40:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1414 (insn, operands);

        case 41:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1405 (insn, operands);

        case 42:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1346 (insn, operands);

        case 43:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1367 (insn, operands);

        case 44:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1373 (insn, operands);

        case 45:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1409 (insn, operands);

        case 46:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1418 (insn, operands);

        case 47:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1349 (insn, operands);

        case 48:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1352 (insn, operands);

        case 49:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1355 (insn, operands);

        case 50:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1358 (insn, operands);

        case 51:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1361 (insn, operands);

        case 52:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1370 (insn, operands);

        case 53:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1376 (insn, operands);

        case 54:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1379 (insn, operands);

        case 55:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1382 (insn, operands);

        case 56:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1385 (insn, operands);

        case 57:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1388 (insn, operands);

        case 58:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1421 (insn, operands);

        case 59:
          if (!((
#line 4439 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4445 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1364 (insn, operands);

        case 60:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1412 (insn, operands);

        case 61:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1415 (insn, operands);

        case 62:
          if (!((
#line 4528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1406 (insn, operands);

        case 63:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1434 (insn, operands);

        case 64:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1437 (insn, operands);

        case 65:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1446 (insn, operands);

        case 66:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1452 (insn, operands);

        case 67:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1440 (insn, operands);

        case 68:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1443 (insn, operands);

        case 69:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1449 (insn, operands);

        case 70:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1453 (insn, operands);

        case 71:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1454 (insn, operands);

        case 72:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1455 (insn, operands);

        case 73:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1456 (insn, operands);

        case 74:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1457 (insn, operands);

        case 75:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1435 (insn, operands);

        case 76:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1438 (insn, operands);

        case 77:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1447 (insn, operands);

        case 78:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1458 (insn, operands);

        case 79:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1441 (insn, operands);

        case 80:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1444 (insn, operands);

        case 81:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1450 (insn, operands);

        case 82:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1459 (insn, operands);

        case 83:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1460 (insn, operands);

        case 84:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1461 (insn, operands);

        case 85:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1462 (insn, operands);

        case 86:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1463 (insn, operands);

        case 87:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1436 (insn, operands);

        case 88:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1439 (insn, operands);

        case 89:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1448 (insn, operands);

        case 90:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1464 (insn, operands);

        case 91:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1442 (insn, operands);

        case 92:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1445 (insn, operands);

        case 93:
          if (!((
#line 4638 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1451 (insn, operands);

        case 94:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1465 (insn, operands);

        case 95:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1466 (insn, operands);

        case 96:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1467 (insn, operands);

        case 97:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1468 (insn, operands);

        case 98:
          if (!((
#line 4728 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1469 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern533 (x2))
        {
        case 0:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1985 (insn, operands);

        case 1:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2012 (insn, operands);

        case 2:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2039 (insn, operands);

        case 3:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2066 (insn, operands);

        case 4:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2093 (insn, operands);

        case 5:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2120 (insn, operands);

        case 6:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2147 (insn, operands);

        case 7:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2174 (insn, operands);

        case 8:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2201 (insn, operands);

        case 9:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2228 (insn, operands);

        case 10:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2255 (insn, operands);

        case 11:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2282 (insn, operands);

        case 12:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1988 (insn, operands);

        case 13:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2015 (insn, operands);

        case 14:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2042 (insn, operands);

        case 15:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2069 (insn, operands);

        case 16:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2096 (insn, operands);

        case 17:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2123 (insn, operands);

        case 18:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2150 (insn, operands);

        case 19:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2177 (insn, operands);

        case 20:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2204 (insn, operands);

        case 21:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2231 (insn, operands);

        case 22:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2258 (insn, operands);

        case 23:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2285 (insn, operands);

        case 24:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1991 (insn, operands);

        case 25:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2018 (insn, operands);

        case 26:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2045 (insn, operands);

        case 27:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2072 (insn, operands);

        case 28:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2099 (insn, operands);

        case 29:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2126 (insn, operands);

        case 30:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2153 (insn, operands);

        case 31:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2180 (insn, operands);

        case 32:
          if (!(
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2207 (insn, operands);

        case 33:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2234 (insn, operands);

        case 34:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2261 (insn, operands);

        case 35:
          if (!((
#line 13763 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2288 (insn, operands);

        case 36:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3065 (insn, operands);

        case 37:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3074 (insn, operands);

        case 38:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3083 (insn, operands);

        case 39:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3092 (insn, operands);

        case 40:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3101 (insn, operands);

        case 41:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3110 (insn, operands);

        case 42:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3119 (insn, operands);

        case 43:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3128 (insn, operands);

        case 44:
          if (!(
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3137 (insn, operands);

        case 45:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3146 (insn, operands);

        case 46:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3155 (insn, operands);

        case 47:
          if (!((
#line 13932 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3164 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2633 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2660 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2687 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2714 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2741 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2768 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2795 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2822 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2849 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2876 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2903 (insn, operands);

        case 11:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2930 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2636 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2663 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2690 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2717 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2744 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2771 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2798 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2825 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2852 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2879 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2906 (insn, operands);

        case 11:
          if (!((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2933 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1175 (x2, 
E_V32HFmode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2639 (insn, operands);

        case E_V16HFmode:
          if (pattern991 (x2, 
E_V16HFmode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V16HFmode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V16HFmode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V16HFmode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V16HFmode)
                  && ((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2666 (insn, operands);
            }
          if (!register_operand (operands[1], E_V16HFmode)
              || !register_operand (operands[2], E_V16HFmode)
              || !nonimmediate_operand (operands[3], E_V16HFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3702 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3718 (insn, operands);

        case E_V8HFmode:
          if (pattern991 (x2, 
E_V8HFmode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V8HFmode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V8HFmode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V8HFmode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V8HFmode)
                  && (
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2693 (insn, operands);
            }
          if (!register_operand (operands[1], E_V8HFmode)
              || !register_operand (operands[2], E_V8HFmode)
              || !nonimmediate_operand (operands[3], E_V8HFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3703 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3719 (insn, operands);

        case E_V32BFmode:
          if (pattern1175 (x2, 
E_V32BFmode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2720 (insn, operands);

        case E_V16BFmode:
          if (pattern1175 (x2, 
E_V16BFmode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2747 (insn, operands);

        case E_V8BFmode:
          if (pattern1175 (x2, 
E_V8BFmode) != 0
              || !(
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2774 (insn, operands);

        case E_V16SFmode:
          if (pattern1175 (x2, 
E_V16SFmode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2801 (insn, operands);

        case E_V8SFmode:
          if (pattern991 (x2, 
E_V8SFmode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V8SFmode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V8SFmode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V8SFmode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V8SFmode)
                  && ((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2828 (insn, operands);
            }
          if (!register_operand (operands[1], E_V8SFmode)
              || !register_operand (operands[2], E_V8SFmode)
              || !nonimmediate_operand (operands[3], E_V8SFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3704 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3720 (insn, operands);

        case E_V4SFmode:
          if (pattern991 (x2, 
E_V4SFmode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V4SFmode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V4SFmode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V4SFmode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V4SFmode)
                  && (
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2855 (insn, operands);
            }
          if (!register_operand (operands[1], E_V4SFmode)
              || !register_operand (operands[2], E_V4SFmode)
              || !nonimmediate_operand (operands[3], E_V4SFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3705 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3721 (insn, operands);

        case E_V8DFmode:
          if (pattern1175 (x2, 
E_V8DFmode) != 0
              || !((
#line 13848 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2882 (insn, operands);

        case E_V4DFmode:
          if (pattern991 (x2, 
E_V4DFmode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V4DFmode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V4DFmode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V4DFmode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V4DFmode)
                  && ((
#line 13848 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2909 (insn, operands);
            }
          if (!register_operand (operands[1], E_V4DFmode)
              || !register_operand (operands[2], E_V4DFmode)
              || !nonimmediate_operand (operands[3], E_V4DFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3706 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3722 (insn, operands);

        case E_V2DFmode:
          if (pattern991 (x2, 
E_V2DFmode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V2DFmode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V2DFmode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V2DFmode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V2DFmode)
                  && ((
#line 13848 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../gcc/config/i386/sse.md"
( 1)))
                return gen_split_2936 (insn, operands);
            }
          if (!register_operand (operands[1], E_V2DFmode)
              || !register_operand (operands[2], E_V2DFmode)
              || !nonimmediate_operand (operands[3], E_V2DFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3707 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3723 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_83 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case MINUS:
          switch (pattern721 (x2, 
PLUS))
            {
            case 0:
              if (pattern1647 (x4, 
E_V8SFmode, 
E_V16SFmode) != 0
                  || !(
#line 3593 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_1308 (insn, operands);

            case 1:
              if (pattern1647 (x4, 
E_V4SFmode, 
E_V8SFmode) != 0
                  || !
#line 3593 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))))
                return NULL;
              return gen_split_1309 (insn, operands);

            case 2:
              if (pattern1647 (x4, 
E_V4DFmode, 
E_V8DFmode) != 0
                  || !(
#line 3593 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_1310 (insn, operands);

            case 3:
              if (pattern1647 (x4, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !(
#line 3593 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return NULL;
              return gen_split_1311 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          switch (pattern721 (x2, 
MINUS))
            {
            case 0:
              if (pattern1648 (x4, 
E_V8SFmode, 
E_V16SFmode) != 0
                  || !(
#line 3627 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_1312 (insn, operands);

            case 1:
              if (pattern1648 (x4, 
E_V4SFmode, 
E_V8SFmode) != 0
                  || !
#line 3627 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))))
                return NULL;
              return gen_split_1313 (insn, operands);

            case 2:
              if (pattern1648 (x4, 
E_V4DFmode, 
E_V8DFmode) != 0
                  || !(
#line 3627 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return NULL;
              return gen_split_1314 (insn, operands);

            case 3:
              if (pattern1648 (x4, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !(
#line 3627 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return NULL;
              return gen_split_1315 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          res = split_59 (x1, insn);
          if (res != NULL_RTX)
            return res;
          if (XVECLEN (x3, 0) < 1)
            return NULL;
          operands[4] = x3;
          switch (pattern801 (x2))
            {
            case 0:
              if ((
#line 24143 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24145 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3510 (insn, operands);
              break;

            case 1:
              if ((
#line 24143 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24145 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3511 (insn, operands);
              break;

            case 2:
              if ((
#line 24143 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24145 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3512 (insn, operands);
              break;

            case 3:
              if (((
#line 24196 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 24198 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3514 (insn, operands);
              break;

            case 4:
              if (((
#line 24196 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 24198 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3515 (insn, operands);
              break;

            case 5:
              if (((
#line 24196 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 24198 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3516 (insn, operands);
              break;

            case 6:
              if ((
#line 24307 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24309 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3522 (insn, operands);
              break;

            case 7:
              if ((
#line 24307 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24309 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3523 (insn, operands);
              break;

            case 8:
              if ((
#line 24307 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24309 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3524 (insn, operands);
              break;

            case 9:
              if (((
#line 24540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 24542 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3534 (insn, operands);
              break;

            case 10:
              if (((
#line 24540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 24542 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3535 (insn, operands);
              break;

            case 11:
              if (((
#line 24540 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 24542 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3536 (insn, operands);
              break;

            case 12:
              if ((
#line 24594 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24596 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3538 (insn, operands);
              break;

            case 13:
              if ((
#line 24594 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24596 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3539 (insn, operands);
              break;

            case 14:
              if ((
#line 24594 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24596 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3540 (insn, operands);
              break;

            case 15:
              if ((
#line 24712 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24714 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3546 (insn, operands);
              break;

            case 16:
              if ((
#line 24712 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24714 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3547 (insn, operands);
              break;

            case 17:
              if ((
#line 24712 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24714 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_3548 (insn, operands);
              break;

            default:
              break;
            }
          operands[3] = x3;
          switch (pattern802 (x2))
            {
            case 0:
              if (!((
#line 29050 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29052 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3769 (insn, operands);

            case 1:
              if (!((
#line 29050 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29052 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3770 (insn, operands);

            case 2:
              if (!(
#line 29050 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29052 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3771 (insn, operands);

            case 3:
              if (!((
#line 29050 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29052 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3772 (insn, operands);

            case 4:
              if (!((
#line 29050 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29052 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3773 (insn, operands);

            case 5:
              if (!(
#line 29050 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29052 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3774 (insn, operands);

            default:
              return NULL;
            }

        case VEC_CONCAT:
          switch (pattern521 (x2))
            {
            case 0:
              if (!(
#line 25095 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512) && 
#line 25097 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3569 (insn, operands);

            case 1:
              if (!(
#line 25147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 25149 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3571 (insn, operands);

            case 2:
              if (!(
#line 25243 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 25245 "../../../gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3577 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      res = split_63 (x1, insn);
      if (res != NULL_RTX)
        return res;
      if (GET_CODE (x4) != SUBREG)
        return NULL;
      switch (pattern523 (x2))
        {
        case 0:
          if (!(
#line 15021 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 15023 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3178 (insn, operands);

        case 1:
          if (!(
#line 15074 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 15076 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3180 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return NULL;
      switch (pattern525 (x2))
        {
        case 0:
          if (!(
#line 14996 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 14998 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3177 (insn, operands);

        case 1:
          if (!(
#line 15258 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512VBMI
   && ix86_pre_reload_split ()) && 
#line 15261 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3183 (insn, operands);

        case 2:
          if (!(
#line 15053 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 15055 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3179 (insn, operands);

        case 3:
          if (!(
#line 15105 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 15107 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3181 (insn, operands);

        case 4:
          if (!(
#line 15177 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 15179 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3182 (insn, operands);

        case 5:
          if (!(
#line 15277 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15279 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3184 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case EH_RETURN:
      if (!
#line 20866 "../../../gcc/config/i386/i386.md"
(epilogue_completed))
        return NULL;
      return gen_split_869 (insn, operands);

    case PARALLEL:
    case UNSPEC:
    case UNSPEC_VOLATILE:
    case SET:
      switch (GET_CODE (x1))
        {
        case SET:
          res = split_13 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case PARALLEL:
          res = split_35 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (tls_address_pattern (operands[0], E_VOIDmode)
          && 
#line 23396 "../../../gcc/config/i386/i386.md"
(TARGET_TLS_DIRECT_SEG_REFS))
        return gen_split_926 (insn, operands);
      switch (GET_CODE (x1))
        {
        case PARALLEL:
          return split_85 (x1, insn);

        case SET:
          x2 = XEXP (x1, 1);
          switch (GET_CODE (x2))
            {
            case NEG:
              res = split_39 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case IF_THEN_ELSE:
              res = split_41 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case UNSPEC:
              res = split_42 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case COMPARE:
              res = split_43 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case NOT:
              res = split_44 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case REG:
            case SUBREG:
            case MEM:
              res = split_45 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[1] = x2;
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (nonimmediate_gr_operand (operands[0], E_V8QImode)
                      && const0_operand (operands[1], E_V8QImode)
                      && 
#line 317 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
                    return gen_split_996 (insn, operands);
                  if (memory_operand (operands[0], E_V8QImode)
                      && x86_64_const_vector_operand (operands[1], E_V8QImode)
                      && (
#line 87 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT) && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1007 (insn, operands);
                  break;

                case E_V4HImode:
                  if (nonimmediate_gr_operand (operands[0], E_V4HImode)
                      && const0_operand (operands[1], E_V4HImode)
                      && 
#line 317 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
                    return gen_split_997 (insn, operands);
                  if (memory_operand (operands[0], E_V4HImode)
                      && x86_64_const_vector_operand (operands[1], E_V4HImode)
                      && (
#line 87 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT) && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1008 (insn, operands);
                  break;

                case E_V2SImode:
                  if (nonimmediate_gr_operand (operands[0], E_V2SImode)
                      && const0_operand (operands[1], E_V2SImode)
                      && 
#line 317 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
                    return gen_split_998 (insn, operands);
                  if (memory_operand (operands[0], E_V2SImode)
                      && x86_64_const_vector_operand (operands[1], E_V2SImode)
                      && (
#line 89 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT) && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1011 (insn, operands);
                  break;

                case E_V1DImode:
                  if (nonimmediate_gr_operand (operands[0], E_V1DImode)
                      && const0_operand (operands[1], E_V1DImode)
                      && 
#line 317 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
                    return gen_split_999 (insn, operands);
                  break;

                case E_V2SFmode:
                  if (nonimmediate_gr_operand (operands[0], E_V2SFmode)
                      && const0_operand (operands[1], E_V2SFmode)
                      && 
#line 317 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
                    return gen_split_1000 (insn, operands);
                  if (memory_operand (operands[0], E_V2SFmode)
                      && x86_64_const_vector_operand (operands[1], E_V2SFmode)
                      && (
#line 89 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT) && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1012 (insn, operands);
                  break;

                case E_V4HFmode:
                  if (nonimmediate_gr_operand (operands[0], E_V4HFmode)
                      && const0_operand (operands[1], E_V4HFmode)
                      && 
#line 317 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
                    return gen_split_1001 (insn, operands);
                  if (memory_operand (operands[0], E_V4HFmode)
                      && x86_64_const_vector_operand (operands[1], E_V4HFmode)
                      && (
#line 88 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT) && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1009 (insn, operands);
                  break;

                case E_V4BFmode:
                  if (nonimmediate_gr_operand (operands[0], E_V4BFmode)
                      && const0_operand (operands[1], E_V4BFmode)
                      && 
#line 317 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
                    return gen_split_1002 (insn, operands);
                  if (memory_operand (operands[0], E_V4BFmode)
                      && x86_64_const_vector_operand (operands[1], E_V4BFmode)
                      && (
#line 88 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT) && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_1010 (insn, operands);
                  break;

                case E_V2QImode:
                  if (memory_operand (operands[0], E_V2QImode)
                      && x86_64_const_vector_operand (operands[1], E_V2QImode)
                      && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed))
                    return gen_split_1003 (insn, operands);
                  break;

                case E_V4QImode:
                  if (memory_operand (operands[0], E_V4QImode)
                      && x86_64_const_vector_operand (operands[1], E_V4QImode)
                      && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed))
                    return gen_split_1004 (insn, operands);
                  break;

                case E_V2HImode:
                  if (memory_operand (operands[0], E_V2HImode)
                      && x86_64_const_vector_operand (operands[1], E_V2HImode)
                      && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed))
                    return gen_split_1005 (insn, operands);
                  break;

                case E_V2HFmode:
                  if (memory_operand (operands[0], E_V2HFmode)
                      && x86_64_const_vector_operand (operands[1], E_V2HFmode)
                      && 
#line 417 "../../../gcc/config/i386/mmx.md"
( reload_completed))
                    return gen_split_1006 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case PLUS:
              res = split_46 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case MINUS:
              res = split_47 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case VEC_SELECT:
              res = split_49 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case LT:
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              switch (pattern236 (x2))
                {
                case 0:
                  if ((
#line 3873 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()) && 
#line 3875 "../../../gcc/config/i386/mmx.md"
( 1)))
                    return gen_split_1052 (insn, operands);
                  break;

                case 1:
                  if ((
#line 3873 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE && ix86_pre_reload_split ()) && 
#line 3875 "../../../gcc/config/i386/mmx.md"
( 1)))
                    return gen_split_1053 (insn, operands);
                  break;

                case 2:
                  if ((
#line 3962 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 3964 "../../../gcc/config/i386/mmx.md"
( 1)))
                    return gen_split_1057 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              res = split_50 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case VEC_CONCAT:
              res = split_51 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case VEC_MERGE:
              res = split_52 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case ZERO_EXTEND:
              res = split_53 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case IOR:
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              switch (pattern238 (x2))
                {
                case 0:
                  if (
#line 2118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                    return gen_split_1184 (insn, operands);
                  break;

                case 1:
                  if (
#line 2118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                    return gen_split_1187 (insn, operands);
                  break;

                case 2:
                  if ((
#line 2118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                    return gen_split_1190 (insn, operands);
                  break;

                case 3:
                  if ((
#line 2118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                    return gen_split_1193 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              switch (pattern238 (x2))
                {
                case 0:
                  if (
#line 2118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                    return gen_split_1185 (insn, operands);
                  break;

                case 1:
                  if (
#line 2118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                    return gen_split_1188 (insn, operands);
                  break;

                case 2:
                  if ((
#line 2118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                    return gen_split_1191 (insn, operands);
                  break;

                case 3:
                  if ((
#line 2118 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                    return gen_split_1194 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case ASHIFT:
              switch (pattern52 (x1))
                {
                case 0:
                  if (
#line 2282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                    return gen_split_1216 (insn, operands);
                  break;

                case 1:
                  if (
#line 2282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                    return gen_split_1218 (insn, operands);
                  break;

                case 2:
                  if ((
#line 2282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                    return gen_split_1220 (insn, operands);
                  break;

                case 3:
                  if ((
#line 2282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                    return gen_split_1222 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case LSHIFTRT:
              switch (pattern52 (x1))
                {
                case 0:
                  if (
#line 2282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                    return gen_split_1217 (insn, operands);
                  break;

                case 1:
                  if (
#line 2282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                    return gen_split_1219 (insn, operands);
                  break;

                case 2:
                  if ((
#line 2282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                    return gen_split_1221 (insn, operands);
                  break;

                case 3:
                  if ((
#line 2282 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                    return gen_split_1223 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case SIGN_EXTEND:
              res = split_54 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case SS_PLUS:
              if (pattern54 (x1) == 0
                  && 
#line 22610 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && reload_completed
   && SSE_REGNO_P (REGNO (operands[0]))))
                return gen_split_3466 (insn, operands);
              break;

            case SS_MINUS:
              if (pattern54 (x1) == 0
                  && 
#line 22610 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && reload_completed
   && SSE_REGNO_P (REGNO (operands[0]))))
                return gen_split_3468 (insn, operands);
              break;

            case NE:
            case EQ:
              res = split_55 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          return split_84 (x1, insn);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && const_int_operand (operands[1], E_DImode)
          && 
#line 2799 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && optimize_insn_for_size_p ()
   && LEGACY_INT_REG_P (operands[0])
   && !x86_64_immediate_operand (operands[1], DImode)
   && !x86_64_zext_immediate_operand (operands[1], DImode)
   && !((UINTVAL (operands[1]) >> ctz_hwi (UINTVAL (operands[1])))
	& ~HOST_WIDE_INT_C (0xffffffff))
   && peep2_regno_dead_p (0, FLAGS_REG)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_4 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!general_reg_operand (operands[0], E_DImode))
        return NULL;
      if (const_int_operand (operands[1], E_DImode))
        {
          if ((
#line 2948 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && optimize_size > 1
   && operands[1] != const0_rtx
   && IN_RANGE (INTVAL (operands[1]), -128, 127)
   && !ix86_red_zone_used
   && REGNO (operands[0]) != SP_REG) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_7 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count >= 2)
            {
              x2 = PATTERN (peep2_next_insn (1));
              switch (pattern1056 (x2))
                {
                case 0:
                  if ((
#line 3656 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_36 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 3656 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_38 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 3656 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_40 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (peep2_current_count < 2)
        return NULL;
      x2 = PATTERN (peep2_next_insn (1));
      if (pattern947 (x2, 
E_DImode) != 0
          || !(
#line 3283 "../../../gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])
   && (const0_operand (operands[1], DImode)
       || (constm1_operand (operands[1], DImode)
	   && (8 > 1 || TARGET_AVX512DQ)))) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_14 (insn, operands);

    case E_HImode:
      if (!general_reg_operand (operands[0], E_HImode))
        return NULL;
      if (const_int_operand (operands[1], E_HImode)
          && 
#line 2948 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && optimize_size > 1
   && operands[1] != const0_rtx
   && IN_RANGE (INTVAL (operands[1]), -128, 127)
   && !ix86_red_zone_used
   && REGNO (operands[0]) != SP_REG))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_5 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x2 = PATTERN (peep2_next_insn (1));
      if (pattern947 (x2, 
E_HImode) != 0
          || !
#line 3283 "../../../gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])
   && (const0_operand (operands[1], HImode)
       || (constm1_operand (operands[1], HImode)
	   && (2 > 1 || TARGET_AVX512DQ)))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_12 (insn, operands);

    case E_SImode:
      if (!general_reg_operand (operands[0], E_SImode))
        return NULL;
      if (const_int_operand (operands[1], E_SImode))
        {
          if (
#line 2948 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && optimize_size > 1
   && operands[1] != const0_rtx
   && IN_RANGE (INTVAL (operands[1]), -128, 127)
   && !ix86_red_zone_used
   && REGNO (operands[0]) != SP_REG))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_6 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count >= 2)
            {
              x2 = PATTERN (peep2_next_insn (1));
              switch (pattern1056 (x2))
                {
                case 0:
                  if (
#line 3656 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_35 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if (
#line 3656 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_37 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 3656 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_39 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (peep2_current_count < 2)
        return NULL;
      x2 = PATTERN (peep2_next_insn (1));
      if (pattern947 (x2, 
E_SImode) != 0
          || !
#line 3283 "../../../gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])
   && (const0_operand (operands[1], SImode)
       || (constm1_operand (operands[1], SImode)
	   && (4 > 1 || TARGET_AVX512DQ)))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    case E_QImode:
      if (peep2_current_count < 2
          || !general_reg_operand (operands[0], E_QImode))
        return NULL;
      x2 = PATTERN (peep2_next_insn (1));
      if (pattern947 (x2, 
E_QImode) != 0
          || !
#line 3283 "../../../gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])
   && (const0_operand (operands[1], QImode)
       || (constm1_operand (operands[1], QImode)
	   && (1 > 1 || TARGET_AVX512DQ)))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (operands[0]))
        {
        case MEM:
          if (push_operand (operands[0], E_DImode)
              && immediate_operand (operands[1], E_DImode)
              && 
#line 2223 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !symbolic_operand (operands[1], DImode)
   && !x86_64_immediate_operand (operands[1], DImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_3 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case REG:
        case SUBREG:
          res = peephole2_4 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (memory_operand (operands[0], E_HImode)
              && const_int_operand (operands[1], E_HImode)
              && 
#line 2970 "../../../gcc/config/i386/i386.md"
((operands[1] == const0_rtx || operands[1] == constm1_rtx)
   && optimize_insn_for_size_p () && optimize_size > 1
   && peep2_regno_dead_p (0, FLAGS_REG)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_8 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_SImode:
          if (memory_operand (operands[0], E_SImode)
              && const_int_operand (operands[1], E_SImode)
              && 
#line 2970 "../../../gcc/config/i386/i386.md"
((operands[1] == const0_rtx || operands[1] == constm1_rtx)
   && optimize_insn_for_size_p () && optimize_size > 1
   && peep2_regno_dead_p (0, FLAGS_REG)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_DImode:
          if (memory_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && (
#line 2970 "../../../gcc/config/i386/i386.md"
((operands[1] == const0_rtx || operands[1] == constm1_rtx)
   && optimize_insn_for_size_p () && optimize_size > 1
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = peephole2_5 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      operands[1] = x2;
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (memory_operand (operands[0], E_QImode)
              && immediate_operand (operands[1], E_QImode)
              && 
#line 27838 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((QImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_259 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_HImode:
          if (memory_operand (operands[0], E_HImode)
              && immediate_operand (operands[1], E_HImode)
              && 
#line 27838 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((HImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_260 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      break;

    case REG:
      res = peephole2_6 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case SUBREG:
    case MEM:
      res = peephole2_7 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (peep2_current_count < 2)
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x3 = XEXP (x1, 0);
  switch (GET_MODE (x3))
    {
    case E_HImode:
      if (peep2_current_count >= 3
          && peep2_current_count >= 4)
        {
          operands[2] = x3;
          if (general_reg_operand (operands[2], E_HImode))
            {
              operands[3] = x2;
              if (general_gr_operand (operands[3], E_HImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[0] = x5;
                  if (general_reg_operand (operands[0], E_HImode))
                    {
                      x6 = XEXP (x4, 1);
                      if (pattern952 (x6, 
E_HImode) == 0
                          && 
#line 26545 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (2, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])
  && !reg_mentioned_p (operands[2], operands[6])))
                        {
                          *pmatch_len_ = 3;
                          res = gen_peephole2_206 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
        }
      operands[0] = x3;
      operands[1] = x2;
      if (x86_64_general_operand (operands[1], E_HImode)
          && general_reg_operand (operands[0], E_HImode))
        {
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (general_reg_operand (operands[2], E_HImode))
            {
              x6 = XEXP (x4, 1);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27142 "../../../gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_230 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 3
          || pattern833 (x4, 
E_HImode) != 0)
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_HImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1848 (x9, 
E_HImode) != 0
              || !
#line 28403 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[4]) == REGNO (operands[0])
       || REGNO (operands[4]) == REGNO (operands[3]))
   && (rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
			     ? 3 : 0], operands[5])
       ? rtx_equal_p (operands[2], operands[6])
       : rtx_equal_p (operands[2], operands[5])
	 && rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
				  ? 3 : 0], operands[6]))
   && peep2_reg_dead_p (4, operands[4])
   && peep2_reg_dead_p (5, operands[REGNO (operands[4]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_326 (insn, operands);

        case E_SImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1849 (x9, 
E_HImode) != 0
              || !
#line 28447 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[5]) == REGNO (operands[0])
       || REGNO (operands[5]) == REGNO (operands[3]))
   && REGNO (operands[5]) == REGNO (operands[4])
   && (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
			     ? 3 : 0], operands[6])
       ? (REG_P (operands[2])
	  ? REG_P (operands[7]) && REGNO (operands[2]) == REGNO (operands[7])
	  : rtx_equal_p (operands[2], operands[7]))
       : (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
				? 3 : 0], operands[7])
	  && REG_P (operands[2])
	  && REGNO (operands[2]) == REGNO (operands[6])))
   && peep2_reg_dead_p (4, operands[5])
   && peep2_reg_dead_p (5, operands[REGNO (operands[5]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], SImode)
       || any_QIreg_operand (operands[2], SImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_330 (insn, operands);

        default:
          return NULL;
        }

    case E_QImode:
      operands[0] = x3;
      operands[1] = x2;
      if (x86_64_general_operand (operands[1], E_QImode)
          && general_reg_operand (operands[0], E_QImode))
        {
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (general_reg_operand (operands[2], E_QImode))
            {
              x6 = XEXP (x4, 1);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27142 "../../../gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_229 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 3
          || pattern833 (x4, 
E_QImode) != 0)
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1848 (x9, 
E_QImode) != 0
              || !
#line 28403 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[4]) == REGNO (operands[0])
       || REGNO (operands[4]) == REGNO (operands[3]))
   && (rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
			     ? 3 : 0], operands[5])
       ? rtx_equal_p (operands[2], operands[6])
       : rtx_equal_p (operands[2], operands[5])
	 && rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
				  ? 3 : 0], operands[6]))
   && peep2_reg_dead_p (4, operands[4])
   && peep2_reg_dead_p (5, operands[REGNO (operands[4]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_325 (insn, operands);

        case E_SImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1849 (x9, 
E_QImode) != 0
              || !
#line 28447 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[5]) == REGNO (operands[0])
       || REGNO (operands[5]) == REGNO (operands[3]))
   && REGNO (operands[5]) == REGNO (operands[4])
   && (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
			     ? 3 : 0], operands[6])
       ? (REG_P (operands[2])
	  ? REG_P (operands[7]) && REGNO (operands[2]) == REGNO (operands[7])
	  : rtx_equal_p (operands[2], operands[7]))
       : (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
				? 3 : 0], operands[7])
	  && REG_P (operands[2])
	  && REGNO (operands[2]) == REGNO (operands[6])))
   && peep2_reg_dead_p (4, operands[5])
   && peep2_reg_dead_p (5, operands[REGNO (operands[5]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], SImode)
       || any_QIreg_operand (operands[2], SImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_329 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (register_operand (operands[0], E_DImode))
    {
      res = peephole2_15 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], E_DImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) == PARALLEL
      && XVECLEN (x3, 0) == 2)
    {
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) == SET)
        {
          if (memory_operand (operands[1], E_DImode))
            {
              switch (pattern1182 (x3, 
E_DImode, 
E_TImode))
                {
                case 0:
                  if ((
#line 8701 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_71 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 9134 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_87 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 9621 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_99 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if ((
#line 9987 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_111 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 4:
                  if ((
#line 8818 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_79 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 5:
                  if ((
#line 8844 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[5])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[5], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_83 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 6:
                  if ((
#line 9302 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_93 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 7:
                  if ((
#line 9328 "../../../gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[5])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[5], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_97 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          if (peep2_current_count >= 4
              && pattern1184 (x3, 
E_DImode) == 0
              && (
#line 14288 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[2])
   && !reg_mentioned_p (operands[0], operands[1])
   && !reg_mentioned_p (operands[2], operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_152 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (general_reg_operand (operands[1], E_DImode))
            {
              x5 = PATTERN (peep2_next_insn (2));
              if (GET_CODE (x5) == SET)
                {
                  x6 = XEXP (x4, 1);
                  if (GET_CODE (x6) == NEG
                      && pattern1332 (x3, 
E_DImode) == 0
                      && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_158 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (peep2_current_count >= 4
                      && pattern1334 (x3, 
E_DImode) == 0
                      && (
#line 26511 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (1, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_205 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  if (!immediate_operand (operands[1], E_DImode)
      || GET_CODE (x3) != SET)
    return NULL;
  switch (pattern949 (x3, 
E_TImode, 
E_DImode))
    {
    case 0:
      if (!(
#line 11085 "../../../gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == DX_REG
       || peep2_reg_dead_p (3, operands[0]))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_115 (insn, operands);

    case 1:
      if (!(
#line 11107 "../../../gcc/config/i386/i386.md"
(REGNO (operands[3]) != DX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == REGNO (operands[5])
       || peep2_reg_dead_p (3, operands[0]))
   && (REGNO (operands[2]) == REGNO (operands[4])
       || REGNO (operands[2]) == REGNO (operands[5])
       || peep2_reg_dead_p (3, operands[2]))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_117 (insn, operands);

    case 2:
      if (!general_reg_operand (operands[4], E_DImode))
        return NULL;
      x5 = PATTERN (peep2_next_insn (2));
      x7 = XVECEXP (x5, 0, 0);
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != E_DImode)
        return NULL;
      x9 = XVECEXP (x5, 0, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return NULL;
      switch (GET_CODE (x8))
        {
        case SMUL_HIGHPART:
          x11 = XEXP (x8, 0);
          if (!rtx_equal_p (x11, operands[2]))
            return NULL;
          x12 = XEXP (x8, 1);
          if (!rtx_equal_p (x12, operands[0])
              || !(
#line 11246 "../../../gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_120 (insn, operands);

        case UMUL_HIGHPART:
          x11 = XEXP (x8, 0);
          if (!rtx_equal_p (x11, operands[2]))
            return NULL;
          x12 = XEXP (x8, 1);
          if (!rtx_equal_p (x12, operands[0])
              || !(
#line 11246 "../../../gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_121 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count >= 2)
    {
      x2 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x2) == SET)
        {
          x3 = XEXP (x2, 1);
          if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x4 = XEXP (x2, 0);
              operands[2] = x4;
              if (memory_operand (operands[2], E_SImode))
                {
                  if (peep2_current_count >= 3)
                    {
                      x5 = PATTERN (peep2_next_insn (2));
                      if (pattern1242 (x5, 
E_SImode) == 0
                          && 
#line 27047 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)))
                        {
                          *pmatch_len_ = 3;
                          res = gen_peephole2_217 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (
#line 27063 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_219 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  if (!
#line 27076 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)))
    return NULL;
  *pmatch_len_ = 0;
  return gen_peephole2_221 (insn, operands);
}

 rtx_insn *
peephole2_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count >= 2)
    {
      res = peephole2_32 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (const0_operand (operands[1], E_VOIDmode)
      && general_reg_operand (operands[0], E_VOIDmode)
      && 
#line 28499 "../../../gcc/config/i386/i386.md"
(GET_MODE_SIZE (GET_MODE (operands[0])) <= UNITS_PER_WORD
   && (! TARGET_USE_MOV0 || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)))
    {
      *pmatch_len_ = 0;
      res = gen_peephole2_332 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || !memory_operand (operands[1], E_DFmode)
      || !sse_reg_operand (operands[0], E_DFmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return NULL;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!sse_reg_operand (operands[2], E_V2DFmode))
    return NULL;
  x7 = XEXP (x5, 0);
  operands[4] = x7;
  if (!sse_reg_operand (operands[4], E_DFmode))
    return NULL;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  if (!memory_operand (operands[3], E_DFmode)
      || !
#line 1966 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_SSE_UNALIGNED_LOAD_OPTIMAL
   && REGNO (operands[4]) == REGNO (operands[2])
   && ix86_operands_ok_for_move_multiple (operands, true, DFmode)))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_401 (insn, operands);
}

 rtx_insn *
peephole2_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
      if (peep2_current_count < 2)
        return NULL;
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1335 (x4, 
E_SImode))
            {
            case 0:
              if (!
#line 3643 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_29 (insn, operands);

            case 1:
              if (!
#line 3643 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_31 (insn, operands);

            case 2:
              if (!(
#line 3643 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_33 (insn, operands);

            case 3:
              if (!
#line 4937 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (SImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_41 (insn, operands);

            case 4:
              if (!
#line 4937 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (SImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_43 (insn, operands);

            case 5:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_SImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_133 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_145 (insn, operands);

            case 6:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_SImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_134 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_146 (insn, operands);

            case 7:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_SImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_135 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_147 (insn, operands);

            case 8:
              if (!
#line 14333 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_153 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1335 (x4, 
E_DImode))
            {
            case 0:
              if (!(
#line 3643 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_30 (insn, operands);

            case 1:
              if (!(
#line 3643 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_32 (insn, operands);

            case 2:
              if (!(
#line 3643 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_34 (insn, operands);

            case 3:
              if (!(
#line 4937 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (DImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_42 (insn, operands);

            case 4:
              if (!(
#line 4937 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (DImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_44 (insn, operands);

            case 5:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_DImode)
                  && (
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_136 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0])
                  || !
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_148 (insn, operands);

            case 6:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_DImode)
                  && (
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_137 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0])
                  || !
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_149 (insn, operands);

            case 7:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_DImode)
                  && (
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_138 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0])
                  || !
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_150 (insn, operands);

            case 8:
              if (!(
#line 14333 "../../../gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_154 (insn, operands);

            default:
              return NULL;
            }

        case E_QImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1336 (x4, 
E_QImode))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_127 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_139 (insn, operands);

            case 1:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_128 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_140 (insn, operands);

            case 2:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_129 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_141 (insn, operands);

            default:
              return NULL;
            }

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1336 (x4, 
E_HImode))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_130 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_142 (insn, operands);

            case 1:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_131 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_143 (insn, operands);

            case 2:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14039 "../../../gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_132 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_144 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      if (pattern1058 (x3) != 0
          || !
#line 19101 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && !TARGET_USE_BT))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_166 (insn, operands);

    default:
      return NULL;
    }
}
